package com.sw.mes.itemclean.clean.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sw.mes.itemclean.clean.utils.LocalDateStringConverter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 组托明细
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Getter
@Setter
@ApiModel(value = "MaterialBrokenUpAndDownDto", description = "关联破碎上料+破碎下料组托明细")
public class MaterialBrokenUpAndDownDto implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("破碎上料id")
    private Integer upId;

    @ApiModelProperty("上料箱号")
    @ExcelProperty(value = "上料箱号")
    private String upBoxNo;

    @ApiModelProperty("上料重量")
    @ExcelProperty(value = "上料重量")
    private BigDecimal upWeight;

    @ApiModelProperty("上料时间")
    @ExcelProperty(value = "上料时间", converter = LocalDateStringConverter.class)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime upCreateTime;

    @ApiModelProperty("上料人")
    @ExcelProperty(value = "上料人")
    private String upCreateUser;

    @ApiModelProperty("分选pp批次")
    @ExcelProperty(value = "分选pp批次")
    private String productBatchNo;

    @ApiModelProperty("下料小箱盒号")
    @ExcelProperty(value = "下料箱号")
    private String downBoxNo;

    @ApiModelProperty("下料id")
    private Integer downId;

    @ApiModelProperty("下料重量")
    @ExcelProperty(value = "下料重量")
    private BigDecimal DownWeight;

    @ApiModelProperty("物料名称")
    @ExcelProperty(value = "物料名称")
    private String materialName;

    @ApiModelProperty("物料编号")
    @ExcelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty("物料等级")
    @ExcelProperty(value = "物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    @ExcelProperty(value = "物料型号")
    private String materialModel;

    @ApiModelProperty("电阻档位")
    @ExcelProperty(value = "电阻档位")
    private String materialGear;

    @ApiModelProperty("下料人")
    @ExcelProperty(value = "下料人")
    private String downUser;

    @ApiModelProperty("下料时间")
    @ExcelProperty(value = "下料时间", converter = LocalDateStringConverter.class)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime downCreateTime;

    @ApiModelProperty("组托号")
    @ExcelProperty(value = "托号")
    private String groupNo;

    @ApiModelProperty("组托id")
    private Integer groupId;
}
