package com.sw.mes.itemclean.clean.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 清洗
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Getter
@Setter
@ApiModel(value = "MaterialCleaning对象", description = "清洗")
public class MaterialCleaningDto implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    private Integer id;

    @ApiModelProperty("重量（上料总计）")
    private BigDecimal weight;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    private String materialModel;

    @ApiModelProperty("电阻档位")
    private String materialGear;

    @ApiModelProperty("分选pp生产批次")
    private String productBatchNo;

    @ApiModelProperty("批次完结 1完结 0未完结")
    private Integer batchEnd;

    @ApiModelProperty("设备号")
    private String deviceNo;

    @ApiModelProperty("创建人-清洗上料人")
    private String createUser;

    @ApiModelProperty("创建时间-清洗上料时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private String updateUser;

    @ApiModelProperty("更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime updateTime;

    @ApiModelProperty("花篮载具号")
    private String boxNo;

    @ApiModelProperty("下料人")
    private String downUser;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("下料时间")
    private LocalDateTime downTime;

    @ApiModelProperty("下料重量")
    private BigDecimal downWeight;

    @ApiModelProperty("逻辑删除标记")
    private Integer delFlag;

    @ApiModelProperty("是否有新批次")
    private Integer isNewBatch; //1:有新批次  。  2:无新批次

    @ApiModelProperty("清洗状态 0 清洗上料 1 清洗下料 2 拆花篮成箱 3 待破碎")
    private Integer status;

}
