package com.sw.mes.itemclean.clean.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 分选拆箱
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Getter
@Setter
@ApiModel(value = "MaterialUnpackingJoinPageDto对象", description = "分选拆箱列表页")
public class MaterialUnpackingJoinPageDto implements Serializable {

    //----------分选前
    @ApiModelProperty("回收料表-分选前-掺杂剂")
    private String dopant;

    @ApiModelProperty("回收料表-分选前-成本中心")
    private String kostl;

    @ApiModelProperty("回收料表-分选前-定向标识")
    private String directionalSign;

    @ApiModelProperty("回收料表-分选前-导电型号")
    private String conductionType;

    @ApiModelProperty("回收料表-分选前-车间")
    private String workShop;

    //--------领料表
    @ApiModelProperty("领料表主键")
    private Integer id;

    @ApiModelProperty("重量")
    private BigDecimal weight;

    @ApiModelProperty("成箱箱号")
    private String materialBoxNo;

    @ApiModelProperty("生产批次号")
    private String productBatchNo;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    private String materialModel;

    @ApiModelProperty("物料档位")
    private String materialGear;

    @ApiModelProperty("物料类型 1原生多晶2回收料3落地料4返工料5清洗料6破碎料")
    /**
     * {@link com.sw.mes.core.enums.ItemCleanEnums.MaterialType}
     */
    private Integer materialType;

    @ApiModelProperty("物料来源 1：清洗 2：循环料破碎 3：多晶破碎 4：分选")
    private Integer materialResource;

    @ApiModelProperty("是否被领料 1是 0否")
    /**
     * (被领料的才能进入加工工序)
     */
    private Integer pickingStatus;

    @ApiModelProperty("创建人")
    private String createUser;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private String updateUser;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("逻辑删除标记")
    @TableLogic
    private Integer delFlag;

    @ApiModelProperty("是否成箱 0否 1是")
    private Integer isPack;

    @ApiModelProperty("是否空箱 0否 1是")
    private Integer isEmptyBox;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("ERP工单")
    private String aufnr;

    @ApiModelProperty(value = "卡板箱号")
    private String boxNo;

    /**
     * erp库位
     */
    @ApiModelProperty("erp库位")
    private String erpWarehouseCode;


    @ApiModelProperty("已使用重量")
    private BigDecimal usedWeight;

    @ApiModelProperty("剩余重量")
    private BigDecimal unusedWeight;

    @ApiModelProperty("审核状态 0 待审核 1 已接收 2已拒收")
    private Integer status;

    @ApiModelProperty("使用状态 0未使用 1已使用 2合批 3分选 4已清空")
    private Integer useStatus;

    @ApiModelProperty("合批父id")
    Integer parentId;

    @ApiModelProperty("合批批次号")
    private String blendingProductBatchNo;

    @ApiModelProperty("合批人")
    private String blendingUser;

    @ApiModelProperty("合批时间")
    private LocalDateTime blendingTime;

    @ApiModelProperty("审核人")
    private String examineUser;

    @ApiModelProperty("审核时间")
    private LocalDateTime examineTime;

    @ApiModelProperty("发起人")
    private String initiateUser;

    @ApiModelProperty("发起时间")
    private LocalDateTime initiateTime;

    @ApiModelProperty("去向")
    private String hasGone;

    @ApiModelProperty(value = "物料主数据供应商")
    private String supplier;

    @ApiModelProperty(value = "物料主数据供应商Code")
    private String supplierCode;

    //分选后-分选表--------

    @ApiModelProperty("分选后-主键")
    private Integer muId;

    @ApiModelProperty("分选后-成箱号-分选批号")
    private String muMaterialBoxNo;

    @ApiModelProperty("分选后-成箱重量")
    private BigDecimal muWeight;

    @ApiModelProperty("分选后-物料编号")
    private String muMaterialCode;

    @ApiModelProperty("分选后-物料名称")
    private String muMaterialName;

    @ApiModelProperty("分选后-物料等级")
    private String muMaterialLevel;

    @ApiModelProperty("分选后-物料型号")
    private String muMaterialModel;

    @ApiModelProperty("分选后-电阻档位")
    private String muMaterialGear;

    @ApiModelProperty("分选后-领料的生产批次")
    private String muProductBatchNo;

    @ApiModelProperty("分选后-分选生产批次")
    private String muFxProductBatchNo;

    @ApiModelProperty("分选后-物料属性：1原生多晶、2回收料、3返工料、4落地料、5清洗料、6破碎料")
    /**
     * {@link com.sw.mes.core.enums.ItemCleanEnums.MaterialType}
     */
    private Integer muMaterialType;

    @ApiModelProperty("分选后-暂存标记")
    private Integer muStagingFlag;

    @ApiModelProperty("分选后-逻辑删除标记")
    @TableLogic
    private Integer muDelFlag;

    @ApiModelProperty("分选后-创建人")
    private String muCreateUser;

    @ApiModelProperty("分选后-创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime muCreateTime;

    @ApiModelProperty("分选后-更新人")
    private String muUpdateUser;

    @ApiModelProperty("分选后-更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime muUpdateTime;

    @ApiModelProperty(value = "分选后-卡板箱号")
    private String muBoxNo;

    @ApiModelProperty("分选后-载具皮重")
    private String muBoxWeight;

    @ApiModelProperty("分选后-载具类型")
    private String muTypeName;

    @ApiModelProperty("分选后-已使用重量")
    private BigDecimal muUsedWeight;

    @ApiModelProperty("分选后-剩余重量")
    private BigDecimal muUnusedWeight;

    @ApiModelProperty("分选后-领料表中拆箱箱号")
    private String muUnpackingBoxNo;

    @ApiModelProperty("分选后-其他异物重量")
    private BigDecimal muOtherWeight;

    @ApiModelProperty("分选后-使用状态 0未使用 1已使用 2已清空")
    private Integer muUseStatus;

    @ApiModelProperty("分选后-ERP工单")
    private String muAufnr;

    @ApiModelProperty("分选后-去向")
    private String muHasGone;

}
