package com.sw.mes.fb.checkout.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class ExportFbCheckOutDataDto {
    @ApiModelProperty(value = "单晶条码编号(方)")
    @ExcelProperty(value = "单晶条码编号(方)")
    String fbSectionNo;

    @ApiModelProperty(value = "单晶条码编号(圆)")
    @ExcelProperty(value = "单晶条码编号(圆)")
    String ybSectionNo;

    @ApiModelProperty(value = "编号(毛棒)")
    @ExcelProperty(value = "编号(毛棒)")
    String crystalNo;

    @ApiModelProperty(value = "一体机编号")
    @ExcelProperty(value = "一体机编号")
    String deviceNo;

    @ApiModelProperty(value = "领料来源")
    @ExcelProperty(value = "领料来源")
    String materialSourceValue;

    @ApiModelProperty(value = "检验线编号")
    @ExcelProperty(value = "检验线编号")
    String checkLineNo;

    @ApiModelProperty(value = "晶棒方向")
    @ExcelProperty(value = "晶棒方向")
    String crystalRodDirection;

    @ApiModelProperty(value = "检验类型")
    @ExcelProperty(value = "检验类型")
    String checkoutName;

    @ApiModelProperty(value = "复检类型")
    @ExcelProperty(value = "复检类型")
    String reCheckType;

    @ApiModelProperty(value = "创建日期")
    @ExcelProperty(value = "创建日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date checkTime;

    @ApiModelProperty(value = "日期")
    @ExcelProperty(value = "日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    String time;

    @ApiModelProperty(value = "检验员")
    @ExcelProperty(value = "检验员")
    String checkUserName;

    @ApiModelProperty(value = "规格")
    @ExcelProperty(value = "规格")
    String specification;

    @ApiModelProperty(value = "掺杂剂")
    @ExcelProperty(value = "掺杂剂")
    String dopant;

    @ApiModelProperty(value = "是否反切")
    @ExcelProperty(value = "是否反切")
    String tangentFlag;

    @ApiModelProperty(value = "方棒长度")
    @ExcelProperty(value = "方棒长度")
    BigDecimal length;

    @ApiModelProperty(value = "边长范围")
    @ExcelProperty(value = "边长范围")
    private String sideLengthRange;

    @ApiModelProperty(value = "方棒称重")
    @ExcelProperty(value = "方棒称重")
    BigDecimal weight;

    @ApiModelProperty(value = "理论重量")
    @ExcelProperty(value = "理论重量")
    BigDecimal theoryWeightFb;

    @ApiModelProperty(value = "方棒等级/检验入库类别")
    @ExcelProperty(value = "方棒等级/检验入库类别")
    String productLevelFb;

    @ApiModelProperty(value = "方棒评级时间")
    @ExcelProperty(value = "方棒评级时间")
    Date fbGradeTime;

    @ApiModelProperty(value = "圆棒实验评级")
    @ExcelProperty(value = "圆棒实验评级")
    String ybExperiLevel;

    @ApiModelProperty(value = "方棒实验评级")
    @ExcelProperty(value = "方棒实验评级")
    String fbExperiLevel;

    @ApiModelProperty(value = "方棒备注")
    @ExcelProperty(value = "方棒备注")
    String squareRodRemark;

    @ApiModelProperty(value = "其他备注")
    @ExcelProperty(value = "其他备注")
    String otherRemark;


    @ApiModelProperty(value = "料号")
    @ExcelProperty(value = "料号")
    String materialNumber;

    @ApiModelProperty(value = "订单号")
    @ExcelProperty(value = "订单号")
    String orderNo;

    @ApiModelProperty(value = "线痕长度(mm)")
    @ExcelProperty(value = "线痕长度")
    BigDecimal lineScratch;

    @ApiModelProperty(value = "划痕长度(mm)")
    @ExcelProperty(value = "划痕长度")
    BigDecimal scratch;

    @ApiModelProperty(value = "未磨到长度(mm)")
    @ExcelProperty(value = "未磨到长度")
    BigDecimal noFriction;

    @ApiModelProperty(value = "砂轮印扣减(mm)")
    @ExcelProperty(value = "砂轮印扣减(mm)")
    BigDecimal wheelPrintReduce;

    @ApiModelProperty(value = "尺寸异常长度(mm)")
    @ExcelProperty(value = "尺寸异常长度")
    BigDecimal sizeException;

    @ApiModelProperty(value = "粗糙度异常(mm)")
    @ExcelProperty(value = "粗糙度异常(mm)")
    BigDecimal roughnessAbnormality;

    @ApiModelProperty(value = "斜面扣减(mm)")
    @ExcelProperty(value = "斜面扣减(mm)")
    BigDecimal bevelDeduction;

    @ApiModelProperty(value = "传入边长max")
    @ExcelProperty(value = "传入边长max")
    BigDecimal eapSideMax;

    @ApiModelProperty(value = "传入边长min")
    @ExcelProperty(value = "传入边长min")
    BigDecimal eapSideMin;

    @ApiModelProperty(value = "传入直径max")
    @ExcelProperty(value = "传入直径max")
    BigDecimal eapDiameterMax;

    @ApiModelProperty(value = "传入直径min")
    @ExcelProperty(value = "传入直径min")
    BigDecimal eapDiameterMin;

    @ApiModelProperty(value = "边长max")
    @ExcelProperty(value = "边长max")
    BigDecimal sideLengthMax;

    @ApiModelProperty(value = "边长min")
    @ExcelProperty(value = "边长min")
    BigDecimal sideLengthMin;

    @ApiModelProperty(value = "直径max")
    @ExcelProperty(value = "直径max")
    BigDecimal diameterMax;

    @ApiModelProperty(value = "直径min")
    @ExcelProperty(value = "直径min")
    BigDecimal diameterMin;

    @ApiModelProperty(value = "垂直度max")
    @ExcelProperty(value = "垂直度max")
    BigDecimal verticalityMax;

    @ApiModelProperty(value = "垂直度min")
    @ExcelProperty(value = "垂直度min")
    BigDecimal verticalityMin;

//    @ApiModelProperty(value = "弧长投影max")
//    @ExcelProperty(value = "弧长投影max")
//    BigDecimal projectionMax;
//
//    @ApiModelProperty(value = "弧长投影min")
//    @ExcelProperty(value = "弧长投影min")
//    BigDecimal projectionMin;


    @ApiModelProperty(value = "弦长max ")
    @ExcelProperty(value = "弦长max")
    BigDecimal chordLengthMax;

    @ApiModelProperty(value = "弦长min")
    @ExcelProperty(value = "弦长min")
    BigDecimal chordLengthMin;

    @ApiModelProperty(value = "圆棒入库长度(mm)")
    @ExcelProperty(value = "圆棒入库长度")
    BigDecimal instoreLengthYb;

    @ApiModelProperty(value = "计划产品等级")
    @ExcelProperty(value = "计划产品等级")
    String planGrade;

    @ApiModelProperty(value = "计划规格")
    @ExcelProperty(value = "计划规格")
    String planSpecs;

    @ApiModelProperty(value = "计划电阻率")
    @ExcelProperty(value = "计划电阻率")
    String planResistivity;

    @ApiModelProperty(value = "计划拼数")
    @ExcelProperty(value = "计划拼数")
    String planStickCount;

    @ApiModelProperty(value = "计划长度范围")
    @ExcelProperty(value = "计划长度范围")
    String planLenRange;

    @ApiModelProperty(value = "计划掺杂剂")
    @ExcelProperty(value = "计划掺杂剂")
    String planDopant;

    @ApiModelProperty(value = "计划导电型号")
    @ExcelProperty(value = "计划导电型号")
    String planConductiveType;

    @ApiModelProperty(value = "倒角亮点")
    @ExcelProperty(value = "倒角亮点")
    BigDecimal wheelHighLights;

    @ApiModelProperty(value = "崩边扣减(mm)")
    @ExcelProperty(value = "崩边扣减")
    BigDecimal collapseLoss;

    @ApiModelProperty(value = "最终实验评级")
    @ExcelProperty(value = "最终实验评级")
    String experiLevel;

    @ApiModelProperty(value = "圆棒最终评级")
    @ExcelProperty(value = "圆棒最终评级")
    String ybLevel;

    @ApiModelProperty(value = "产品评级")
    @ExcelProperty(value = "产品评级")
    String productLevel;

    @ApiModelProperty(value = "产品类型")
    @ExcelProperty(value = "产品类型")
    String productType;


    @ApiModelProperty(value = "崩边扣减上")
    @ExcelProperty(value = "崩边扣减上")
    BigDecimal collapseLossSh;

    @ApiModelProperty(value = "崩边扣减中")
    @ExcelProperty(value = "崩边扣减中")
    BigDecimal collapseLossZh;

    @ApiModelProperty(value = "崩边扣减下")
    @ExcelProperty(value = "崩边扣减下")
    BigDecimal collapseLossXia;

    @ApiModelProperty(value = "修改人")
    @ExcelProperty(value = "修改人")
    String updateUser;

    @ApiModelProperty(value = "修改日期")
    @ExcelProperty(value = "修改日期")
    Date updateTime;

    @ApiModelProperty(value = "组合编号")
    @ExcelProperty(value = "组合编号")
    String sectionCompose;

    /**
     * 头尾识别
     */
    @ApiModelProperty(value = "头尾识别")
    @ExcelProperty(value = "头尾识别")
    private String headTailRecognition;

    /**
     * 单晶段号
     */
    @ApiModelProperty(value = "单晶段号")
    @ExcelProperty(value = "单晶段号")
    private Integer piecewiseNum;

}
