/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.checkout.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="loss_entry_record")
@DynamicUpdate
@DynamicInsert
public class LossEntryRecord{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 托盘编号
	 */
    @Column(length=100)
    private String trayNo;
    
	/**
	 * 单晶编号
	 */
    @Column(length=100)
    private String sectionNo;
    
	/**
	 * 损耗信息
	 */
    @Column(length=0)
    private String lossInfo;
    
	/**
	 * 创建人
	 */
    @Column(length=32)
    private String createUser;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    

	public LossEntryRecord() {
	}

	public LossEntryRecord(Long id) {
		this.id = id;
	}
}
