package com.sw.mes.fb.checkout.service.impl;


import com.alibaba.fastjson.JSONObject;
import com.sw.mes.core.base.BaseServiceImpl;
import com.sw.mes.core.context.BaseContextHandler;
import com.sw.mes.core.entity.FbCheckOutData;
import com.sw.mes.fb.checkout.dao.LossEntryRecordDao;
import com.sw.mes.fb.checkout.dto.LossRecordInfoDto;
import com.sw.mes.fb.checkout.dto.PdaLossRecordDto;
import com.sw.mes.fb.checkout.entity.LossEntryRecord;
import com.sw.mes.fb.checkout.service.FbCheckOutDataService;
import com.sw.mes.fb.checkout.service.LossEntryRecordService;
import com.sw.mes.fb.utils.StringUtils;
import org.apache.commons.collections.CollectionUtils;
import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Optional;


/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Service
@Transactional
public class LossEntryRecordServiceImpl extends BaseServiceImpl<LossEntryRecord> implements LossEntryRecordService {
    LossEntryRecordDao dao;

    @Autowired
    private FbCheckOutDataService fbCheckOutDataService;

    @Autowired
    private ModelMapper modelMapper;

	@Autowired
    public void setDao(LossEntryRecordDao dao) {
        super.setBaseDao(dao);
        this.dao=dao;
    }

    @Override
    public void saveLossRecordByPda(PdaLossRecordDto pdaLossRecordDto) {

	    if (StringUtils.isBlank(pdaLossRecordDto.getSectionNo())){
	        throw new RuntimeException("单晶编号为空！");
        }
	    //todo 托盘信息暂时不处理
        FbCheckOutData dataByFbSectionNo = fbCheckOutDataService.findDataByFbSectionNo(pdaLossRecordDto.getSectionNo());
	    if (null == dataByFbSectionNo){
            throw new RuntimeException("方棒检验信息不存在！");
        }
        BigDecimal lossLength = BigDecimal.ZERO;
	    if (CollectionUtils.isNotEmpty(pdaLossRecordDto.getLossRecordInfoDtoList())){
	        for (LossRecordInfoDto lossRecordInfoDto : pdaLossRecordDto.getLossRecordInfoDtoList()){
                lossLength = lossLength.add(lossRecordInfoDto.getLossLength());
            }
        }
        dataByFbSectionNo.setReducedLength(lossLength);
        fbCheckOutDataService.saveOrUpdate(dataByFbSectionNo);
        //保存记录
        LossEntryRecord lossEntryRecord = modelMapper.map(pdaLossRecordDto, LossEntryRecord.class);
        lossEntryRecord.setCreateTime(new Date());
        if (StringUtils.isBlank(lossEntryRecord.getCreateUser())){
            lossEntryRecord.setCreateUser(BaseContextHandler.getUsername());
        }
        lossEntryRecord.setLossInfo(JSONObject.toJSONString(pdaLossRecordDto.getLossRecordInfoDtoList()));
        this.saveOrUpdate(lossEntryRecord);

    }
}
