package com.sw.mes.fb.turnstore.service;

import com.sw.mes.base.factory.inspect.dto.ProductRuleValidateDto;
import com.sw.mes.core.base.BaseService;
import com.sw.mes.core.entity.FbCheckOutData;
import com.sw.mes.core.response.Result;
import com.sw.mes.base.factory.inspect.dto.ProductRuleDto;
import com.sw.mes.base.factory.inspect.entity.ProductAssemblyRule;
import com.sw.mes.fb.turnstore.dto.FbInfoDto;
import com.sw.mes.fb.turnstore.dto.UpdateStateByTrayNoDto;
import com.sw.mes.fb.turnstore.dto.WmsToFbReceiveDto;
import com.sw.mes.fb.turnstore.entity.FbTurnstoreTray;
import com.sw.mes.fb.turnstore.entity.FbTurnstoreTrayItem;

import java.util.List;

/**
 * @Author
 * @Description：
 * @Date:
 * @Modified By:
 */
public interface FbTurnstoreTrayService extends BaseService<FbTurnstoreTray> {


    /**
     * 根据方棒编号获取对应圆棒的相关信息（pda的定制接口）
     *
     * @param fbSectionNo
     * @return
     */
    Result<FbInfoDto> getInfoByFbSectionNo(String fbSectionNo);


    /**
     * 创建成品组托
     *
     * @param productRule
     * @param turnstoreTray
     * @param items
     */
    void createTray(ProductAssemblyRule productRule, FbTurnstoreTray turnstoreTray, List<FbTurnstoreTrayItem> items);

    /**
     * 更新成品组托
     *
     * @param turnstoreTray
     * @param items
     */
    void updateTray(FbTurnstoreTray turnstoreTray, List<FbTurnstoreTrayItem> items);

    Result lengthCheck(ProductRuleDto ruleDto);

    FbTurnstoreTray getFbTray(String trayNo);

    String validateRules(ProductRuleDto ruleDto, FbCheckOutData checkOut);

    FbTurnstoreTray findByTrayNo(String trayNo);

    List<FbTurnstoreTray> findByTime(String startTime, String endTime);

    void updateItem(FbTurnstoreTray turnstoreTray, List<FbTurnstoreTrayItem> turnstoreTrayItemList);

    Result initiateReceipt(FbTurnstoreTray turnstoreTray, List<FbTurnstoreTrayItem> turnstoreTrayItemList);

    void updateTrayItemState(WmsToFbReceiveDto receiveDto, FbTurnstoreTray turnstoreTray, List<FbTurnstoreTrayItem> trayItemList);

    List<FbTurnstoreTrayItem> groupItemList(FbCheckOutData checkOut);

    FbTurnstoreTrayItem groupItem(FbCheckOutData checkOut);

    Result validateRuleAndData(ProductRuleDto ruleDto, FbCheckOutData checkOutData, String state);

    void updateTurnstoreTrayStateById(WmsToFbReceiveDto receiveDto, FbTurnstoreTray turnstoreTray);

    void createTrayNoMk(FbTurnstoreTray fbTurnstoreTray, ProductAssemblyRule productRule);

    Result reportedErp(FbTurnstoreTray turnstoreTray, List<FbTurnstoreTrayItem> turnstoreTrayItemList);


    Result validateRuleNew(ProductRuleValidateDto ruleDto);

    void updateStateByTrayNo(UpdateStateByTrayNoDto dto);

}
