package com.sw.mes.fb.turnstore.service.impl;


import com.alibaba.fastjson.JSON;
import com.sw.mes.base.system.entity.DictionaryItem;
import com.sw.mes.base.system.service.DictionaryItemService;
import com.sw.mes.core.api.system.YbFeignClients;
import com.sw.mes.core.dto.wms.RemesstaDto;
import com.sw.mes.core.enums.EnumValuesFactory;
import com.sw.mes.core.base.BaseServiceImpl;
import com.sw.mes.core.exception.BusinessException;
import com.sw.mes.core.response.Result;
import com.sw.mes.core.response.ResultCode;
import com.sw.mes.core.response.ResultGenerator;
import com.sw.mes.base.factory.init.dto.MesToWmsReceiptDataDto;
import com.sw.mes.base.factory.init.dto.MesToWmsReceiptDto;
import com.sw.mes.fb.checkout.entity.FbJoin;
import com.sw.mes.fb.checkout.service.FbCheckOutDataService;
import com.sw.mes.fb.checkout.service.FbJoinService;
import com.sw.mes.fb.checkout.service.OperateCheckOutDataLogService;
import com.sw.mes.fb.turnstore.dao.RecheckInspectReceiveDao;
import com.sw.mes.fb.turnstore.entity.FbTurnstoreTrayItem;
import com.sw.mes.fb.turnstore.entity.RecheckInspectReceive;
import com.sw.mes.fb.turnstore.entity.RecheckInspectReceiveDetail;
import com.sw.mes.fb.turnstore.service.FbTurnstoreTrayItemService;
import com.sw.mes.fb.turnstore.service.RecheckInspectReceiveDetailService;
import com.sw.mes.fb.turnstore.service.RecheckInspectReceiveService;
import com.sw.mes.base.workinprocess.entity.PlanProcessingOrder;
import com.sw.mes.base.workinprocess.service.PlanProcessingOrderService;
import com.sw.mes.base.workinprocess.service.WipStorageService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.util.Assert;
import org.springframework.util.CollectionUtils;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Service
@Transactional
public class RecheckInspectReceiveServiceImpl extends BaseServiceImpl<RecheckInspectReceive> implements RecheckInspectReceiveService {
    RecheckInspectReceiveDao dao;

    @Autowired
    public void setDao(RecheckInspectReceiveDao dao) {
        super.setBaseDao(dao);
        this.dao = dao;
    }

    @Autowired
    private RecheckInspectReceiveDetailService receiveDetailService;

    @Autowired
    private WipStorageService wipStorageService;

    @Autowired
    private FbCheckOutDataService checkOutDataService;

    @Autowired
    private DictionaryItemService dictionaryItemService;

    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private PlanProcessingOrderService planProcessingOrderService;

    @Autowired
    private OperateCheckOutDataLogService operateCheckOutDataLogService;

    @Autowired
    private RecheckInspectReceiveDetailService recheckInspectReceiveDetailService;

    @Autowired
    private FbTurnstoreTrayItemService fbTurnstoreTrayItemService;

    @Autowired
    private FbJoinService fbJoinService;

    @Autowired
    private YbFeignClients ybFeignClients;

    @Value("${wms.url}")
    private String wmsUrl;

    @Override
    public RecheckInspectReceive findByTrayNo(String trayNo) {
        return dao.findByTrayNo(trayNo);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateState(RecheckInspectReceive receive, List<RecheckInspectReceiveDetail> detailDtoList) {
        //更新列表
//        for (RecheckInspectReceiveDetail receiveDetail : detailDtoList) {
//            FbTurnstoreTrayItem trayItem = fbTurnstoreTrayItemService.findByTrayNoAndSectionNo(receiveDetail.getTrayNo(), receiveDetail.getCrystalNo());
//            if (null == trayItem) {
//                throw new RuntimeException("不存在托号" + receiveDetail.getTrayNo() + "，单晶编号: " + receiveDetail.getCrystalNo() + "组拖信息");
//            } else {
//                //更新组拖明细状态
//                FbTurnstoreTrayItem bySectionNo = fbTurnstoreTrayItemService.findBySectionNo(receiveDetail.getCrystalNo());
//                if (null != bySectionNo) {
//                    bySectionNo.setState(10);
//                    fbTurnstoreTrayItemService.saveOrUpdate(bySectionNo);
//
//                    FbJoin fbJoinBySectionNo = fbJoinService.getFbJoinBySectionNo(bySectionNo.getSectionNo());
//                    if (null != fbJoinBySectionNo) {
//                        fbJoinService.fbRelieve(fbJoinBySectionNo.getId().longValue(), "退库自动解绑");
//                    }
//                }
//            }
//            //更新列表值
//            receiveDetail.setState(receive.getState());
//            receiveDetail.setHasGone(receive.getHasGone());
//            receiveDetail.setConfirmTime(receive.getConfirmTime());
//            receiveDetail.setConfirmUser(receive.getConfirmUser());
//            if (1 == receive.getState()) {
//                //解锁组托状态
//                PlanProcessingOrder planProcessingOrder = planProcessingOrderService.findByCode(receiveDetail.getCrystalNo());
//                if (null == planProcessingOrder) {
//                    throw new BusinessException(receiveDetail.getCrystalNo() + "工单号不存在");
//                }
//                planProcessingOrder.setStatus(EnumValuesFactory.PlanProcessingOrderStatus.加工中.getKey());
//                planProcessingOrderService.saveOrUpdate(planProcessingOrder);
//                //需求修改调整
//                //查询数据字典中接收类型的扩展字段
//                DictionaryItem dictionaryItem = null;
//                if (StringUtils.isNotBlank(receiveDetail.getCrystalNo()) && StringUtils.isNotBlank(receiveDetail.getQuitType()) && receiveDetail.getQuitType().contains("复检")) {
//                    dictionaryItem = dictionaryItemService.findByThemeValueAndValue("withdrawing_type", receiveDetail.getQuitType());
//                }
//                Integer isDirectIn = EnumValuesFactory.WipStorageStatus.待进站.getKey();
//                if (null != dictionaryItem && StringUtils.equals(dictionaryItem.getExtendValue(), "1")) {
//                    isDirectIn = EnumValuesFactory.WipStorageStatus.已进站.getKey();
//                }
//                //当去向为‘方棒反切’时，MES将晶段的站点更新为方棒工序的‘截断待进站’；
//                Result result;
//                if (null != receive.getHasGone() && "方棒反切".equals(receive.getHasGone())) {
//                    //执行出站操作---WMS出站---截断待进站
//                    result = wipStorageService.outStation(receiveDetail.getCrystalNo(), "B", EnumValuesFactory.WipStorageStatus.待进站.getKey());
//                } else {
//                    //执行出站操作---WMS出站---方棒检验
//                    result = wipStorageService.outStation(receiveDetail.getCrystalNo(), "A", isDirectIn, false);
//                }
//
//                if (result.getCode() != ResultCode.SUCCESS.getCode()) {
//                    //手动回滚事务
//                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                    throw new RuntimeException(result.getMessage());
//                }
//                //更新检验数据库
//                if (receiveDetail.getQuitType().contains("复检")) {
//                    //改为检验数据录入时赋值
////                    FbCheckOutData sectionNo = checkOutDataService.findDataByFbSectionNo(receiveDetail.getCrystalNo());
////                    if (null != sectionNo) {
////                        int reCheck = 1;
////                        if (null != sectionNo.getReCheckType()) {
////                            reCheck = Integer.parseInt(sectionNo.getReCheckType()) + 1;
////                        }
////                        sectionNo.setReCheckType(String.valueOf(reCheck));
////                        //更新订单类型
////                        sectionNo.setOrderType("ZH04");
////                        sectionNo.setCheckoutName(receiveDetail.getQuitType());
////                        sectionNo.setCheckType(receiveDetail.getQuitType());
////                        checkOutDataService.saveOrUpdate(sectionNo);
////                    }
//                }
//            }
//            receiveDetailService.saveOrUpdate(receiveDetail);
//        }
//        //更新主表
//        saveOrUpdate(receive);
        RecheckInspectReceive recheckInspectReceiveDb = get(receive.getId());
        Assert.notNull(recheckInspectReceiveDb, "退库复检数据不存在");
        Assert.isTrue(recheckInspectReceiveDb.getState() == 0, "此退库复检数据不属于接收或拒绝范围内");
        recheckInspectReceiveDb.setState(receive.getState());
//        修改主表
        saveOrUpdate(recheckInspectReceiveDb);
//        修改明细表
        List<RecheckInspectReceiveDetail> recheckInspectReceiveDetailList = receiveDetailService.findByRecheckReceiveId(recheckInspectReceiveDb.getId());
        if (!CollectionUtils.isEmpty(recheckInspectReceiveDetailList)) {
            recheckInspectReceiveDetailList.forEach(recheckInspectReceiveDetail -> {
                recheckInspectReceiveDetail.setState(receive.getState());
                receiveDetailService.saveOrUpdate(recheckInspectReceiveDetail);
            });
        }
        //        通知wms
        ArrayList<RemesstaDto> list = new ArrayList<>();
        RemesstaDto dto = new RemesstaDto();
        dto.setOrganizationid("JINKO");
        dto.setWarehouseid("5041");
        dto.setCustomerid("5041");
        dto.setDocno(receive.getOutOrderNo());
        dto.setAufn(receive.getId().toString());
        dto.setTraceid(receive.getTrayNo());
        dto.setSerialno(receive.getTrayNo());
        if (receive.getState()==1){
            dto.setBillresult("S");
        }else if (receive.getState()==2){
            dto.setBillresult("C");
        }
        list.add(dto);
        Result remessta = ybFeignClients.remessta(list);
        if (!remessta.getCode().equals(200)) {
            throw new RuntimeException("调用成品返工车间MES接收状态回传接口");
        }
    }

    @Override
    public Result mesToWmsReceipt(String outOrderNo, Integer state) {
        MesToWmsReceiptDto mesToWmsReceiptDto = new MesToWmsReceiptDto();
        MesToWmsReceiptDataDto mesToWmsReceiptDataDto = new MesToWmsReceiptDataDto();
        mesToWmsReceiptDataDto.setOrderNum(outOrderNo);
        mesToWmsReceiptDataDto.setIsReceive("S");
        if (2 == state) {
            mesToWmsReceiptDataDto.setIsReceive("E");
        }
        //调用接口
        String jsonString = JSON.toJSONString(mesToWmsReceiptDataDto);
        mesToWmsReceiptDto.setZDATA(jsonString);
        String content = JSON.toJSONString(mesToWmsReceiptDto);
        String url = wmsUrl + "api/YC6MES/otherinteraction";
        String send = send(content, url);
        if (null != send && send.contains("\"ztype\":\"E\"")) {
            return ResultGenerator.fail(send);
        }
        return ResultGenerator.success();
    }

    @Override
    public void audit(Integer id, Integer state) {
        RecheckInspectReceive recheckInspectReceiveDb = get(id);
        Assert.notNull(recheckInspectReceiveDb, "退库复检数据不存在");
        Assert.isTrue(recheckInspectReceiveDb.getState() == 0, "此退库复检数据不属于接收或拒绝范围内");
        recheckInspectReceiveDb.setState(state);
//        修改主表
        saveOrUpdate(recheckInspectReceiveDb);
//        修改明细表
        List<RecheckInspectReceiveDetail> recheckInspectReceiveDetailList = receiveDetailService.findByRecheckReceiveId(id);
        if (!CollectionUtils.isEmpty(recheckInspectReceiveDetailList)) {
            recheckInspectReceiveDetailList.forEach(recheckInspectReceiveDetail -> {
                recheckInspectReceiveDetail.setState(state);
                receiveDetailService.saveOrUpdate(recheckInspectReceiveDetail);
            });
        }
//        通知wms
        ArrayList<RemesstaDto> list = new ArrayList<>();
        RemesstaDto dto = new RemesstaDto();
        dto.setOrganizationid("JINKO");
        dto.setWarehouseid("5041");
        dto.setCustomerid("5041");
        dto.setDocno(recheckInspectReceiveDb.getOutOrderNo());
        dto.setAufn(recheckInspectReceiveDb.getId().toString());
        dto.setTraceid(recheckInspectReceiveDb.getTrayNo());
        dto.setSerialno(recheckInspectReceiveDb.getTrayNo());
        if (state==1){
            dto.setBillresult("S");
        }else if (state==2){
            dto.setBillresult("C");
        }
        list.add(dto);
        ybFeignClients.remessta(list);
    }

    @Override
    public void add(RecheckInspectReceive receive, List<RecheckInspectReceiveDetail> detailList) {
        saveOrUpdate(receive);
        if (!CollectionUtils.isEmpty(detailList)){
            for (RecheckInspectReceiveDetail recheckInspectReceiveDetail : detailList) {
                recheckInspectReceiveDetail.setRecheckReceiveId(receive.getId());
            }
            receiveDetailService.saveAll(detailList);
        }
    }

    private String send(String data, String url) {
        HttpHeaders headers = new HttpHeaders();
        MediaType mediaType = MediaType.parseMediaType("application/json; charset=UTF-8");
        headers.setContentType(mediaType);
        headers.add("Accept", MediaType.APPLICATION_JSON.toString());
        HttpEntity<String> httpEntity = new HttpEntity<>(data, headers);
        //使用exchange请求接口
        ResponseEntity<String> exchange = restTemplate.exchange(url, HttpMethod.POST, httpEntity, String.class);
        return exchange.getBody();
    }

}
