package com.sw.mes.inspect.service.impl;


import com.alibaba.excel.EasyExcel;
import com.alibaba.fastjson.JSON;
import com.sw.mes.base.factory.init.entity.CrystalMaterialRelation;
import com.sw.mes.base.factory.init.entity.Equipment;
import com.sw.mes.base.factory.init.entity.FactoryModel;
import com.sw.mes.base.factory.init.service.CrystalMaterialRelationService;
import com.sw.mes.base.factory.init.service.EquipmentService;
import com.sw.mes.base.factory.inspect.entity.EarlyWarningManagement;
import com.sw.mes.base.factory.inspect.entity.WarningRuleConfiguration;
import com.sw.mes.base.factory.inspect.service.DefaultCrystalAttrService;
import com.sw.mes.base.factory.inspect.service.DefaultSampleService;
import com.sw.mes.base.factory.inspect.service.EarlyWarningManagementService;
import com.sw.mes.base.factory.inspect.service.WarningRuleConfigurationService;
import com.sw.mes.base.factory.utils.excel.EasyExcelUtil;
import com.sw.mes.base.system.dto.InventoryManageLogExcelDto;
import com.sw.mes.base.system.entity.DictionaryItem;
import com.sw.mes.base.system.entity.InventoryManageLog;
import com.sw.mes.base.system.service.DictionaryItemService;
import com.sw.mes.base.system.service.InventoryManageLogService;
import com.sw.mes.base.system.service.SysLogService;
import com.sw.mes.base.workinprocess.dto.CurrentWipStorageStatusDto;
import com.sw.mes.base.workinprocess.entity.PlanProcessingOrder;
import com.sw.mes.base.workinprocess.service.PlanProcessingOrderService;
import com.sw.mes.base.workinprocess.service.WipStorageService;
import com.sw.mes.config.rabbit.InspectDataBaseChangeAsync;
import com.sw.mes.core.annotation.ServiceLogs;
import com.sw.mes.core.base.BaseServiceImpl;
import com.sw.mes.core.constant.Constants;
import com.sw.mes.core.context.BaseContextHandler;
import com.sw.mes.core.dto.RankResultDto;
import com.sw.mes.core.dto.YbInspectDataToMcsDto;
import com.sw.mes.core.dto.store.WarehouseInputReturnDto;
import com.sw.mes.core.enums.EnumValues;
import com.sw.mes.core.enums.EnumValuesFactory;
import com.sw.mes.core.enums.SectionIndexRangeEnum;
import com.sw.mes.core.exception.BusinessException;
import com.sw.mes.core.response.Result;
import com.sw.mes.core.response.ResultCode;
import com.sw.mes.core.response.ResultGenerator;
import com.sw.mes.core.utils.BeanUtil;
import com.sw.mes.core.utils.DynamicSpecifications;
import com.sw.mes.core.utils.MathUtils;
import com.sw.mes.core.utils.NumberUtil;
import com.sw.mes.enumvalue.EnumValuesServer;
import com.sw.mes.grade.entity.RuleTest;
import com.sw.mes.grade.entity.RuleTestData;
import com.sw.mes.grade.service.GradeService;
import com.sw.mes.grade.service.RuleTestDataService;
import com.sw.mes.grade.service.RuleTestService;
import com.sw.mes.gread.common.EnumValuesGrade;
import com.sw.mes.gread.entity.FieldPool;
import com.sw.mes.gread.service.FieldPoolService;
import com.sw.mes.inspect.dao.YbInspectDataDao;
import com.sw.mes.inspect.dto.YbInspectDataCUDto;
import com.sw.mes.inspect.dto.YbInspectDataSideLengthUpdateDto;
import com.sw.mes.inspect.entity.YbInspectData;
import com.sw.mes.inspect.entity.YbInspectDataLog;
import com.sw.mes.inspect.service.YbInspectDataLogService;
import com.sw.mes.inspect.service.YbInspectDataService;
import com.sw.mes.sap.entity.ReportSapGoodsmvt;
import com.sw.mes.sap.entity.ReportSapWorkinghours;
import com.sw.mes.sap.service.ReportSapGoodsmvtService;
import com.sw.mes.sap.service.ReportSapWorkinghoursService;
import com.sw.mes.utils.ExcelUtil;
import com.sw.mes.utils.StringUtils;
import com.sw.mes.wipstorage.service.WipStorageYbService;
import com.sw.mes.yb.check.dao.PieceCheckDAO;
import com.sw.mes.yb.check.entity.PieceCheck;
import com.sw.mes.yb.check.service.PieceCheckService;
import com.sw.mes.yb.mcs.service.CodingRecordService;
import com.sw.mes.yb.pad.dao.PieceDetailDao;
import com.sw.mes.yb.pad.dao.SectionNoDetailDao;
import com.sw.mes.yb.pad.entity.*;
import com.sw.mes.yb.pad.service.ProductionPaintingLineDetailService;
import com.sw.mes.yb.pad.service.ProductionPaintingLineService;
import com.sw.mes.yb.pad.service.ProductionRecutService;
import com.sw.mes.yb.pad.service.SectionNoDetailService;
import com.sw.mes.yb.pc.dto.GetFbInfoDto;
import com.sw.mes.yb.pc.entity.DataInspectLog;
import com.sw.mes.yb.pc.service.DataInspectLogService;
import com.sw.mes.yb.plan.entity.ProductionOrder;
import com.sw.mes.yb.plan.service.ProductionOrderService;
import com.sw.mes.yb.production.entity.LongCrystal;
import com.sw.mes.yb.production.entity.OutgoMarkOperate;
import com.sw.mes.yb.production.service.CrystalBatchOperationService;
import com.sw.mes.yb.production.service.LongCrystalService;
import com.sw.mes.yb.production.service.OutgoMarkOperateService;
import com.sw.mes.yb.seed.enums.InputBillStatusEnum;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.util.Assert;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;
import java.util.stream.Collectors;


/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Slf4j
@Service
@Transactional
public class YbInspectDataServiceImpl extends BaseServiceImpl<YbInspectData> implements YbInspectDataService {
    YbInspectDataDao dao;

    @Autowired
    public void setDao(YbInspectDataDao dao) {
        super.setBaseDao(dao);
        this.dao = dao;
    }

    @Autowired
    private GradeService gradeService;

    @Autowired
    private PlanProcessingOrderService planProcessingOrderService;

    @Autowired
    private RuleTestService ruleTestService;

    @Autowired
    private RuleTestDataService ruleTestDataService;

    @Autowired
    private WipStorageService wipStorageService;

    @Autowired
    private InspectDataBaseChangeAsync inspectDataBaseChangeAsync;

    @Autowired
    private YbInspectDataLogService ybInspectDataLogService;

    @Autowired
    private ProductionRecutService productionRecutService;
    @Autowired
    private ProductionPaintingLineDetailService productionPaintingLineDetailService;
    @Autowired
    private ProductionPaintingLineService productionPaintingLineService;
    @Autowired
    private SectionNoDetailDao sectionNoDetailDao;
    @Autowired
    private DictionaryItemService dictionaryItemService;
    @Autowired
    private PieceDetailDao pieceDetailDao;
    @Autowired
    private SysLogService sysLogService;

    @Autowired
    private PieceCheckDAO pieceCheckDAO;

    @Autowired
    private DataInspectLogService dataInspectLogService;

    @Autowired
    private CodingRecordService codingRecordService;

    @Autowired
    InventoryManageLogService inventoryManageLogService;

    @Autowired
    private YbInspectDataService ybInspectDataService;


    @Autowired
    private CrystalBatchOperationService crystalBatchOperationService;

    @Autowired
    private WarningRuleConfigurationService warningRuleConfigurationService;

    @Autowired
    private EarlyWarningManagementService earlyWarningManagementService;

    @Autowired
    private FieldPoolService fieldPoolService;

    private static final String T = "1Y";
    private static final String W = "1Y";

    @Override
    public void exportExcel(HttpServletRequest request, HttpServletResponse response) {
        Specification<InventoryManageLog> specification = DynamicSpecifications.bySearchFilter(request, InventoryManageLog.class);
        List<InventoryManageLog> InventoryManageLogs = inventoryManageLogService.findByExampleSort(specification, null);
        try {
//            List<String> sectionNos = InventoryManageLogs.stream().map(InventoryManageLog::getRoundSn).collect(Collectors.toList());
//            List<YbInspectData> ybInspectDataList = this.findBySections(sectionNos);
            List<InventoryManageLogExcelDto> inventoryManageLogExcelDtoList = new ArrayList<>();
            if (!InventoryManageLogs.isEmpty()) {
                InventoryManageLogs.stream().forEach(inventoryManageLog -> {
                    InventoryManageLogExcelDto inventoryManageLogExcelDto = new InventoryManageLogExcelDto();
                    YbInspectData ybInspectData = this.findBySectionNo(inventoryManageLog.getRoundSn());
                    if (null != ybInspectData) {
                        inventoryManageLogExcelDto.setOrderNo(ybInspectData.getOrderNo());
                        inventoryManageLogExcelDto.setMaterialCode(ybInspectData.getMaterialCode());
                        inventoryManageLogExcelDto.setProductTypeSecond(ybInspectData.getProductTypeSecond());
                        inventoryManageLogExcelDto.setCheckoutName(ybInspectData.getCheckoutName());
                        inventoryManageLogExcelDto.setProductLevel(ybInspectData.getProductLevel());
                        inventoryManageLogExcelDto.setProductLevelExperiment(ybInspectData.getProductLevelExperiment());
                        inventoryManageLogExcelDto.setConductiveType(ybInspectData.getConductiveType());
                        inventoryManageLogExcelDto.setActualLength(ybInspectData.getActualLength());
                        inventoryManageLogExcelDto.setActualWeight(ybInspectData.getActualWeight());
                    }
                    inventoryManageLogExcelDto.setSectionNo(inventoryManageLog.getRoundSn());
                    inventoryManageLogExcelDto.setCreateTime(inventoryManageLog.getCreateTime());
                    inventoryManageLogExcelDtoList.add(inventoryManageLogExcelDto);
                });
            }
            EasyExcelUtil.setResponse(response);
            EasyExcel.write(response.getOutputStream(), InventoryManageLogExcelDto.class).sheet("出入库记录导出Excel").doWrite(inventoryManageLogExcelDtoList);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    public List<YbInspectData> findBySections(List<String> sectionNoList) {
        return dao.findBySections(sectionNoList);
    }

    @Override
    public Map<String, Object> findBySectionNoMap(String sectionNo) {
        List<Map<String, Object>> inspectData = dao.findBySectionNoMap(sectionNo);
        if (inspectData != null && inspectData.size() > 0) {
            return inspectData.get(0);
        }
        return null;
    }

    @Override
    public YbInspectData findBySectionNo(String sectionNo) {
        List<YbInspectData> inspectData = dao.findBySectionNo(sectionNo);
        if (inspectData != null && inspectData.size() > 0) {
            return inspectData.get(0);
        }
        return null;
    }

    @Override
    public List<YbInspectData> getInspectDatasByCrystalNo(String crystalNo) {
        List<YbInspectData> datas = dao.getInspectDatasByCrystalNo(crystalNo);
        if (datas != null && datas.size() > 0) {
            return datas;
        }
        return null;
    }

    @Override
    public YbInspectData getSectionNo(String sectionNo) {
        sectionNo = sectionNo + "%";
        List<YbInspectData> inspectData = dao.getSectionNo(sectionNo);
        if (inspectData != null && inspectData.size() > 0) {
            return inspectData.get(0);
        }
        return null;
    }


    /**
     * 根据晶段编号获取 圆棒检验数据库详细信息
     *
     * @param sectionNo
     * @return
     */
    @Override
    public YbInspectDataCUDto getYbInspectDataDto(String sectionNo) {
        sectionNo = com.sw.mes.core.utils.StringUtils.trim(sectionNo);
        wipStorageService.selectWipStorage(sectionNo, EnumValuesFactory.WipStorageCode.圆棒检验.getKey(), false);
        YbInspectData ybInspectData = this.findBySectionNo(sectionNo);
        if (null == ybInspectData) {
            ybInspectData = new YbInspectData();
            // 通过圆棒编号 去追溯表判断晶段是否存在
            SectionNoDetail sectionNoDetail = sectionNoDetailService.findBySectionNo(sectionNo);
            if (sectionNoDetail == null) {
                throw new RuntimeException(sectionNo + "晶段信息不存在，数据异常");
            }
            LongCrystal longCrystal = longCrystalService.get(sectionNoDetail.getCrystalId());
            if (longCrystal == null) {
                throw new RuntimeException(sectionNo + "长棒信息不存在，数据异常");
            }
            ybInspectData.setSectionNo(sectionNo);
            ybInspectData.setDiameterMax(longCrystal.getMaxDiam());
            ybInspectData.setDiameterMin(longCrystal.getMinDiam());
            this.initInspectData(ybInspectData, sectionNoDetail, longCrystal);
        }
        YbInspectDataCUDto ybInspectDataCuDto = new YbInspectDataCUDto();
        BeanUtil.copyBeanPropWithNullValue(ybInspectDataCuDto, ybInspectData, "id");
        return ybInspectDataCuDto;
    }

    @Override
    public List<YbInspectData> findByLotNo(String lotNo) {
        return dao.findByLotNo(lotNo);
    }

    @Override
    public void updateOrderTypeBySectionNoList(List<String> sectionNoList, String orderType, String checkoutName) {
        if (CollectionUtils.isNotEmpty(sectionNoList)) {
            dao.updateOrderTypeBySectionNoList(sectionNoList, orderType, checkoutName);
        }
    }

    @Override
    public void updateOrderTypeBySectionNoListNoType(List<String> sectionNoList, String orderType, String checkoutName) {
        if (CollectionUtils.isNotEmpty(sectionNoList)) {
            dao.updateOrderTypeBySectionNoListNoType(sectionNoList, orderType, checkoutName);
        }
    }


    @Override
    public Integer updateSticksCountFbSectionNoList(List<String> sectionNoList, Integer sticksCount, BigDecimal totalLength, String sectionType, String SectionNoGroup) {
        return dao.updateSticksCountFbSectionNoList(sectionNoList, sticksCount, totalLength, sectionType, SectionNoGroup);
    }

    @Autowired
    private SectionNoDetailService sectionNoDetailService;
    @Autowired
    private LongCrystalService longCrystalService;
    @Autowired
    private ProductionOrderService productionOrderService;
    @Autowired
    private DefaultCrystalAttrService defaultCrystalAttrService;
    @Autowired
    private DefaultSampleService defaultSampleService;

    @Autowired
    private PieceCheckService pieceCheckService;

    @Autowired
    private OutgoMarkOperateService outgoMarkOperateService;

    @Autowired
    private WipStorageYbService wipStorageYbService;

    @Autowired
    private ReportSapGoodsmvtService reportSapGoodsmvtService;

    @Autowired
    private ReportSapWorkinghoursService reportSapWorkinghoursService;
    @Autowired
    private CrystalMaterialRelationService crystalMaterialRelationService;

    @Autowired
    private EquipmentService equipmentService;

    @Override
    public Result saveYbInspectData(YbInspectDataCUDto ybInspectDataCdto) {

        /**
         * 根据头尾信息自动计算中间段
         * 1、查询是否开启：开启则自动计算
         * 2、需要头部头信息及尾部尾信息都存在并且电性能合格才计算
         * 3、需要查询划线明细找到所有单晶计算系数
         *
         * 1. （头中心电阻-尾中心电阻）/（1Y长度+2Y长度+3Y长度.........+WY长度）=C(系数)
         * 2. 1Y、2Y、3Y......WY电性能必须为合格( 电阻范围0.4-1.1；  寿命大于70（W寿命）)
         * 3. 边缘电阻=中心电阻+0.1
         *
         * （B=W ;A=T）
         * 1. 1Y的B面电阻=2Y的A面电阻，2Y的B面电阻=3Y的A面电阻.........以此类推
         * 4. 1Y的B面中心电阻=头部中心电阻-（C*1Y的长度），1Y的B边缘电阻=1Y的B面中心电阻+0.1
         * 5. 2Y的B面中心电阻=1Y的B面中心电阻-（C*2Y的长度），2Y的B边缘电阻=2Y的B面中心电阻+0.1，
         * 6. 3Y的B面中心电阻=2Y的B面中心电阻-（C*3Y的长度），3Y的B边缘电阻=3Y的B面中心电阻+0.1，
         * 7. 寿命计算公式同上
         * 8. 唯一不同，边缘寿命=中心寿命+80
         *
         * 当头段尾段数据发生反切时，中间段寿命、电阻率不随着发生变化；反切情况，中间段可不需考虑。
         */

        Boolean whetherAllInput = false;
       /* //查询数据字典
        List<DictionaryItem> automaticCalculation = dictionaryItemService.findByThemeValueAndEnable("automaticCalculation", true);
        Map<String, String> collect = automaticCalculation.stream().collect(Collectors.toMap(DictionaryItem::getName, DictionaryItem::getValue));
        if (collect.containsKey("是否开启") && collect.get("是否开启").equals("1")) {

            List<ProductionPaintingLineDetail> productionPaintingLineDetails = new ArrayList<>();
            YbInspectData bySectionNo;
            //电阻率
            BigDecimal tRadialCentre = new BigDecimal(0);
            BigDecimal tRadialEdge1 = new BigDecimal(0);
            BigDecimal tRadialEdge2 = new BigDecimal(0);
            BigDecimal wRadialCentre = new BigDecimal(0);
            BigDecimal wRadialEdge1 = new BigDecimal(0);
            BigDecimal wRadialEdge2 = new BigDecimal(0);

            //寿命
            BigDecimal tCentreLife = new BigDecimal(0);
            BigDecimal tLifeEdge1 = new BigDecimal(0);
            BigDecimal tLifeEdge2 = new BigDecimal(0);
            BigDecimal wCentreLife = new BigDecimal(0);
            BigDecimal wLifeEdge11 = new BigDecimal(0);
            BigDecimal wLifeEdge12 = new BigDecimal(0);

            BigDecimal resistivityCoefficient = new BigDecimal(0);
            BigDecimal lifeCoefficient = new BigDecimal(0);

            //判断TW段信息是否全部录入以及电性能是否合格
            if (ybInspectDataCdto.getSectionNo().endsWith("1Y")) {
                String sectionNo = ybInspectDataCdto.getSectionNo().substring(0, ybInspectDataCdto.getSectionNo().lastIndexOf("1Y")) + "WY";
                bySectionNo = ybInspectDataService.findBySectionNo(sectionNo);
                if (null != bySectionNo) {
                    tRadialCentre = ybInspectDataCdto.getTRadialCentre();
                    tRadialEdge1 = ybInspectDataCdto.getTRadialEdge1();
                    tRadialEdge2 = ybInspectDataCdto.getTRadialEdge2();
                    wRadialCentre = bySectionNo.getWRadialCentre();
                    wRadialEdge1 = bySectionNo.getWLifeEdge1();
                    wRadialEdge2 = bySectionNo.getWLifeEdge2();

                    tCentreLife = ybInspectDataCdto.getTCentreLife();
                    tLifeEdge1 = ybInspectDataCdto.getTLifeEdge1();
                    tLifeEdge2 = ybInspectDataCdto.getTLifeEdge2();
                    wCentreLife = bySectionNo.getWCentreLife();
                    wLifeEdge11 = bySectionNo.getWLifeEdge1();
                    wLifeEdge12 = bySectionNo.getWLifeEdge2();
                }

            }
            if (ybInspectDataCdto.getSectionNo().endsWith("WY")) {
                String sectionNo = ybInspectDataCdto.getSectionNo().substring(0, ybInspectDataCdto.getSectionNo().lastIndexOf("WY")) + "1Y";
                bySectionNo = ybInspectDataService.findBySectionNo(sectionNo);
                if (null != bySectionNo) {
                    tRadialCentre = bySectionNo.getTRadialCentre();
                    tRadialEdge1 = bySectionNo.getTRadialEdge1();
                    tRadialEdge2 = bySectionNo.getTRadialEdge2();
                    wRadialCentre = ybInspectDataCdto.getWRadialCentre();
                    wRadialEdge1 = ybInspectDataCdto.getWRadialEdge1();
                    wRadialEdge2 = ybInspectDataCdto.getWRadialEdge2();

                    tCentreLife = bySectionNo.getTCentreLife();
                    tLifeEdge1 = bySectionNo.getTLifeEdge1();
                    tLifeEdge2 = bySectionNo.getTLifeEdge2();
                    wCentreLife = ybInspectDataCdto.getWCentreLife();
                    wLifeEdge11 = ybInspectDataCdto.getWLifeEdge1();
                    wLifeEdge12 = ybInspectDataCdto.getWLifeEdge2();
                }
            }

            if (collect.containsKey("电阻范围") && collect.containsKey("寿命范围（大于）")) {
                String[] radialRange = collect.get("电阻范围").split("-");
                String[] lifeRange = collect.get("寿命范围（大于）").split("-");
                if (null != tRadialCentre && tRadialCentre.compareTo(new BigDecimal(Double.valueOf(radialRange[0]))) > 0 && tRadialCentre.compareTo(new BigDecimal(Double.valueOf(radialRange[1]))) < 0
                        && null != tCentreLife && tCentreLife.compareTo(new BigDecimal(Double.valueOf(lifeRange[0]))) > 0 && null != wCentreLife && wCentreLife.compareTo(new BigDecimal(Double.valueOf(lifeRange[0]))) > 0) {
                    whetherAllInput = true;
                }
            }

            if (whetherAllInput) {
                BigDecimal totalLength = new BigDecimal(0);
                //查询画线记录
                ProductionPaintingLineDetail bySegmentNo = productionPaintingLineDetailService.findBySegmentNo(ybInspectDataCdto.getSectionNo());
                Long crystalId = bySegmentNo.getCrystalId();
                List<ProductionPaintingLineDetail> byCrystalId = productionPaintingLineDetailService.findByCrystalId(crystalId);
                LongCrystal longCrystal = longCrystalService.get(crystalId);
                if (CollectionUtils.isNotEmpty(byCrystalId)) {
                    productionPaintingLineDetails = byCrystalId.stream().filter(productionPaintingLineDetail -> productionPaintingLineDetail.getOperateReversecutDrawId() == 0 && productionPaintingLineDetail.getType() == 0).collect(Collectors.toList());
                    for (ProductionPaintingLineDetail productionPaintingLineDetail : productionPaintingLineDetails) {
                        totalLength = totalLength.add(productionPaintingLineDetail.getLength());
                    }
                    productionPaintingLineDetails.sort(Comparator.comparing(ProductionPaintingLineDetail::getId));
                }

                List<DictionaryItem> itemList = dictionaryItemService.findItemByThemeValue("WeightRatio", true);
                Map<String, String> weightCoefficient = itemList.stream().collect(Collectors.toMap(DictionaryItem::getName, DictionaryItem::getValue));

                //计算电阻率系数
                if (totalLength.compareTo(new BigDecimal(0)) > 0) {
                    resistivityCoefficient = tRadialCentre.subtract(wRadialCentre).divide(totalLength, 10, BigDecimal.ROUND_HALF_UP);
                }

                //计算寿命系数
                if (totalLength.compareTo(new BigDecimal(0)) > 0) {
                    lifeCoefficient = tCentreLife.subtract(wCentreLife).divide(totalLength, 10, BigDecimal.ROUND_HALF_UP);
                }

                Double[] resistivityList = new Double[productionPaintingLineDetails.size()];
                Double[] lifeList = new Double[productionPaintingLineDetails.size()];

                for (int i = 0; i < productionPaintingLineDetails.size(); i++) {
                    YbInspectDataCUDto ybInspectDataCUDto1 = new YbInspectDataCUDto();
                    ybInspectDataCUDto1.setSectionNo(productionPaintingLineDetails.get(i).getNo());
                    ybInspectDataCUDto1.setActualLength(productionPaintingLineDetails.get(i).getLength());
                    ybInspectDataCUDto1.setActualWeight(productionPaintingLineDetails.get(i).getLength().divide(new BigDecimal(weightCoefficient.get(longCrystal.getSpecs())), 3, BigDecimal.ROUND_HALF_UP));
                    ybInspectDataCUDto1.setProductTypeSecond(longCrystal.getSpecs());
                    ybInspectDataCUDto1.setConductiveType(longCrystal.getConductiveType());
                    ybInspectDataCUDto1.setDopant(longCrystal.getDopant());
                    ybInspectDataCUDto1.setDiameterMax(longCrystal.getMaxDiam());
                    ybInspectDataCUDto1.setDiameterMin(longCrystal.getMinDiam());
                    ybInspectDataCUDto1.setCheckReback("无");
                    ybInspectDataCUDto1.setSideLengthRange(longCrystal.getSideLengthRange());
                    ybInspectDataCUDto1.setEdgeBark(new BigDecimal(0));
                    ybInspectDataCUDto1.setCollapseLine(new BigDecimal(0));
                    ybInspectDataCUDto1.setDistortion(new BigDecimal(0));
                    ybInspectDataCUDto1.setSlopeLength(new BigDecimal(0));
                    ybInspectDataCUDto1.setCrack(new BigDecimal(0));

                    if (i == 0) {
                        ybInspectDataCUDto1.setTRadialCentre(tRadialCentre);
                        ybInspectDataCUDto1.setTRadialEdge1(tRadialEdge1);
                        ybInspectDataCUDto1.setTRadialEdge2(tRadialEdge2);
                        ybInspectDataCUDto1.setTCentreLife(tCentreLife);
                        ybInspectDataCUDto1.setTLifeEdge1(tLifeEdge1);
                        ybInspectDataCUDto1.setTLifeEdge2(tLifeEdge2);

                    } else {
                        BigDecimal resistivity = new BigDecimal(resistivityList[i - 1]);
                        BigDecimal life = new BigDecimal(lifeList[i - 1]);
                        ybInspectDataCUDto1.setTRadialCentre(resistivity);
                        ybInspectDataCUDto1.setTRadialEdge1(resistivity.add(new BigDecimal(collect.get("电阻率边缘（加）"))));
                        ybInspectDataCUDto1.setTRadialEdge2(resistivity.add(new BigDecimal(collect.get("电阻率边缘（加）"))));
                        ybInspectDataCUDto1.setTCentreLife(life);
                        ybInspectDataCUDto1.setTLifeEdge1(life.add(new BigDecimal(collect.get("寿命边缘（加）"))));
                        ybInspectDataCUDto1.setTLifeEdge2(life.add(new BigDecimal(collect.get("寿命边缘（加）"))));

                    }

                    if (i == productionPaintingLineDetails.size() - 1) {
                        ybInspectDataCUDto1.setWRadialCentre(wRadialCentre);
                        ybInspectDataCUDto1.setWRadialEdge1(wRadialEdge1);
                        ybInspectDataCUDto1.setWRadialEdge2(wRadialEdge2);
                        ybInspectDataCUDto1.setWCentreLife(wCentreLife);
                        ybInspectDataCUDto1.setWLifeEdge1(wLifeEdge11);
                        ybInspectDataCUDto1.setWLifeEdge2(wLifeEdge12);
                    } else if (i == 0) {
                        supplementaryData(collect, resistivityCoefficient, lifeCoefficient, productionPaintingLineDetails, ybInspectDataCUDto1, resistivityList, lifeList, i, tRadialCentre, tCentreLife);
                    } else {
                        BigDecimal resistivity = new BigDecimal(resistivityList[i - 1]);
                        BigDecimal life = new BigDecimal(lifeList[i - 1]);
                        supplementaryData(collect, resistivityCoefficient, lifeCoefficient, productionPaintingLineDetails, ybInspectDataCUDto1, resistivityList, lifeList, i, resistivity, life);
                    }
                    if ((ybInspectDataCdto.getSectionNo().endsWith("1Y") && ybInspectDataCUDto1.getSectionNo().endsWith("WY")) ||
                            (ybInspectDataCdto.getSectionNo().endsWith("WY") && ybInspectDataCUDto1.getSectionNo().endsWith("1Y"))) {
                        continue;
                    }
                    List<ProductionBackCuttingRecord> allBySegmentNo = productionRecutService.findAllBySegmentNo1(ybInspectDataCUDto1.getSectionNo());
                    if (CollectionUtils.isNotEmpty(allBySegmentNo)) {
                        continue;
                    }
                    execYbInspectData(ybInspectDataCUDto1);
                }
            }
        }*/

        //原来只有这部分，上面的代码为新增代码
        if (!whetherAllInput) {
            Result result = execYbInspectData(ybInspectDataCdto);
            return result;
        }
        return ResultGenerator.success();
    }

    @Override
    public Result saveYbInspectDataNew(YbInspectDataCUDto ybInspectDataCdto) {

        /**
         对于电阻率，逻辑是根据后面的电阻率 1，电阻率 2，电阻率3的3 个值取平均值到电阻率即可。T寿命，W 寿命的逻辑和电阻率保持一致。
         */
        //电阻率计算 A
        BigDecimal divideDecimal = new BigDecimal(3);
        if (null == ybInspectDataCdto.getMeanResistivityA()){
            BigDecimal resistivityAOne = null == ybInspectDataCdto.getResistivityAOne() ? BigDecimal.ZERO : ybInspectDataCdto.getResistivityAOne();
            BigDecimal resistivityATwo = null == ybInspectDataCdto.getResistivityATwo() ? BigDecimal.ZERO : ybInspectDataCdto.getResistivityATwo();
            BigDecimal resistivityAThree = null == ybInspectDataCdto.getResistivityAThree() ? BigDecimal.ZERO : ybInspectDataCdto.getResistivityAThree();
            ybInspectDataCdto.setMeanResistivityA((resistivityAOne.add(resistivityATwo).add(resistivityAThree)).divide(divideDecimal,2, BigDecimal.ROUND_HALF_UP));

        }
        //电阻率计算 B
        if (null == ybInspectDataCdto.getMeanResistivityB()){
            BigDecimal resistivityBOne = null == ybInspectDataCdto.getResistivityBOne() ? BigDecimal.ZERO : ybInspectDataCdto.getResistivityBOne();
            BigDecimal resistivityBTwo = null == ybInspectDataCdto.getResistivityBTwo() ? BigDecimal.ZERO : ybInspectDataCdto.getResistivityBTwo();
            BigDecimal resistivityBThree = null == ybInspectDataCdto.getResistivityBThree() ? BigDecimal.ZERO : ybInspectDataCdto.getResistivityBThree();
            ybInspectDataCdto.setMeanResistivityB((resistivityBOne.add(resistivityBTwo).add(resistivityBThree)).divide(divideDecimal,2, BigDecimal.ROUND_HALF_UP));
        }

        //A少子寿命均值
        if (null == ybInspectDataCdto.getMeanCarrierLifetimeA()){
            BigDecimal carrierLifetimeAOne = null == ybInspectDataCdto.getCarrierLifetimeAOne() ? BigDecimal.ZERO : ybInspectDataCdto.getCarrierLifetimeAOne();
            BigDecimal carrierLifetimeATwo = null == ybInspectDataCdto.getCarrierLifetimeATwo() ? BigDecimal.ZERO : ybInspectDataCdto.getCarrierLifetimeATwo();
            BigDecimal carrierLifetimeAThree = null == ybInspectDataCdto.getCarrierLifetimeAThree() ? BigDecimal.ZERO : ybInspectDataCdto.getCarrierLifetimeAThree();
            ybInspectDataCdto.setMeanCarrierLifetimeA((carrierLifetimeAOne.add(carrierLifetimeATwo).add(carrierLifetimeAThree)).divide(divideDecimal,2, BigDecimal.ROUND_HALF_UP));
        }
        //B少子寿命均值
        if (null == ybInspectDataCdto.getMeanCarrierLifetimeB()){
            BigDecimal carrierLifetimeBOne = null == ybInspectDataCdto.getCarrierLifetimeBOne() ? BigDecimal.ZERO : ybInspectDataCdto.getCarrierLifetimeBOne();
            BigDecimal carrierLifetimeBTwo = null == ybInspectDataCdto.getCarrierLifetimeBTwo() ? BigDecimal.ZERO : ybInspectDataCdto.getCarrierLifetimeBTwo();
            BigDecimal carrierLifetimeBThree = null == ybInspectDataCdto.getCarrierLifetimeBThree() ? BigDecimal.ZERO : ybInspectDataCdto.getCarrierLifetimeBThree();
            ybInspectDataCdto.setMeanCarrierLifetimeB((carrierLifetimeBOne.add(carrierLifetimeBTwo).add(carrierLifetimeBThree)).divide(divideDecimal,2, BigDecimal.ROUND_HALF_UP));
        }

        //添加卡控，圆棒检验，人工检验方式里数据录入变更:T(头段)只测A面和A(尾段)只测B面
        if (StringUtils.isBlank(ybInspectDataCdto.getSectionNo())){
            throw new BusinessException("检验晶段编号为空！");
        }
        if (ybInspectDataCdto.getSectionNo().endsWith("A") && (ybInspectDataCdto.getMeanCarrierLifetimeB().compareTo(BigDecimal.ZERO) <= 0 ||
                ybInspectDataCdto.getMeanResistivityB().compareTo(BigDecimal.ZERO) <= 0)){
            throw new BusinessException("尾段B面电阻率或少子寿命未检出！");
        }
        if (ybInspectDataCdto.getSectionNo().endsWith("T") && (ybInspectDataCdto.getMeanCarrierLifetimeA().compareTo(BigDecimal.ZERO) <= 0 ||
                ybInspectDataCdto.getMeanResistivityA().compareTo(BigDecimal.ZERO) <= 0)){
            throw new BusinessException("头段A面电阻率或少子寿命未检出！");
        }

        Result result = this.execYbInspectData(ybInspectDataCdto);
        return result;
    }

    private void supplementaryData(Map<String, String> collect, BigDecimal resistivityCoefficient, BigDecimal lifeCoefficient, List<ProductionPaintingLineDetail> byCrystalId, YbInspectDataCUDto ybInspectDataCUDto1, Double[] resistivityList, Double[] lifeList, int i, BigDecimal resistivity, BigDecimal life) {
        BigDecimal bwRadialCentre = resistivity.subtract(resistivityCoefficient.multiply(byCrystalId.get(i).getLength()));
        //ybInspectDataCUDto1.setWRadialCentre(bwRadialCentre);
        //ybInspectDataCUDto1.setWRadialEdge1(bwRadialCentre.add(new BigDecimal(collect.get("电阻率边缘（加）"))));
        ybInspectDataCUDto1.setWRadialEdge2(bwRadialCentre.add(new BigDecimal(collect.get("电阻率边缘（加）"))));

        BigDecimal bwCentreLife = life.subtract(lifeCoefficient.multiply(byCrystalId.get(i).getLength()));
        //ybInspectDataCUDto1.setWCentreLife(bwCentreLife);
       // ybInspectDataCUDto1.setWLifeEdge1(bwCentreLife.add(new BigDecimal(collect.get("寿命边缘（加）"))));
        ybInspectDataCUDto1.setWLifeEdge2(bwCentreLife.add(new BigDecimal(collect.get("寿命边缘（加）"))));

        resistivityList[i] = Double.valueOf(bwRadialCentre.toString());
        lifeList[i] = Double.valueOf(bwCentreLife.toString());
    }

    private Result execYbInspectData(YbInspectDataCUDto ybInspectDataCdto) {

        Result<CurrentWipStorageStatusDto> currentWipStorageStatusDtoResult = wipStorageService.selectWipStorageResult(ybInspectDataCdto.getSectionNo());
        if (currentWipStorageStatusDtoResult.getCode() != ResultCode.SUCCESS.getCode()) {
            throw new BusinessException(currentWipStorageStatusDtoResult.getMessage());
        }
        CurrentWipStorageStatusDto currentWipStorageStatusDto = currentWipStorageStatusDtoResult.getData();
        if (currentWipStorageStatusDto == null || currentWipStorageStatusDto.getWipStorageCode() == null || currentWipStorageStatusDto.getWipStorageStatus() == null) {
            throw new BusinessException("站点信息查询失败，请检查在制品信息");
        }

        //添加批次锁定校验
        crystalBatchOperationService.judgeCrystalNoIsLock(null,ybInspectDataCdto.getSectionNo(),false);
        //查询历史数据
        YbInspectData ybInspectDataOld = findBySectionNo(ybInspectDataCdto.getSectionNo());
        if (ybInspectDataOld != null) {
            ybInspectDataCdto.setId(ybInspectDataOld.getId());
            ybInspectDataCdto.setDopant(ybInspectDataOld.getDopant());
            ybInspectDataCdto.setProductTypeSecond(ybInspectDataOld.getProductTypeSecond());
            ybInspectDataCdto.setConductiveType(ybInspectDataOld.getConductiveType());
        }
        //是否处于圆棒检验待进站状态
        boolean isStatus = currentWipStorageStatusDto.getWipStorageCode().equals(EnumValuesFactory.WipStorageCode.圆棒检验.getKey())
                && currentWipStorageStatusDto.getWipStorageStatus() == EnumValuesFactory.WipStorageStatus.待进站.getKey();

        // 新增请求，并且不在圆棒检验待进站，将其变为修改请求
        if (ybInspectDataCdto.getId() == null && !isStatus) {
            if (ybInspectDataOld != null) {
                //把该条数据至为设备上传状态
                ybInspectDataCdto.setId(-1L);
            }
        }

        //新增数据
        if (ybInspectDataCdto.getId() == null) {
            return execAddYbInspectData(ybInspectDataCdto, ybInspectDataOld, isStatus);
        }
        //修改
        else {
            return execUpdateYbInspectData(ybInspectDataCdto, ybInspectDataOld, isStatus);
        }
    }

    @Override
    public Result updateYbInspectDataSideLengthRange(YbInspectDataSideLengthUpdateDto dto) {
        List<String> sectionNos = dto.getSectionNos();
        if (!sectionNos.isEmpty()) {
            for (String sectionNo : sectionNos) {
                SectionNoDetail sectionNoDetail = sectionNoDetailService.findBySectionNo(sectionNo);

                if (null != sectionNoDetail) {
                    LongCrystal longCrystal = longCrystalService.get(sectionNoDetail.getCrystalId());

                    //查询历史数据
                    YbInspectData ybInspectDataOld = findBySectionNo(sectionNo);
                    if (!longCrystal.getSideLengthRange().isEmpty() && null != ybInspectDataOld && (ybInspectDataOld.getSideLengthRange() == null || ybInspectDataOld.getSideLengthRange().isEmpty())) {
                        //多边距字段赋值
                        ybInspectDataOld.setSideLengthRange(longCrystal.getSideLengthRange());
                        saveOrUpdate(ybInspectDataOld);
                    }
                }
            }
        }
        return ResultGenerator.success();
    }

    @Override
    public Result updateYbInspectResistivity(YbInspectDataCUDto ybInspectDataCdto) {
        //查询历史数据
        YbInspectData ybInspectDataOld = findBySectionNo(ybInspectDataCdto.getSectionNo());
        Assert.notNull(ybInspectDataOld, "当前晶棒无检验信息！");

        BeanUtil.copyBeanPropWithOutNullValue(ybInspectDataOld, ybInspectDataCdto, "id");
        ybInspectDataOld.setUpdateTime(new Date());
        ybInspectDataOld.setUpdateUser(BaseContextHandler.getUsername());
        saveOrUpdate(ybInspectDataOld);
        saveDataInspectLog(ybInspectDataOld);//保存圆棒检验记录表
        return ResultGenerator.success("操作成功！");
    }

    /**
     * 执行圆棒检验数据新增
     *
     * @param ybInspectDataCdto 本次上传的检验数据
     * @param ybInspectDataOld  该晶段的历史数据
     * @param isStatus          当前在制品状态是否满足 圆棒检验[待进站]
     * @return 是否成功
     */
    private Result execAddYbInspectData(YbInspectDataCUDto ybInspectDataCdto, YbInspectData ybInspectDataOld, boolean isStatus) {
        String sectionNo = ybInspectDataCdto.getSectionNo();
        // 处于圆棒检验待进站状态的新增请求，就处理过站操作
        if (isStatus) {
            Result result = wipStorageService.inStation(ybInspectDataCdto.getSectionNo(), null, false);
            if (result.getCode() != ResultCode.SUCCESS.getCode()) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return result;
            }
        }
        //添加判断，对于样片值的获取，其中T段，T02 段，w 段，需要等待样片实际值出来后进行流转，否则则进库等待，其余段可以直接流转
        Boolean waitSampleFlag = sectionNo.endsWith("A") || sectionNo.endsWith("T");
        String pieceNoHead = "";
        String pieceNoEnd = "";
        // 第一次检验新增，初始化数据
        if (ybInspectDataOld == null) {
            ybInspectDataOld = new YbInspectData();
            ybInspectDataOld.setSectionNo(sectionNo);
            // 通过圆棒编号 去追溯表判断晶段是否存在
            SectionNoDetail sectionNoDetail = sectionNoDetailService.findBySectionNo(ybInspectDataCdto.getSectionNo());
            if (sectionNoDetail == null) {
                return ResultGenerator.fail(ybInspectDataCdto.getSectionNo() + "晶段信息不存在，数据异常");
            }
            if (null != sectionNoDetail.getSectionPosiotion() && sectionNoDetail.getSectionPosiotion() == 2){
                waitSampleFlag = true;
            }
            if (waitSampleFlag){
                pieceNoHead = this.handlePieceNo( sectionNoDetail.getCrystalNo() + "T",true);
                pieceNoEnd = this.handlePieceNo( sectionNoDetail.getCrystalNo() + "A",false);
            }
            LongCrystal longCrystal = longCrystalService.get(sectionNoDetail.getCrystalId());
            if (longCrystal == null) {
                return ResultGenerator.fail(ybInspectDataCdto.getSectionNo() + "长棒信息不存在，数据异常");
            }
            initInspectData(ybInspectDataOld, sectionNoDetail, longCrystal);
            //赋值段号
            ybInspectDataOld.setPiecewiseNum(sectionNoDetail.getSegmentNum());
            if (sectionNoDetail.getParentId() == 0) {
                ybInspectDataOld.setCheckoutName("一次检验");
                ybInspectDataOld.setReCheckType("0");
            }
            // 如果是反切第一次，需继承父单晶的一些属性
            else {
                SectionNoDetail sectionNoDetailParent = sectionNoDetailService.get(sectionNoDetail.getParentId());
                if (sectionNoDetailParent != null && sectionNoDetailParent.getId() != null) {
                    YbInspectData ybInspectDataParent = findBySectionNo(sectionNoDetailParent.getSectionNo());
                    if (ybInspectDataParent != null) {
                        if (ybInspectDataParent.getReCheckType() != null) {
                            String checkTypeF = (Integer.parseInt(ybInspectDataParent.getReCheckType()) + 1) + "";
                            ybInspectDataOld.setReCheckType(checkTypeF);
                        }
                        ybInspectDataOld.setCheckoutName(EnumValues.CheckoutName.返切复检.getValue());
                        ybInspectDataOld.setOrderType(ybInspectDataParent.getOrderType());
                        ybInspectDataOld.setHeadTailRecognition(ybInspectDataParent.getHeadTailRecognition());
                    }
                }
            }
            //赋值头尾样片信息
            setSampleData(ybInspectDataOld, sectionNoDetail.getPieceNoHead(), sectionNoDetail.getPieceNoEnd());
        } else {
            ybInspectDataOld.setCheckoutName("复检");
            //更新复检次数
            ybInspectDataOld.setReCheckType(String.valueOf(NumberUtil.String2Integer(ybInspectDataOld.getReCheckType(), 0) + 1));
            //新增，并且有历史数据，记录日志数据
            YbInspectDataLog ybInspectDataLog = ybInspectDataLogService.findByInspectDataId(ybInspectDataOld.getId());
            List<YbInspectData> ybInspectDatas = new LinkedList<>();
            //查看有没有日志记录
            if (ybInspectDataLog != null) {
                ybInspectDatas = JSON.parseArray(ybInspectDataLog.getDataLog(), YbInspectData.class);
            } else {
                ybInspectDataLog = new YbInspectDataLog();
                ybInspectDataLog.setInspectDataId(ybInspectDataOld.getId());
                ybInspectDataLog.setSectionNo(ybInspectDataOld.getSectionNo());
            }
            ybInspectDataLog.setUserUpdate(BaseContextHandler.getUsername());
            ybInspectDataLog.setGmtUpdate(new Date());
            ybInspectDatas.add(ybInspectDataOld);
            ybInspectDataLog.setDataLog(JSON.toJSONString(ybInspectDatas));
            ybInspectDataLogService.saveOrUpdate(ybInspectDataLog);
            handleContentInfo(ybInspectDataOld,ybInspectDataOld.getCrystalNo());
        }
        //获取晶段属性
        String sectionType = defaultCrystalAttrService.getDefaultCrystalAttrOneTimes(ybInspectDataOld.getDopant(), ybInspectDataOld.getProductTypeSecond(), ybInspectDataOld.getProductLevel(), ybInspectDataOld.getSticksCount() != null && ybInspectDataOld.getSticksCount() > 1 ? ybInspectDataOld.getSpellBarLength() : ybInspectDataOld.getActualLength());
        //继承历史数据，更新本次数据
//        BeanUtil.copyBeanPropWithNullValue(ybInspectDataOld, ybInspectDataCdto, "id");
        BeanUtils.copyProperties(ybInspectDataCdto, ybInspectDataOld, BeanUtil.getIgnoreProperties(ybInspectDataCdto, "id", null));
        ybInspectDataOld.setInspector(BaseContextHandler.getUsername());
        ybInspectDataOld.setCreateTime(new Date());
        // 完结尾查询完结头氧值
        try {
            LongCrystal longCrystal = longCrystalService.findByCrystalNo(ybInspectDataOld.getCrystalNo());
            if (null != longCrystal.getClosureIdentification() && longCrystal.getClosureIdentification().equals(EnumValuesServer.FINALIDENTIFICATION)) {
                setEndOxygenAndCarbon(ybInspectDataOld, longCrystal);
            } else if (!longCrystal.getClosureIdentification().equals(EnumValuesServer.FINALIDENTIFICATION)){
                ybInspectDataOld.setEndCarbonContentHead(new BigDecimal(0));
                ybInspectDataOld.setEndOxygenContentHead(new BigDecimal(0));
                ybInspectDataOld.setEndCarbonContentTail(new BigDecimal(0));
                ybInspectDataOld.setEndOxygenContentTail(new BigDecimal(0));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        // 判断晶段类型
        ybInspectDataOld.setSectionType(sectionType);
        //补充完结标识
        LongCrystal byCrystalNo = longCrystalService.findByCrystalNo(ybInspectDataOld.getCrystalNo());
        if (byCrystalNo == null) {
            throw new RuntimeException("晶棒信息不存在！");
        }
        ybInspectDataOld.setClosureIdentification(byCrystalNo.getClosureIdentification());
//        ybInspectDataOld.setSideLengthRange(ybInspectDataCdto.getSideLengthRange());

        //添加判断，对于样片值的获取，其中T段，T02 段，w 段，需要等待样片实际值出来后进行流转，否则则进库等待，其余段可以直接流转
        Boolean ratedFlage = false;
        if (waitSampleFlag){

            if (StringUtils.isNotBlank(pieceNoHead)){
                PieceCheck pieceCheckHead = pieceCheckService.getByPieceNo(pieceNoHead);
                if (null == pieceCheckHead){
                    ratedFlage = true;
                }
            }
            if (StringUtils.isNotBlank(pieceNoEnd)){
                PieceCheck pieceCheckTail = pieceCheckService.getByPieceNo(pieceNoHead);
                if (null == pieceCheckTail){
                    ratedFlage = true;
                }
            }
        }

        if (!ratedFlage){
            Result<String> stringResult = saveDataAndGrade(ybInspectDataOld, false);
            if (null != stringResult && stringResult.getCode().equals("400")) {
                return stringResult;
            }
        }else {
            saveOrUpdate(ybInspectDataOld);
            PlanProcessingOrder planProcessingOrder = planProcessingOrderService.findByCodeAndOrderType(sectionNo, EnumValuesFactory.PlanProcessingOrderOrderType.晶段.getKey());
            if (planProcessingOrder == null) {
                throw new BusinessException("工单不存在，请联系管理员");
            }
            // 满足不能评级条件，直接创建评级记录
            createRuleTest(sectionNo, "等待样片检验数据不再触发评级");
        }
        saveDataInspectLog(ybInspectDataOld);//保存圆棒检验记录表
        return ResultGenerator.success();
    }

    private String handlePieceNo(String sectionNo,Boolean headFlag){
        if (StringUtils.isNotBlank(sectionNo)){
            SectionNoDetail sectionNoDetail = sectionNoDetailService.findBySectionNo(sectionNo);
            if (null != sectionNoDetail){
                if (headFlag){
                    return sectionNoDetail.getPieceNoHead();
                }else {
                    return sectionNoDetail.getPieceNoEnd();
                }
            }
        }

        return null;
    }

    @Override
    public void saveDataInspectLog(YbInspectData ybInspectDataOld) {

        DataInspectLog dataInspectLog = new DataInspectLog();

        dataToLog(ybInspectDataOld, dataInspectLog);

        if (ybInspectDataOld.getId() != null) {
            dataInspectLog.setOperateType(1);
            dataInspectLog.setRemarks("修改");
        } else {
            dataInspectLog.setOperateType(0);
            dataInspectLog.setRemarks("新增");
        }
        dataInspectLog.setOperateTime(new Date());
        dataInspectLog.setOperator(BaseContextHandler.getUsername());

        dataInspectLogService.saveOrUpdate(dataInspectLog);
    }

    @Override
    public String getResistanceLevel(BigDecimal tRadialCentre) {
        if(tRadialCentre==null){
            return "-1";
        }
        //电阻档位判断
        List<DictionaryItem> resistanceLevel = dictionaryItemService.findByThemeValueAndEnableOrderByPriority("resistanceLevel", true);
        String resLevel = null;
        int i = 0;
        for (DictionaryItem dictionaryItem : resistanceLevel) {
            i++;
            String value = dictionaryItem.getValue();
            String[] split = value.split("-");
            if(split.length > 1){
                if(tRadialCentre.compareTo(new BigDecimal(split[0])) > 0 && tRadialCentre.compareTo(new BigDecimal(split[1])) <= 0){
                    resLevel = dictionaryItem.getName();
                    break;
                }
            } else if(i == 1 && tRadialCentre.compareTo(new BigDecimal(dictionaryItem.getValue())) <= 0) {
                resLevel = dictionaryItem.getName();
                break;
            } else if(tRadialCentre.compareTo(new BigDecimal(dictionaryItem.getValue())) > 0) {
                resLevel = dictionaryItem.getName();
                break;
            }
        }
        return resLevel;
    }

    @Override
    public List<YbInspectData> findByLotNoAndAgainNum(String lotNo, Integer againNum) {
        return dao.findByLotNoAndAgainNum(lotNo, againNum);
    }

    @Override
    public void verificationManagement(String sectionNo) {
        if (StringUtils.isBlank(sectionNo)){
            return;
        }

        Map<String, Object> bySectionNoMap = this.findBySectionNoMap(sectionNo);
        if (null == bySectionNoMap || bySectionNoMap.size() == 0){
            return;
        }
        if (null == bySectionNoMap.get("product_type_second")){
            return;
        }
        String productTypeSecond = String.valueOf(bySectionNoMap.get("product_type_second"));
        if (null == bySectionNoMap.get("dopant")){
            return;
        }
        String deviceNo = "";
        String lotNo = "";
        Integer againNum = 0;

        SectionNoDetail sectionNoDetailHead = sectionNoDetailService.findBySectionNo(sectionNo);
        if (null != sectionNoDetailHead && StringUtils.isNotBlank(sectionNoDetailHead.getCrystalNo())){
            LongCrystal byCrystalNo = longCrystalService.findByCrystalNo(sectionNoDetailHead.getCrystalNo());
            deviceNo = byCrystalNo.getEquipmentCode();
            lotNo = byCrystalNo.getLotNo();
            againNum = byCrystalNo.getAgainNum();
        }
        String dopant = String.valueOf(bySectionNoMap.get("dopant"));

        List<WarningRuleConfiguration> warningRuleConfigurationList = warningRuleConfigurationService.findByDopantAndSpecificationAndStatusAndRestrictedReporting(dopant, productTypeSecond, 1, null);

        List<FieldPool> fieldPools = fieldPoolService.findByRegion(EnumValuesGrade.Region.圆棒.getKey());
        Map<String, FieldPool> fieldPoolMap = new HashMap<>();
        for (FieldPool fieldPool : fieldPools) {
            fieldPoolMap.put(fieldPool.getName(), fieldPool);
        }
        Date date = new Date();

        if (CollectionUtils.isNotEmpty(warningRuleConfigurationList)){
            for (WarningRuleConfiguration warningRuleConfiguration : warningRuleConfigurationList){
                if (StringUtils.isNotBlank(warningRuleConfiguration.getConditionsShow())){
                    List<Map<String,String>> listConditions = JSON.parseObject(warningRuleConfiguration.getConditionsShow(), List.class);
                    StringBuilder sqlStr  = new StringBuilder();
                    sqlStr.append("SELECT ");
                    StringBuilder actualValue = new StringBuilder();
                    for (Map<String,String> condition : listConditions){
                        String[] ruleTextArr = condition.get("text").split(" ");
                        for (String text : ruleTextArr){
                            if (text.startsWith("@")){
                                String replaceKey = text.replace("@", "").trim();
                                if (!fieldPoolMap.containsKey(replaceKey)){
                                    return;
                                }
                                FieldPool fieldPool = fieldPoolMap.get(replaceKey);
                                Object field = bySectionNoMap.get(fieldPool.getCode());
                                actualValue.append(fieldPool.getCode()).append(":").append(field);
                                if (null == field){
                                    return;
                                }
                                sqlStr.append(" ").append(field).append(" ");
                            }else {
                                sqlStr.append(" ").append(text).append(" ");
                            }
                        }
                        sqlStr.append(" AND ");
                    }
                    String sql = sqlStr.substring(0, sqlStr.length() - 5);
                    Map<String, Object> result = this.handCheck(sql);

                    if (null != result){
                        for (Map.Entry<String, Object> entry : result.entrySet()) {
                            if (null != entry.getValue()){
                                Integer value =NumberUtil.Object2Integer(entry.getValue(),null);
                                if (value == 1 && warningRuleConfiguration.getManageStatus() == 1){
                                    EarlyWarningManagement earlyWarningManagement = new EarlyWarningManagement();
                                    earlyWarningManagement.setConditions(warningRuleConfiguration.getConditions().replace("~",""));
                                    earlyWarningManagement.setSectionNo(sectionNo);
                                    earlyWarningManagement.setName(warningRuleConfiguration.getName());
                                    earlyWarningManagement.setActualValue(actualValue.toString());
                                    earlyWarningManagement.setDeviceNo(deviceNo);
                                    earlyWarningManagement.setGmtCreate(date);
                                    earlyWarningManagement.setStatus(0);
                                    earlyWarningManagement.setLotNo(lotNo);
                                    earlyWarningManagement.setAgainNum(againNum);
                                    earlyWarningManagement.setUserCreate(BaseContextHandler.getUsername());
                                    earlyWarningManagementService.saveOrUpdate(earlyWarningManagement);
                                }
                            }
                        }
                    }
                }
            }
        }

    }
    @Override
    public void sendSquareRodInfo(String fbSectionNo, String ybSectionNo, BigDecimal weight) {
        Date date = new Date();
        if (StringUtils.isNotBlank(ybSectionNo)){
            YbInspectData bySectionNo = this.findBySectionNo(ybSectionNo);
            if (null == bySectionNo || StringUtils.isBlank(bySectionNo.getCrystalNo())){
                return;
            }
            LongCrystal byCrystalNo = longCrystalService.findByCrystalNo(bySectionNo.getCrystalNo());
            ReportSapGoodsmvt byCrystalNoAndBwart = reportSapGoodsmvtService.findByCrystalNoAndBwart(ybSectionNo, "261");
            if (null != byCrystalNoAndBwart){
                DictionaryItem warehouseLocation = dictionaryItemService.findNameByThemeValueAndExtendValue("WarehouseLocation", byCrystalNoAndBwart.getLgort(),true);
                if (null != warehouseLocation){
                    wipStorageYbService.sendReportSapGoodsmvt("101",byCrystalNoAndBwart.getKostl(),byCrystalNoAndBwart.getAufnr(),byCrystalNoAndBwart.getMatnr(),byCrystalNoAndBwart.getCharg(),weight.toString(),"KG","5041", warehouseLocation.getExtendValue1(),fbSectionNo,null,EnumValuesFactory.WipStorageCode.方棒检验.getValue());
                }

                //报工时
                ReportSapWorkinghours reportSapWorkinghours = new ReportSapWorkinghours();
                String cnfTime = "0.00";
                if (null != byCrystalNoAndBwart.getBldat()){
                    cnfTime = new BigDecimal((date.getTime() - byCrystalNoAndBwart.getBldat().getTime()) / 3600000).setScale(2, BigDecimal.ROUND_HALF_UP).toString();
                }
                reportSapWorkinghours.setCnfTime(cnfTime);
                reportSapWorkinghours.setCnfTimeUom("H");
                reportSapWorkinghours.setStatus(false);
                reportSapWorkinghours.setCnfQty1(weight.toString());
                reportSapWorkinghours.setProductionOrderId(byCrystalNoAndBwart.getAufnr());
                reportSapWorkinghours.setRecordId(byCrystalNoAndBwart.getCharg());
                reportSapWorkinghours.setPlant("5041");
                reportSapWorkinghoursService.saveOrUpdate(reportSapWorkinghours);

            }
            //调整方棒线边仓入库库位
            CrystalMaterialRelation crystalMaterialRelation = crystalMaterialRelationService.findBySectionNo(ybSectionNo);
            if (null == crystalMaterialRelation){
                throw new RuntimeException("开方过站未关联排程信息！");
            }
            String umlgo = "";
            String warehouseCode = "";
            if (StringUtils.isNotBlank(crystalMaterialRelation.getDeviceNo())){
                Equipment equipment = equipmentService.findByCode(crystalMaterialRelation.getDeviceNo());
                if (null != equipment){
                    DictionaryItem  warehouseLocation = dictionaryItemService.findByThemeValueAndNameAndValueAndEnable("WarehouseLocation",equipment.getArea(),equipment.getSeries(), true);
                    if (null != warehouseLocation){
                        warehouseCode = warehouseLocation.getExtendValue1();
                        umlgo = warehouseLocation.getExtendValue2();
                    }
                }
            }


            Result<WarehouseInputReturnDto> warehouseInputReturnDtoResult = wipStorageYbService.sendWarehouseInputBillBo(byCrystalNo, weight, InputBillStatusEnum.开方入库.getValue(),umlgo,warehouseCode,null);
            if (warehouseInputReturnDtoResult.getCode() != ResultCode.SUCCESS.getCode()){
                log.info("开方入库线边仓出库失败:{}",warehouseInputReturnDtoResult.getMessage());
                throw new RuntimeException("开方入库线边仓出库失败: " + warehouseInputReturnDtoResult.getMessage());
            }
        }
    }


    @Transactional(propagation = Propagation.REQUIRES_NEW)
    public Map<String, Object> handCheck(String sql){
        try {
            return getMapResult(sql);
        }catch (Exception e){
            return  null;
        }
    }


    private void dataToLog(YbInspectData ybInspectDataOld, DataInspectLog dataInspectLog) {

        dataInspectLog.setCrystalNo(ybInspectDataOld.getCrystalNo());
        dataInspectLog.setSectionNo(ybInspectDataOld.getSectionNo());
        dataInspectLog.setSectionType(ybInspectDataOld.getSectionType());
        dataInspectLog.setAgainNum(ybInspectDataOld.getAgainNum());
        dataInspectLog.setAgainPiece(ybInspectDataOld.getAgainPiece());
        dataInspectLog.setDopant(ybInspectDataOld.getDopant());
        dataInspectLog.setPullType(ybInspectDataOld.getPullType());
//        dataInspectLog.setKube();
        dataInspectLog.setIsCutBack(ybInspectDataOld.getIsCutBack());
        dataInspectLog.setCheckoutName(ybInspectDataOld.getCheckoutName());
        dataInspectLog.setReCheckType(ybInspectDataOld.getReCheckType());
        dataInspectLog.setProductTypeSecond(ybInspectDataOld.getProductTypeSecond());
        dataInspectLog.setIsChangeSpecs(ybInspectDataOld.getIsChangeSpecs());
//        dataInspectLog.setWareHouseLength();
        dataInspectLog.setActualLength(ybInspectDataOld.getActualLength());
        dataInspectLog.setActualWeight(ybInspectDataOld.getActualWeight());
        dataInspectLog.setTheoryWeight(ybInspectDataOld.getTheoryWeight());
        dataInspectLog.setHeadTailRecognition(ybInspectDataOld.getHeadTailRecognition());
        dataInspectLog.setDiameterMin(ybInspectDataOld.getDiameterMin());
        dataInspectLog.setDiameterMax(ybInspectDataOld.getDiameterMax());
//        dataInspectLog.setDiamDecide();
//        dataInspectLog.setFineDiameter();
//        dataInspectLog.setFineCutLength();
        dataInspectLog.setEdgeBark(ybInspectDataOld.getEdgeBark());
        dataInspectLog.setCollapseLine(ybInspectDataOld.getCollapseLine());
        dataInspectLog.setIsBevel(ybInspectDataOld.getIsBevel());
//        dataInspectLog.setIsFork();
//        dataInspectLog.setColorful();
        dataInspectLog.setCrack(ybInspectDataOld.getCrack());
//        dataInspectLog.setIsTwinCrystal();
//        dataInspectLog.setTwinLength();
//        dataInspectLog.setHeadSlope();
//        dataInspectLog.setTailSlope();
//        dataInspectLog.setDistortionBig();
        dataInspectLog.setDistortion(ybInspectDataOld.getDistortion());
        dataInspectLog.setProductLevel(ybInspectDataOld.getProductLevel());
        dataInspectLog.setProductLevelExperiment(ybInspectDataOld.getProductLevelExperiment());
        dataInspectLog.setLevelTime(ybInspectDataOld.getLevelTime());
        dataInspectLog.setRemark(ybInspectDataOld.getRemark());
        dataInspectLog.setLevel(ybInspectDataOld.getLevel());
        dataInspectLog.setExperiLevel(ybInspectDataOld.getExperiLevel());
        dataInspectLog.setConductiveType(ybInspectDataOld.getConductiveType());
//        dataInspectLog.setResistivityMin();
//        dataInspectLog.setResistivityMax();
//        dataInspectLog.setTLifeMin();
        dataInspectLog.setWLifeMin(ybInspectDataOld.getWLifeMin());
        dataInspectLog.setTRadialCentre(ybInspectDataOld.getTRadialCentre());
        dataInspectLog.setTRadialEdge1(ybInspectDataOld.getTRadialEdge1());
        dataInspectLog.setTRadialEdge2(ybInspectDataOld.getTRadialEdge2());
        dataInspectLog.setTRadialEdge3(ybInspectDataOld.getTRadialEdge3());
        dataInspectLog.setTRadialEdge4(ybInspectDataOld.getTRadialEdge4());
        dataInspectLog.setTRadialEdge5(ybInspectDataOld.getTRadialEdge5());
        dataInspectLog.setTRadialEdge6(ybInspectDataOld.getTRadialEdge6());
        dataInspectLog.setTRadialEdge7(ybInspectDataOld.getTRadialEdge7());
        dataInspectLog.setTRadialEdge8(ybInspectDataOld.getTRadialEdge8());
        dataInspectLog.setWRadialCentre(ybInspectDataOld.getWRadialCentre());
        dataInspectLog.setWRadialEdge1(ybInspectDataOld.getWRadialEdge1());
        dataInspectLog.setWRadialEdge2(ybInspectDataOld.getWRadialEdge2());
        dataInspectLog.setWRadialEdge3(ybInspectDataOld.getWRadialEdge3());
        dataInspectLog.setWRadialEdge4(ybInspectDataOld.getWRadialEdge4());
        dataInspectLog.setWRadialEdge5(ybInspectDataOld.getWRadialEdge5());
        dataInspectLog.setWRadialEdge6(ybInspectDataOld.getWRadialEdge6());
        dataInspectLog.setWRadialEdge7(ybInspectDataOld.getWRadialEdge7());
        dataInspectLog.setWRadialEdge8(ybInspectDataOld.getWRadialEdge8());
//        dataInspectLog.setEndCentreEdgeAvg4();
//        dataInspectLog.setTopCentreEdgeAvg();
//        dataInspectLog.setEndCentreEdgeAvg();
        dataInspectLog.setResistivityTopAvg(ybInspectDataOld.getResistivityTopAvg());
//        dataInspectLog.setResistivityEndAvg();
//        dataInspectLog.setSellResistivity();
//        dataInspectLog.setResistivityConclusion();
//        dataInspectLog.setIsSeeBottom();
//        dataInspectLog.setResistivityWarping();
        dataInspectLog.setTCentreLife(ybInspectDataOld.getTCentreLife());
        dataInspectLog.setTLifeEdge1(ybInspectDataOld.getTLifeEdge1());
        dataInspectLog.setTLifeEdge2(ybInspectDataOld.getTLifeEdge2());
        dataInspectLog.setTLifeEdge3(ybInspectDataOld.getTLifeEdge3());
        dataInspectLog.setTLifeEdge4(ybInspectDataOld.getTLifeEdge4());
        dataInspectLog.setWCentreLife(ybInspectDataOld.getWCentreLife());
        dataInspectLog.setWLifeEdge1(ybInspectDataOld.getWLifeEdge1());
        dataInspectLog.setWLifeEdge2(ybInspectDataOld.getWLifeEdge2());
        dataInspectLog.setWLifeEdge3(ybInspectDataOld.getWLifeEdge3());
        dataInspectLog.setWLifeEdge4(ybInspectDataOld.getWLifeEdge4());
        dataInspectLog.setReduceCrystalLength(ybInspectDataOld.getReduceCrystalLength());
        dataInspectLog.setCrystalWorkshop(ybInspectDataOld.getCrystalWorkshop());
        dataInspectLog.setOxygenContentHead(ybInspectDataOld.getOxygenContentHead());
//        dataInspectLog.setOxygenContentBorder();
        dataInspectLog.setCarbonContentHead(ybInspectDataOld.getCarbonContentHead());
//        dataInspectLog.setCarbonContentBorder();
        dataInspectLog.setOxygenContentTail(ybInspectDataOld.getOxygenContentTail());
//        dataInspectLog.setOxygenContentBorderTail();
        dataInspectLog.setCarbonContentTail(ybInspectDataOld.getCarbonContentTail());
//        dataInspectLog.setCarbonContentBorderTail();
//        dataInspectLog.setHeadDefectGrade();
//        dataInspectLog.setTailDefect();
//        dataInspectLog.setIsMalpositionHead();
//        dataInspectLog.setIsMalpositionTail();
//        dataInspectLog.setTCenterAnneal();
//        dataInspectLog.setWcenterAnneal();
//        dataInspectLog.setTBorderAnneal();
//        dataInspectLog.setWBorderAnneal();
//        dataInspectLog.setAnomaly();
        dataInspectLog.setInspector(ybInspectDataOld.getInspector());
//        dataInspectLog.setHasGone();
        dataInspectLog.setOrderNo(ybInspectDataOld.getOrderNo());
        dataInspectLog.setPlanSpecs(ybInspectDataOld.getPlanSpecs());
//        dataInspectLog.setPlanMaterialCode();
        dataInspectLog.setOrderType(ybInspectDataOld.getOrderType());
        dataInspectLog.setFurnaceType(ybInspectDataOld.getFurnaceType());
        dataInspectLog.setDeviceNo(ybInspectDataOld.getDeviceNo());
//        dataInspectLog.setSeries();
        dataInspectLog.setLotNo(ybInspectDataOld.getLotNo());
//        dataInspectLog.setMaterialCount();
//        dataInspectLog.setSintonCenter();
//        dataInspectLog.setSintonTail();
//        dataInspectLog.setLifeSpanw1();
//        dataInspectLog.setResistivityw1();
//        dataInspectLog.setLifeSpant2();
//        dataInspectLog.setResistivityt2();
        dataInspectLog.setPiecewiseNum(ybInspectDataOld.getPiecewiseNum());
        dataInspectLog.setCreateTime(ybInspectDataOld.getCreateTime());
        dataInspectLog.setUpdateTime(ybInspectDataOld.getUpdateTime());
//        dataInspectLog.setDrawLine();
        dataInspectLog.setCrystalAbnormal(ybInspectDataOld.getCrystalAbnormal());
        dataInspectLog.setSectionCompose(ybInspectDataOld.getSectionCompose());
        dataInspectLog.setSticksCount(ybInspectDataOld.getSticksCount());
        dataInspectLog.setFactory(ybInspectDataOld.getFactory());
//        dataInspectLog.setHeadLevel();
//        dataInspectLog.setTailLevel();
//        dataInspectLog.setGradeName();
        dataInspectLog.setGradeVersion(ybInspectDataOld.getGradeVersion());
//        dataInspectLog.setPlanGradeName();
//        dataInspectLog.setPlanGradeVersion();
        dataInspectLog.setCheckReback(ybInspectDataOld.getCheckReback());
        dataInspectLog.setCheckLineNo(ybInspectDataOld.getCheckLineNo());
//        dataInspectLog.setTTempRadialCentreTheory();
//        dataInspectLog.setTTempRadialEdgeTheory1();
//        dataInspectLog.setWTempRadialCentreTheory();
//        dataInspectLog.setWTempRadialEdgeTheory1();
//        dataInspectLog.setTTempRadialCentre();
//        dataInspectLog.setTTempRadialEdge1();
//        dataInspectLog.setTTempRadialEdge2();
//        dataInspectLog.setTTempRadialEdge3();
//        dataInspectLog.setTTempRadialEdge4();
//        dataInspectLog.setTTempRadialEdge5();
//        dataInspectLog.setTTempRadialEdge6();
//        dataInspectLog.setTTempRadialEdge7();
//        dataInspectLog.setTTempRadialEdge8();
//        dataInspectLog.setWTempRadialCentre();
//        dataInspectLog.setWTempRadialEdge1();
//        dataInspectLog.setWTempRadialEdge2();
//        dataInspectLog.setWTempRadialEdge3();
//        dataInspectLog.setWTempRadialEdge4();
//        dataInspectLog.setWTempRadialEdge5();
//        dataInspectLog.setWTempRadialEdge6();
//        dataInspectLog.setWTempRadialEdge7();
//        dataInspectLog.setWTempRadialEdge8();
        dataInspectLog.setCrystalDirection(ybInspectDataOld.getCrystalDirection());
        dataInspectLog.setGradeData(ybInspectDataOld.getGradeData());
//        dataInspectLog.setPlanOrderNo();
        dataInspectLog.setMaterialCode(ybInspectDataOld.getMaterialCode());
//        dataInspectLog.setTemperature();
//        dataInspectLog.setTemperatureEnd();
//        dataInspectLog.setDemcMax();
//        dataInspectLog.setDiameterMinusBig();
//        dataInspectLog.setPlanOrderType();
//        dataInspectLog.setPlanStickCount();
//        dataInspectLog.setPlanLenRange();
        dataInspectLog.setPlanDopant(ybInspectDataOld.getPlanDopant());
        dataInspectLog.setPlanConductiveType(ybInspectDataOld.getPlanConductiveType());
        dataInspectLog.setPlanGrade(ybInspectDataOld.getPlanGrade());
        dataInspectLog.setSpellBarLength(ybInspectDataOld.getSpellBarLength());
//        dataInspectLog.setAvgDiameter();
//        dataInspectLog.setAllAvgDiameter();
//        dataInspectLog.setLineMarking();
        dataInspectLog.setGradeType(ybInspectDataOld.getGradeType());
//        dataInspectLog.setOperator();
//        dataInspectLog.setOperateTime();
//        dataInspectLog.setOperateType();
//        dataInspectLog.setRemarks();
//        dataInspectLog.setCompensateResistivityw1();
//        dataInspectLog.setCompensateResistivityt2();
//        dataInspectLog.setHeadTailChange();
//        dataInspectLog.setRetestNum();
    }

    @Override
    public void initInspectData(YbInspectData ybInspectDataOld, SectionNoDetail sectionNoDetail, LongCrystal longCrystal) {
        // 查询短棒棒属性值 只在新增时候赋值
        setSectionNoDetailData(ybInspectDataOld, sectionNoDetail);
        // 查询长晶棒属性值 只在新增时候赋值
        setLongCryStalData(ybInspectDataOld, longCrystal);
    }

    /**
     * 给检验数据赋值长棒信息
     *
     * @param ybInspectData 检验数据
     * @param longCrystal   长棒信息
     */
    public void setLongCryStalData(YbInspectData ybInspectData, LongCrystal longCrystal) {
        //长棒订单
        if (longCrystal != null) {
            ybInspectData.setCrystalNo(longCrystal.getCrystalNo());
            // 单晶拉制异常
            if (StringUtils.isNotBlank(longCrystal.getCrystalErrorLevelOne())
                    && StringUtils.isNotBlank(longCrystal.getCrystalErrorLevelTwo())) {
                ybInspectData.setCrystalAbnormal("3");
            } else if (StringUtils.isNotBlank(longCrystal.getCrystalErrorLevelOne())) {
                ybInspectData.setCrystalAbnormal("1");
            } else if (StringUtils.isNotBlank(longCrystal.getCrystalErrorLevelTwo())) {
                ybInspectData.setCrystalAbnormal("2");
            }
            ybInspectData.setProductType(longCrystal.getProductType());
            ybInspectData.setAgainNum(longCrystal.getAgainNum());
            ybInspectData.setAgainPiece(longCrystal.getCrystalNum());
            ybInspectData.setDopant(longCrystal.getDopant());
            ybInspectData.setPullType(longCrystal.getWindUp());
            ybInspectData.setCrystalWorkshop(longCrystal.getArea());
            ybInspectData.setFurnaceType(longCrystal.getFurnaceType());
            ybInspectData.setDeviceNo(longCrystal.getEquipmentCode());
            ybInspectData.setLotNo(longCrystal.getLotNo());
            ybInspectData.setDiameterMax(longCrystal.getMaxDiam());
            ybInspectData.setDiameterMin(longCrystal.getMinDiam());
            //多边距字段赋值
            ybInspectData.setSideLengthRange(longCrystal.getSideLengthRange());
            //赋值长棒计划订单信息
            if (longCrystal.getOrderId() != null) {
                ProductionOrder productionOrder = productionOrderService.get(longCrystal.getOrderId());
                if (productionOrder != null && productionOrder.getProductModel() != null) {
                    //计划产品评级
                    ybInspectData.setPlanGrade(productionOrder.getProductModel().getProductGrade());
                    // 计划产品规格
                    ybInspectData.setPlanSpecs(productionOrder.getProductModel().getSpecs());
                    // 计划掺杂剂
                    ybInspectData.setPlanDopant(productionOrder.getProductModel().getDopant());
                    ybInspectData.setDopant(productionOrder.getProductModel().getDopant());
                    // 计划导电类型
                    ybInspectData.setPlanConductiveType(productionOrder.getProductModel().getConductionType());
                    ybInspectData.setConductiveType(productionOrder.getProductModel().getConductionType());
                    ybInspectData.setProductTypeSecond(longCrystal.getSpecs());

                    String productTypeSecond = ybInspectData.getProductTypeSecond();
                    BigDecimal actualLength = ybInspectData.getActualLength();
                    if(StringUtils.isEmpty(productTypeSecond)){
                        throw new BusinessException("晶编【" + ybInspectData.getSectionNo() + "】的规格异常");
                    }
                    if(null == actualLength){
                        throw new BusinessException("晶编【" + ybInspectData.getSectionNo() + "】的实际长度异常");
                    }
                  /*  移植代码注释
                  List<DictionaryItem> dictionaryItems = dictionaryItemService.findByThemeValueAndItemName(Constants.WEIGHT_RATIO, productTypeSecond, true);
                    if (dictionaryItems.size() == 0) {
                        throw new BusinessException("请配置【" + productTypeSecond + "】规格的理论重量系数");
                    }
                    BigDecimal weightLossCoefficient = NumberUtil.Object2BigDecimal(dictionaryItems.get(0).getValue());
                    // 计算理论重量
                    ybInspectData.setTheoryWeight(actualLength.divide(weightLossCoefficient, 2, RoundingMode.CEILING));*/

                    // 订单类型
                    ybInspectData.setOrderType(productionOrder.getAuart());
                    // 计划订单号
                    ybInspectData.setOrderNo(productionOrder.getAufnr());
                    //ybInspectData.setMaterialCode(productionOrder.getMatnr());
                }

                //处理料号
                CrystalMaterialRelation bySectionNo = crystalMaterialRelationService.findBySectionNo(longCrystal.getCrystalNo());
                if (null != bySectionNo){
                    ybInspectData.setMaterialCode(bySectionNo.getMaterialCode());
                    ybInspectData.setOrderNo(bySectionNo.getOrderNo());
                }
            }
        }
    }

    @Override
    @ServiceLogs(description = "圆棒检验数据系数计算寿命")
    public YbInspectDataCUDto coefficient(YbInspectDataCUDto ybInspectDataCuDto) {
        if (null != ybInspectDataCuDto.getConductiveType()) {
            List<DictionaryItem> dictionaryItemList = dictionaryItemService.findByThemeValueAndItemName("life_coefficient", ybInspectDataCuDto.getConductiveType(), true);
            if (dictionaryItemList.isEmpty()) {
                return ybInspectDataCuDto;
            }
            DictionaryItem dictionaryItem = dictionaryItemList.get(0);
            String value = dictionaryItem.getValue();
            String extendValue = dictionaryItem.getExtendValue();
            if (StringUtils.isEmpty(value) || StringUtils.isEmpty(extendValue)) {
                return ybInspectDataCuDto;
            }
            double coefficient = 1D;
            double constant = 0D;
            try {
                coefficient = Double.parseDouble(value);
                constant = Double.parseDouble(extendValue);
            } catch (Exception e) {
                e.printStackTrace();
            }
            // 导电型号为p型, 需*系数    (sz * 1.801)+0.0658
            if (null != ybInspectDataCuDto.getTCentreLife()) {
                BigDecimal bigDecimal = MathUtils.keepDecimalDigis(ybInspectDataCuDto.getTCentreLife().doubleValue() * coefficient + constant);
                ybInspectDataCuDto.setTCentreLife(bigDecimal);
            }
            if (null != ybInspectDataCuDto.getTLifeEdge1()) {
                BigDecimal bigDecimal = MathUtils.keepDecimalDigis(ybInspectDataCuDto.getTLifeEdge1().doubleValue() * coefficient + constant);
                ybInspectDataCuDto.setTLifeEdge1(bigDecimal);
            }
            if (null != ybInspectDataCuDto.getTLifeEdge2()) {
                BigDecimal bigDecimal = MathUtils.keepDecimalDigis(ybInspectDataCuDto.getTLifeEdge2().doubleValue() * coefficient + constant);
                ybInspectDataCuDto.setTLifeEdge2(bigDecimal);
            }
            if (null != ybInspectDataCuDto.getWCentreLife()) {
                BigDecimal bigDecimal = MathUtils.keepDecimalDigis(ybInspectDataCuDto.getWCentreLife().doubleValue() * coefficient + constant);
                ybInspectDataCuDto.setWCentreLife(bigDecimal);
            }
            if (null != ybInspectDataCuDto.getWLifeEdge1()) {
                BigDecimal bigDecimal = MathUtils.keepDecimalDigis(ybInspectDataCuDto.getWLifeEdge1().doubleValue() * coefficient + constant);
                ybInspectDataCuDto.setWLifeEdge1(bigDecimal);
            }
            if (null != ybInspectDataCuDto.getWLifeEdge2()) {
                BigDecimal bigDecimal = MathUtils.keepDecimalDigis(ybInspectDataCuDto.getWLifeEdge2().doubleValue() * coefficient + constant);
                ybInspectDataCuDto.setWLifeEdge2(bigDecimal);
            }
        }
        return ybInspectDataCuDto;
    }

    private void setSectionNoDetailData(YbInspectData ybInspectData, SectionNoDetail sectionNoDetail) {
        ybInspectData.setPiecewiseNum(sectionNoDetail.getSegmentNum());
        ybInspectData.setSectionType(sectionNoDetail.getSectionType());
//        ybInspectData.setTheoryWeight(sectionNoDetail.getWeight());
        ybInspectData.setActualLength(sectionNoDetail.getLength());
        if (StringUtils.isNotBlank(sectionNoDetail.getSectionNo())){
            if (sectionNoDetail.getSectionNo().endsWith("T")){
                ybInspectData.setHeadTailRecognition("T段");
            }else if (sectionNoDetail.getSectionNo().endsWith("A")){
                ybInspectData.setHeadTailRecognition("W段");
            }else {
                ybInspectData.setHeadTailRecognition("Z段");
            }
            Integer segmentNum = sectionNoDetailService.findSegmentNumByNo(sectionNoDetail.getCrystalNo());
            if (null != segmentNum && segmentNum == 1){
                ybInspectData.setHeadTailRecognition("T段W段");
            }
        }

        //获取外发标识
        ybInspectData.setOutGoing(0);
        OutgoMarkOperate byCrystalNoAndStatus = outgoMarkOperateService.findByCrystalNoAndStatus(sectionNoDetail.getCrystalNo(), 0);
        //毛棒已标识外发
        if (null != byCrystalNoAndStatus){
            ybInspectData.setOutGoing(1);
        }else {
            OutgoMarkOperate bySectionNoAndStatus = outgoMarkOperateService.findBySectionNoAndStatus(ybInspectData.getSectionNo(), 0);
            if (null != bySectionNoAndStatus){
                ybInspectData.setOutGoing(1);
            }
        }

        //处理头片氧，尾片碳数据
        ybInspectData.setCrystalNo(sectionNoDetail.getCrystalNo());
        handleContentInfo(ybInspectData,sectionNoDetail.getCrystalNo());
        if (null != ybInspectData.getActualLength()){
            String specs = sectionNoDetail.getSpecs();
            ybInspectData.setProductTypeSecond(specs);
            List<DictionaryItem> dictionaryItems = dictionaryItemService.findByThemeValueAndItemName(Constants.WEIGHT_RATIO, specs, true);
            if (CollectionUtils.isNotEmpty(dictionaryItems)) {
                BigDecimal weightLossCoefficient = NumberUtil.Object2BigDecimal(dictionaryItems.get(0).getValue());
                if (null != weightLossCoefficient && weightLossCoefficient.compareTo(BigDecimal.ONE) > 1) {
                    ybInspectData.setTheoryWeight(sectionNoDetail.getLength().divide(weightLossCoefficient, 2, RoundingMode.CEILING));
                }
            }
        }

       /* Integer segmentNum = sectionNoDetailService.findSegmentNumByNo(sectionNoDetail.getCrystalNo());
        if (sectionNoDetail.getSegmentNum() != null) {
            if (sectionNoDetail.getSegmentNum() == 1 && segmentNum == 1) {
                ybInspectData.setHeadTailRecognition("T段W段");
            } else if (sectionNoDetail.getSegmentNum() == 1) {
                ybInspectData.setHeadTailRecognition("T段");
            } else if (sectionNoDetail.getSegmentNum().equals(segmentNum)) {
                ybInspectData.setHeadTailRecognition("W段");
            } else {
                ybInspectData.setHeadTailRecognition("Z段");
            }
        } else {
            ybInspectData.setHeadTailRecognition("未知");
        }*/
    }

    private void handleContentInfo(YbInspectData ybInspectData,String crystalNoTemp){
        SectionNoDetail sectionNoDetailHead = sectionNoDetailService.findBySectionNo(crystalNoTemp + "T");
        if (null != sectionNoDetailHead && StringUtils.isNotBlank(sectionNoDetailHead.getPieceNoHead())){
            PieceCheck pieceCheckHead = pieceCheckService.getByPieceNo(sectionNoDetailHead.getPieceNoHead());
            if (null != pieceCheckHead){
                //T氧含量中心
                ybInspectData.setOxygenContentHead(pieceCheckHead.getoContents());
                //T碳含量中心
                ybInspectData.setCarbonContentHead(pieceCheckHead.getcContents());
            }

        }
        SectionNoDetail sectionNoDetailTail = sectionNoDetailService.findBySectionNo(crystalNoTemp + "A");
        if (null == sectionNoDetailTail){
            sectionNoDetailTail = sectionNoDetailHead;
        }
        if (null != sectionNoDetailTail && StringUtils.isNotBlank(sectionNoDetailTail.getPieceNoEnd())){
            PieceCheck pieceCheckTail = pieceCheckService.getByPieceNo(sectionNoDetailTail.getPieceNoEnd());
            if (null != pieceCheckTail){
                //W氧含量中心
                ybInspectData.setOxygenContentTail(pieceCheckTail.getoContents());
                //W碳含量中心
                ybInspectData.setCarbonContentTail(pieceCheckTail.getcContents());
            }
        }

        //添加卡控，中间段单晶需要等待头尾两段检测之后才能流转
        if (StringUtils.isNotBlank(ybInspectData.getSectionNo())){
            if (ybInspectData.getSectionNo().endsWith("A")){
                this.handleResistivityAndLife(ybInspectData,ybInspectData,true);
            }else if (ybInspectData.getSectionNo().endsWith("T")){
                this.handleResistivityAndLife(ybInspectData,ybInspectData,false);
            }else {
                YbInspectData headInspectData = dao.findBySectionNoLike(crystalNoTemp + "T");
                if (null == headInspectData){
                    throw new BusinessException("头段电阻率和少子寿命未测量完成出，请先检测头段晶段电阻率和少子寿命!");
                }
                this.handleResistivityAndLife(ybInspectData,headInspectData,true);
                YbInspectData tailInspectData =  dao.findBySectionNoLike(crystalNoTemp + "A");
                if (null == tailInspectData){
                    throw new BusinessException("尾段电阻率和少子寿命未测量完成出，请先检测尾段晶段电阻率和少子寿命!");
                }
                this.handleResistivityAndLife(ybInspectData,tailInspectData,false);
            }
        }



    }
    private void handleResistivityAndLife (YbInspectData ybInspectData,YbInspectData ybInspectDataQuote,Boolean headFlag){
        if (null == ybInspectData || null == ybInspectDataQuote){
            return;
        }
        if (headFlag){
            //头段A电阻率均值
            ybInspectData.setTRadialCentre(ybInspectDataQuote.getMeanResistivityA());
            //头段B电阻率均值
            ybInspectData.setTRadialEdge1(ybInspectDataQuote.getMeanResistivityB());
            //头段A少子寿命均值
            ybInspectData.setTCentreLife(ybInspectDataQuote.getMeanCarrierLifetimeA());
            //头段B少子寿命均值
            ybInspectData.setTLifeEdge1(ybInspectDataQuote.getMeanCarrierLifetimeB());
        }else {
            //尾段A电阻率均值
            ybInspectData.setWRadialCentre(ybInspectDataQuote.getMeanResistivityA());
            //尾段B电阻率均值
            ybInspectData.setWRadialEdge1(ybInspectDataQuote.getMeanResistivityB());
            //尾段A少子寿命均值
            ybInspectData.setWCentreLife(ybInspectDataQuote.getMeanCarrierLifetimeA());
            //尾段B少子寿命均值
            ybInspectData.setWLifeEdge1(ybInspectDataQuote.getMeanCarrierLifetimeB());
        }
    }

    /**
     * 执行圆棒检验数据修改
     *
     * @param ybInspectDataCdto 本次上传的检验数据
     * @param ybInspectDataOld  该晶段的历史数据
     * @param isStatus          当前在制品状态是否满足 圆棒检验[待进站]
     * @return 是否成功
     */
    private Result execUpdateYbInspectData(YbInspectDataCUDto ybInspectDataCdto, YbInspectData ybInspectDataOld, boolean isStatus) {
        // 如果是人工上传数据
        if (ybInspectDataCdto.getId() != -1) {
            // 待进站状态，不允许修改数据
            if (isStatus) {
                return ResultGenerator.fail("圆棒检验[待进站]状态，不允许修改检验数据");
            }
            //人工上传数据时，如果
            if ((ybInspectDataOld == null || !ybInspectDataCdto.getId().equals(ybInspectDataOld.getId()))) {
                return ResultGenerator.fail("检验数据异常");
            }
        }
        //获取晶段属性
        String sectionType = defaultCrystalAttrService.getDefaultCrystalAttrOneTimes(ybInspectDataOld.getDopant(), ybInspectDataOld.getProductTypeSecond(), ybInspectDataOld.getProductLevel(), ybInspectDataOld.getSticksCount() != null && ybInspectDataOld.getSticksCount() > 1 ? ybInspectDataOld.getSpellBarLength() : ybInspectDataOld.getActualLength());
        // 更新本次数据
        BeanUtil.copyBeanPropWithOutNullValue(ybInspectDataOld, ybInspectDataCdto, "id");
        ybInspectDataOld.setUpdateTime(new Date());
        ybInspectDataOld.setUpdateUser(BaseContextHandler.getUsername());
        // 判断晶段类型
        ybInspectDataOld.setSectionType(sectionType);
        this.handleContentInfo(ybInspectDataOld,ybInspectDataOld.getCrystalNo());

        // 完结尾查询完结头氧值
        try {
            LongCrystal longCrystal = longCrystalService.findByCrystalNo(ybInspectDataOld.getCrystalNo());
            if (null != longCrystal.getClosureIdentification() && longCrystal.getClosureIdentification().equals(EnumValuesServer.FINALIDENTIFICATION)) {
                setEndOxygenAndCarbon(ybInspectDataOld, longCrystal);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        //处理
        Boolean ratedFlage = false;
        String sectionNo = ybInspectDataOld.getSectionNo();
        if (StringUtils.isNotBlank(sectionNo)){
            SectionNoDetail sectionNoDetail = sectionNoDetailService.findBySectionNo(sectionNo);
            if (null != sectionNoDetail && (sectionNo.endsWith("A") || sectionNo.endsWith("T")
                    || (null != sectionNoDetail.getSectionPosiotion() && sectionNoDetail.getSectionPosiotion() == 2))){
                String pieceNoHead = this.handlePieceNo(sectionNoDetail.getCrystalNo() + "T",true);
                String pieceNoEnd = this.handlePieceNo(sectionNoDetail.getCrystalNo() + "A",false);

                if (StringUtils.isNotBlank(pieceNoHead)){
                    PieceCheck byPieceNo = pieceCheckService.getByPieceNo(pieceNoHead);
                    if (null == byPieceNo){
                        ratedFlage = true;
                    }
                }
                if (StringUtils.isNotBlank(pieceNoEnd)){
                    PieceCheck byPieceNoEnd = pieceCheckService.getByPieceNo(pieceNoEnd);
                    if (null == byPieceNoEnd){
                        ratedFlage = true;
                    }
                }
            }

        }

        handleContentInfo(ybInspectDataOld,ybInspectDataOld.getCrystalNo());
        if (!ratedFlage){
            Result<String> stringResult = saveDataAndGrade(ybInspectDataOld, false);
            if (null != stringResult && stringResult.getCode().equals("400")) {
                return stringResult;
            }
        }else {
            saveOrUpdate(ybInspectDataOld);
            PlanProcessingOrder planProcessingOrder = planProcessingOrderService.findByCodeAndOrderType(sectionNo, EnumValuesFactory.PlanProcessingOrderOrderType.晶段.getKey());
            if (planProcessingOrder == null) {
                throw new BusinessException("工单不存在，请联系管理员!");
            }
            // 满足不能评级条件，直接创建评级记录
            createRuleTest(sectionNo, "等待样片检验数据不再触发评级!");
        }
        saveDataInspectLog(ybInspectDataOld);//保存圆棒检验记录表
        return ResultGenerator.success();
    }


    /**
     * 给晶段赋值样片信息
     *
     * @param ybInspectData 检验数据
     * @param pieNoHead     头样片编号
     * @param pieNoEnd      尾样片编号
     */
    private void setSampleData(YbInspectData ybInspectData, String pieNoHead, String pieNoEnd) {
       /* DefaultSample sample = defaultSampleService.findByDopantLikeAndSpecificationsLike(ybInspectData.getDopant(), ybInspectData.getProductTypeSecond());
        if (sample == null) {
            throw new BusinessException("[" + ybInspectData.getDopant() + "]/[" + ybInspectData.getProductTypeSecond() + "]该规格的样片没有设置默认值");
        }*/
        // 头片信息
        if (StringUtils.isNotBlank(pieNoHead)) {
            List<PieceCheck> pieceChecks = pieceCheckDAO.findByPieceNo(pieNoHead);
            if (pieceChecks.size() > 0 && pieceChecks.get(0) != null) {
                // 氧含量中心不找默认值
                ybInspectData.setOxygenContentHead(pieceChecks.get(0).getoContents());
                // 碳含量中心不找默认值
                ybInspectData.setCarbonContentHead(pieceChecks.get(0).getcContents());
            }
        }/* else {
            ybInspectData.setOxygenContentHead(NumberUtil.Object2BigDecimal(sample.getOxygenCenter(), null));
            ybInspectData.setCarbonContentHead(NumberUtil.Object2BigDecimal(sample.getCarbonCenter(), null));
        }*/

        // 尾片信息
        //有样片信息
        if (StringUtils.isNotBlank(pieNoEnd)) {
            List<PieceCheck> pieces = pieceCheckDAO.findByPieceNo(pieNoEnd);
            if (pieces.size() > 0 && pieces.get(0) != null) {
                // 氧含量中心不找默认值
                ybInspectData.setOxygenContentTail(pieces.get(0).getoContents());
                // 碳含量中心不找默认值
                ybInspectData.setCarbonContentTail(pieces.get(0).getcContents());
            }
        }/* else {
            // 无样片信息则使用默认值
            ybInspectData.setOxygenContentTail(NumberUtil.Object2BigDecimal(sample.getOxygenCenter()));
            ybInspectData.setCarbonContentTail(NumberUtil.Object2BigDecimal(sample.getCarbonCenter()));
        }*/
    }

    private void setEndOxygenAndCarbon(YbInspectData ybInspectDataOld, LongCrystal longCrystal) {
        List<PieceCheck> piece = pieceCheckDAO.findCountByMotherCrystalNo(longCrystal.getCrystalNo());
        piece.sort(Comparator.comparing(PieceCheck::getCheckTime2).reversed());
        if (CollectionUtils.isNotEmpty(piece)) {
            for (PieceCheck pieceCheck : piece) {
                if (pieceCheck.getPieceNo().endsWith("TP")) {
                    ybInspectDataOld.setEndCarbonContentHead(pieceCheck.getcContents());
                    ybInspectDataOld.setEndOxygenContentHead(pieceCheck.getoContents());
                    break;
                }
            }
           for (PieceCheck pieceCheck : piece) {
               if (pieceCheck.getPieceNo().endsWith("WP")) {
                   ybInspectDataOld.setEndCarbonContentTail(pieceCheck.getcContents());
                   ybInspectDataOld.setEndOxygenContentTail(pieceCheck.getoContents());
                   break;
               }
            }
        }
        if(ybInspectDataOld.getEndCarbonContentTail().compareTo(new BigDecimal(0)) == 0){
            ybInspectDataOld.setEndCarbonContentTail(ybInspectDataOld.getCarbonContentTail());
        }
        if(ybInspectDataOld.getEndOxygenContentTail().compareTo(new BigDecimal(0)) == 0){
            ybInspectDataOld.setEndOxygenContentTail(ybInspectDataOld.getOxygenContentTail());
        }
    }

    @Override
    public void saveDataAndGrade(YbInspectData ybInspectData) {
        saveDataAndGrade(ybInspectData, false);
    }

    @Override
    public Result<String> saveDataAndGrade(YbInspectData ybInspectData, boolean mandatoryTrigger) {
        Result<String> stringResult = null;
        saveOrUpdate(ybInspectData);

        PlanProcessingOrder planProcessingOrder = planProcessingOrderService.findByCodeAndOrderType(ybInspectData.getSectionNo(), EnumValuesFactory.PlanProcessingOrderOrderType.晶段.getKey());
        if (planProcessingOrder == null) {
            throw new BusinessException("工单不存在，请联系管理员");
        }
        String message = getGradeStatus(ybInspectData.getSticksCount(), planProcessingOrder);
        // 满足不能评级条件，直接创建评级记录
        if (message != null && !mandatoryTrigger) {
            createRuleTest(ybInspectData.getSectionNo(), message + "不再触发评级");
        }
        //执行评级
        else {
            Map<String, YbInspectData> map = new HashMap<>();
            map.put(ybInspectData.getSectionNo(), ybInspectData);
            gradeService.execGrade(map);
            ybInspectData = map.get(ybInspectData.getSectionNo());
            //处理是否需要反切， 晶段去找对应的评级返切规则,自动生成返切画线记录
            stringResult = productionRecutService.execProductionBackCuttingRecord(ybInspectData);
        }
        //修改工单重量与长度
        updatePlanProcessingOrderInfo(ybInspectData.getTheoryWeight(), ybInspectData.getActualLength(), planProcessingOrder);
        //重新计算直径平均值
        dao.recalculateAllAvgDiameter(ybInspectData.getCrystalNo());
        //异步发送检验信息变动mq消息
        inspectDataBaseChangeAsync.inspectDataBaseChange(ybInspectData);
        return stringResult;
    }

    @Override
    public void saveAndLog(YbInspectData inspectDataBase, DataInspectLog dataInspectLog) {
        dataInspectLogService.saveOrUpdate(dataInspectLog);
        dao.save(inspectDataBase);
    }

    @Override
    public String getGradeStatus(Integer sticksCount, PlanProcessingOrder planProcessingOrder) {
        String message = null;
        // 1.不是加工中状态，不再触发评级
        if (planProcessingOrder.getStatus() != EnumValuesFactory.PlanProcessingOrderStatus.加工中.getKey()) {
            message = "当前工单状态为：" + EnumValuesFactory.PlanProcessingOrderStatus.getText(planProcessingOrder.getStatus()) + "，不是加工中状态；";
        }
        // 2.已经是拼棒，不再触发评级
        if (sticksCount != null && sticksCount > 1) {
            message = "已经是拼棒；";
        }
        // 3.在制品站点不满足，不进行评级
        //   不在圆棒检验，并且不在截断待进站，就不进行评级
        if (planProcessingOrder.getWipStorage() != null) {
            FactoryModel factoryModel = wipStorageService.getFactoryModel(planProcessingOrder.getWipStorage().getProcessId(), planProcessingOrder.getWipStorage().getProcessName());
            //不在圆棒检验，并且不在截断待进站，就不进行评级
            boolean isGrade = !EnumValuesFactory.WipStorageCode.圆棒检验.getKey().equals(factoryModel.getCode()) && !(planProcessingOrder.getMaterialType() == EnumValuesFactory.MaterialType.圆棒.getKey() && EnumValuesFactory.WipStorageCode.圆棒截断.getKey().equals(factoryModel.getCode()) && planProcessingOrder.getWipStorage().getStatus() == EnumValuesFactory.WipStorageStatus.待进站.getKey());
            if (isGrade) {
                message = "当前站点为：" + EnumValuesFactory.WipStorageCode.getText(factoryModel.getCode()) + EnumValuesFactory.WipStorageStatus.getText(planProcessingOrder.getWipStorage().getStatus()) + "，不在圆棒检验和圆棒截断待进站；";
            }
        }
        return message;
    }

    /**
     * 修改工单重量与长度
     *
     * @param theoryWeight
     * @param actualLength
     * @param planProcessingOrder
     */
    private void updatePlanProcessingOrderInfo(BigDecimal theoryWeight, BigDecimal
            actualLength, PlanProcessingOrder planProcessingOrder) {
        if (theoryWeight != null || actualLength != null) {
            if (theoryWeight != null) {
                planProcessingOrder.setWeight(theoryWeight);
            }
            if (actualLength != null) {
                planProcessingOrder.setLength(actualLength);
            }
            planProcessingOrderService.createPlanProcessingOrder(planProcessingOrder, null, null);
        }
    }

    /**
     * 满足不能评级条件，直接创建评级记录
     *
     * @param sectionNo 晶段编号
     * @param message   不能评级备注
     */
    private void createRuleTest(String sectionNo, String message) {
        RuleTest ruleTest = new RuleTest();
        ruleTest.setGradeVersion(null);
        ruleTest.setGmtUpdate(new Date());
        ruleTest.setUserUpdate(BaseContextHandler.getUsername());
        ruleTest.setRemarks("正常评级-检验数据变动");
        ruleTestService.saveOrUpdate(ruleTest);
        List<RuleTestData> ruleTestDatas = new LinkedList<>();
        RuleTestData ruleTestData = new RuleTestData();
        ruleTestData.setGmtUpdate(new Date());
        ruleTestData.setUserUpdate(BaseContextHandler.getUsername());
        ruleTestData.setRuleTestId(ruleTest.getId());
        ruleTestData.setSectionNo(sectionNo);
        gradeService.setRuleTestData(ruleTestData, message);
        ruleTestDatas.add(ruleTestData);
        ruleTestDataService.saveAll(ruleTestDatas);
    }

    @Override
    public List<String> findByAllSectionNo() {
        return dao.findByAllSectionNo();
    }

    @Override
    public String getSectionComposeBySectionNo(String sectionNo) {
        return dao.getSectionComposeBySectionNo(sectionNo);
    }

    @Override
    public void updateIsCutBack(int isCutBack, String sectionNo) {
        dao.updateIsCutBack(isCutBack, sectionNo);
    }

    @Override
    public void updateOrderNoBySectionNo(String sectionNo, String orderNo) {
        dao.updateOrderNoBySectionNo(sectionNo, orderNo);
    }

    @Override
    public void updateOrderNoAndModelCodeBySectionNo(String sectionNo, String orderNo, String materialCode) {
        dao.updateOrderNoAndModelCodeBySectionNo(sectionNo, orderNo, materialCode);
    }

    @Override
    public void updateSticksCountFbSectionNoListFromYb(List<String> sectionNos, int i, Object o, String
            sectionType, Object o1) {
        dao.updateSticksCountFbSectionNoListFromYb(sectionNos, 1, null, sectionType, null);
    }

    @Override
    public Result<GetFbInfoDto> findInfoByYbNo(String sectionNoYb) {
        GetFbInfoDto getFbInfoDto = new GetFbInfoDto();
        List<SectionNoDetail> bySectionNo = this.sectionNoDetailDao.findBySectionNo(sectionNoYb);
        if (bySectionNo != null && bySectionNo.size() > 0) {
            SectionNoDetail sectionNoDetail = bySectionNo.get(0);
            if (!sectionNoYb.startsWith("B") && sectionNoDetail.getCrystalId() != null) {
                LongCrystal longCrystal = this.longCrystalService.get(sectionNoDetail.getCrystalId());
                getFbInfoDto.setOrderType(longCrystal.getOrderType());
                getFbInfoDto.setCrystalNo(longCrystal.getCrystalNo());
                getFbInfoDto.setPlanOrderType(longCrystal.getOrderType());
                getFbInfoDto.setPlanGrade(longCrystal.getProductGrade());
                getFbInfoDto.setPlanOrderNo(longCrystal.getOrderNo());
                getFbInfoDto.setSideLengthRange(longCrystal.getSideLengthRange());
                getFbInfoDto.setBatchNo(longCrystal.getBatchNo());
                getFbInfoDto.setMaterialCode(longCrystal.getProductCode());
            }
            if (StringUtils.isBlank(getFbInfoDto.getBatchNo())){
                LongCrystal byCrystalNo = longCrystalService.findByCrystalNo(sectionNoDetail.getCrystalNo());
                getFbInfoDto.setBatchNo(byCrystalNo.getBatchNo());
                getFbInfoDto.setMaterialCode(byCrystalNo.getProductCode());
            }
        }
        //从长晶棒拿方棒边长属性
        if (null != sectionNoYb && sectionNoYb.length() > 12) {

            String fromMark = sectionNoYb.substring(SectionIndexRangeEnum.基地追溯产品类型.getBeginIndex(), SectionIndexRangeEnum.基地追溯产品类型.getEndIndex());
            LongCrystal byCrystalNo = null;
            if (fromMark.matches("[A-Z]+")) {
                byCrystalNo = longCrystalService.findByCrystalNo(sectionNoYb.substring(SectionIndexRangeEnum.毛棒范围.getBeginIndex(), SectionIndexRangeEnum.毛棒范围.getEndIndex()));
                if (null != byCrystalNo && null != byCrystalNo.getSideLengthRange()) {
                    getFbInfoDto.setSideLengthRange(byCrystalNo.getSideLengthRange());
                }
            } else {
                byCrystalNo = longCrystalService.findByCrystalNo(sectionNoYb.substring(0, 12));
                if (null != byCrystalNo && null != byCrystalNo.getSideLengthRange()) {
                    getFbInfoDto.setSideLengthRange(byCrystalNo.getSideLengthRange());
                }
            }
        }
        YbInspectData ybInspectData = findBySectionNo(sectionNoYb);
        if (ybInspectData == null) {
            return ResultGenerator.success(getFbInfoDto);
        }
        getFbInfoDto.setConductionType(ybInspectData.getConductiveType());
//        getFbInfoDto.setInstoreLengthYb(ybInspectData.getWareHouseLength());
        getFbInfoDto.setLength(ybInspectData.getActualLength());
        getFbInfoDto.setProductLevel(ybInspectData.getProductLevel());
        getFbInfoDto.setDopant(ybInspectData.getDopant());
        getFbInfoDto.setOrderNo(ybInspectData.getOrderNo());
        getFbInfoDto.setYbExperiLevel(ybInspectData.getExperiLevel());
        getFbInfoDto.setYbSectionNo(ybInspectData.getSectionNo());
//        getFbInfoDto.setDiamDecide(ybInspectData.getDiamDecide());
//        getFbInfoDto.setFineDiameter(ybInspectData.getFineDiameter());
//        getFbInfoDto.setFineCutLength(ybInspectData.getFineCutLength());
        getFbInfoDto.setProductTypeSecond(ybInspectData.getProductTypeSecond());
        getFbInfoDto.setSectionCompose(ybInspectData.getSectionCompose());
        getFbInfoDto.setProductLevelExperiment(ybInspectData.getProductLevelExperiment());
        getFbInfoDto.setSticksCount(ybInspectData.getSticksCount());
        getFbInfoDto.setSpellBarLength(ybInspectData.getSpellBarLength());
        getFbInfoDto.setStickCount(ybInspectData.getSticksCount());
        getFbInfoDto.setProductType(ybInspectData.getProductType());
        getFbInfoDto.setPiecewiseNum(ybInspectData.getPiecewiseNum());
        getFbInfoDto.setHeadTailRecognition(ybInspectData.getHeadTailRecognition());
        if (null != ybInspectData.getSideLengthRange()) {
            getFbInfoDto.setSideLengthRange(ybInspectData.getSideLengthRange());
        }
        if (null != ybInspectData.getMaterialCode()){
            getFbInfoDto.setMaterialCode(ybInspectData.getMaterialCode());
        }
        getFbInfoDto.setCarbonContentHead(ybInspectData.getCarbonContentHead());
        getFbInfoDto.setCarbonContentTail(ybInspectData.getCarbonContentTail());
        getFbInfoDto.setMeanResistivityA(ybInspectData.getMeanResistivityA());
        getFbInfoDto.setMeanResistivityB(ybInspectData.getMeanResistivityB());
        getFbInfoDto.setMeanCarrierLifetimeA(ybInspectData.getMeanCarrierLifetimeA());
        getFbInfoDto.setMeanCarrierLifetimeB(ybInspectData.getMeanCarrierLifetimeB());
        getFbInfoDto.setMeanResistivityA(ybInspectData.getMeanResistivityA());
        getFbInfoDto.setMeanResistivityB(ybInspectData.getMeanResistivityB());
        getFbInfoDto.setTCarrierLifetime(ybInspectData.getTCentreLife());
        getFbInfoDto.setWCentreLife(ybInspectData.getWCentreLife());
        getFbInfoDto.setTResistivity(ybInspectData.getTResistivity());
        getFbInfoDto.setWResistivity(ybInspectData.getWResistivity());
        getFbInfoDto.setTLifeEdge1(ybInspectData.getTLifeEdge1());
        getFbInfoDto.setWCarrierLifetime(ybInspectData.getWLifeEdge1());
        return ResultGenerator.success(getFbInfoDto);
    }

    @Override
    public YbInspectDataToMcsDto getPinKuData(YbInspectData inspectDataBase, RankResultDto rankResultDto) {
        YbInspectDataToMcsDto ybInspectDataToMcsDto = new YbInspectDataToMcsDto();
        if (null != inspectDataBase) {
//            BeanUtil.copyBeanPropWithNullValue(ybInspectDataToMcsDto, inspectDataBase, "id");

            ybInspectDataToMcsDto.setSectionNo(inspectDataBase.getSectionNo());
            ybInspectDataToMcsDto.setProductTypeSecond(inspectDataBase.getProductTypeSecond());
            ybInspectDataToMcsDto.setActualLength(inspectDataBase.getActualLength());
            ybInspectDataToMcsDto.setProductType(inspectDataBase.getProductType());
            ybInspectDataToMcsDto.setConductiveType(inspectDataBase.getConductiveType());
            ybInspectDataToMcsDto.setOrderNo(inspectDataBase.getOrderNo());
            ybInspectDataToMcsDto.setProductLevel(inspectDataBase.getProductLevel());
            ybInspectDataToMcsDto.setGradeType(inspectDataBase.getGradeType());
            ybInspectDataToMcsDto.setPullType(inspectDataBase.getPullType());

            ybInspectDataToMcsDto.setTradialCentre(NumberUtil.object2String(inspectDataBase.getTRadialCentre(), null));
            ybInspectDataToMcsDto.setWradialCentre(NumberUtil.object2String(inspectDataBase.getWRadialCentre(), null));
            ybInspectDataToMcsDto.setTcentreLife(NumberUtil.object2String(inspectDataBase.getTCentreLife(), null));
            ybInspectDataToMcsDto.setWcentreLife(NumberUtil.object2String(inspectDataBase.getWCentreLife(), null));
            ybInspectDataToMcsDto.setOxygenContentHead(NumberUtil.object2String(inspectDataBase.getOxygenContentHead(), null));
            ybInspectDataToMcsDto.setOxygenContentTail(NumberUtil.object2String(inspectDataBase.getOxygenContentTail(), null));
            ybInspectDataToMcsDto.setCarbonContentHead(NumberUtil.object2String(inspectDataBase.getCarbonContentHead(), null));
            ybInspectDataToMcsDto.setCarbonContentTail(NumberUtil.object2String(inspectDataBase.getCarbonContentTail(), null));

            if (null != rankResultDto) {
                ybInspectDataToMcsDto.setProductLevel(rankResultDto.getProductRank());
                ybInspectDataToMcsDto.setProductTypeSecond(rankResultDto.getSpecs());
                ybInspectDataToMcsDto.setSectionNo(rankResultDto.getSectionNo());
                if (null != rankResultDto.getLength()) {
                    ybInspectDataToMcsDto.setActualLength(rankResultDto.getLength());
                }
                ybInspectDataToMcsDto.setGradeType(rankResultDto.getGradeType());
            }
            //todo    if(!StringUtils.isBlank(ybInspectDataToMcsDto.getProductLevel()) && (ybInspectDataToMcsDto.getProductLevel().equals("A1") || ybInspectDataToMcsDto.getProductLevel().equals("晶昇A2"))){
            if (!StringUtils.isBlank(ybInspectDataToMcsDto.getProductLevel()) && (ybInspectDataToMcsDto.getProductLevel().equals("A1") || ybInspectDataToMcsDto.getProductLevel().equals("A2"))) {
                ybInspectDataToMcsDto.setCarbonContentHead("合格");
                ybInspectDataToMcsDto.setCarbonContentTail("合格");
                ybInspectDataToMcsDto.setOxygenContentHead("合格");
                ybInspectDataToMcsDto.setOxygenContentTail("合格");
                ybInspectDataToMcsDto.setTradialCentre("合格");
                ybInspectDataToMcsDto.setWradialCentre("合格");
                ybInspectDataToMcsDto.setTcentreLife("合格");
                ybInspectDataToMcsDto.setWcentreLife("合格");
            } else if (!StringUtils.isBlank(ybInspectDataToMcsDto.getProductLevel())) {
                ybInspectDataToMcsDto.setCarbonContentHead("不合格");
                ybInspectDataToMcsDto.setCarbonContentTail("不合格");
                ybInspectDataToMcsDto.setOxygenContentHead("不合格");
                ybInspectDataToMcsDto.setOxygenContentTail("不合格");
                ybInspectDataToMcsDto.setTradialCentre("不合格");
                ybInspectDataToMcsDto.setWradialCentre("不合格");
                ybInspectDataToMcsDto.setTcentreLife("不合格");
                ybInspectDataToMcsDto.setWcentreLife("不合格");
            } else {
                ybInspectDataToMcsDto.setCarbonContentHead("");
                ybInspectDataToMcsDto.setCarbonContentTail("");
                ybInspectDataToMcsDto.setOxygenContentHead("");
                ybInspectDataToMcsDto.setOxygenContentTail("");
                ybInspectDataToMcsDto.setTradialCentre("");
                ybInspectDataToMcsDto.setWradialCentre("");
                ybInspectDataToMcsDto.setTcentreLife("");
                ybInspectDataToMcsDto.setWcentreLife("");
            }
//            if(!StringUtils.isBlank(ybInspectDataToMcsDto.getGradeType())){
//                List<CodingRecord> codingRecordBySectionNo = codingRecordService.getCodingRecordBySectionNo(ybInspectDataToMcsDto.getSectionNo());
//                //todo    if(null != codingRecordBySectionNo && codingRecordBySectionNo.size() > 0 && ybInspectDataToMcsDto.getProductLevel().equals("晶昇A2")){
//                if(null != codingRecordBySectionNo && codingRecordBySectionNo.size() > 0 && ybInspectDataToMcsDto.getProductLevel().equals("A2")){
//                    if(codingRecordBySectionNo.size() == 1 && (ybInspectDataToMcsDto.getGradeType().equals("正常") || ybInspectDataToMcsDto.getGradeType().equals("转规格"))){
//                        ybInspectDataToMcsDto.setGradeType("复测");
//                    }
//                }
//            }
            if (StringUtils.isBlank(ybInspectDataToMcsDto.getGradeType())) {
                ybInspectDataToMcsDto.setGradeType(null);
            }
        }
        return ybInspectDataToMcsDto;
    }

    @Override
    public List<YbInspectData> getDataByCrystalNo(String crystalNo) {
        return dao.findByCrystalNo1(crystalNo);
    }

    @Override
    @Transactional
    public Result readResultsImportMk(MultipartFile file) throws Exception {
        Map<String, List<Map<String, Object>>> excelMap;
        try {
            excelMap = ExcelUtil.getExcelInfo(file);
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception("文件导入异常！" + e.getMessage());
        }

        if (!excelMap.isEmpty()) {
            Collection<List<Map<String, Object>>> collection = excelMap.values();
            Iterator<List<Map<String, Object>>> iterator = collection.iterator();
            //遍历excel文件的内容
            while (iterator.hasNext()) {
                List<Map<String, Object>> list = iterator.next();
                for (Map<String, Object> map : list) {
                    YbInspectDataCUDto ybInspectDataCUDto = new YbInspectDataCUDto();
                    YbInspectData ybInspectData = new YbInspectData();
                    //1对单晶条码编号的校验
                    String ybSectionNo = StringUtils.valueOf(map.get("晶段编号")).toUpperCase();
                    if (StringUtils.isBlank(ybSectionNo)) {
                        throw new Exception("请输入晶段编号！");
                    }
                    ybInspectData.setSectionNo(ybSectionNo);

                    //电阻率T中心点
                    String headRadiaCentre = StringUtils.valueOf(map.get("电阻率T中心点"));
                    if (StringUtils.isBlank(headRadiaCentre)) {
                        throw new Exception("请输入电阻率T中心点！");
                    }
                    ybInspectData.setTRadialCentre(new BigDecimal(headRadiaCentre));
                    //电阻率T边缘1
                    String radiaCentreEdge1 = StringUtils.valueOf(map.get("电阻率T边缘1")).toUpperCase();
                    if (StringUtils.isBlank(radiaCentreEdge1)) {
                        throw new Exception("请输入电阻率T边缘1！");
                    }
                    ybInspectData.setTRadialEdge1(new BigDecimal(radiaCentreEdge1));
                    //电阻率T边缘2
                    String radiaCentreEdge2 = StringUtils.valueOf(map.get("电阻率T边缘2")).toUpperCase();
                    if (StringUtils.isBlank(radiaCentreEdge2)) {
                        throw new Exception("请输入电阻率T边缘2！");
                    }
                    ybInspectData.setTRadialEdge2(new BigDecimal(radiaCentreEdge2));
                    //电阻率W中心点
                    String tailRadiaCentre = StringUtils.valueOf(map.get("电阻率W中心点")).toUpperCase();
                    if (StringUtils.isBlank(tailRadiaCentre)) {
                        throw new Exception("请输入电阻率W中心点！");
                    }
                    ybInspectData.setWRadialCentre(new BigDecimal(tailRadiaCentre));
                    //电阻率W边缘1
                    String tailCentreEdge1 = StringUtils.valueOf(map.get("电阻率W边缘1")).toUpperCase();
                    if (StringUtils.isBlank(tailCentreEdge1)) {
                        throw new Exception("请输入电阻率W边缘1！");
                    }
                    ybInspectData.setWRadialEdge1(new BigDecimal(tailCentreEdge1));
                    //电阻率W边缘2
                    String tailCentreEdge2 = StringUtils.valueOf(map.get("电阻率W边缘2")).toUpperCase();
                    if (StringUtils.isBlank(tailCentreEdge2)) {
                        throw new Exception("请输入电阻率W边缘2！");
                    }
                    ybInspectData.setWRadialEdge2(new BigDecimal(tailCentreEdge2));
                    //T中心寿命
                    String headLifeCentre = StringUtils.valueOf(map.get("T中心寿命")).toUpperCase();
                    if (StringUtils.isBlank(headLifeCentre)) {
                        throw new Exception("请输入T中心寿命！");
                    }
                    ybInspectData.setTCentreLife(new BigDecimal(headLifeCentre));
                    //T边缘寿命1
                    String headLifeEdge1 = StringUtils.valueOf(map.get("T边缘寿命1")).toUpperCase();
                    if (StringUtils.isBlank(headLifeEdge1)) {
                        throw new Exception("请输入T边缘寿命1！");
                    }
                    ybInspectData.setTLifeEdge1(new BigDecimal(headLifeEdge1));
                    //T边缘寿命2
                    String headLifeEdge2 = StringUtils.valueOf(map.get("T边缘寿命2")).toUpperCase();
                    if (StringUtils.isBlank(headLifeEdge2)) {
                        throw new Exception("请输入T边缘寿命2！");
                    }
                    ybInspectData.setTLifeEdge2(new BigDecimal(headLifeEdge2));
                    //W中心寿命
                    String tailLifeCentre = StringUtils.valueOf(map.get("W中心寿命")).toUpperCase();
                    if (StringUtils.isBlank(tailLifeCentre)) {
                        throw new Exception("请输入W中心寿命！");
                    }
                    ybInspectData.setWCentreLife(new BigDecimal(tailLifeCentre));
                    //T边缘寿命1
                    String tailLifeEdge1 = StringUtils.valueOf(map.get("W边缘寿命1")).toUpperCase();
                    if (StringUtils.isBlank(tailLifeEdge1)) {
                        throw new Exception("请输入W边缘寿命1！");
                    }
                    ybInspectData.setWLifeEdge1(new BigDecimal(tailLifeEdge1));
                    //T边缘寿命2
                    String tailLifeEdge2 = StringUtils.valueOf(map.get("W边缘寿命2")).toUpperCase();
                    if (StringUtils.isBlank(tailLifeEdge2)) {
                        throw new Exception("请输入W边缘寿命2！");
                    }
                    ybInspectData.setWLifeEdge2(new BigDecimal(tailLifeEdge2));
                    //外观检验返切
                    String recut = StringUtils.valueOf(map.get("外观检验返切")).toUpperCase();
                    if (StringUtils.isBlank(recut)) {
                        throw new Exception("请输入外观检验返切！");
                    }
                    ybInspectData.setCheckReback(recut);
                    // 检验数据提交判断是否在圆棒检验待进站状态
                    wipStorageService.selectWipStorage(ybSectionNo, EnumValuesFactory.WipStorageCode.圆棒检验.getKey(), false);

                    ProductionPaintingLineDetail bySegmentNo = productionPaintingLineDetailService.findBySegmentNo(ybSectionNo);
                    if (bySegmentNo == null) {
                        throw new Exception("该圆棒单晶编号：" + bySegmentNo + "划线记录不存在");
                    }
                    YbInspectData no = findBySectionNo(ybSectionNo);
                    if (no != null) {
                        throw new Exception("该圆棒单晶编号：" + ybSectionNo + "圆棒检验数据已存在");
                    }
                    ybInspectData.setSectionNo(ybSectionNo);
                    if (null == no) {
                        // 通过圆棒编号 去追溯表判断晶段是否存在
                        SectionNoDetail sectionNoDetail = sectionNoDetailService.findBySectionNo(ybSectionNo);
                        if (sectionNoDetail == null) {
                            return ResultGenerator.fail(ybSectionNo + "晶段信息不存在，数据异常");
                        }
                        LongCrystal longCrystal = longCrystalService.get(sectionNoDetail.getCrystalId());
                        if (longCrystal == null) {
                            return ResultGenerator.fail(ybSectionNo + "长棒信息不存在，数据异常");
                        }
                        ybInspectData.setClosureIdentification(longCrystal.getClosureIdentification());
                        ybInspectData.setDiameterMax(longCrystal.getMaxDiam());
                        ybInspectData.setDiameterMin(longCrystal.getMinDiam());
                        initInspectData(ybInspectData, sectionNoDetail, longCrystal);
                    }

                    String fromMark = ybSectionNo.substring(SectionIndexRangeEnum.基地追溯产品类型.getBeginIndex(), SectionIndexRangeEnum.基地追溯产品类型.getEndIndex());
                    if(fromMark.matches("[A-Z]+")) {
                        ybInspectData.setCrystalNo(ybSectionNo.substring(SectionIndexRangeEnum.毛棒范围.getBeginIndex(), SectionIndexRangeEnum.毛棒范围.getEndIndex()));
                    }else {
                        ybInspectData.setCrystalNo(ybSectionNo.substring(0, 12));
                    }
                    ybInspectData.setInspector(BaseContextHandler.getUsername());
                    ybInspectData.setCreateTime(new Date());
                    //实测重量
                    ybInspectData.setActualWeight(ybInspectData.getActualLength());

                    BeanUtils.copyProperties(ybInspectData, ybInspectDataCUDto);
                    saveYbInspectData(ybInspectDataCUDto);
                }
            }
            return ResultGenerator.success();
        }
        return ResultGenerator.fail("数据有误，导入失败");
    }
}
