package com.sw.mes.jip.service.impl;

import java.util.List;
import com.sw.mes.core.annotation.Jinko;
import com.sw.mes.core.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.sw.mes.jip.dao.JipHeaderConfigDao;
import com.sw.mes.jip.entity.JipHeaderConfig;
import com.sw.mes.jip.service.JipHeaderConfigService;

/**
 * 晶科JIP接口配置信息Service业务层处理
 * 
 * @author liru
 * @date 2024-01-01
 */
@Slf4j
@Service
@Transactional
@Jinko(value="晶科JIP接口配置信息Service业务层处理",author = "liru")
public class JipHeaderConfigServiceImpl extends BaseServiceImpl<JipHeaderConfig> implements JipHeaderConfigService
{
    private JipHeaderConfigDao dao;

    @Autowired
    public void setDao(JipHeaderConfigDao dao) {
        super.setBaseDao(dao);
        this.dao=dao;
    }

    @Override
    public JipHeaderConfig getByIfId(String ifId) {
        List<JipHeaderConfig> configs = dao.findByIfId(ifId);
        if(configs.size()>0)
            return configs.get(0);
        return null;
    }

    @Override
    public JipHeaderConfig getByKeyword(String keyword) {
        List<JipHeaderConfig> configs = dao.findByKeyword(keyword);
        if(configs.size()>0)
            return configs.get(0);
        return null;
    }
}
