package com.sw.mes.outside.service.impl;

import cn.hutool.core.convert.Convert;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.sw.mes.base.factory.init.entity.*;
import com.sw.mes.base.factory.init.service.EquipmentService;
import com.sw.mes.base.factory.init.service.FactoryModelService;
import com.sw.mes.base.factory.init.service.MachineCapacityService;
import com.sw.mes.base.factory.product.entity.NewProductModel;
import com.sw.mes.base.factory.product.entity.NewProductModelDetail;
import com.sw.mes.base.factory.product.entity.ProductModel;
import com.sw.mes.base.factory.product.service.NewProductModelDetailService;
import com.sw.mes.base.factory.product.service.NewProductModelService;
import com.sw.mes.base.system.entity.DictionaryItem;
import com.sw.mes.base.system.entity.SysLog;
import com.sw.mes.base.system.service.DictionaryItemService;
import com.sw.mes.base.system.service.SysLogService;
import com.sw.mes.base.technology.entity.MaterialPath;
import com.sw.mes.base.technology.service.MaterialPathService;
import com.sw.mes.base.workinprocess.dto.ProcessingOrderNewDto;
import com.sw.mes.base.workinprocess.entity.PlanProcessingOrder;
import com.sw.mes.base.workinprocess.service.PlanProcessingOrderService;
import com.sw.mes.base.workinprocess.service.WipStorageService;
import com.sw.mes.config.drabbitmq.DrabbitmqConfig;
import com.sw.mes.core.annotation.Jinko;
import com.sw.mes.core.api.system.StoreFeignClients;
import com.sw.mes.core.context.BaseContextHandler;
import com.sw.mes.core.dto.WarehouseModelDto;
import com.sw.mes.core.dto.store.WarehouseInventoryDto;
import com.sw.mes.core.entity.SearchFilter;
import com.sw.mes.core.enums.EnumValuesFactory;
import com.sw.mes.core.enums.SectionIndexRangeEnum;
import com.sw.mes.core.exception.BusinessException;
import com.sw.mes.core.response.Result;
import com.sw.mes.core.response.ResultCode;
import com.sw.mes.core.response.ResultGenerator;

import com.sw.mes.core.utils.*;
import com.sw.mes.crucible.service.CrucibleFixedCastingService;
import com.sw.mes.enumvalue.EnumValuesEap;
import com.sw.mes.enumvalue.EnumValuesServer;
import com.sw.mes.enumvalue.SurplusStepEnum;
import com.sw.mes.mmcs.entity.MmcsDistributionPlan;
import com.sw.mes.mmcs.service.MmcsDistributionPlanService;
import com.sw.mes.mqtt.service.NotificationService;
import com.sw.mes.outside.dto.*;
import com.sw.mes.outside.service.EapService;
import com.sw.mes.outside.util.EAPUtils;
import com.sw.mes.redis.server.RedisUtils;
import com.sw.mes.sap.entity.ReportSapGoodsmvt;
import com.sw.mes.sap.service.ReportSapGoodsmvtService;
import com.sw.mes.yb.accessory.entity.EquipmentDeviceStatus;
import com.sw.mes.yb.accessory.service.EquipmentDeviceStatusService;
import com.sw.mes.yb.ipc.entity.ParamSet;
import com.sw.mes.yb.ipc.service.ParamSetService;
import com.sw.mes.yb.pc.entity.EstimatedRecord;
import com.sw.mes.yb.pc.service.EstimatedRecordService;
import com.sw.mes.yb.plan.entity.ProductionOrder;
import com.sw.mes.yb.plan.entity.ProductionSchedule;
import com.sw.mes.yb.plan.service.ProductionOrderService;
import com.sw.mes.yb.plan.service.ProductionScheduleService;
import com.sw.mes.yb.production.dto.AgainTask.AgainTaskDto;
import com.sw.mes.yb.production.dto.LoadingTask.LoadingTaskDto;
import com.sw.mes.yb.production.dto.LongCrystalDto;
import com.sw.mes.yb.production.dto.LongCrystalInfoDto;
import com.sw.mes.yb.production.dto.LongCrystalVO;
import com.sw.mes.yb.production.entity.*;
import com.sw.mes.yb.production.enums.SurplusInfoStatusEnum;
import com.sw.mes.yb.production.notification.SongYanMessage;
import com.sw.mes.yb.production.service.*;
import com.sw.mes.yb.report.dao.CrystalPullingInfoLogDao;
import com.sw.mes.yb.report.entity.*;
import com.sw.mes.yb.report.service.*;
import lombok.extern.slf4j.Slf4j;
import org.modelmapper.ModelMapper;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

import static com.sw.mes.enumvalue.EnumValuesEap.EapSignalType.*;

@Service
@Slf4j
public class EapServiceImpl implements EapService {
    @Autowired
    private WipStorageService wipStorageService;
    @Autowired
    private EquipmentService equipmentService;
    @Autowired
    private ProductionScheduleService productionScheduleService;
    @Autowired
    private LongCrystalService longCrystalService;
    @Autowired
    private EAPDockingService eapDockingService;
    @Autowired
    private DictionaryItemService dictionaryItemService;
    @Autowired
    private MachineCapacityService machineCapacityService;
    @Autowired
    private NotificationService notificationService;
    @Autowired
    private CrystalPullingInfoService crystalPullingInfoService;
    @Autowired
    private CrystalPullingInfoLogService crystalPullingInfoLogService;
    @Autowired
    private ProcessPathService processPathService;
    @Autowired
    private ProcessWorkingHoursService processWorkingHoursService;
    @Autowired
    private ParamSetService paramSetService;
    @Autowired
    private EquipmentDeviceStatusService equipmentDeviceStatusService;
    @Autowired
    private ShoulderSurvivalRateService shoulderSurvivalRateService;
    @Autowired
    private ShoulderSeedingRateService shoulderSeedingRateService;
    @Autowired
    private EquipmentExtendStateService equipmentExtendStateService;
    @Autowired
    private ExpansionBaseService expansionBaseService;
    @Autowired
    private BrokenBractBaseService brokenBractBaseService;
    @Autowired
    private SuccessCrystalBaseService successCrystalBaseService;
    @Autowired
    private CrystalBrokenBaseService crystalBrokenBaseService;
    @Autowired
    private MmcsDistributionPlanService mmcsDistributionPlanService;
    @Autowired
    private RedisUtils redisUtils;
    @Autowired
    private LoadingTaskService loadingTaskService;
    @Autowired
    private AgainTaskService againTaskService;
    @Autowired
    private AgainTaskDetailService againTaskDetailService;
    @Autowired
    private MaterialPathService materialPathService;
    @Autowired
    private ModelMapper modelMapper;

    @Autowired
    private IpcButtonControlService ipcButtonControlService;

    @Autowired
    private ProductionOrderService productionOrderService;

    @Autowired
    private CrystalPullingInfoLogDao crystalPullingInfoLogDao;

    @Autowired
    private ProcessWorkingStepService processWorkingStepService;

    @Autowired
    EstimatedRecordService estimatedRecordService;

    @Autowired
    private OutputRecordService outputRecordService;
    @Autowired
    private SysLogService sysLogService;

    @Autowired
    private FactoryModelService factoryModelService;

    @Autowired
    private NewProductModelService newProductModelService;

    @Autowired
    private SurplusInfoService surplusInfoService;

    @Autowired
    private ReportSapGoodsmvtService reportSapGoodsmvtService;

    @Autowired
    private NewProductModelDetailService newProductModelDetailService;

    @Autowired
    StoreFeignClients storeFeignClients;

    private static final String splicCode="qwe123!@#";

    private static Map<Integer, String> convertNumMap = new HashMap<Integer, String>();

    private static Map<String, String> materialCountTaskCodeScope = new HashMap<String, String>();

    public EapServiceImpl() {
        materialCountTaskCodeScope.put("初始装料", "1424");
        materialCountTaskCodeScope.put("投料重量", "复投总重");
        materialCountTaskCodeScope.put("初始复投", "复投总重");


        convertNumMap.put(0, "零段保持");
        convertNumMap.put(1, "一段保持");
        convertNumMap.put(2, "二段保持");
        convertNumMap.put(3, "三段保持");
        convertNumMap.put(4, "四段保持");
        convertNumMap.put(5, "五段保持");
        convertNumMap.put(6, "六段保持");
        convertNumMap.put(7, "七段保持");
        convertNumMap.put(8, "八段保持");
        convertNumMap.put(9, "九段保持");
        convertNumMap.put(10, "十段保持");
        convertNumMap.put(11, "十一段保持");
        convertNumMap.put(12, "十二段保持");
        convertNumMap.put(13, "十三段保持");
        convertNumMap.put(14, "十四段保持");
        convertNumMap.put(15, "十五段保持");
        convertNumMap.put(16, "十六段保持");
        convertNumMap.put(17, "十七段保持");
        convertNumMap.put(18, "十八段保持");
        convertNumMap.put(19, "十九段保持");
        convertNumMap.put(20, "二十段保持");
        convertNumMap.put(21, "二十一段保持");
        convertNumMap.put(22, "二十二段保持");
        convertNumMap.put(23, "二十三段保持");
        convertNumMap.put(24, "二十四段保持");
        convertNumMap.put(25, "二十五段保持");
        convertNumMap.put(26, "二十六段保持");
        convertNumMap.put(27, "二十七段保持");
        convertNumMap.put(28, "二十八段保持");
        convertNumMap.put(29, "二十九段保持");
        convertNumMap.put(30, "三十段保持");
        convertNumMap.put(31, "三十一段保持");
        convertNumMap.put(32, "三十二段保持");
        convertNumMap.put(33, "三十三段保持");
        convertNumMap.put(34, "三十四段保持");
        convertNumMap.put(35, "三十五段保持");
        convertNumMap.put(36, "三十六段保持");
        convertNumMap.put(37, "三十七段保持");
        convertNumMap.put(38, "三十八段保持");
        convertNumMap.put(39, "三十九段保持");
        convertNumMap.put(40, "四十段保持");
        convertNumMap.put(41, "四十一段保持");
        convertNumMap.put(42, "四十二段保持");
        convertNumMap.put(43, "四十三段保持");
        convertNumMap.put(44, "四十四段保持");
        convertNumMap.put(45, "四十五段保持");
        convertNumMap.put(46, "四十六段保持");
        convertNumMap.put(47, "四十七段保持");
        convertNumMap.put(48, "四十八段保持");
        convertNumMap.put(49, "四十九段保持");
        convertNumMap.put(50, "五十段保持");
    }


    @Override
    @Transactional
    public Result sendEapSignal(SendEapSignalDto sendEapSignalDto) {
        if (sendEapSignalDto.getCrystalInfoDto() == null) {
            sendEapSignalDto.setCrystalInfoDto(new CrystalInfoDto());
        }
        Equipment equipment = equipmentService.findByCode(sendEapSignalDto.getEquipmentCode());
        if (equipment == null) {
            return ResultGenerator.fail(sendEapSignalDto.getEquipmentCode() + "设备编号不存在");
        }
        EnumValuesEap.EapSignalType eapSignalenum = EnumValuesEap.EapSignalType.getEnum(sendEapSignalDto.getSignal());
        ProductionSchedule productionSchedule;
        if (eapSignalenum != null) {
            if (eapSignalenum == 开炉 || eapSignalenum == 备料 ) {
                MachineCapacity machineCapacity = machineCapacityService.findByEquipmentId(equipment.getId());
                if (machineCapacity != null) {
                    // 可排程时间
                    Date time = DateUtil.add(machineCapacity.getCreateTime(), 1, Calendar.MINUTE);
                    boolean klStatusBool = time.getTime() > new Date().getTime();
                    if (klStatusBool) {
                        return ResultGenerator.fail(equipment.getCode() +
                                "自动排程处理中，请在" + DateUtil.formatDate(time, DateUtil.longFormat) + "后，再点击备料");
                    }
                }
                productionSchedule = productionScheduleService.findTopByDeviceIdAndStatusOrderByIdDesc(equipment.getId(), EnumValuesServer.ProductionScheduleStatus.未开始.getKey());
                if (productionSchedule == null) {
                    log.error(sendEapSignalDto.getEquipmentCode() + "该设备没有的排产任务");
                    return ResultGenerator.fail(sendEapSignalDto.getEquipmentCode() + "该设备没有的排产任务");
                }
            } else {
                productionSchedule = productionScheduleService.findTopByDeviceIdAndStatusOrderByIdDesc(equipment.getId(), EnumValuesServer.ProductionScheduleStatus.进行中.getKey());
                if (productionSchedule == null) {
                    log.error(sendEapSignalDto.getEquipmentCode() + "该设备没有正在运行的排产任务");
                    return ResultGenerator.fail(sendEapSignalDto.getEquipmentCode() + "该设备没有正在运行的排产任务");
                }
            }
            if (eapSignalenum == 取段结晶) {
                final String key = "all_device_qdjj";
                ipcButtonControlService.ipcButtonControlTime(new IpcButtonControlTimeParam("取段结晶",60,sendEapSignalDto.getEquipmentCode(),"取段结晶",key));

                Result result = handleQujj(sendEapSignalDto, equipment, productionSchedule, true);

                if (result.getCode() == 200){
                    //按钮执行成功，更新redis对应key时间
                    redisUtils.hmSet(key, sendEapSignalDto.getEquipmentCode(), DateUtil.formatDate(new Date(), DateUtil.longFormat));
                }
                return result;
            } else if (eapSignalenum == 停炉) {
                final String key = "all_device_shutdown_time";
                ipcButtonControlService.ipcButtonControlTime(new IpcButtonControlTimeParam("停炉", 600, sendEapSignalDto.getEquipmentCode(), "停炉", key));

                equipmentDeviceStatusService.accessoryLifeRecord(sendEapSignalDto);
                if (StringUtils.isNotBlank(sendEapSignalDto.getCrystalInfoDto().getClosureIdentification()) && "W".equals(sendEapSignalDto.getCrystalInfoDto().getClosureIdentification())) {
                    //卡控:一个炉次只能有一根完结尾
                    LongCrystal longCrystal = longCrystalService.findBLotNoAndClosureIdentification(productionSchedule.getLotNo(), "W");
                    if(null != longCrystal){
                        log.error(longCrystal.getLotNo() + "炉次存在完结尾晶棒,编号为 :" + longCrystal.getCrystalNo());
                        return ResultGenerator.fail(longCrystal.getLotNo() + "炉次存在完结尾晶棒,编号为 :" + longCrystal.getCrystalNo());
                    }
                }
                Result result = handleTl(sendEapSignalDto, equipment, productionSchedule, 0);

                if (result.getCode() == 200) {
                    //按钮执行成功，更新redis对应key时间
                    redisUtils.hmSet(key, sendEapSignalDto.getEquipmentCode(), DateUtil.formatDate(new Date(), DateUtil.longFormat));

                    // 自动开炉
                     DrabbitmqConfig.sendAutomaticDelayedStartOfMaterialPreparation(sendEapSignalDto.getEquipmentCode());
                }
                return result;
            } else if (eapSignalenum == 开炉 || eapSignalenum == 备料) {
                final String key;
                if (eapSignalenum == 开炉){
                    key = "all_device_kl";
                    ipcButtonControlService.ipcButtonControlTime(new IpcButtonControlTimeParam("开炉",60,sendEapSignalDto.getEquipmentCode(),"开炉",key));
                }else {
                    key = "all_device_bl";
                    ipcButtonControlService.ipcButtonControlTime(new IpcButtonControlTimeParam("备料",60,sendEapSignalDto.getEquipmentCode(),"备料",key));
                }
                Result result = handleKl(sendEapSignalDto, equipment, productionSchedule);
                if (result.getCode() == 200){
                    //按钮执行成功，更新redis对应key时间
                    redisUtils.hmSet(key, sendEapSignalDto.getEquipmentCode(), DateUtil.formatDate(new Date(), DateUtil.longFormat));
                }
                return result;
            } else if (eapSignalenum == 熔料) {
                final String key = "all_device_rl";
                ipcButtonControlService.ipcButtonControlTime(new IpcButtonControlTimeParam("熔料",60,equipment.getCode(),"熔料",key));
                //剩料重量
                BigDecimal residualWeight = sendEapSignalDto.getCrystalInfoDto().getResidualWeight();
                //总装锅料
                BigDecimal totalWeight = sendEapSignalDto.getCrystalInfoDto().getTotalWeight();
                PlanProcessingOrder planProcessingOrder = planProcessingOrderService.get(productionSchedule.getLotId());
                Result result = handleRl(equipment, productionSchedule, residualWeight, totalWeight, planProcessingOrder.getAgainNum());
                if (result.getCode() == 200){
                    //按钮执行成功，更新redis对应key时间
                    redisUtils.hmSet(key, equipment.getCode(), DateUtil.formatDate(new Date(), DateUtil.longFormat));
                }
                return result;
            } else if (eapSignalenum == 取段稳温) {
                final String key = "all_device_qdww";
                ipcButtonControlService.ipcButtonControlTime(new IpcButtonControlTimeParam("取段稳温",60,sendEapSignalDto.getEquipmentCode(),"取段稳温",key));
                Result result = handleQujj(sendEapSignalDto, equipment, productionSchedule, false);
                if (result.getCode() == 200){
                    //按钮执行成功，更新redis对应key时间
                    redisUtils.hmSet(key, sendEapSignalDto.getEquipmentCode(), DateUtil.formatDate(new Date(), DateUtil.longFormat));
                }
                return result;
            } else if (eapSignalenum == 焖锅漏硅) {
                return handleTl(sendEapSignalDto, equipment, productionSchedule, 1);
            } else if (eapSignalenum == 抽真空) {
                final String key = "all_device_czk";
                ipcButtonControlService.ipcButtonControlTime(new IpcButtonControlTimeParam("开炉",60,sendEapSignalDto.getEquipmentCode(),"抽真空",key));
                equipmentDeviceStatusService.accessoryLifeRecord(sendEapSignalDto);
                redisUtils.hmSet(key, sendEapSignalDto.getEquipmentCode(), DateUtil.formatDate(new Date(), DateUtil.longFormat));

                //需求变更：抽真空时，记录（更新）拉晶实时情况的开始时间
                updateStartTimeForPullingInfo(sendEapSignalDto.getEquipmentCode());

                return ResultGenerator.success();
            } else {
                log.info("该信号未处理");
                return ResultGenerator.fail("该信号未处理");
            }
        } else {
            log.info("信号类型未知");
            return ResultGenerator.fail("信号类型未知");
        }
    }

    /**
     * 处理熔料信号
     *
     * @param equipment
     * @param productionSchedule
     * @return
     */
    private Result handleRl(Equipment equipment, ProductionSchedule productionSchedule, BigDecimal residualWeight, BigDecimal totalWeight, Integer againNum) {
        productionSchedule.setStatusInfo("接收熔料信号");
        productionScheduleService.saveOrUpdate(productionSchedule);
        // 发送初始复投
        return ftTaskCreate(productionSchedule, equipment, 1, residualWeight, totalWeight, 1,0);
    }


    @Autowired
    private PlanProcessingOrderService planProcessingOrderService;

    /**
     * 处理开炉信号
     *
     * @param sendEapSignalDto
     * @param equipment
     * @param productionSchedule
     * @return
     */
    private Result handleKl(SendEapSignalDto sendEapSignalDto, Equipment equipment, ProductionSchedule productionSchedule) {
        ProductionSchedule productionScheduleRun = productionScheduleService.findTopByDeviceIdAndStatusOrderByIdDesc(equipment.getId(), EnumValuesServer.ProductionScheduleStatus.进行中.getKey());
        if (productionScheduleRun != null) {
            log.error(sendEapSignalDto.getEquipmentCode() + "该设备还有进行中的排产任务，无法开炉");
            return ResultGenerator.fail(sendEapSignalDto.getEquipmentCode() + "该设备还有进行中的排产任务，无法开炉");
        }

        //0907 经讨论，eap开炉、停炉时不再对设备台账表、单晶炉运行状态表做状态写入，故注释相关代码,保持设备台账表、单晶炉运行状态表中状态字段的一致性
//        EquipmentExtendState equipmentExtendState = equipmentExtendStateService.getByCode(equipment.getCode());
//        if (equipmentExtendState != null) {
//            equipmentExtendState.setEquipmentState(1);
//            equipmentExtendStateService.saveOrUpdate(equipmentExtendState);
//        }

        /*Date currentMonthFirstTime9H = DateUtil.getCurrentMonthStartTime1();
        Date nowDate = new Date();
        String moth;
        String stoveFirstSegment;
        if (nowDate.getTime() < currentMonthFirstTime9H.getTime()) {
            moth = DateUtil.formatDate(DateUtil.subOneDay(nowDate), "yyMM");
//            moth = DateUtil.formatDate(nowDate, "yyMM");
            stoveFirstSegment = generateStoveFirstSegment(false);
        } else {
//            moth = DateUtil.formatDate(DateUtil.addOneDay(nowDate), "yyMM");
            moth = DateUtil.formatDate(nowDate, "yyMM");
            stoveFirstSegment = generateStoveFirstSegment(true);

        }*/
        //auth:scm 美科炉次号第一段规则变更。例如：2B A01 3 .第一位取年的最后一位，第二位取当前月，如果大于9分别用A/B/C代表10/11/12
//        String stoveFirstSegment=generateStoveFirstSegment();
        String moth = DateUtil.formatDate(new Date(), "yyMM");
        LocalDate localDate = LocalDate.now();
        String ym = (localDate.getYear()-2020) + CodeMapUtils.NUM_CODE_MAP.get(localDate.getMonthValue());

        PlanProcessingOrder planProcessingOrderLast = planProcessingOrderService.findTopByEquipmentIdAndOrderTypeAndMothOrderByIdDesc(equipment.getId(), EnumValuesFactory.WipStorOrderType.炉次.getKey(), moth);
        // 开启新的炉次
        PlanProcessingOrder planProcessingOrder = new PlanProcessingOrder();
        planProcessingOrder.setWeight(BigDecimal.valueOf(productionSchedule.getCount() / 3));
        planProcessingOrder.setModelId(productionSchedule.getProductModel().getId());
        planProcessingOrder.setModelType(EnumValuesFactory.PlanProcessingOrderModelType.产品.getKey());
        planProcessingOrder.setEquipmentId(equipment.getId());
        planProcessingOrder.setEquipmentCode(equipment.getCode());
        //planProcessingOrder.setAgainNum(0);
        //美科设置复投次数第一次为1
        planProcessingOrder.setAgainNum(1);
        planProcessingOrder.setCrystalNum(1);
        if (planProcessingOrderLast == null) {
            planProcessingOrder.setLotTimes(1);
        } else {
            planProcessingOrder.setLotTimes(planProcessingOrderLast.getLotTimes() + 1);
        }
        planProcessingOrder.setMoth(moth);
        planProcessingOrder.setStatus(EnumValuesFactory.PlanProcessingOrderStatus.待加工.getKey());
        //设置开炉炉次号
//        if (StringUtils.isEmpty(productionSchedule.getProductionOrder().getFromMark())) {
        //炉次内切换排程
        planProcessingOrder.setCode(ym + equipment.getCode() + planProcessingOrder.getLotTimes());
//        } else {
//            //追溯改造
//            planProcessingOrder.setCode(productionSchedule.getProductionOrder().getBaseMark() + productionSchedule.getProductionOrder().getProductType() + stoveFirstSegment + equipment.getCode() + planProcessingOrder.getLotTimes());
//        }
        planProcessingOrder.setOrderType(EnumValuesFactory.WipStorOrderType.炉次.getKey());
        planProcessingOrder.setOrderDataId(productionSchedule.getProductionOrder().getId());
        planProcessingOrder.setGoodsId(0L);
        MaterialPath materialPath = materialPathService.getMaterialPath(productionSchedule.getProductModel().getCode(),EnumValuesFactory.WipStorOrderType.炉次.getKey());
        if(materialPath == null || materialPath.getPathId() == null){
            return ResultGenerator.fail("料号"+productionSchedule.getProductModel().getCode()+"未绑定工艺路线，无法开炉！");
        }
        planProcessingOrder.setPathId(materialPath.getPathId());
        planProcessingOrderService.createPlanProcessingOrder(planProcessingOrder, null, null);
        planProcessingOrder.setGoodsId(planProcessingOrder.getId());
        planProcessingOrderService.createPlanProcessingOrder(planProcessingOrder, null, null);
        wipStorageService.inStation(planProcessingOrder.getCode(), equipment.getCode());

        ProductionSchedule productionSchedule1 = new ProductionSchedule();
        BeanUtils.copyProperties(productionSchedule, productionSchedule1);
        productionSchedule1.setId(null);
        productionSchedule1.setLotNo(planProcessingOrder.getCode());
        productionSchedule1.setLotId(planProcessingOrder.getId());
        //炉次内切换排程
        if (StringUtils.isEmpty(productionSchedule.getProductionOrder().getFromMark())) {
            //炉次内切换排程
            productionSchedule1.setDeliveryNo(ym + equipment.getCode() + planProcessingOrder.getLotTimes());
        } else {
            productionSchedule1.setDeliveryNo(productionSchedule.getProductionOrder().getBaseMark() + productionSchedule.getProductionOrder().getProductType() + ym + equipment.getCode() + planProcessingOrder.getLotTimes());
        }
        productionSchedule1.setStatusInfo("接收到开炉信号，开始新的炉次");
        productionSchedule1.setStatus(EnumValuesServer.ProductionScheduleStatus.待备料.getKey());
        productionSchedule1.setCount(productionSchedule.getCount() / 3);
        productionSchedule1.setCreateTime(new Date());
        productionScheduleService.saveOrUpdate(productionSchedule1);

        //开炉清空拉晶情况 - 重置炉次号
        resetCode(productionSchedule1.getDeviceNo(), productionSchedule1.getLotNo(), productionSchedule.getProductModel());

        //开炉时修改设备状态为运行
        equipment.setEnableState(true);
        equipmentService.saveOrUpdate(equipment);

        return handleStart(equipment, productionSchedule1);
    }

    private String generateStoveFirstSegment(Boolean flag) {
        Calendar c = Calendar.getInstance();
        String year = String.valueOf(String.valueOf(c.get(Calendar.YEAR)).charAt(3));
        int intMonth = c.get(Calendar.MONTH)+1;
        int day = c.get(Calendar.DAY_OF_MONTH);

        //未超过当月第一天早上八点半月份减少一月
        if(!flag){
            if(intMonth == 1){
                intMonth = 12;
                c.add(Calendar.YEAR, -1);
                year = String.valueOf(String.valueOf(c.get(Calendar.YEAR)).charAt(3));
            }
            if(intMonth != 1 && day == 1){
                intMonth = intMonth - 1;
            }
        }
        String strMonth=String.valueOf(intMonth);
        if (intMonth>9){
            switch (intMonth){
                case 10:
                    strMonth="A";
                    break;
                case 11:
                    strMonth="B";
                    break;
                case 12:
                    strMonth="C";
                    break;
            }
        }

        return year+strMonth;
    }

    /**
     * 处理停炉信号
     *
     * @param sendEapSignalDto   eap 信号
     * @param equipment          设备
     * @param productionSchedule 设备排产任务
     * @param type               0：正常停炉，1：焖锅漏硅
     * @return
     */
    private Result handleTl(SendEapSignalDto sendEapSignalDto, Equipment equipment, ProductionSchedule productionSchedule, int type) {
        PlanProcessingOrder planProcessingOrder = planProcessingOrderService.get(productionSchedule.getLotId());
        equipment.setEnableState(true);
        equipmentService.saveOrUpdate(equipment);

//0907 经讨论，eap开炉、停炉时不再对设备台账表、单晶炉运行状态表做状态写入，故注释相关代码,保持设备台账表、单晶炉运行状态表中状态字段的一致性
//        EquipmentExtendState equipmentExtendState = equipmentExtendStateService.getByCode(equipment.getCode());
//        if (equipmentExtendState != null) {
//            equipmentExtendState.setEquipmentState(2);
//            equipmentExtendStateService.saveOrUpdate(equipmentExtendState);
//        }

        LongCrystal longCrystal = null;
        if (type == 0 && sendEapSignalDto.getCrystalInfoDto() != null && sendEapSignalDto.getCrystalInfoDto().getLength() != null && sendEapSignalDto.getCrystalInfoDto().getLength().doubleValue() > 350) {
            if (sendEapSignalDto.getCrystalInfoDto() != null && sendEapSignalDto.getCrystalInfoDto().getAgainNum() != null) {
                planProcessingOrder.setAgainNum(sendEapSignalDto.getCrystalInfoDto().getAgainNum());
            }
            if (sendEapSignalDto.getCrystalInfoDto() != null && sendEapSignalDto.getCrystalInfoDto().getCrystalNum() != null) {
                planProcessingOrder.setCrystalNum(sendEapSignalDto.getCrystalInfoDto().getCrystalNum());
            }
            execCrystalNumRule(sendEapSignalDto, planProcessingOrder);
            // 保存长棒信息
            longCrystal = saveLongCrystal(sendEapSignalDto, equipment, productionSchedule, planProcessingOrder, true);
        }
        planProcessingOrder.setStatus(EnumValuesFactory.PlanProcessingOrderStatus.加工完成.getKey());
        planProcessingOrderService.saveOrUpdate(planProcessingOrder);

        //处理炉次任务，改成完成
        productionSchedule.setStatus(EnumValuesServer.ProductionScheduleStatus.已完成.getKey());
        productionSchedule.setStatusInfo("接收停炉信号");
        productionScheduleService.saveOrUpdate(productionSchedule);
        //修改设备加工能力的已开炉次数量
        MachineCapacity machineCapacity = machineCapacityService.findByEquipmentId(planProcessingOrder.getEquipmentId());
        if (machineCapacity != null) {
            //防止eap错误，关闭自动增长已开炉次
            machineCapacity.setUsedCount((machineCapacity.getUsedCount() == null ? 0 : machineCapacity.getUsedCount()) + 1);
            if (machineCapacity.getCapacityInfoNext() != null) {
                MachineCapacity machineCapacity1 = JSON.parseObject(machineCapacity.getCapacityInfoNext(), MachineCapacity.class);
                machineCapacity.setCapacityInfo(machineCapacity1.getCapacityInfo());
                machineCapacity.setProductType(machineCapacity1.getProductType());
                machineCapacity.setRdlogo(machineCapacity1.getRdlogo());
                machineCapacity.setRdonlylogo(machineCapacity1.getRdonlylogo());
                machineCapacity.setCapacityInfoNext(null);
                machineCapacity.setCreateTime(new Date());
            }
        }
        machineCapacityService.saveOrUpdate(machineCapacity);
        if (longCrystal != null) {
            //处理完所有业务，发送取晶体通知
            sendGetCrystalNotification(longCrystal);
        }
        CrystalPullingInfo info = crystalPullingInfoService.getByDeviceNo(equipment.getCode());
        clearCrystalPullingInfo(info, equipment.getCode());

        // 上报SAP氩气消耗
        reportArgonToSap(productionSchedule);

        redisUtils.hmSet("all_device_shutdown_time", equipment.getCode(), DateUtil.formatDate(new Date(), DateUtil.longFormat));
        return ResultGenerator.success();
    }


    /**
     * 停炉时上报SAP氩气消耗
     * @param schedule
     */
    private void reportArgonToSap(ProductionSchedule schedule){
        ReportSapGoodsmvt reportSap = new ReportSapGoodsmvt();
        reportSap.setBwart("261");		// 移动类型
        reportSap.setKostl(null);		// 成本中心
        reportSap.setProcName("拉晶");	// 工序
        reportSap.setAufnr(schedule.getCode());		// SAP生产订单
        NewProductModel productModel = newProductModelService.findByCode(schedule.getProductModel().getCode());
        if (ObjectUtils.isEmpty(productModel)) return;
        List<NewProductModelDetail> modelDetailList = newProductModelDetailService.findByProductModelId(productModel.getId());
        if (CollectionUtils.isEmpty(modelDetailList)) return;
        NewProductModelDetail modelDetail = null;
        for (NewProductModelDetail detail : modelDetailList) {
            if (detail.getCodeName().contains("氩气")){
                modelDetail = detail;
                break;
            }
        }
        if (ObjectUtils.isEmpty(modelDetail)) return;

        reportSap.setMatnr(modelDetail.getCode());	// 物料编码

        // 查询氩气库存信息
        Result<List<WarehouseInventoryDto>> result = storeFeignClients.getByMaterialCode(modelDetail.getCode());
        if (ResultCode.SUCCESS.getCode() != result.getCode()) return;
        List<WarehouseInventoryDto> resultData = result.getData();
        if (CollectionUtils.isEmpty(resultData)) return;
        for (WarehouseInventoryDto dto : resultData) {
            if (dto.getBatchNo() == null || dto.getWarehouseCode() == null) continue;
            reportSap.setCharg(dto.getBatchNo());		// 批次号
            reportSap.setLgort(dto.getWarehouseCode());	// 库存地点
        }

        // 从字典中获取数量和单位
        DictionaryItem weight = dictionaryItemService.findByThemeValueAndNameAndEnable("reportArgonToSap", "weight", true);
        if (weight != null) reportSap.setMenge(weight.getValue());	// 数量
        DictionaryItem unit = dictionaryItemService.findByThemeValueAndNameAndEnable("reportArgonToSap", "unit", true);
        if(unit != null) reportSap.setMeins(unit.getValue());		// 单位

        reportSapGoodsmvtService.saveOrUpdate(reportSap);
    }


    /**
     * 采集的引晶剩料重量，并且小于900，并且指定课次为null，并且当前颗次小于2，才将当前颗次改为2
     *
     * @param sendEapSignalDto
     * @param planProcessingOrder
     */
    private void execCrystalNumRule(SendEapSignalDto sendEapSignalDto, PlanProcessingOrder planProcessingOrder) {
        if (planProcessingOrder.getCrystalNum() < 2 && sendEapSignalDto.getCrystalInfoDto().getCrystalIntroductionResidualWeight() != null
                && sendEapSignalDto.getCrystalInfoDto().getCrystalNum() == null) {
            BigDecimal crystalIntroductionResidualWeight = new BigDecimal("900");
            Boolean isExists = null;
            try {
                isExists = redisUtils.exists("CrystalNumRule");
            } catch (Exception ignored) {
            }
            if (isExists != null && isExists) {
                Object crystalNumRule = redisUtils.get("CrystalNumRule");
                crystalIntroductionResidualWeight = NumberUtil.Object2BigDecimal(crystalNumRule, crystalIntroductionResidualWeight);
            } else {
                DictionaryItem dictionaryItem = dictionaryItemService.findByThemeValueAndNameAndEnable("CrystalNumRule", "引晶剩料重量", true);
                crystalIntroductionResidualWeight = NumberUtil.Object2BigDecimal(dictionaryItem.getValue(), crystalIntroductionResidualWeight);
                if (isExists != null) {
                    redisUtils.set("CrystalNumRule", crystalIntroductionResidualWeight, 10L, TimeUnit.MINUTES);
                }
            }
            if (sendEapSignalDto.getCrystalInfoDto().getCrystalIntroductionResidualWeight().compareTo(crystalIntroductionResidualWeight) < 0) {
                planProcessingOrder.setCrystalNum(2);
            }
        }
    }

    /**
     * 处理取段结晶信号，取段稳温信号
     *
     * @param sendEapSignalDto
     * @param equipment
     * @param productionSchedule
     * @return
     */
    private Result handleQujj(SendEapSignalDto sendEapSignalDto, Equipment equipment, ProductionSchedule productionSchedule, Boolean isFt) {
        // 保存长棒信息
        PlanProcessingOrder planProcessingOrder = planProcessingOrderService.get(productionSchedule.getLotId());
        if (sendEapSignalDto.getCrystalInfoDto().getAgainNum() != null) {
            planProcessingOrder.setAgainNum(sendEapSignalDto.getCrystalInfoDto().getAgainNum());
        }
        if (sendEapSignalDto.getCrystalInfoDto().getCrystalNum() != null) {
            planProcessingOrder.setCrystalNum(sendEapSignalDto.getCrystalInfoDto().getCrystalNum());
        }
        boolean isOutput = false;
        LongCrystal longCrystal = null;

        //获取当前产出单晶对应订单的规格，再根据规格查询最小长度的长晶棒
        double lengthControl;
        DictionaryItem defaultItem = dictionaryItemService.findByThemeValueAndNameAndEnable("longCrystalLengthControl", "default", true);
        String defaultValue = Optional.ofNullable(defaultItem).map(DictionaryItem::getValue).orElse("1");

        String spec = Optional.of(productionSchedule).map(ProductionSchedule::getProductionOrder).map(ProductionOrder::getProductModel).map(ProductModel::getSpecs).orElse("-1");
        if ("-1".equals(spec)){
            lengthControl = Convert.toDouble(defaultValue);
        }else {
            DictionaryItem item = dictionaryItemService.findByThemeValueAndNameAndEnable("longCrystalLengthControl", spec, true);
            String value = Optional.ofNullable(item).map(DictionaryItem::getValue).orElse(defaultValue);
            lengthControl = Convert.toDouble(value, 1d);
        }

        if (sendEapSignalDto.getCrystalInfoDto() != null && sendEapSignalDto.getCrystalInfoDto().getLength() != null && sendEapSignalDto.getCrystalInfoDto().getLength().doubleValue() >= lengthControl) {
            isOutput = true;
            execCrystalNumRule(sendEapSignalDto, planProcessingOrder);
            longCrystal = saveLongCrystal(sendEapSignalDto, equipment, productionSchedule, planProcessingOrder, false);
        }
        if (isFt) {
            //复投次数加1
            planProcessingOrder.setAgainNum(planProcessingOrder.getAgainNum() + 1);
            //取段结晶，重置当前颗次 1
            planProcessingOrder.setCrystalNum(1);
            planProcessingOrder.setOutputMode(0);
        } else {
            //取段稳温，重置当前颗次 1
            planProcessingOrder.setCrystalNum(planProcessingOrder.getCrystalNum() + 1);
            planProcessingOrder.setOutputMode(1);
        }
        planProcessingOrderService.saveOrUpdate(planProcessingOrder);

        //开始复投生产下一颗次
        ProductionSchedule productionSchedule1 = productionScheduleService.findTopByDeviceIdAndStatusOrderByIdDesc(equipment.getId(), EnumValuesServer.ProductionScheduleStatus.未开始.getKey());
        MachineCapacity byEquipmentId = machineCapacityService.findByEquipmentId(equipment.getId());
        String capacityInfoNext = byEquipmentId.getCapacityInfoNext();
        Boolean flag = false;
        if(null == capacityInfoNext){
            flag = true;
        }
        ProductionSchedule productionSchedule2 = null;
        if (productionSchedule1 != null && productionSchedule1.getProductionOrder().getId().intValue() != productionSchedule.getProductionOrder().getId() && flag) {
            //处理炉次任务，改成完成
            productionSchedule.setStatus(EnumValuesServer.ProductionScheduleStatus.已完成.getKey());
            productionSchedule.setStatusInfo("加工能力改变，当前任务结束");
            productionScheduleService.saveOrUpdate(productionSchedule);
            //加工能改变，按照新的加工能力生产
            productionSchedule2 = new ProductionSchedule();
            BeanUtils.copyProperties(productionSchedule1, productionSchedule2);
            productionSchedule2.setCreateTime(new Date());
            productionSchedule2.setId(null);
            productionSchedule2.setLotNo(productionSchedule.getLotNo());

            // 删除追溯信息-WXL标记
            /*String baseMark = productionSchedule1.getProductionOrder().getBaseMark() == null ? "" : productionSchedule1.getProductionOrder().getBaseMark();
            if (StringUtils.isEmpty(baseMark)) {
                //炉次内切换旧版本订单的排程,使用上个排程的 : 炉次号 作为 发料编号
                productionSchedule2.setDeliveryNo(productionSchedule.getLotNo());
            } else {
                //炉次内切换新版本订单的排程,使用新排程的 : 基地+产品类别+上一个排程的炉次号 作为 发料编号
                productionSchedule2.setDeliveryNo(baseMark + productionSchedule1.getProductionOrder().getProductType() + productionSchedule.getLotNo());
            }*/

            productionSchedule2.setLotId(productionSchedule.getLotId());
            productionSchedule2.setStatusInfo("匹配到新的加工能力，任务开始");
            productionSchedule2.setStatus(EnumValuesServer.ProductionScheduleStatus.进行中.getKey());
            //开始新的任务
            productionScheduleService.saveOrUpdate(productionSchedule2);
        } else {
            productionSchedule.setStatusInfo("接收到取段结晶信号，发送复投任务" + (!isOutput ? "，当前产出长度为：" + sendEapSignalDto.getCrystalInfoDto().getLength() + "，不生成产出记录" : ""));
            productionScheduleService.saveOrUpdate(productionSchedule);
        }
        //处理完所有业务，发送取晶体通知
        if (longCrystal != null) {
            sendGetCrystalNotification(longCrystal);
        }
        if (isFt) {
            //省料重量
            BigDecimal residualWeight = sendEapSignalDto.getCrystalInfoDto().getResidualWeight();
            //总装埚料
            BigDecimal totalWeight = sendEapSignalDto.getCrystalInfoDto().getTotalWeight();

            // 发送复投任务
            if (productionSchedule2 == null) {
                return ftTaskCreate(productionSchedule, equipment, 2, residualWeight, totalWeight, planProcessingOrder.getAgainNum(),sendEapSignalDto.getCrystalInfoDto().getIsDone());
            } else {
                return ftTaskCreate(productionSchedule2, equipment, 2, residualWeight, totalWeight, planProcessingOrder.getAgainNum(),sendEapSignalDto.getCrystalInfoDto().getIsDone());
            }
        }
        return ResultGenerator.success();
    }

    //处理完所有业务，发送取晶体通知
    private void sendGetCrystalNotification(LongCrystal longCrystal) {
        try {
            //TODO 李儒添加代码
            if (longCrystal.getLength().floatValue() >= 1500) {
                //发送MQTT通知
                SongYanMessage message = new SongYanMessage();
                message.setArea(longCrystal.getArea());
                message.setEquipmentCode(longCrystal.getEquipmentCode());
                message.setId(longCrystal.getId());
                message.setLotNo(longCrystal.getLotNo());
                message.setSeries(longCrystal.getSeries());
                notificationService.sendNotification(message);
            }
        } catch (Exception e) {
        }
    }

    /**
     * 发送复投任务
     *
     * @param productionSchedule
     * @param equipment
     * @param rawType
     * @return
     */
    private Result ftTaskCreate(ProductionSchedule productionSchedule, Equipment equipment, Integer rawType, BigDecimal residualWeight, BigDecimal totalWeight, Integer againNum,Integer isDone) {
        try {
            AgainTaskDto againTaskDto = new AgainTaskDto();
            againTaskDto.setSeries(equipment.getSeries());
            againTaskDto.setArea(equipment.getArea());
            againTaskDto.setRawType(rawType);
            againTaskDto.setSapNo(productionSchedule.getProductionOrder().getAufnr());
            againTaskDto.setFurnaceType(productionSchedule.getFurnaceType());
            againTaskDto.setEquipmentCode(productionSchedule.getDeviceNo());
            againTaskDto.setLotNo(productionSchedule.getLotNo());
            againTaskDto.setProductCode(productionSchedule.getProductModel().getCode());
            againTaskDto.setProductGrade(productionSchedule.getProductModel().getProductGrade());
            againTaskDto.setSpecs(productionSchedule.getCapacityInfo().getSpecification());
            againTaskDto.setDopant(productionSchedule.getCapacityInfo().getDopant());
            againTaskDto.setProductType(productionSchedule.getProductType());
            againTaskDto.setSurplusWeigth(residualWeight);//剩料重量
            againTaskDto.setTotalUseWeigth(totalWeight);//总装锅料
            againTaskDto.setAgainNum(againNum);
            againTaskDto.setIsDone(isDone);
            eapDockingService.ftTaskCreate(againTaskDto);
            return ResultGenerator.success();
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return ResultGenerator.fail("复投任务发送失败：" + e.getMessage());
        }
    }

    /**
     * 保存单晶信息
     *
     * @param sendEapSignalDto
     * @param equipment
     * @param productionSchedule
     * @param planProcessingOrder
     */
    private LongCrystal saveLongCrystal(SendEapSignalDto sendEapSignalDto, Equipment equipment, ProductionSchedule productionSchedule, PlanProcessingOrder planProcessingOrder, boolean isStop) {
        LongCrystal longCrystal = new LongCrystal();
        if (sendEapSignalDto.getCrystalInfoDto() != null) {
            longCrystal.setWeight(sendEapSignalDto.getCrystalInfoDto().getWeight());
            longCrystal.setLength(sendEapSignalDto.getCrystalInfoDto().getLength());
            longCrystal.setWindUp(sendEapSignalDto.getCrystalInfoDto().getWindUp());
            //添加完结方式
            if (StringUtils.isEmpty(sendEapSignalDto.getCrystalInfoDto().getClosureIdentification())) {
                longCrystal.setClosureIdentification("无");
            } else {
                longCrystal.setClosureIdentification(sendEapSignalDto.getCrystalInfoDto().getClosureIdentification());
            }
            //处理 产出时间 ：完结尾的长晶棒产出时间特殊处理，增加9个小时
            if (null != sendEapSignalDto.getCrystalInfoDto().getClosureIdentification() &&
                    !StringUtils.isEmpty(sendEapSignalDto.getCrystalInfoDto().getClosureIdentification()) &&
                    sendEapSignalDto.getCrystalInfoDto().getClosureIdentification().equals("W")) {
                Date newDate = new Date();
                newDate.setTime(newDate.getTime() + 145 * 6 * 60 * 1000);
                longCrystal.setGmtCreateAdd(newDate);
                longCrystal.setGmtCreate(new Date());

            } else {
                longCrystal.setGmtCreate(new Date());
                longCrystal.setGmtCreateAdd(new Date());
            }
        }else {
            longCrystal.setGmtCreate(new Date());
        }
        longCrystal.setEquipmentCode(sendEapSignalDto.getEquipmentCode());
        longCrystal.setSeries(equipment.getSeries());
        longCrystal.setArea(equipment.getArea());
        longCrystal.setWindUp((sendEapSignalDto.getCrystalInfoDto() == null || sendEapSignalDto.getCrystalInfoDto().getWindUp().length() == 0) ? "X" : sendEapSignalDto.getCrystalInfoDto().getWindUp());
        longCrystal.setAgainNum(planProcessingOrder.getAgainNum());
        longCrystal.setLotTimes(planProcessingOrder.getLotTimes());
        longCrystal.setCrystalNum(planProcessingOrder.getCrystalNum());
        //生成单晶编号
        longCrystal.setCrystalNo(generateCrystalNo(productionSchedule, planProcessingOrder, sendEapSignalDto.getCrystalInfoDto().getWindUp(), longCrystal));
        // 生成单晶批次号
        longCrystal.setBatchNo(generateBatchNo(productionSchedule));

        // 删除追溯 - WXL标记
        /*String fromMark = longCrystal.getCrystalNo().substring(SectionIndexRangeEnum.基地追溯产品类型.getBeginIndex(), SectionIndexRangeEnum.基地追溯产品类型.getEndIndex());
        if (fromMark.matches("[A-Z]+")) {
            longCrystal.setDeliveryNo(longCrystal.getCrystalNo().substring(SectionIndexRangeEnum.发料编号.getBeginIndex(), SectionIndexRangeEnum.发料编号.getEndIndex()));
        }*/

        longCrystal.setLotNo(productionSchedule.getDeliveryNo());
        longCrystal.setLotId(planProcessingOrder.getId());
        longCrystal.setCrystalStatus(EnumValuesFactory.CrystalStatus.待确认.getKey());
        longCrystal.setFurnaceType(productionSchedule.getFurnaceType());
        longCrystal.setProductCode(productionSchedule.getProductModel().getCode());
        longCrystal.setProductName(productionSchedule.getProductModel().getName());
        longCrystal.setProductGrade(productionSchedule.getProductModel().getProductGrade());
        longCrystal.setSpecs(productionSchedule.getCapacityInfo().getSpecification());
        longCrystal.setDopant(productionSchedule.getCapacityInfo().getDopant());
        longCrystal.setSimpleName(productionSchedule.getCapacityInfo().getSimpleName());
        longCrystal.setProductType(productionSchedule.getCapacityInfo().getProductType());
        longCrystal.setConductiveType(productionSchedule.getCapacityInfo().getConductionType());
        longCrystal.setAgainNum(planProcessingOrder.getAgainNum());
        longCrystal.setCrystalNum(planProcessingOrder.getCrystalNum());
        //longCrystal.setGmtCreate(new Date());
        longCrystal.setUserCreate(BaseContextHandler.getUsername());
        //长晶棒产出-订单编号在划线时挂上，但需提前暴露个订单id供长棒检验时使用
        ProductionOrder oldProductionOrder = productionSchedule.getProductionOrder();
        longCrystal.setOrderId(oldProductionOrder.getId());
        longCrystal.setOrderNo(oldProductionOrder.getAufnr());
        longCrystal.setOrderType(oldProductionOrder.getAuart());
        longCrystal.setBaseMark(oldProductionOrder.getBaseMark());
        longCrystal.setWorkShop(oldProductionOrder.getWorkShop());
        longCrystal.setScheduleId(productionSchedule.getId());
        //继承当前炉次
        longCrystal.setCrystalErrorLevelOne(planProcessingOrder.getLotErrorLevelOne());
        longCrystal.setCrystalErrorLevelTwo(planProcessingOrder.getLotErrorLevelTwo());
        longCrystal.setHeadLen(sendEapSignalDto.getCrystalInfoDto().getHeadLen());
        longCrystal.setTailLen(sendEapSignalDto.getCrystalInfoDto().getTailLen());
        longCrystal.setIsDone(sendEapSignalDto.getCrystalInfoDto().getIsDone());
        longCrystal.setFromMark(oldProductionOrder.getFromMark());
        String productType = productionSchedule.getProductType();
        if(productType != null && productType.length()>1){
            longCrystal.setProductCategory(productType.substring(productType.length()-1));
        }

        if (isStop) {
            wipStorageService.outStation2(planProcessingOrder.getCode(), new ArrayList<>(), isStop, new HashMap<>());
        }

        /*Date rodProductionTime = sendEapSignalDto.getCrystalInfoDto().getRodProductionTime();
        if(null != rodProductionTime){
            //进入抽空时间
            getRodProductionTime(rodProductionTime, longCrystal, SendDeviceEapSignalDto.ENTRY_EVACUATION_TIME);
        } else {
            //进入取熔料时间
            Date meltingTime = sendEapSignalDto.getCrystalInfoDto().getMeltingTime();
            getRodProductionTime(meltingTime, longCrystal, SendDeviceEapSignalDto.MELTING_TIME);
        }*/

        longCrystalService.saveOrUpdate(longCrystal);
        return longCrystal;
    }

    public void getRodProductionTime(Date rodProductionTime, LongCrystal longCrystal, String type) {
        //todo 棒次时间    抽空时间不为空则是首棒
        //判断是否为首棒
        LongCrystal lastCrystalNo = longCrystalService.getLastCrystalNo(longCrystal.getEquipmentCode());
        Date date = new Date();
        if(null != lastCrystalNo && !longCrystal.getLotNo().equals(lastCrystalNo.getLotNo())){
            Date gmtCreate = lastCrystalNo.getGmtCreate();
            //首棒 如果抽空时间-上一炉停炉时间《=18小时（数据字典），那么时间为产出时间-上一炉完结尾晶棒的产出时间，
            // 大于18小时=产出时间-上一炉停炉时间+14.5
            //或
            //首棒 如果取熔料时间+1.5-上一炉停炉时间《=18小时（数据字典），那么时间为产出时间-上一炉完结尾晶棒的产出时间，
            // 大于18小时=产出时间-上一炉停炉时间+14.5
            Date stopTime = null;
            CrystalPullingInfoLog crystalPullingInfoLogByDeviceNo = crystalPullingInfoLogService.getCrystalPullingInfoLogByDeviceNo(longCrystal.getEquipmentCode());
            if(null != crystalPullingInfoLogByDeviceNo){
                stopTime = crystalPullingInfoLogByDeviceNo.getStopTime();
            }
            List<DictionaryItem> rodProductionTime1 = dictionaryItemService.findByThemeValueAndEnable("rodProductionTime", true);
            DictionaryItem dictionaryItem = rodProductionTime1.get(0);
            Double aDouble = Double.valueOf(dictionaryItem.getValue());
            if(null != rodProductionTime && null != stopTime){
                if(type.equals(SendDeviceEapSignalDto.ENTRY_EVACUATION_TIME)){
                    if((rodProductionTime.getTime() - stopTime.getTime())/1000/60/60 <= aDouble) {
                        longCrystal.setRodProductionTime(new BigDecimal(date.getTime() - lastCrystalNo.getGmtCreate().getTime()).divide(new BigDecimal(1000*60*60), 2, BigDecimal.ROUND_HALF_UP));
                    } else {
                        longCrystal.setRodProductionTime(new BigDecimal(date.getTime() - rodProductionTime.getTime()).divide(new BigDecimal(1000*60*60), 2, BigDecimal.ROUND_HALF_UP).add(new BigDecimal(14.5)));
                    }
                } else if(type.equals(SendDeviceEapSignalDto.MELTING_TIME)) {
                    if((rodProductionTime.getTime() - 5400000 - stopTime.getTime())/1000/60/60 <= aDouble) {
                        longCrystal.setRodProductionTime(new BigDecimal(date.getTime() - lastCrystalNo.getGmtCreate().getTime()).divide(new BigDecimal(1000*60*60), 2, BigDecimal.ROUND_HALF_UP));
                    } else {
                        longCrystal.setRodProductionTime(new BigDecimal(date.getTime() - rodProductionTime.getTime() + 5400000).divide(new BigDecimal(1000*60*60), 2, BigDecimal.ROUND_HALF_UP).add(new BigDecimal(14.5)));
                    }
                }
            } else {
                longCrystal.setRodProductionTime(new BigDecimal(date.getTime() - gmtCreate.getTime()).divide(new BigDecimal(1000*60*60), 2, BigDecimal.ROUND_HALF_UP));
            }
        } else {
            //非首棒产出时间-上一棒产出时间
            if(null != lastCrystalNo){
                Date gmtCreate = lastCrystalNo.getGmtCreate();
                longCrystal.setRodProductionTime(new BigDecimal(date.getTime() - gmtCreate.getTime()).divide(new BigDecimal(1000*60*60), 2, BigDecimal.ROUND_HALF_UP));
            }
        }
        //新装炉的首颗
        if(type.equals(SendDeviceEapSignalDto.ENTRY_EVACUATION_TIME)){
            if(null == lastCrystalNo && null != rodProductionTime){
                longCrystal.setRodProductionTime(new BigDecimal(date.getTime() - rodProductionTime.getTime()).divide(new BigDecimal(1000*60*60), 2, BigDecimal.ROUND_HALF_UP));
            }
        } else  if(type.equals(SendDeviceEapSignalDto.MELTING_TIME)) {
            if(null == lastCrystalNo && null != rodProductionTime){
                longCrystal.setRodProductionTime(new BigDecimal(date.getTime() - rodProductionTime.getTime() + 5400000).divide(new BigDecimal(1000*60*60), 2, BigDecimal.ROUND_HALF_UP));
            }
        }
    }

    /**
     * 确认单晶编号
     *
     * @param longCrystal 单晶信息
     * @param outputMode  单晶产出方式
     */
    @Override
    public void generateCrystalNo(LongCrystal longCrystal, Integer outputMode,String windUp) {
        if (longCrystal == null) {
            throw new BusinessException("长晶棒对象信息为空");
        }
        PlanProcessingOrder planProcessingOrder = planProcessingOrderService.get(longCrystal.getLotId());
        if (planProcessingOrder == null) {
            throw new BusinessException("该单晶的炉次工单不存在");
        }
        ProductionSchedule productionSchedule = productionScheduleService.get(longCrystal.getScheduleId());
        if (productionSchedule == null) {
            throw new BusinessException("该单晶的生产任务不存在");
        }
        Equipment equipment = equipmentService.get(productionSchedule.getDeviceId());
        LongCrystal longCrystal1 = longCrystalService.findByLotIdAndAgainNumAndCrystalNumAndCrystalStatusNotAndIdNot(longCrystal.getLotId(), longCrystal.getAgainNum(), longCrystal.getCrystalNum(), EnumValuesFactory.CrystalStatus.待确认.getKey(), longCrystal.getId());
        if (longCrystal1 != null) {
            throw new BusinessException("该【" + longCrystal.getLotNo() + "】已存在复投次数【" + longCrystal.getAgainNum() + "】" + "颗次【" + longCrystal.getCrystalNum() + "】的单晶");
        }
        String crystalNo = generateCrystalNo(productionSchedule, planProcessingOrder, windUp, longCrystal);
        longCrystal.setCrystalNo(crystalNo);
        longCrystal.setBatchNo(generateBatchNo(productionSchedule));
        //修改工单编号
        PlanProcessingOrder planProcessingOrderLongCrystal = planProcessingOrderService.findByGoodsIdAndOrderType(longCrystal.getId(), EnumValuesFactory.PlanProcessingOrderOrderType.单晶.getKey());
        if (planProcessingOrderLongCrystal != null) {
            planProcessingOrderLongCrystal.setCode(crystalNo);
            planProcessingOrderService.createPlanProcessingOrder(planProcessingOrderLongCrystal, null, null);
            //修改在制品
            wipStorageService.updatePlanProcessingOrderCode(planProcessingOrderLongCrystal.getId(), crystalNo);
        } else {
            List<ProcessingOrderNewDto> processingOrderNewDtos = new ArrayList<>();
            ProcessingOrderNewDto processingOrderNewDto = new ProcessingOrderNewDto();
            processingOrderNewDto.setCode(longCrystal.getCrystalNo());
            processingOrderNewDto.setLength(longCrystal.getLength());
            processingOrderNewDto.setWeight(longCrystal.getWeight() == null ? new BigDecimal("1") : longCrystal.getWeight());
            processingOrderNewDto.setGoodsId(longCrystal.getId());
            processingOrderNewDto.setOrderType(EnumValuesFactory.PlanProcessingOrderOrderType.单晶.getKey());
            processingOrderNewDtos.add(processingOrderNewDto);

            Result result = wipStorageService.outStation2(planProcessingOrder.getCode(), processingOrderNewDtos, false, new HashMap<>(), false);
            if (result.getCode() != ResultCode.SUCCESS.getCode()) {
                //手动回滚事务
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                throw new RuntimeException(result.getMessage());
            }
        }
        //修改炉次工单的投次数，颗次计数
        LongCrystal longCrystalLotLast = longCrystalService.findTopByLotId(longCrystal.getLotId());
        //修改长晶棒编号
        longCrystalService.saveOrUpdate(longCrystal);
        if (longCrystalLotLast != null && longCrystal.getId().equals(longCrystalLotLast.getId())) {
            // 如果本次确认是取段结晶，则复投次数+1，颗次变为0
            if (outputMode == 0) {
                planProcessingOrder.setAgainNum(longCrystal.getAgainNum() + 1);
                planProcessingOrder.setCrystalNum(1);
            }
            // 如果本次确认是取段稳温，则复投次数不变，颗次+1
            else {
                planProcessingOrder.setAgainNum(longCrystal.getAgainNum());
                planProcessingOrder.setCrystalNum(longCrystal.getCrystalNum() + 1);
            }
            planProcessingOrderService.createPlanProcessingOrder(planProcessingOrder, null, null);
        }

    }

    //todo:长晶棒产出表 修改晶编
    @Override
    public String generateCrystalNo(String crystalNo, LongCrystalInfoDto dto) {
        //todo:追溯改造
        ProductionOrder productionOrder = productionOrderService.get(dto.getOrderId());
        if (null != productionOrder && StringUtils.isNotEmpty(productionOrder.getFromMark())) {
            crystalNo = replaceIndex(SectionIndexRangeEnum.复投次数.getBeginIndex(), crystalNo, NumberUtil.getLTE10English(dto.getAgainNum()));

            //修改内容： 颗次为1 ， 收尾是 不断苞 或 完结尾;这个单晶编号 最后一位替代为0
            if (dto.getCrystalNum() == 1 && dto.getCrystalNum() < 9) {
                if (("Y").equals(dto.getWindUp()) || ("W").equals(dto.getWindUp())) {
                    crystalNo = replaceIndex(SectionIndexRangeEnum.断次.getBeginIndex(), crystalNo, "0");
                } else {
                    crystalNo = replaceIndex(SectionIndexRangeEnum.断次.getBeginIndex(), crystalNo, NumberUtil.getLTE10English(dto.getCrystalNum()));
                }
            }
            if (dto.getCrystalNum() > 1 && dto.getCrystalNum() < 9) {
                crystalNo = replaceIndex(SectionIndexRangeEnum.断次.getBeginIndex(), crystalNo, NumberUtil.getLTE10English(dto.getCrystalNum()));
            }

            crystalNo = replaceIndex(SectionIndexRangeEnum.原产品类型.getBeginIndex(), crystalNo,  dto.getProductType());
            crystalNo = replaceIndex(SectionIndexRangeEnum.追溯标识.getBeginIndex(), crystalNo, "");
        }  else {
            // crystalNo = replaceIndex(0, crystalNo, (dto.getWindUp() != null && dto.getWindUp().length() > 0) ? dto.getWindUp().charAt(0) + "" : "X");
            crystalNo = replaceIndex(10, crystalNo, NumberUtil.getLTE10English(dto.getAgainNum()));
            //修改内容： 颗次为1 ， 收尾是 不断苞 或 完结尾;这个单晶编号 最后一位替代为0
            if (dto.getCrystalNum() == 1 && dto.getCrystalNum() < 9) {
                if (("Y").equals(dto.getWindUp()) || ("W").equals(dto.getWindUp())) {
                    crystalNo = replaceIndex(11, crystalNo, "0");
                } else {
                    crystalNo = replaceIndex(11, crystalNo, NumberUtil.getLTE10English(dto.getCrystalNum()));
                }
            }
            if (dto.getCrystalNum() > 1 && dto.getCrystalNum() < 9) {
                crystalNo = replaceIndex(11, crystalNo, NumberUtil.getLTE10English(dto.getCrystalNum()));
            }
            crystalNo = replaceIndex(1, crystalNo, dto.getProductType());
        }
        return crystalNo;
    }

    private static String replaceIndex(int index, String res, String str) {
        return res.substring(0, index) + str + res.substring(index + 1);
    }

    /**
     * 生成单晶编号
     * todo: 修改成云南晶编
     *
     * @param productionSchedule
     * @param planProcessingOrder
     * @param windUp
     * @param longCrystal
     * @return
     */
    /*private String generateCrystalNo(ProductionSchedule productionSchedule, PlanProcessingOrder planProcessingOrder, String windUp, LongCrystal longCrystal) {
        //todo:追溯改造
        //获取单晶生产订单(计划)对应追溯标识
        String fromMark = productionSchedule.getProductionOrder().getFromMark();
        String baseMark = productionSchedule.getProductionOrder().getBaseMark();
        String productType = productionSchedule.getProductionOrder().getProductType();

        StringBuilder crystalNo = new StringBuilder();
        if (StringUtils.isEmpty(fromMark)) {
            crystalNo.append("Y");
            crystalNo.append(productionSchedule.getProductType());
            crystalNo.append(productionSchedule.getLotNo());
            crystalNo.append("R");
            crystalNo.append(NumberUtil.getLTE10English(longCrystal.getAgainNum()));
            if (longCrystal.getCrystalNum() == 1) {
                if (("Y").equals(windUp) || ("W").equals(windUp)) {
                    crystalNo.append("0");
                } else {
                    crystalNo.append(NumberUtil.getLTE10English(longCrystal.getCrystalNum()));
                }
            } else {
                crystalNo.append(NumberUtil.getLTE10English(longCrystal.getCrystalNum()));
            }
            return crystalNo.toString();
        } else {
//            crystalNo.append(baseMark);
//            crystalNo.append(productType);
            crystalNo.append(baseMark);
            crystalNo.append(productionSchedule.getProductType());
            crystalNo.append(productionSchedule.getLotNo());
            crystalNo.append(NumberUtil.getLTE10English(longCrystal.getAgainNum()));
            if (longCrystal.getCrystalNum() == 1) {
                if (("Y").equals(windUp) || ("W").equals(windUp)) {
                    crystalNo.append("0");
                } else {
                    crystalNo.append(NumberUtil.getLTE10English(longCrystal.getCrystalNum()));
                }
            } else {
                crystalNo.append(NumberUtil.getLTE10English(longCrystal.getCrystalNum()));
            }
            return crystalNo.toString();
        }
    }*/

    /**
     * 太原晶科生成单晶批次号
     */
    @Jinko(value = "生成晶棒批次号", author = "wxl")
    private String generateBatchNo(ProductionSchedule schedule) {
        StringBuilder batchNo = new StringBuilder();
        // 1基地：太原
        batchNo.append("T");

        // 2定向：非定向-B，定向-C，供欧定向-D，等外-E
        batchNo.append(dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNo",
                "定向", true).getValue());

        // 3掺杂类型: P型掺镓-U，N型掺磷-N
        batchNo.append(dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNo",
                schedule.getCapacityInfo().getDopant(), true).getValue());

        LocalDate now = LocalDate.now();
        // 4-5年
        batchNo.append(now.getYear() - 2000);
        // 6月
        batchNo.append(CodeMapUtils.NUM_CODE_MAP.get(now.getMonthValue()));
        // 7-8日
        int day = now.getDayOfMonth();
        batchNo.append((day <= 9)? ("0"+day): day);

        // 9车间
        Equipment equipment = equipmentService.get(schedule.getDeviceId());
        FactoryModel factoryModel1 = factoryModelService.findByChildIdAndTypeKey(equipment.getFactoryModel().getId(), "2");
        String cj = dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNoFactory",
                factoryModel1.getCode(), true).getValue();
        batchNo.append(cj);

        // 10片区
        FactoryModel factoryModel2 = factoryModelService.findByChildIdAndTypeKey(equipment.getFactoryModel().getId(), "5");
        String pq = dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNoFactory",
                factoryModel2.getCode(), true).getValue();
        batchNo.append(pq);

        return batchNo.toString();
    }

    /**
     * 太原晶科生成单晶编号
     */
    @Jinko(value = "生成晶棒编码", author = "wxl")
    private String generateCrystalNo(ProductionSchedule schedule, PlanProcessingOrder order, String windUp, LongCrystal longCrystal) {
        // 获取编码循环界限
        int loop = 35;     // 实际是1-9，A-Z总共35项，不包含0

        StringBuilder crystalNo = new StringBuilder();
        // 1基地：太原
        crystalNo.append("T");

        ProductModel productModel = schedule.getProductModel();
        if (productModel == null) throw new RuntimeException("与排程关联的【物料主数据】不存在");
        ProductionOrder productionOrder = schedule.getProductionOrder();
        if (productionOrder == null) throw new RuntimeException("与排程关联的【订单数据】不存在");

        // 2定向：非定向-B，定向-C，供欧定向-D，等外-E
        String directional = productionOrder.getZorientationind();
        if (StringUtils.isEmpty(directional)) directional = "非定向";
        DictionaryItem directionalSign = dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNo",
                directional, true);
        if (directionalSign == null) {
            crystalNo.append("C");
        }else {
            crystalNo.append(directionalSign.getValue());
        }

        MachineCapacityInfo capacityInfo = schedule.getCapacityInfo();
        // 3掺杂类型: P型掺镓-U，N型掺磷-N
        DictionaryItem dopant = dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNo",
                capacityInfo.getDopant(), true);
        if (dopant == null) throw new RuntimeException("creatCrystalNo字典中【掺杂类型】不存在");
        crystalNo.append(dopant.getValue());

        // 4尺寸：10吋-X，11吋-F，12吋-K，矩形-R，提纯棒-T，黄金片-H，多晶：D
        if (longCrystal.getIsCrystal() != null && longCrystal.getIsCrystal() == 0){     // 多晶
            crystalNo.append("D");
        }else {
            DictionaryItem specification = dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNo",
                    capacityInfo.getSpecification(), true);
            if (specification == null) throw new RuntimeException("creatCrystalNo字典中【尺寸】不存在");
            crystalNo.append(specification.getValue());
        }

        LocalDate now = LocalDate.now();
        // 5年
        crystalNo.append(CodeMapUtils.NUM_CODE_MAP.get(now.getYear() - 2020));
        // 6月
        crystalNo.append(CodeMapUtils.NUM_CODE_MAP.get(now.getMonthValue()));

        // 7车间
        Equipment equipment = equipmentService.get(schedule.getDeviceId());
        FactoryModel factoryModel1 = factoryModelService.findByChildIdAndTypeKey(equipment.getFactoryModel().getId(), "2");
        DictionaryItem cj = dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNoFactory",
                factoryModel1.getCode(), true);
        if (cj == null) throw new RuntimeException("creatCrystalNoFactory字典中【车间】不存在");
        crystalNo.append(cj.getValue());

        // 8片区
        FactoryModel factoryModel2 = factoryModelService.findByChildIdAndTypeKey(equipment.getFactoryModel().getId(), "5");
        DictionaryItem pq = dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNoFactory",
                factoryModel2.getCode(), true);
        if (pq == null) throw new RuntimeException("creatCrystalNoFactory字典中【片区】不存在");
        crystalNo.append(pq.getValue());

        // 9-11炉台号
        crystalNo.append(equipment.getCode().substring(equipment.getCode().length()-3));

        // 12炉数
        int lotTimes = order.getLotTimes();
        crystalNo.append(CodeMapUtils.NUM_CODE_MAP.get((lotTimes == loop)? loop : (lotTimes % loop)));

        // 13加料次数
        int againNum = longCrystal.getAgainNum();
        crystalNo.append(CodeMapUtils.NUM_CODE_MAP.get((againNum == loop)? loop : (againNum % loop)));

        // 14加料后产出根数
        int crystalNum = longCrystal.getCrystalNum();
        crystalNo.append(CodeMapUtils.NUM_CODE_MAP.get((crystalNum == loop)? loop : (crystalNum % loop)));

        // 15是否完结
        crystalNo.append("W".equals(longCrystal.getWindUp())? "W" : "N");

        // 16高低阻
        NewProductModel newProductModel = newProductModelService.findByCode(productModel.getCode());
        if (newProductModel == null) throw new RuntimeException("产品模型不存在");
        DictionaryItem resistanceType = dictionaryItemService.findByThemeValueAndNameAndEnable("creatCrystalNo",
                newProductModel.getResistanceType(), true);
        if (resistanceType == null) throw new RuntimeException("creatCrystalNo字典中【高低阻】不存在");
        crystalNo.append(resistanceType.getValue());

        return crystalNo.toString();
    }

    /**
     * 发起装料任务
     *
     * @param equipment
     * @param productionSchedule
     */
    private Result handleStart(Equipment equipment, ProductionSchedule productionSchedule) {
        try {
            LoadingTaskDto loadingTaskDto = new LoadingTaskDto();
            loadingTaskDto.setScheduleId(productionSchedule.getId());
            loadingTaskDto.setEquipmentCode(productionSchedule.getDeviceNo());
            loadingTaskDto.setLotNo(productionSchedule.getLotNo());
            loadingTaskDto.setSeries(equipment.getSeries());
            loadingTaskDto.setArea(equipment.getArea());
            loadingTaskDto.setFurnaceType(productionSchedule.getFurnaceType());
            loadingTaskDto.setSapNo(productionSchedule.getProductionOrder().getAufnr());
            loadingTaskDto.setProductCode(productionSchedule.getProductModel().getCode());
            loadingTaskDto.setProductGrade(productionSchedule.getProductModel().getProductGrade());
            loadingTaskDto.setSpecs(productionSchedule.getCapacityInfo().getSpecification());
            loadingTaskDto.setDopant(productionSchedule.getCapacityInfo().getDopant());
            loadingTaskDto.setSimpleName(productionSchedule.getCapacityInfo().getSimpleName());
            loadingTaskDto.setProductType(productionSchedule.getProductType());
            eapDockingService.zlTaskCreate(loadingTaskDto);
            return ResultGenerator.success();
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return ResultGenerator.fail("发起装料任务失败：" + e.getMessage());
        }
    }


    /**
     * 停炉时清空上炉次数据
     * 用于eap上传异常停炉信息
     * @param info
     */
    private void clearCrystalPullingInfoForEAP(CrystalPullingInfo info,String deviceCode) {
        try {

            if (info == null) {
                info = new CrystalPullingInfo();
                info.setDeviceNo(deviceCode);
            }

            info.setStopTime(new Date());


            CrystalPullingInfoLog crystalPullingInfoLog = new CrystalPullingInfoLog();
            crystalPullingInfoLog.setSeries(info.getSeries());
            crystalPullingInfoLog.setSpecs(info.getSpecs());
            crystalPullingInfoLog.setConductionType(info.getConductionType());
            crystalPullingInfoLog.setDeviceNo(info.getDeviceNo());
            crystalPullingInfoLog.setLotNo(info.getLotNo());
            crystalPullingInfoLog.setMaterialCount(info.getMaterialCount());
            crystalPullingInfoLog.setLineLength(info.getLineLength());
            crystalPullingInfoLog.setInfo(info.getInfo());

            List<DictionaryItem> items = dictionaryItemService.findByThemeValueAndEnable(EnumValuesServer.DictionaryTheme.划线重量折算系数.getKey(), true);

            Map<String, DictionaryItem> collect = items.stream().collect(Collectors.toMap(DictionaryItem::getName, DictionaryItem -> DictionaryItem));

            try {
                double lineLength = info.getLineLength().doubleValue();
                double xishu = Double.valueOf(collect.get(info.getSpecs()).getValue());

                crystalPullingInfoLog.setLineWeight(BigDecimal.valueOf(lineLength / xishu));
            } catch (Exception e) {
                log.error("计算划线重量发生错误" + e.getMessage());
            }

            if (crystalPullingInfoLog.getMaterialCount() == null || crystalPullingInfoLog.getMaterialCount().doubleValue() <= 0) {
                crystalPullingInfoLog.setLineCompletionRate(new BigDecimal(0));
            } else {
                try {
                    crystalPullingInfoLog.setLineCompletionRate(BigDecimal.valueOf(crystalPullingInfoLog.getLineWeight().doubleValue() / crystalPullingInfoLog.getMaterialCount().doubleValue()));
                } catch (Exception e) {
                    log.error("计算划线成晶率发生错误" + e.getMessage());
                }
            }

            crystalPullingInfoLog.setStopTime(info.getStopTime());
            crystalPullingInfoLog.setStartTime(info.getStartTime());

            if (info.getStopTime() != null && info.getStartTime() != null) {
                long runTimeLen = info.getStopTime().getTime() - info.getStartTime().getTime();
                double _runTime = runTimeLen / 1000 / 60 / 60d;
                BigDecimal runTime = new BigDecimal(_runTime).setScale(2, BigDecimal.ROUND_DOWN);
                crystalPullingInfoLog.setRunTime(runTime);
            }




            //0714 新运行时间=当前炉次的停炉时间(当前时间 new date()) - 上一炉次停炉时间 - 异常停炉时间
            if (info.getStopTime() != null){
                CrystalPullingInfoLog pullingInfoLogOld = crystalPullingInfoLogService.getCrystalPullingInfoLogByDeviceNo(info.getDeviceNo());//上一炉次的拉晶情况记录表
                if (null!= pullingInfoLogOld && null != pullingInfoLogOld.getStopTime()){
                    long runTimeLen1 = info.getStopTime().getTime() - pullingInfoLogOld.getStopTime().getTime();
                    double _runTime1 = runTimeLen1 / 1000 / 60 / 60d;
                    if (null == info.getStandbyTime()){
                        BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                        crystalPullingInfoLog.setRunTimeActual(runTimeActual);
                    }else {
                        BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                        BigDecimal subtract = runTimeActual.subtract(info.getStandbyTime());
                        crystalPullingInfoLog.setRunTimeActual(subtract);
                    }
                }else {
                    //新开炉次情况，没有上一炉次信息，开始时间取开炉时间
                    if (null != info.getStartTime()){
                        long runTimeLen1 = info.getStopTime().getTime() - info.getStartTime().getTime();
                        double _runTime1 = runTimeLen1 / 1000 / 60 / 60d;
                        if (null == info.getStandbyTime()){
                            BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                            crystalPullingInfoLog.setRunTimeActual(runTimeActual);
                        }else {
                            BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                            BigDecimal subtract = runTimeActual.subtract(info.getStandbyTime());
                            crystalPullingInfoLog.setRunTimeActual(subtract);
                        }
                    }
                }
            }


            if (null != info.getStandbyTime()){
                crystalPullingInfoLog.setStandbyTime(info.getStandbyTime());
            }
            if (null != info.getAbnormalStandbyInfo()){
                crystalPullingInfoLog.setAbnormalStandbyInfo(info.getAbnormalStandbyInfo());
            }




            crystalPullingInfoLog.setPowerConsumption(info.getUseKwh());

            if (crystalPullingInfoLog.getRunTime() != null && crystalPullingInfoLog.getLineWeight() != null
                    && !(crystalPullingInfoLog.getRunTime().compareTo(BigDecimal.ZERO) == 0)) {
                BigDecimal runTime = crystalPullingInfoLog.getRunTime().add(new BigDecimal(14.5));
                crystalPullingInfoLog.setOneHourOut(crystalPullingInfoLog.getLineWeight().divide(runTime, 2, BigDecimal.ROUND_HALF_UP));
            }

            crystalPullingInfoLogService.saveOrUpdate(crystalPullingInfoLog);
            if (info.getLineLength() != null) {
                info.setLineLength(new BigDecimal(0));
            }
            //info.setLotNo(lotNo);//炉次号
//            info.setCrucible("");
//            info.setConductionType("");//型号
//            info.setSpecs("");//规格
//            info.setMaterialCount(null);
//            info.setInfo(null);
//
            //eap 异常上传停炉信号的情况下，清除开始时间，后续正常停炉再写入开始时间
//            info.setStartTime(null);
//            info.setStopTime(null);
//            info.setUseKwh(null);
//            info.setDataUpdateTime(null);
//            crystalPullingInfoService.saveOrUpdate(info);
            //异常停炉不清空拉晶实时情况，防止后续正常停炉采集不到开始时间

        } catch (Exception e) {
            e.printStackTrace();
        }
    }




    /**
     * 停炉时清空上炉次数据
     * 用于eap上传正常停炉信号用
     * @param info
     */
    private void clearCrystalPullingInfo(CrystalPullingInfo info,String deviceCode) {
        try {

            if (info == null) {
                info = new CrystalPullingInfo();
                info.setDeviceNo(deviceCode);
            }

            info.setStopTime(new Date());


            CrystalPullingInfoLog crystalPullingInfoLog = new CrystalPullingInfoLog();
            crystalPullingInfoLog.setSeries(info.getSeries());
            crystalPullingInfoLog.setSpecs(info.getSpecs());
            crystalPullingInfoLog.setConductionType(info.getConductionType());
            crystalPullingInfoLog.setDeviceNo(info.getDeviceNo());
            crystalPullingInfoLog.setLotNo(info.getLotNo());
            crystalPullingInfoLog.setMaterialCount(info.getMaterialCount());
            crystalPullingInfoLog.setLineLength(info.getLineLength());
            crystalPullingInfoLog.setInfo(info.getInfo());

            List<DictionaryItem> items = dictionaryItemService.findByThemeValueAndEnable(EnumValuesServer.DictionaryTheme.划线重量折算系数.getKey(), true);

            Map<String, DictionaryItem> collect = items.stream().collect(Collectors.toMap(DictionaryItem::getName, DictionaryItem -> DictionaryItem));

            try {
                double lineLength = info.getLineLength().doubleValue();
                double xishu = Double.valueOf(collect.get(info.getSpecs()).getValue());

                crystalPullingInfoLog.setLineWeight(BigDecimal.valueOf(lineLength / xishu));
            } catch (Exception e) {
                log.error("计算划线重量发生错误" + e.getMessage());
            }

            if (crystalPullingInfoLog.getMaterialCount() == null || crystalPullingInfoLog.getMaterialCount().doubleValue() <= 0) {
                crystalPullingInfoLog.setLineCompletionRate(new BigDecimal(0));
            } else {
                try {
                    crystalPullingInfoLog.setLineCompletionRate(BigDecimal.valueOf(crystalPullingInfoLog.getLineWeight().doubleValue() / crystalPullingInfoLog.getMaterialCount().doubleValue()));
                } catch (Exception e) {
                    log.error("计算划线成晶率发生错误" + e.getMessage());
                }
            }

            crystalPullingInfoLog.setStopTime(info.getStopTime());
            crystalPullingInfoLog.setStartTime(info.getStartTime());

            if (info.getStopTime() != null && info.getStartTime() != null) {
                long runTimeLen = info.getStopTime().getTime() - info.getStartTime().getTime();
                double _runTime = runTimeLen / 1000 / 60 / 60d;
                BigDecimal runTime = new BigDecimal(_runTime).setScale(2, BigDecimal.ROUND_DOWN);
                crystalPullingInfoLog.setRunTime(runTime);
            }




            //0714 新运行时间=当前炉次的停炉时间(当前时间 new date()) - 上一炉次停炉时间 - 异常停炉时间
            if (info.getStopTime() != null){
                CrystalPullingInfoLog pullingInfoLogOld = crystalPullingInfoLogService.getCrystalPullingInfoLogByDeviceNo(info.getDeviceNo());//上一炉次的拉晶情况记录表
                if (null!= pullingInfoLogOld && null != pullingInfoLogOld.getStopTime()){
                    long runTimeLen1 = info.getStopTime().getTime() - pullingInfoLogOld.getStopTime().getTime();
                    double _runTime1 = runTimeLen1 / 1000 / 60 / 60d;
                    if (null == info.getStandbyTime()){
                        BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                        crystalPullingInfoLog.setRunTimeActual(runTimeActual);
                    }else {
                        BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                        BigDecimal subtract = runTimeActual.subtract(info.getStandbyTime());
                        crystalPullingInfoLog.setRunTimeActual(subtract);
                    }
                }else {
                    //新开炉次情况，没有上一炉次信息，开始时间取开炉时间
                    if (null != info.getStartTime()){
                        long runTimeLen1 = info.getStopTime().getTime() - info.getStartTime().getTime();
                        double _runTime1 = runTimeLen1 / 1000 / 60 / 60d;
                        if (null == info.getStandbyTime()){
                            BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                            crystalPullingInfoLog.setRunTimeActual(runTimeActual);
                        }else {
                            BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                            BigDecimal subtract = runTimeActual.subtract(info.getStandbyTime());
                            crystalPullingInfoLog.setRunTimeActual(subtract);
                        }
                    }
                }
            }


            if (null != info.getStandbyTime()){
                crystalPullingInfoLog.setStandbyTime(info.getStandbyTime());
            }
            if (null != info.getAbnormalStandbyInfo()){
                crystalPullingInfoLog.setAbnormalStandbyInfo(info.getAbnormalStandbyInfo());
            }




            crystalPullingInfoLog.setPowerConsumption(info.getUseKwh());

            if (crystalPullingInfoLog.getRunTime() != null && crystalPullingInfoLog.getLineWeight() != null
                    && !(crystalPullingInfoLog.getRunTime().compareTo(BigDecimal.ZERO) == 0)) {
                BigDecimal runTime = crystalPullingInfoLog.getRunTime().add(new BigDecimal(14.5));
                crystalPullingInfoLog.setOneHourOut(crystalPullingInfoLog.getLineWeight().divide(runTime, 2, BigDecimal.ROUND_HALF_UP));
            }


            //先清除之前的记录，再插入最新记录
            crystalPullingInfoLogDao.deleteLogByLotNo(info.getLotNo());
            crystalPullingInfoLogService.saveOrUpdate(crystalPullingInfoLog);
            if (info.getLineLength() != null) {
                info.setLineLength(new BigDecimal(0));
            }
            //info.setLotNo(lotNo);//炉次号
            info.setCrucible("");
            info.setConductionType("");//型号
            info.setSpecs("");//规格
            info.setMaterialCount(null);
            info.setInfo(null);
            info.setStartTime(null);
            info.setStopTime(null);
            info.setUseKwh(null);
            info.setDataUpdateTime(null);
            crystalPullingInfoService.saveOrUpdate(info);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }




    /**
     * 0810，手动停炉时传入异常原因，同时变更停炉时间计算逻辑
     * 手动停炉时清空上炉次数据
     * @param info
     * @param deviceCode 设备号
     * @param abnormalCause 异常原因
     */
    private void clearCrystalPullingInfoForManual(CrystalPullingInfo info,String deviceCode,String abnormalCause) {
        try {

            if (info == null) {
                info = new CrystalPullingInfo();
                info.setDeviceNo(deviceCode);
            }

            info.setStopTime(new Date());


            CrystalPullingInfoLog crystalPullingInfoLog = new CrystalPullingInfoLog();
            crystalPullingInfoLog.setSeries(info.getSeries());
            crystalPullingInfoLog.setSpecs(info.getSpecs());
            crystalPullingInfoLog.setConductionType(info.getConductionType());
            crystalPullingInfoLog.setDeviceNo(info.getDeviceNo());
            crystalPullingInfoLog.setLotNo(info.getLotNo());
            crystalPullingInfoLog.setMaterialCount(info.getMaterialCount());
            crystalPullingInfoLog.setLineLength(info.getLineLength());
            crystalPullingInfoLog.setInfo(info.getInfo());

            List<DictionaryItem> items = dictionaryItemService.findByThemeValueAndEnable(EnumValuesServer.DictionaryTheme.划线重量折算系数.getKey(), true);

            Map<String, DictionaryItem> collect = items.stream().collect(Collectors.toMap(DictionaryItem::getName, DictionaryItem -> DictionaryItem));

            try {
                double lineLength = info.getLineLength().doubleValue();
                double xishu = Double.valueOf(collect.get(info.getSpecs()).getValue());

                crystalPullingInfoLog.setLineWeight(BigDecimal.valueOf(lineLength / xishu));
            } catch (Exception e) {
                log.error("计算划线重量发生错误" + e.getMessage());
            }

            if (crystalPullingInfoLog.getMaterialCount() == null || crystalPullingInfoLog.getMaterialCount().doubleValue() <= 0) {
                crystalPullingInfoLog.setLineCompletionRate(new BigDecimal(0));
            } else {
                try {
                    crystalPullingInfoLog.setLineCompletionRate(BigDecimal.valueOf(crystalPullingInfoLog.getLineWeight().doubleValue() / crystalPullingInfoLog.getMaterialCount().doubleValue()));
                } catch (Exception e) {
                    log.error("计算划线成晶率发生错误" + e.getMessage());
                }
            }

            crystalPullingInfoLog.setStopTime(info.getStopTime());
            crystalPullingInfoLog.setStartTime(info.getStartTime());

            if (info.getStopTime() != null && info.getStartTime() != null) {
                long runTimeLen = info.getStopTime().getTime() - info.getStartTime().getTime();
                double _runTime = runTimeLen / 1000 / 60 / 60d;
                BigDecimal runTime = new BigDecimal(_runTime).setScale(2, BigDecimal.ROUND_DOWN);
                crystalPullingInfoLog.setRunTime(runTime);
            }






            //0714 新运行时间=当前炉次的停炉时间(当前时间 new date()) - 上一炉次停炉时间 - 异常停炉时间
            if (info.getStopTime() != null){
                CrystalPullingInfoLog pullingInfoLogOld = crystalPullingInfoLogService.getCrystalPullingInfoLogByDeviceNo(info.getDeviceNo());//上一炉次的拉晶情况记录表
                if (null!= pullingInfoLogOld && null != pullingInfoLogOld.getStopTime()){
                    long runTimeLen1 = info.getStopTime().getTime() - pullingInfoLogOld.getStopTime().getTime();
                    double _runTime1 = runTimeLen1 / 1000 / 60 / 60d;
                    if (null == info.getStandbyTime()){
                        BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                        crystalPullingInfoLog.setRunTimeActual(runTimeActual);
                    }else {
                        BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                        BigDecimal subtract = runTimeActual.subtract(info.getStandbyTime());
                        crystalPullingInfoLog.setRunTimeActual(subtract);
                    }
                }else {
                    //新开炉次情况，没有上一炉次信息，开始时间取开炉时间
                    if (null != info.getStartTime()){
                        long runTimeLen1 = info.getStopTime().getTime() - info.getStartTime().getTime();
                        double _runTime1 = runTimeLen1 / 1000 / 60 / 60d;
                        if (null == info.getStandbyTime()){
                            BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                            crystalPullingInfoLog.setRunTimeActual(runTimeActual);
                        }else {
                            BigDecimal runTimeActual = new BigDecimal(_runTime1).setScale(2, BigDecimal.ROUND_DOWN);
                            BigDecimal subtract = runTimeActual.subtract(info.getStandbyTime());
                            crystalPullingInfoLog.setRunTimeActual(subtract);
                        }
                    }
                }
            }


            if (null != info.getStandbyTime()){
                crystalPullingInfoLog.setStandbyTime(info.getStandbyTime());
            }
            if (null != info.getAbnormalStandbyInfo()){
                crystalPullingInfoLog.setAbnormalStandbyInfo(info.getAbnormalStandbyInfo());
            }






            crystalPullingInfoLog.setPowerConsumption(info.getUseKwh());

            if (crystalPullingInfoLog.getRunTime() != null && crystalPullingInfoLog.getLineWeight() != null
                    && !(crystalPullingInfoLog.getRunTime().compareTo(BigDecimal.ZERO) == 0)) {
                BigDecimal runTime = crystalPullingInfoLog.getRunTime().add(new BigDecimal(13));
                crystalPullingInfoLog.setOneHourOut(crystalPullingInfoLog.getLineWeight().divide(runTime, 2, BigDecimal.ROUND_HALF_UP));
            }

            //新增异常拉晶原因 字段
            if (null != abnormalCause && !abnormalCause.isEmpty()){
                crystalPullingInfoLog.setAbnormalCause(abnormalCause);
            }

            //先清除之前的记录，再插入最新记录
            crystalPullingInfoLogDao.deleteLogByLotNo(info.getLotNo());

            crystalPullingInfoLogService.saveOrUpdate(crystalPullingInfoLog);
            if (info.getLineLength() != null) {
                info.setLineLength(new BigDecimal(0));
            }
            //info.setLotNo(lotNo);//炉次号
            info.setCrucible("");
            info.setConductionType("");//型号
            info.setSpecs("");//规格
            info.setMaterialCount(null);
            info.setInfo(null);
            info.setStartTime(null);
            info.setStopTime(null);
            info.setUseKwh(null);
            info.setDataUpdateTime(null);
            //初始化待机相关信息
            info.setStandbyTime(null);
            info.setAbnormalStandbyInfo(null);
            crystalPullingInfoService.saveOrUpdate(info);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 开炉时清空上炉次数据
     *
     * @param deviceCode
     * @param lotNo      切换后炉次号
     */
    private void resetCode(String deviceCode, String lotNo, ProductModel productModel) {
        try {
            CrystalPullingInfo info = crystalPullingInfoService.getByDeviceNo(deviceCode);
            if (info == null) {
                info = new CrystalPullingInfo();
                info.setDeviceNo(deviceCode);
            }
            info.setLotNo(lotNo);//炉次号
            info.setConductionType(productModel.getConductionType());//型号
            info.setSpecs(productModel.getSpecs());//规格
            //开炉不记录开始时间，抽真空时记录
//            info.setStartTime(new Date());
            info.setDataUpdateTime(new Date());
            crystalPullingInfoService.saveOrUpdate(info);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * eap发送抽真空信号时更新实时新拉晶情况的开始时间
     * @param deviceCode
     */
    private void updateStartTimeForPullingInfo(String deviceCode) {
        try {
            CrystalPullingInfo info = crystalPullingInfoService.getByDeviceNo(deviceCode);
            if (info == null) {
                info = new CrystalPullingInfo();
                info.setDeviceNo(deviceCode);
            }

            //初次发送抽真空记录开始时间，后面再发送抽真空不记录
            if (null == info.getStartTime()){
                info.setStartTime(new Date());
            }
            info.setDataUpdateTime(new Date());
            crystalPullingInfoService.saveOrUpdate(info);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * 拉晶情况: 接收EAP数据处理
     */
    @Override
    public void crystalpullingHandler(ToMESData dto) {
        if (StringUtils.isBlank(dto.getDeviceCode())) {
            throw new RuntimeException("未传输炉台号");
        }

        Equipment equipment = equipmentService.findByCode(dto.getDeviceCode());

        if (equipment == null) {
            throw new RuntimeException("MES未配置此炉台信息");
        }


        //处理拉晶情况-实时数据
        realTimeCrystalPullingInfo(dto, equipment);

        //处理拉晶情况-记录数据

    }

    @Override
    public void crystalpullingRealTime(ToMESData dto) {
        if (StringUtils.isBlank(dto.getDeviceCode())) {
            throw new RuntimeException("未传输炉台号");
        }

        Equipment equipment = equipmentService.findByCode(dto.getDeviceCode());
        if (equipment == null) {
            throw new RuntimeException("MES未配置此炉台信息");
        }

        CrystalPullingInfo info = crystalPullingInfoService.getByDeviceNo(dto.getDeviceCode());
        if (info == null) {
            throw new RuntimeException("炉台" + dto.getDeviceCode() + "对应拉晶情况数据不存在！");
        }

        String realTimeInfo = "";
        String step = EAPUtils.getProcessStep(EAPUtils.getEventValue(dto, "4647"));
        if (step.equals("等径")) {
            info.setRealTimeInfo("等径:" + EAPUtils.getEventValue(dto, "1274Max"));
        } else {
            info.setRealTimeInfo(step);
        }
        crystalPullingInfoService.saveOrUpdate(info);
    }

    @Override
    public void shoulderSurvivalRate(ToMESData dto) {

        Equipment equipment = equipmentService.findByCode(dto.getDeviceCode());

        if (StringUtils.isBlank(dto.getDeviceCode())) {
            throw new RuntimeException("MES未配置此炉台信息");
        }

        ShoulderSurvivalRate rate = new ShoulderSurvivalRate();
        rate.setIntoShouldering(1);

        String lotNo = null;
        ProductionSchedule current_productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(dto.getDeviceCode(), Arrays.asList(1, 4, 5));
        if (current_productionSchedule != null) {
            lotNo = current_productionSchedule.getLotNo();
        }

        //系列
        String series = equipment.getSeries();
        //模块
        String area = equipment.getArea();


//        {
//            "deviceCode":"Z00",
//            "deviceType":"单晶炉",
//            "startCollectionData":{
//                "进入等径时间":"2022-02-22 18:59:45",
//                "引晶剩料重量":"123",
//                "扩肩进入等径时间":"2022-02-22 18:57:01",
//                "是否断取":"1.0"
//            },
//            "startTime":"2022-02-22 19:00:43",
//            "startValidateMap":{
//                "4647":"0.0",
//                "4737":""
//            },
//            "taskCode":"扩肩成活率",
//            "taskName":"扩肩成活率",
//            "taskType":"执行任务"
//        }

        //是否断取  值取反

        rate.setArea(area);
        rate.setSeries(series);
        rate.setDeviceNo(dto.getDeviceCode());
        rate.setLotNo(lotNo);

        rate.setCreateTime(new Date());


        String infoShoulderingTimeStr = EAPUtils.getEventValue(dto, "进入放肩时间");
        try {
            Date infoShoulderingTime = DateUtil.toDate(infoShoulderingTimeStr, "yyyy-MM-dd HH:mm:ss");
            rate.setInfoShoulderingTime(infoShoulderingTime);
        } catch (ParseException e) {
            e.printStackTrace();
        }


        String classNo = null;
        SimpleDateFormat df = new SimpleDateFormat("HH:mm:ss");
        try {
            if (rate.getInfoShoulderingTime() != null) {
                Date nowTime = df.parse(df.format(rate.getInfoShoulderingTime()));
                Date dayTimeStart = df.parse("09:00:00");
                Date dayTimeEnd = df.parse("21:00:00");

                if (timeCalendar(nowTime, dayTimeStart, dayTimeEnd)) {
                    classNo = "白班";
                } else {
                    classNo = "夜班";
                }
            }
        } catch (ParseException e) {
            e.printStackTrace();
        }
        rate.setClassNo(classNo);


        String infoIsodiametricTimeStr = EAPUtils.getEventValue(dto, "扩肩进入等径时间");
        try {
            Date infoIsodiametricTime = DateUtil.toDate(infoIsodiametricTimeStr, "yyyy-MM-dd HH:mm:ss");
            rate.setInfoIsodiametricTime(infoIsodiametricTime);
        } catch (ParseException e) {
            e.printStackTrace();
        }

        int breakTake = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "是否断取")).intValue();
        rate.setBreakTake(breakTake);


        Double residueWeight = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "引晶剩料重量")).doubleValue();
        rate.setResidueWeight(residueWeight);


        //扩肩成活率
        BigDecimal shoulderSurvivalRate = new BigDecimal(rate.getBreakTake() / rate.getIntoShouldering() * 100);
        rate.setShoulderSurvivalRate(shoulderSurvivalRate);

        //引晶功率
        BigDecimal crystalPower = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "引晶功率"));
        rate.setCrystalPower(crystalPower);

        //放肩长度
        BigDecimal infoShoulderingLength = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "放肩长度"));
        rate.setInfoShoulderingLength(infoShoulderingLength);

        shoulderSurvivalRateService.saveOrUpdate(rate);
    }

    public boolean timeCalendar(Date nowTime, Date dayTimeStart, Date dayTimeEnd) {
        //设置当前时间
        Calendar date = Calendar.getInstance();
        date.setTime(nowTime);
        //设置开始时间
        Calendar timeStart = Calendar.getInstance();
        timeStart.setTime(dayTimeStart);
        //设置结束时间
        Calendar timeEnd = Calendar.getInstance();
        timeEnd.setTime(dayTimeEnd);
        if (date.after(timeStart) && date.before(timeEnd)) {
            return true;
        } else {
            return false;
        }
    }


    /**
     * 处理拉晶情况-实时数据
     **/
    private void realTimeCrystalPullingInfo(ToMESData dto, Equipment equipment) {
        CrystalPullingInfo info = crystalPullingInfoService.getByDeviceNo(dto.getDeviceCode());
        if (info == null) {
            info = new CrystalPullingInfo();
            info.setDeviceNo(dto.getDeviceCode());
        }

        if (StringUtils.isBlank(info.getLotNo()) || StringUtils.isBlank(info.getConductionType()) || StringUtils.isBlank(info.getSpecs())) {
            ProductionSchedule productionSchedule = productionScheduleService.findTopByDeviceIdAndStatusOrderByIdDesc(equipment.getId(), EnumValuesServer.ProductionScheduleStatus.进行中.getKey());
            if (productionSchedule != null) {
                info.setLotNo(productionSchedule.getLotNo());//炉次号
                ProductModel productModel = productionSchedule.getProductModel();
                if (productModel != null) {
                    info.setConductionType(productModel.getConductionType());//型号
                    info.setSpecs(productModel.getSpecs());//规格
                }
                //未点开炉无生产工单(排程),去设备加工能力中取生产规格
                if (StringUtils.isBlank(info.getSpecs())) {
                    MachineCapacity machineCapacity = machineCapacityService.findByEquipmentId(equipment.getId());
                    if (machineCapacity != null) {
                        MachineCapacityInfo machineCapacityInfo = machineCapacity.getCapacityInfo();
                        if (machineCapacityInfo != null) {
                            info.setSpecs(machineCapacityInfo.getSpecification());//1.7规格
                        }
                    }
                }
            }
        }

        //info.setCrucible(crucible);//坩埚规格    --- IpcOperationController.initCrucibleInfo  370行更新此数据
        info.setSeries(equipment.getSeries());//系列
        info.setDeviceNo(dto.getDeviceCode());//炉台号

        //投料量
        BigDecimal materialCount = splicingMaterialCount(info.getMaterialCount(), dto.getTaskCode(), dto);
        if (materialCount != null) info.setMaterialCount(materialCount.setScale(0, BigDecimal.ROUND_HALF_UP));
        //拉晶情况
        String infoStr = splicingInfo(info.getInfo(), dto.getTaskCode(), dto);
        if (infoStr != null) info.setInfo(infoStr);

        //划线长度
        BigDecimal lineLength = splicingLineLength(info.getLineLength(), dto.getTaskCode(), dto);
        info.setLineLength(lineLength);

        //耗电量
        BigDecimal useKwh = splicingUseKwh(info.getUseKwh(), dto.getTaskCode(), dto);
        info.setUseKwh(useKwh);

        info.setDataUpdateTime(new Date());

        crystalPullingInfoService.saveOrUpdate(info);

        //停炉处理
//        if (dto.getTaskCode().equals("ShutdownFurnace")) {
//            if (!"停炉异常".equals(EAPUtils.getStartCollectionEventValue(dto, "停炉类型"))) {
//                clearCrystalPullingInfo(equipment.getCode());
//            }
//        }
//        else if(dto.getTaskCode().equals("晶棒情况") && EAPUtils.getEventValue(dto, "sectionNoStation").equals("停炉收尾")){
//        	clearCrystalPullingInfo(equipment.getCode());
//        }

        if ("1.0".equals(EAPUtils.getStartCollectionEventValue(dto, "是否停炉"))
                && !"停炉异常".equals(EAPUtils.getStartCollectionEventValue(dto, "停炉类型"))) {
            clearCrystalPullingInfoForEAP(info,equipment.getCode());
        }
    }

    /**
     * 计算耗电量
     **/
    private BigDecimal splicingUseKwh(BigDecimal source, String taskCode, ToMESData data) {
        Double useKwh = source == null ? 0 : source.doubleValue();

        switch (taskCode) {
            case "ShutdownFurnace": {//停炉
                //String _useKwh = EAPUtils.getEventValue(data, "1365");//当前体现的是 总加热电能   目前数值比较小
                String _useKwh = EAPUtils.getEventValue(data, "3304");//本次加热电能  目前数值很多 看着不像本次像总耗电
                useKwh = Double.valueOf(_useKwh);
                break;
            }
            case "OpenFurnace": {//开炉
                //String _useKwh = EAPUtils.getEventValue(data, "1365");//当前体现的是 总加热电能   目前数值比较小
                String _useKwh = EAPUtils.getEventValue(data, "3304");//本次加热电能  目前数值很多 看着不像本次像总耗电
                useKwh = Double.valueOf(_useKwh);

                break;
            }
            case "初始装料": {
                //String _useKwh = EAPUtils.getEventValue(data, "1365");//当前体现的是 总加热电能   目前数值比较小
                String _useKwh = EAPUtils.getEventValue(data, "3304");//本次加热电能  目前数值很多 看着不像本次像总耗电
                useKwh = Double.valueOf(_useKwh);
                break;
            }
            case "投料重量": {
                //String _useKwh = EAPUtils.getEventValue(data, "1365");//当前体现的是 总加热电能   目前数值比较小
                String _useKwh = EAPUtils.getEventValue(data, "3304");//本次加热电能  目前数值很多 看着不像本次像总耗电
                useKwh = Double.valueOf(_useKwh);
                break;
            }
            case "断提": {
                //String _useKwh = EAPUtils.getEventValue(data, "1365");//当前体现的是 总加热电能   目前数值比较小
                String _useKwh = EAPUtils.getEventValue(data, "3304");//本次加热电能  目前数值很多 看着不像本次像总耗电
                useKwh = Double.valueOf(_useKwh);
                break;
            }
            case "肩长情况": {
                //String _useKwh = EAPUtils.getEventValue(data, "1365");//当前体现的是 总加热电能   目前数值比较小
                String _useKwh = EAPUtils.getEventValue(data, "3304");//本次加热电能  目前数值很多 看着不像本次像总耗电
                useKwh = Double.valueOf(_useKwh);
                break;
            }
            case "晶棒情况": {
                //String _useKwh = EAPUtils.getEventValue(data, "1365");//当前体现的是 总加热电能   目前数值比较小
                String _useKwh = EAPUtils.getEventValue(data, "3304");//本次加热电能  目前数值很多 看着不像本次像总耗电
                useKwh = Double.valueOf(_useKwh);
                break;
            }
            default:
                break;
        }

        return BigDecimal.valueOf(useKwh);
    }


    /**
     * 累加划线长度
     **/
    private BigDecimal splicingLineLength(BigDecimal source, String taskCode, ToMESData data) {
        Double lineLength = source == null ? 0d : source.doubleValue();

        switch (taskCode) {
            case "晶棒情况": {

                DictionaryItem dictionaryItem = dictionaryItemService.findByThemeValueAndNameAndEnable(EnumValuesServer.DictionaryTheme.长晶棒减长.getKey(), "ratio", true);

                //lineLength = 0d;
                String sectionNo = EAPUtils.getEventValue(data, "sectionNo");
                String len = EAPUtils.getEventValue(data, "1274Max");
                String sectionNoStation = EAPUtils.getEventValue(data, "sectionNoStation");

                if (sectionNoStation.equals("断苞")) {
                    lineLength += (Double.valueOf(len) - (dictionaryItem == null ? 200d : Double.valueOf(dictionaryItem.getValue())));
                } else if (sectionNoStation.equals("断苞拉料")) {

                } else {
                    lineLength += Double.valueOf(len);
                }

                break;
            }
            default:
                break;
        }

        return BigDecimal.valueOf(lineLength);
    }

    /**
     * 累加复投总重
     **/
    private BigDecimal splicingMaterialCount(BigDecimal source, String taskCode, ToMESData data) {
        BigDecimal materialCount = source;

        if (materialCountTaskCodeScope.keySet().contains(taskCode)) {
            String key = materialCountTaskCodeScope.get(taskCode);

            if (taskCode.equals("初始装料")) {
                materialCount = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(data, key));
            } else {
                if (materialCount == null) materialCount = new BigDecimal(0);

                BigDecimal value = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(data, key));
                if (value == null) value = new BigDecimal(0);
                materialCount = BigDecimal.valueOf(materialCount.doubleValue() + value.doubleValue());
            }
        } else {
            materialCount = null;
        }

        return materialCount;
    }


    /**
     * 拼接拉晶情况信息
     **/
    private String splicingInfo(String source, String taskCode, ToMESData data) {
        String info = null;


        switch (taskCode) {
            case "初始装料": {
                //初始装料只添加一次
                if (!source.contains("初始装料")) {
                    info = "初始装料" + nullformart(EAPUtils.getEventValue(data, "1424", 0)) + "Kg";
                }
                break;
            }
            case "初始复投": {
                info = "初始复投" + nullformart(EAPUtils.getEventValue(data, "复投总重", 0)) + "Kg";
                break;
            }
            case "投料重量": {
                info = "投料重量" + nullformart(EAPUtils.getEventValue(data, "复投总重", 0)) + "Kg";
                break;
            }
            case "断提": {
                info = "保持" + nullformart(EAPUtils.getEventValue(data, "1274Max", 0)) + "断提";
                break;
            }
            case "肩长情况": {
                info = nullformart(EAPUtils.getEventValue(data, "扩断类型")) + nullformart(EAPUtils.getEventValue(data, "肩部长度", 0));
                break;
            }
            case "晶棒情况": {
                info = "";
                String sectionNo = EAPUtils.getEventValue(data, "sectionNo");
                info += nullformart(convertNumMap.get(Double.valueOf(sectionNo).intValue()));
                if ("断苞拉料".equals(EAPUtils.getEventValue(data, "sectionNoStation"))){
                    info += nullformart(EAPUtils.getEventValue(data, "断拉长度", 0));
                }else{
                    info += nullformart(EAPUtils.getEventValue(data, "1274Max", 0));
                }
                info += nullformart(EAPUtils.getEventValue(data, "sectionNoStation"));
                if ("断苞拉料".equals(EAPUtils.getEventValue(data, "sectionNoStation"))){
                    info += (Double.valueOf(EAPUtils.getEventValue(data, "3287", 0)) - Double.valueOf(EAPUtils.getEventValue(data, "断拉重量", 0))) + "KG";
                }
                break;
            }
            default:
                break;
        }

        if (info != null && !StringUtils.isBlank(source)) {
            info = source + "," + info;
        }

        return info;
    }


    private String nullformart(String value) {
        if (StringUtils.isBlank(value) || value.equals("null")) {
            //return "(未采集到)";
            return "";
        } else {

            return value;
        }
    }



    @Override
    public void processReceive(ToMESData data) {
        if (StringUtils.isBlank(data.getDeviceCode())) {
            throw new RuntimeException("未传输炉台号");
        }

        Equipment equipment = equipmentService.findByCode(data.getDeviceCode());

        if (equipment == null) {
            throw new RuntimeException("MES未配置此炉台信息");
        }

        if (data.getTaskCode().equals("工艺变动")) {
            String data4647 = EAPUtils.getProcessStep(EAPUtils.getEventValue(data, "4647"));
            String length = EAPUtils.getEventValue(data, "1274Max");
            if (data4647 != null) {
                equipment.setCurrentStep(data4647);
                equipment.setStepUpdateTime(new Date());
                equipmentService.saveOrUpdate(equipment);

                ProductionSchedule current_productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(data.getDeviceCode(), Arrays.asList(1, 4, 5));

                ProcessPath processPath = new ProcessPath();
                processPath.setEquipmentCode(data.getDeviceCode());
                processPath.setLotNo(current_productionSchedule == null ? null : current_productionSchedule.getLotNo());
                processPath.setDeviceStartTime(data.getStartTime());
                processPath.setRemark(JSON.toJSONString(data.getStartValidateMap()));
                processPath.setStepName(data4647);
                processPath.setStartTime(new Date());
                processPathService.saveOrUpdate(processPath);
                // 产出后未灌料
                if("引晶".equals(data4647)){
                    String deviceCode = data.getDeviceCode();
                    saveOutputRecord(deviceCode);
                }
                if (null == current_productionSchedule || null == current_productionSchedule.getProductModel()
                        || StringUtils.isEmpty(current_productionSchedule.getProductModel().getSpecs())) {
                    log.info("存储预取棒时,排程尺寸为空,不记录!");
                } else {
                    if (EAPUtils.stepMapping.get(57).equals(data4647) ||
                            EAPUtils.stepMapping.get(55).equals(data4647) ||
                            EAPUtils.stepMapping.get(13).equals(data4647)) {
                        //存储到预取棒记录表
                        EstimatedRecord estimatedRecord = new EstimatedRecord();
                        String specs = current_productionSchedule.getProductModel().getSpecs();
                        estimatedRecord.setDeviceCode(data.getDeviceCode())
                                .setRemarkFirst(specs)
                                .setIsDeleted(0)
                                .setLength(length)
                                .setNodeTime(data.getStartTime())
                                .setCreateTime(new Date())
                                .setCreateUser(BaseContextHandler.getUsername())
                                .setNodeName(data4647);
                        if (EAPUtils.stepMapping.get(57).equals(data4647)) {
                            //触发节点由 取段变更为取段收尾
                            if ("10吋".equals(specs)) {
                                estimatedRecord.setTakeTime(DateUtil.addMinute(estimatedRecord.getNodeTime(), 30));
                            } else if ("12吋".equals(specs)) {
                                estimatedRecord.setTakeTime(DateUtil.addMinute(estimatedRecord.getNodeTime(), 90));
                            }

                        } else if (EAPUtils.stepMapping.get(55).equals(data4647)) {
                            //断线提出
                            if ("10吋".equals(specs)) {
                                estimatedRecord.setTakeTime(DateUtil.addMinute(estimatedRecord.getNodeTime(), 30));
                            } else if ("12吋".equals(specs)) {
                                estimatedRecord.setTakeTime(DateUtil.addMinute(estimatedRecord.getNodeTime(), 90));
                            }
                        } else if (EAPUtils.stepMapping.get(13).equals(data4647)) {
                            //停炉
                            estimatedRecord.setTakeTime(DateUtil.addMinute(estimatedRecord.getNodeTime(), 540));
                        }
                        estimatedRecordService.saveOrUpdate(estimatedRecord);
                    }
                }
            }
        } else if (data.getTaskCode().equals("在线状态")) {
            String onlineState = EAPUtils.getEventValue(data, "deviceStatus");
            equipment.setOnlineStatus(onlineState);
            equipmentService.saveOrUpdate(equipment);
        }
    }


    /**
     * 查询当前正在生产的棒子,是否有灌料
     * @param deviceCode
     */
    public void saveOutputRecord(String deviceCode) {
        SysLog sysLog = new SysLog();
        Date date = new Date();
        Map<String,Object> map = new HashMap<>();
        try {
            LongCrystal lastCrystalNo = longCrystalService.getLastCrystalNo(deviceCode);
            Integer nowAgainNum = null;
            Integer againNum = null;
            BigDecimal againWeigth = null;
            String lotNo = null;
            /**
             * 完结棒       V
             * 完结尾       W
             * 无
             */
            String closureIdentification = null;
            /**
             * 完结棒       V
             * 完结尾       W
             * 正常收尾     Y
             * 等径断线     N1
             * 收尾断线     N2
             * 多晶棒       D
             */
            String windUp = null;
            String crystalNo = null;
            BigDecimal length = null;
            if (null != lastCrystalNo && !StringUtils.isEmpty(lastCrystalNo.getLotNo()) && !StringUtils.isEmpty(lastCrystalNo.getCrystalNo())) {
                closureIdentification = lastCrystalNo.getClosureIdentification();
                windUp = lastCrystalNo.getWindUp();
                crystalNo = lastCrystalNo.getCrystalNo();
                length = lastCrystalNo.getLength();
                if(!StringUtils.isEmpty(closureIdentification)) {
                    if ("W".equalsIgnoreCase(closureIdentification)) {
                        // 是完结尾
                        nowAgainNum = 1;
                    } else if("V".equalsIgnoreCase(windUp)){
                        // 完结棒
                        nowAgainNum = lastCrystalNo.getAgainNum();

                    } else {
                        if (!StringUtils.isEmpty(windUp)) {
                            if(!"N1".equalsIgnoreCase(windUp)){
                                // 不是等径断线
                                nowAgainNum =lastCrystalNo.getAgainNum() + 1;
                            } else {
                                // 首棒
                                if(crystalNo.endsWith("10") || crystalNo.endsWith("11")){
                                    // 首棒
                                    if(length.doubleValue() > 1000){
                                        // 首棒且长度大于1000
                                        nowAgainNum = lastCrystalNo.getAgainNum() + 1;
                                    } else {
                                        nowAgainNum = lastCrystalNo.getAgainNum();
                                    }
                                } else {
                                    if(length.doubleValue() > 1500){
                                        // 非首棒且长度大于1500
                                        nowAgainNum = lastCrystalNo.getAgainNum() + 1;
                                    } else {
                                        nowAgainNum = lastCrystalNo.getAgainNum();
                                    }
                                }
                            }

                        }
                    }
                }
                AgainTaskDetail againTaskDetail = againTaskDetailService.findTopByEquipmentCodeOrderByIdDesc(deviceCode);
                if(null != againTaskDetail){
                    lotNo = againTaskDetail.getLotNo();
                    AgainTask againTask = againTaskService.get(againTaskDetail.getAgainTaskId());
                    if(null != againTask){
                        againWeigth = againTask.getAgainWeigth();
                        againNum = againTask.getAgainNum();
                        map.put("againTask",againTask.getId());
                    }
                    if(null != nowAgainNum && !nowAgainNum.equals(againNum)) {
//                    LoadingTask loadingTask = loadingTaskService.getFinishTask(deviceCode, againTaskDetail.getLotNo());
//                    if (null == loadingTask) {
                        // 复投次数不一致，查询当前计算的复投次数是否完成，没有完成保存数据
                        List<AgainTask> againTaskList = againTaskService.findSuccessByEquipmentCodeAndAgainNum(deviceCode, nowAgainNum);
                        boolean empty = againTaskList.isEmpty();
                        map.put("empty",empty);
                        if(againTaskList.isEmpty()) {
                            OutputRecord outputRecord = new OutputRecord();
                            outputRecord.setAgainNum(nowAgainNum);
                            outputRecord.setCreateTime(date);
                            outputRecord.setDeviceNo(deviceCode);
                            outputRecord.setLotNo(lotNo);
                            outputRecord.setWeigth(null == againWeigth ? null : againWeigth.doubleValue());
                            OutputRecord topByDeviceNo = outputRecordService.findTopByDeviceNo(deviceCode);
                            if (null != topByDeviceNo) {
                                outputRecord.setId(topByDeviceNo.getId());
                            }
                            outputRecordService.saveOrUpdate(outputRecord);
//                    } else {
//                        map.put("loadingTask",loadingTask.getId());
//                    }
                        }
                    }
                    map.put("lotNo",lotNo);
                    map.put("nowAgainNum",nowAgainNum);
                    map.put("againNum",againNum);
                    map.put("againWeigth",againWeigth);
                    map.put("closureIdentification",closureIdentification);
                    map.put("windUp",windUp);
                    map.put("againTaskDetail",againTaskDetail.getId());
                    map.put("length",length);
                }
            }

        } catch (Exception e){
            sysLog.setResult(e.getMessage());
            e.printStackTrace();
        }
        sysLog.setCreateTime(date);
        sysLog.setType("info");
        sysLog.setCreateUserName(BaseContextHandler.getUsername());
        sysLog.setContent(JSON.toJSONString(map));
        sysLog.setMethodName("产出后未灌料");
        sysLog.setName("产出后未灌料");
        sysLog.setReqIp(IpUtils.getLocalIP());
        sysLogService.save(sysLog);
    }


    //工时-工步名称
    //operatorUser
    //url {deviceCode:'' operatorUser:''}  还要token
    @Override
    public void workingHours(ToMESData data) {
        if (StringUtils.isBlank(data.getDeviceCode())) {
            throw new RuntimeException("未传输炉台号");
        }

        Equipment equipment = equipmentService.findByCode(data.getDeviceCode());

        if (StringUtils.isBlank(data.getDeviceCode())) {
            throw new RuntimeException("MES未配置此炉台信息");
        }


        String taskCode = data.getTaskCode();
        String[] taskCodeNames = taskCode.split("-");
        if (taskCodeNames.length != 2) throw new RuntimeException("工序名称格式不正确:" + taskCode);

        String name = taskCodeNames[1];


        String deviceTypeCode = null;//设备类型编号
        String lotNo = null;//炉次号

        Device device = equipment.getDevice();
        if (device != null) {
            deviceTypeCode = device.getCode();
        }

        if (StringUtils.isBlank(deviceTypeCode)) {
            throw new RuntimeException("MES未配置设备类型编码:" + deviceTypeCode);
        }


        ProductionSchedule current_productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(data.getDeviceCode(), Arrays.asList(1, 4, 5));
        if (current_productionSchedule != null) {
            lotNo = current_productionSchedule.getLotNo();
        }


        List<ParamSet> paramSets = paramSetService.findByDeviceName(deviceTypeCode);
        Map<String, ParamSet> _paramSetMap = paramSets.stream().collect(Collectors.toMap(ParamSet::getProcessName, t -> t));


//		if(lotNo==null) {
//			workingHours = processWorkingHoursService.getByEquipmentCodeAndLotNoIsNull(data.getDeviceCode());
//			if(workingHours==null) {
//				workingHours = new ProcessWorkingHours();
//			}
//		}else {
//			workingHours = processWorkingHoursService.getByEquipmentCodeAndLotNoIsNull(data.getDeviceCode());
//			if(workingHours==null) {
//				workingHours = processWorkingHoursService.getByEquipmentCodeAndLotNo(data.getDeviceCode(),lotNo);
//				if(workingHours==null) {
//					workingHours = new ProcessWorkingHours();
//				}
//			}
//		}
        ProcessWorkingHours workingHours = new ProcessWorkingHours();
        workingHours.setEquipmentCode(data.getDeviceCode());
        workingHours.setLotNo(lotNo);
        workingHours.setStepName(name);

//        if(name.equals("取段复投")) {
//        	String startTimeStr = EAPUtils.getEndEventValue(data, "取单晶时间");
//
//        	Date startTime = null;
//			try {
//				startTime = DateUtil.toDate(startTimeStr, "yyyy-MM-dd HH:mm:ss");
//			} catch (ParseException e) {
//				e.printStackTrace();
//			}
//        	workingHours.setStartTime(startTime);
//        }else {

        String startTimeStr = EAPUtils.getEventValue(data, taskCode + "-开始时间");
        Date startTime = null;
        try {
            startTime = DateUtil.toDate(startTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }
        workingHours.setStartTime(startTime);
//        }

        workingHours.setArea(equipment.getArea());
        workingHours.setSeries(equipment.getSeries());

        ParamSet paramSet = _paramSetMap.get(name);
        if (paramSet != null && paramSet.getParamValue() != null) {
            workingHours.setTheoryTime(paramSet.getParamValue());
        }

        if (data.getEndTime() != null) {

            String endTimeStr = EAPUtils.getEventValue(data, taskCode + "-结束时间");
            Date endTime = null;
            if (endTimeStr != null) {
                try {
                    endTime = DateUtil.toDate(endTimeStr, "yyyy-MM-dd HH:mm:ss");
                } catch (ParseException e) {
                    e.printStackTrace();
                }
            }

            workingHours.setEndTime(endTime);

            String end_operatorUser = EAPUtils.getEndEventValue(data, "operatorUser");
            workingHours.setEndOperatorUser(end_operatorUser);
        }

        //获取等径断苞稳温单晶长度
        workingHours.setLength(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(data, "1274Max")));

        if (workingHours.getStartTime() != null && workingHours.getEndTime() != null) {
            workingHours.setTimeLong(workingHours.getEndTime().getTime() - workingHours.getStartTime().getTime());

            //计算浪费工时
            if (workingHours.getTheoryTime() != null) {
                Long _theoryTime = new BigDecimal(workingHours.getTheoryTime().doubleValue() * 60 * 60 * 1000).longValue();

                Long wasteTime = _theoryTime - workingHours.getTimeLong();
//				if(wasteTime<0) {
//					wasteTime = 0l;
//				}
                workingHours.setWasteTime(wasteTime);
            }
        }

        String start_operatorUser = EAPUtils.getStartEventValue(data, "operatorUser");
        workingHours.setStartOperatorUser(start_operatorUser);


        //复投次数 - 取段复投专用字段 有值就取

        String end_againNum = EAPUtils.getEndEventValue(data, "复投次数");
        workingHours.setAgainNum(NumberUtil.String2Integer(end_againNum, null));

        processWorkingHoursService.saveOrUpdate(workingHours);

    }

    @Override
    public void workingStep(ToMESData data) {
        if (StringUtils.isBlank(data.getDeviceCode())) {
            throw new RuntimeException("未传输炉台号");
        }

        Equipment equipment = equipmentService.findByCode(data.getDeviceCode());

        if (StringUtils.isBlank(data.getDeviceCode())) {
            throw new RuntimeException("MES未配置此炉台信息");
        }


        String taskCode = data.getTaskCode();
        String[] taskCodeNames = taskCode.split("-");
        if (taskCodeNames.length != 2) throw new RuntimeException("工序名称格式不正确:" + taskCode);

        String name = taskCodeNames[1];


        String deviceTypeCode = null;//设备类型编号
        String lotNo = null;//炉次号

        Device device = equipment.getDevice();
        if (device != null) {
            deviceTypeCode = device.getCode();
        }

        if (StringUtils.isBlank(deviceTypeCode)) {
            throw new RuntimeException("MES未配置设备类型编码:" + deviceTypeCode);
        }
        ProductionSchedule current_productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(data.getDeviceCode(), Arrays.asList(1, 4, 5));
        if (current_productionSchedule != null) {
            lotNo = current_productionSchedule.getLotNo();
        }
        ProcessWorkingStep workingStep = new ProcessWorkingStep();
        workingStep.setEquipmentCode(data.getDeviceCode());
        workingStep.setLotNo(lotNo);
        workingStep.setStepName(name);

        String data4647 = EAPUtils.getProcessStep(EAPUtils.getEndEventValue(data, "4647"));
        workingStep.setLastStepName(data4647);



        workingStep.setStartTime(data.getEndTime());

        workingStep.setArea(equipment.getArea());
        workingStep.setSeries(equipment.getSeries());

        String start_operatorUser = EAPUtils.getEventValue(data, "operatorUser");
        workingStep.setStartOperatorUser(start_operatorUser);


        //复投次数
        String end_againNum = EAPUtils.getEndEventValue(data, "复投次数");
        workingStep.setAgainNum(NumberUtil.String2Integer(end_againNum, null));

        processWorkingStepService.saveOrUpdate(workingStep);

    }


    @Override
    public void shoulderSeedingRate(ToMESData dto) {

        Equipment equipment = equipmentService.findByCode(dto.getDeviceCode());

        if (StringUtils.isBlank(dto.getDeviceCode())) {
            throw new RuntimeException("MES未配置此炉台信息");
        }

        ShoulderSeedingRate rate = new ShoulderSeedingRate();
        rate.setIntoSeeding(1);

        String lotNo = null;
        ProductionSchedule current_productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(dto.getDeviceCode(), Arrays.asList(1, 4, 5));
        if (current_productionSchedule != null) {
            lotNo = current_productionSchedule.getLotNo();
        }

        //系列
        String series = equipment.getSeries();
        //模块
        String area = equipment.getArea();

        rate.setArea(area);
        rate.setSeries(series);
        rate.setDeviceNo(dto.getDeviceCode());
        rate.setLotNo(lotNo);

        rate.setCreateTime(new Date());

        int breakTake = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "是否引段")).intValue();
        rate.setBreakTake(breakTake);

        BigDecimal residueWeightDec = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "引晶剩料重量"));
        Double residueWeight = null;
        if (residueWeightDec != null) {
            residueWeight = residueWeightDec.doubleValue();
        }
        rate.setResidueWeight(residueWeight);

        BigDecimal seedingLength = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "引晶长度"));
        rate.setSeedingLength(seedingLength);


        Date breakTakeTime = null;
        try {
            String breakTakeTimeStr = EAPUtils.getEventValue(dto, "引晶断时间");
            if (StringUtils.isNotBlank(breakTakeTimeStr) && !breakTakeTimeStr.equals("null"))
                breakTakeTime = DateUtil.toDate(breakTakeTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }

        Date yjInfoShoulderingTime = null;
        try {
            String yjInfoShoulderingTimeStr = EAPUtils.getEventValue(dto, "引晶-进入放肩时间");
            yjInfoShoulderingTime = DateUtil.toDate(yjInfoShoulderingTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }

        Date infoSeedingSuccessTime = null;
        try {
            String infoSeedingSuccessTimeStr = EAPUtils.getEventValue(dto, "引晶成功时间");
            infoSeedingSuccessTime = DateUtil.toDate(infoSeedingSuccessTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }


        Date infoSeedingTime = null;
        try {
            String infoSeedingTimeStr = EAPUtils.getEventValue(dto, "进入引晶时间");
            infoSeedingTime = DateUtil.toDate(infoSeedingTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }


        Date infoShoulderingTime = null;
        try {
            String infoShoulderingTimeStr = EAPUtils.getEventValue(dto, "进入放肩时间");
            infoShoulderingTime = DateUtil.toDate(infoShoulderingTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }


        //进入引晶时间
        rate.setInfoSeedingTime(infoSeedingTime);


        //计算班次
        String classNo = null;
        SimpleDateFormat df = new SimpleDateFormat("HH:mm:ss");
        try {
            if (rate.getInfoSeedingTime() != null) {
                Date nowTime = df.parse(df.format(rate.getInfoSeedingTime()));
                Date dayTimeStart = df.parse("09:00:00");
                Date dayTimeEnd = df.parse("21:00:00");

                if (timeCalendar(nowTime, dayTimeStart, dayTimeEnd)) {
                    classNo = "白班";
                } else {
                    classNo = "夜班";
                }
            }
        } catch (ParseException e) {
            e.printStackTrace();
        }
        rate.setClassNo(classNo);

        //计算引晶时长
        BigDecimal seedingTime = null;
        if (rate.getBreakTake() == 1) {//
            rate.setInfoShoulderingTime(infoShoulderingTime);
            if (yjInfoShoulderingTime != null && infoSeedingTime != null) {
                Long time = yjInfoShoulderingTime.getTime() - infoSeedingTime.getTime();
                double value = (time / 1000d) / 60 / 60;
                seedingTime = new BigDecimal(value).setScale(2, BigDecimal.ROUND_DOWN);
            }
        } else {
            rate.setInfoShoulderingTime(breakTakeTime);
            if (breakTakeTime != null && infoSeedingTime != null) {
                Long time = breakTakeTime.getTime() - infoSeedingTime.getTime();
                double value = (time / 1000d) / 60 / 60;
                seedingTime = new BigDecimal(value).setScale(2, BigDecimal.ROUND_DOWN);
            }
        }
        rate.setSeedingTime(seedingTime);

        //扩肩成活率
        BigDecimal shoulderSurvivalRate = new BigDecimal(rate.getBreakTake() / rate.getIntoSeeding() * 100);
        rate.setSeedingRate(shoulderSurvivalRate);

        //引晶功率
        BigDecimal crystalPower = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "引晶功率"));
        rate.setCrystalPower(crystalPower);


        shoulderSeedingRateService.saveOrUpdate(rate);
    }


    @Override
    public void expansionBase(ToMESData dto) {
        Equipment equipment = equipmentService.findByCode(dto.getDeviceCode());
        if (null == equipment) {
            throw new RuntimeException("设备不存在");
        }

        if (StringUtils.isBlank(dto.getDeviceCode())) {
            throw new RuntimeException("MES未配置此炉台信息");
        }

        //系列
        String series = equipment.getSeries();

        ExpansionBase expansionBase = new ExpansionBase();

        String lotNo = null;
        ProductionSchedule current_productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(dto.getDeviceCode(), Arrays.asList(1, 4, 5));
        if (current_productionSchedule != null) {
            lotNo = current_productionSchedule.getLotNo();
            expansionBase.setLotNo(lotNo);
            ProductModel productModel = current_productionSchedule.getProductModel();
            if (productModel != null) {
                expansionBase.setSpecs(productModel.getSpecs());//规格
            }
        }

        //未点开炉无生产工单(排程),去设备加工能力中取生产规格
        if (StringUtils.isBlank(expansionBase.getSpecs())) {
            MachineCapacity machineCapacity = machineCapacityService.findByEquipmentId(equipment.getId());
            if (machineCapacity != null) {
                MachineCapacityInfo machineCapacityInfo = machineCapacity.getCapacityInfo();
                if (machineCapacityInfo != null) {
                    expansionBase.setSpecs(machineCapacityInfo.getSpecification());//1.7规格
                }
            }
        }

        Date startTime = null;
        try {
            String startTimeStr = EAPUtils.getEventValue(dto, "开炉时间");
            startTime = DateUtil.toDate(startTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }

        expansionBase.setStartTime(startTime);

        //扩断时间
        Date expansionTime = new Date();
//        try {
//        	String expansionTimeStr = EAPUtils.getEventValue(dto, "扩断时间");
//        	expansionTime = DateUtil.toDate(expansionTimeStr, "yyyy-MM-dd HH:mm:ss");
//        } catch (ParseException e) {
//        	e.printStackTrace();
//        }


        EquipmentExtendState state = equipmentExtendStateService.getByCode(dto.getDeviceCode());
        if (state != null) {
            expansionBase.setClassGroup(state.getTeamGroup());
        }

        expansionBase.setSeries(series);
        expansionBase.setDeviceNo(dto.getDeviceCode());


        expansionBase.setExpansionTime(expansionTime);//扩断时间

        if (expansionTime != null) {
            String dateTime = DateUtil.formatDate(expansionTime, "yyyy-MM-dd");
            expansionBase.setDateTime(dateTime);
        }

        if (expansionBase.getStartTime() != null) {
            long runTimeLen = expansionBase.getExpansionTime().getTime() - expansionBase.getStartTime().getTime();
            double value = (runTimeLen / 1000d) / 60 / 60;
            BigDecimal runTime = new BigDecimal(value).setScale(2, BigDecimal.ROUND_DOWN);
            expansionBase.setRunTime(runTime);
        }

        String expansionType = EAPUtils.getEventValue(dto, "扩断类别");
        expansionBase.setExpansionType(expansionType);

        String expansionProcesses = EAPUtils.getEventValue(dto, "扩断工序");
        expansionBase.setExpansionProcesses(expansionProcesses);

        Integer repeatedInfoInteger = NumberUtil.String2Integer(EAPUtils.getEventValue(dto, "报表复投次数"), null);
        expansionBase.setRepeatedInfo(repeatedInfoInteger.toString());

        BigDecimal crystalPower = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "引晶功率"));
        expansionBase.setCrystalPower(crystalPower);


        Date fjTime = null;
        try {
            String fjTimeStr = EAPUtils.getEventValue(dto, "进入放肩时间");
            fjTime = DateUtil.toDate(fjTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }

        Date yjTime = null;
        try {
            String yjTimeStr = EAPUtils.getEventValue(dto, "进入引晶时间");
            yjTime = DateUtil.toDate(yjTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }

        if (fjTime != null && yjTime != null) {
            long crystalTimeLen = fjTime.getTime() - yjTime.getTime();
            double value = (crystalTimeLen / 1000d) / 60 / 60;
            BigDecimal crystalTime = new BigDecimal(value).setScale(2, BigDecimal.ROUND_DOWN);
            expansionBase.setCrystalTime(crystalTime);
        }


        CrystalPullingInfo info = crystalPullingInfoService.getByDeviceNo(dto.getDeviceCode());
        if (info != null) {
            BigDecimal materialCount = info.getMaterialCount();
            expansionBase.setFeedingQuantity(materialCount);
        }


        //计算班次
        String classNo = null;
        SimpleDateFormat df = new SimpleDateFormat("HH:mm:ss");
        try {
            if (expansionTime != null) {
                Date nowTime = df.parse(df.format(expansionTime));
                Date dayTimeStart = df.parse("09:00:00");
                Date dayTimeEnd = df.parse("21:00:00");

                if (timeCalendar(nowTime, dayTimeStart, dayTimeEnd)) {
                    classNo = "白班";
                } else {
                    classNo = "夜班";
                }
            }
        } catch (ParseException e) {
            e.printStackTrace();
        }
        expansionBase.setClassNo(classNo);
        expansionBase.setLiquidLevelPixel(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径1000mm液面像素值", 1)));
        expansionBase.setLiquidCursor(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "8032", 1)));
        String dryPotType = EAPUtils.getStartCollectionEventValue(dto, "1196");
        expansionBase.setDryPotType(StringUtils.isNotBlank(dryPotType) && dryPotType.length() > 1 ? dryPotType.substring(dryPotType.length() - 2) : dryPotType);

        //扩断长度取值
        BigDecimal expansionLength = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "扩断长度"));
        expansionBase.setExpansionLength(expansionLength);

        //最新修改时间
        expansionBase.setUpdateTime(new Date());

        expansionBaseService.saveOrUpdate(expansionBase);
    }

    @Override
    public void brokenBractBase(ToMESData dto) throws Exception {
        Equipment equipment = equipmentService.findByCode(dto.getDeviceCode());
        if (null == equipment) {
            throw new RuntimeException("设备不存在");
        }

        if (StringUtils.isBlank(dto.getDeviceCode())) {
            throw new RuntimeException("MES未配置此炉台信息");
        }
        BrokenBractBase brokenBractBase = new BrokenBractBase();


        Date startTime = null;
        try {
            startTime = dto.getStartTime();
            String startTimeStr = DateUtil.formatDate(startTime, "yyyy-MM-dd HH:mm:ss");
            brokenBractBase.setDateTime(startTimeStr); // 1.1 日期
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception("处理startTime发生异常：" + e.getMessage());
        }

        EquipmentExtendState state = equipmentExtendStateService.getByCode(dto.getDeviceCode());
        if (state != null) {
            brokenBractBase.setClassGroup(state.getTeamGroup()); //1.2 班组
        }

        //计算班次
        String classNo = null;
        SimpleDateFormat df = new SimpleDateFormat("HH:mm:ss");
        try {
            if (startTime != null) {
                Date nowTime = df.parse(df.format(startTime));
                Date dayTimeStart = df.parse("09:00:00");
                Date dayTimeEnd = df.parse("21:00:00");

                if (timeCalendar(nowTime, dayTimeStart, dayTimeEnd)) {
                    classNo = "白班";
                } else {
                    classNo = "夜班";
                }
            }
        } catch (ParseException e) {
            e.printStackTrace();
            throw new Exception("计算班次发生异常：" + e.getMessage());
        }
        brokenBractBase.setClassNo(classNo);// 1.3班次

        //系列
        String series = equipment.getSeries();
        brokenBractBase.setSeries(series); // 1.4系列

        brokenBractBase.setDeviceNo(dto.getDeviceCode()); // 1.5 炉台号
        String lotNo = null;
        ProductionSchedule current_productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(dto.getDeviceCode(), Arrays.asList(1, 4, 5));
        if (current_productionSchedule != null) {
            lotNo = current_productionSchedule.getLotNo();
            brokenBractBase.setLotNo(lotNo);// 1.6炉次号
            ProductModel productModel = current_productionSchedule.getProductModel();
            if (productModel != null) {
                brokenBractBase.setSpecs(productModel.getSpecs());//1.7规格
            }
        }

        //未点开炉无生产工单(排程),去设备加工能力中取生产规格
        if (StringUtils.isBlank(brokenBractBase.getSpecs())) {
            MachineCapacity machineCapacity = machineCapacityService.findByEquipmentId(equipment.getId());
            if (machineCapacity != null) {
                MachineCapacityInfo machineCapacityInfo = machineCapacity.getCapacityInfo();
                if (machineCapacityInfo != null) {
                    brokenBractBase.setSpecs(machineCapacityInfo.getSpecification());//1.7规格
                }
            }
        }

        Date klTime = null;
        try {
            String klTimeStr = EAPUtils.getEventValue(dto, "开炉时间");
            if (null != klTimeStr && !"null".equals(klTimeStr)) {
                klTime = DateUtil.toDate(klTimeStr, "yyyy-MM-dd HH:mm:ss");
            }
        } catch (ParseException e) {
            e.printStackTrace();
            throw new Exception("处理开炉时间发生异常：" + e.getMessage());
        }

        if (klTime != null && startTime != null) {
            long runTimeLen = startTime.getTime() - klTime.getTime();
            double value = (runTimeLen / 1000d) / 60 / 60;
            BigDecimal runTime = new BigDecimal(value).setScale(2, BigDecimal.ROUND_DOWN);
            brokenBractBase.setRunTime(runTime); // 1.8 运行时间
        }

        String brokenBractTypeStr = EAPUtils.getEventValue(dto, "断苞类别");
        brokenBractBase.setBrokenBractType(brokenBractTypeStr); // 1.9 断苞类别

//        String brokenBractProcessesStr = (dto.getStartValidateMap().containsKey("4647")? dto.getStartValidateMap().get("4647").toString(): null);
//        brokenBractBase.setBrokenBractProcesses(brokenBractProcessesStr); // 1.9 断苞工序
        brokenBractBase.setBrokenBractProcesses("等径"); // 1.9 断苞工序

        String crystalLengthStr = (dto.getStartCollectionData().get("1274Max") != null ? dto.getStartCollectionData().get("1274Max").toString() : null);
        BigDecimal crystalLength = NumberUtil.Object2BigDecimal(crystalLengthStr);
        brokenBractBase.setCrystalLength(crystalLength); // 1.10 晶体长度

//        String repeatedInfoStr = EAPUtils.getEventValue(dto, "复投次数");
        String repeatedInfoStr = EAPUtils.getEventValue(dto, "报表复投次数", 0);
        brokenBractBase.setRepeatedInfo(repeatedInfoStr); // 1.11 复投次数

        BigDecimal crystalPower = NumberUtil.Object2BigDecimal(EAPUtils.getEventValue(dto, "引晶功率"));
        brokenBractBase.setCrystalPower(crystalPower); // 1.12 引晶功率

        Date fjTime = null;  // 进入放肩时间
        try {
            String fjTimeStr = EAPUtils.getEventValue(dto, "进入放肩时间");
            fjTime = DateUtil.toDate(fjTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
            throw new Exception("处理进入放肩时间发生异常：" + e.getMessage());
        }

        Date yjTime = null;  // 进入引晶时间
        try {
            String yjTimeStr = EAPUtils.getEventValue(dto, "进入引晶时间");
            yjTime = DateUtil.toDate(yjTimeStr, "yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
            throw new Exception("处理进入引晶时间发生异常：" + e.getMessage());
        }

        if (fjTime != null && yjTime != null) {
            long crystalTimeLen = fjTime.getTime() - yjTime.getTime();
            double value = (crystalTimeLen / 1000d) / 60 / 60;
            BigDecimal crystalTime = new BigDecimal(value).setScale(2, BigDecimal.ROUND_DOWN);
            brokenBractBase.setCrystalTime(crystalTime); // 1.13 引晶时间
        }

        CrystalPullingInfo info = crystalPullingInfoService.getByDeviceNo(dto.getDeviceCode());
        if (info != null) {
            BigDecimal materialCount = info.getMaterialCount();
            brokenBractBase.setFeedingQuantity(materialCount); // 1.14 投料量
        }

        //获取字典信息
        List<DictionaryItem> dictionaryItemList = dictionaryItemService.findByThemeValueAndItemName("brokenBractBaseArea", "step", true); // theme：断苞基础表长度区间 name：brokenBractBaseArea
        if (0 < dictionaryItemList.size()) {
            BigDecimal step = new BigDecimal(dictionaryItemList.get(0).getValue());
            if (crystalLength.compareTo(new BigDecimal(0.0d)) == 1) { // crystalLength > 0
                double divideNumber = crystalLength.divide(step).setScale(1, BigDecimal.ROUND_DOWN).doubleValue();
                Integer lowNumber = new BigDecimal(Math.floor(divideNumber)).multiply(step).setScale(0, BigDecimal.ROUND_DOWN).intValue();
                Integer highNumber = new BigDecimal(Math.ceil(divideNumber)).multiply(step).setScale(0, BigDecimal.ROUND_DOWN).intValue();
                if (lowNumber.intValue() == highNumber.intValue()) {
                    highNumber = lowNumber + step.setScale(0, BigDecimal.ROUND_DOWN).intValue();
                }
                brokenBractBase.setCrystalLengthArea(lowNumber.toString() + "-" + highNumber.toString()); // 1.15 长度区间
            }
        }
        brokenBractBase.setLiquidLevelPixel(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径1000mm液面像素值", 1)));
        brokenBractBase.setLiquidCursor(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "8032", 1)));
        String dryPotType = EAPUtils.getStartCollectionEventValue(dto, "1196");
        brokenBractBase.setDryPotType(StringUtils.isNotBlank(dryPotType) && dryPotType.length() > 1 ? dryPotType.substring(dryPotType.length() - 2) : dryPotType);

        brokenBractBase.setToMesDataBody(JSONObject.toJSONString(dto).toString()); // 1.14 uap发送给mes报文内容

        brokenBractBaseService.saveOrUpdate(brokenBractBase);
    }

    @Override
    public void successCrystalBase(ToMESData dto) {

        //设备信息
        Equipment equipment = equipmentService.findByCode(dto.getDeviceCode());
        if (null == equipment) {
            throw new RuntimeException("设备不存在");
        }

        SuccessCrystalBase successCrystalBase = successCrystalBaseService.getByDeviceNoAndSpliceStartTime(equipment.getCode(), DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入熔接时间")));
        if (successCrystalBase == null) {
            successCrystalBase = new SuccessCrystalBase();
        }
        //炉次
        successCrystalBase.setLotNo(EAPUtils.getStartCollectionEventValue(dto, "1196"));
        successCrystalBase.setMoudle(equipment.getArea());
        successCrystalBase.setSeries(equipment.getSeries());
        successCrystalBase.setDeviceNo(equipment.getCode());
        successCrystalBase.setParameterName(EAPUtils.getStartCollectionEventValue(dto, "1417"));

        String againNum = "";
        BigDecimal bigDecimalAgainNum = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "报表复投次数"));
        if (null != bigDecimalAgainNum) {
            againNum = bigDecimalAgainNum.setScale(0, BigDecimal.ROUND_DOWN).toString();
        }
        successCrystalBase.setAgainNum(againNum);
        //熔接开始时间
        Date spliceStartTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入熔接时间"));
        successCrystalBase.setSpliceStartTime(spliceStartTime);
        successCrystalBase.setSpliceStartTemperature(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "熔接起始液面温度", 1)));
        successCrystalBase.setSpliceOverheatingTemperature(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "熔接过热液面温度", 1)));
        //过热完成时间
        Date spliceOverheatingTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "过热完成时间"));
        successCrystalBase.setSpliceOverheatingTime(spliceOverheatingTime);
        //过热时间
        if (null != spliceStartTime && null != spliceOverheatingTime) {
            BigDecimal time = BigDecimal.valueOf(hourBetween(spliceStartTime, spliceOverheatingTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
            successCrystalBase.setSpliceTime(time);
        }
        successCrystalBase.setSpliceBrokenTime(DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "熔接断时间")));
        //引晶开始时间
        Date crystalStartTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入引晶时间"));
        successCrystalBase.setCrystalStartTime(crystalStartTime);
        successCrystalBase.setCrystalPower(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶主加热功率", 1)));
        successCrystalBase.setCrystalLocation(EAPUtils.getStartCollectionEventValue(dto, "引晶埚位"));
        successCrystalBase.setCrystalResidueWeight(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶剩料重量", 1)));
        successCrystalBase.setCrystalStartTemperature(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶起始液面温度", 1)));
        successCrystalBase.setCrystalStartPixel(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶起始液面像素值", 1)));
        //引晶长度
        BigDecimal crystalLength = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶长度", 1));
        successCrystalBase.setCrystalLength(crystalLength);
        successCrystalBase.setCrystalEndTemperature(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶最终液面温度", 1)));
        //引晶50mm长度时间
        Date crystalFiftyTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "引晶50mm长度时间"));
        successCrystalBase.setCrystalFiftyTime(crystalFiftyTime);

        //进入引断时间
        Date crystalBrokenTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入引断时间"));
        //放肩开始时间
        Date shoulderingStartTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入放肩时间"));
        //引晶时间
        BigDecimal CrystalTime = null;
        if (null == crystalBrokenTime) {
            if (null != shoulderingStartTime && null != crystalStartTime) {
                CrystalTime = BigDecimal.valueOf(hourBetween(crystalStartTime, shoulderingStartTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
            }
        } else {
            if (null != crystalStartTime) {
                CrystalTime = BigDecimal.valueOf(hourBetween(crystalStartTime, crystalBrokenTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
            }
        }
        successCrystalBase.setCrystalTime(CrystalTime);
        if (null != CrystalTime && null != crystalLength && !(CrystalTime.compareTo(BigDecimal.ZERO) == 0)) {
            successCrystalBase.setCrystalSpeed(crystalLength.divide(CrystalTime, 2, BigDecimal.ROUND_HALF_UP));
        }

        BigDecimal crystal15Length = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "15min晶体长度", 1));
        if (crystal15Length != null) {
            successCrystalBase.setCrystalStartAverageSpeed(crystal15Length.divide(new BigDecimal(0.25), 2, BigDecimal.ROUND_HALF_UP));
        }

        if (null != crystalFiftyTime && null != crystalStartTime) {
            BigDecimal time = BigDecimal.valueOf(hourBetween(crystalStartTime, crystalFiftyTime)).setScale(1, BigDecimal.ROUND_HALF_UP);
            if (!(time.compareTo(BigDecimal.ZERO) == 0)) {
                successCrystalBase.setCrystalEndAverageSpeed(new BigDecimal(50).divide(time.multiply(new BigDecimal(60)), 2, BigDecimal.ROUND_HALF_UP));
            }
        }

        successCrystalBase.setCrystalEndSpeed(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶最终拉速", 2)));
        successCrystalBase.setCrystalBrokenTime(crystalBrokenTime);
        successCrystalBase.setCrystalWithManual(EAPUtils.getStartCollectionEventValue(dto, "手动引晶").equals("false") ? 0 : 1);
        successCrystalBase.setShoulderingStartTime(shoulderingStartTime);
        successCrystalBase.setShoulderingSixtyLength(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩直径60mm对应长度", 1)));
        successCrystalBase.setShoulderingSixtyDiameter(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩长度60mm对应直径", 1)));
        //放肩扩断时间
        Date shoulderingBrokenTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "放肩扩断时间"));
        //转肩开始时间
        Date shouderCircuitStartTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入转肩时间"));
        //放肩时间
        BigDecimal shoulderingTime = null;
        if (null != shouderCircuitStartTime) {
            if (null != shoulderingStartTime) {
                shoulderingTime = BigDecimal.valueOf(hourBetween(shoulderingStartTime, shouderCircuitStartTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
            }
        } else {
            if (null != shoulderingBrokenTime && null != shoulderingStartTime) {
                shoulderingTime = BigDecimal.valueOf(hourBetween(shoulderingStartTime, shoulderingBrokenTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
            }
        }
        successCrystalBase.setShoulderingBrokenTime(shoulderingBrokenTime);
        successCrystalBase.setShoulderingDiameter(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩扩断直径", 1)));
        successCrystalBase.setShoulderingFinishPixel(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩完成液面像素值", 1)));
        successCrystalBase.setShoulderingEndDiameter(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩最终直径", 1)));
        //放肩长度
        BigDecimal shoulderingLength = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩长度", 1));
        successCrystalBase.setShoulderingLength(shoulderingLength);
        //放肩长度小于十毫引断
        if (null != shoulderingLength) {
            if (shoulderingLength.compareTo(new BigDecimal(10)) != -1) {
                successCrystalBase.setCrystalWithBroken(0);
            } else {
                successCrystalBase.setCrystalWithBroken(1);
            }
        }
        //计算大角
        BigDecimal lengthBigAngle = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩直径200mm对应长度"));
        BigDecimal diameterBigAngle = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩长度180mm对应直径"));
        successCrystalBase.setShoulderingBigAngle(getBigAngleOrSmallAngle(shoulderingLength, successCrystalBase.getShoulderingEndDiameter(), 2));
        //计算小角
        BigDecimal lengthSmallAngle = new BigDecimal(60);
        BigDecimal diameterSmallAngle = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩长度60mm对应直径"));
        successCrystalBase.setShoulderingSmallAngle(getBigAngleOrSmallAngle(lengthSmallAngle, diameterSmallAngle, 1));
//        successCrystalBase.setShoulderingBigAngle(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto,"大角",2)));
//        successCrystalBase.setShoulderingSmallAngle(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto,"小角",2)));
        successCrystalBase.setShoulderingWeight(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "放肩重量", 1)));
        successCrystalBase.setShoulderingTime(shoulderingTime);

        successCrystalBase.setShouderCircuitStartTime(shouderCircuitStartTime);
        successCrystalBase.setShouderCircuitTopSpeed(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "转肩最大拉速", 2)));
        successCrystalBase.setShouderCircuitStartDiameter(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "转肩启动直径", 1)));
        successCrystalBase.setShouderCircuitWeight(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "转肩晶体重量", 1)));
        //转肩扩断时间
        Date shouderCircuitBrokenTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "转肩扩断时间"));
        //等径开始时间
        Date isometricStartTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入等径时间"));
        //等径时间
        BigDecimal shouderCircuitTime = null;
        if (null == shouderCircuitBrokenTime) {
            if (null != isometricStartTime && null != shouderCircuitStartTime) {
                shouderCircuitTime = BigDecimal.valueOf(hourBetween(shouderCircuitStartTime, isometricStartTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
            }
        } else {
            if (null != shouderCircuitStartTime) {
                shouderCircuitTime = BigDecimal.valueOf(hourBetween(shouderCircuitStartTime, shouderCircuitBrokenTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
            }
        }
        successCrystalBase.setShouderCircuitBrokenTime(shouderCircuitBrokenTime);
        successCrystalBase.setShouderCircuitTime(shouderCircuitTime);
        successCrystalBase.setIsometricStartTime(isometricStartTime);
        successCrystalBase.setIsometricFiftyDistance(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径50mm液口距", 1)));
        successCrystalBase.setIsometricStartPower(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径起始功率", 1)));
        successCrystalBase.setIsometricThousandPower(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径1000mm功率", 1)));
        successCrystalBase.setIsometricStartPixel(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径起始液面像素值", 1)));
        successCrystalBase.setIsometricFiveHundredPixel(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径500mm液面像素值", 1)));
        successCrystalBase.setIsometricStartDiameter(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径起始直径", 1)));
        //等径100mm时间
        Date isometricOneHundredTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "等径100mm时间"));
        successCrystalBase.setIsometricOneHundredTime(isometricOneHundredTime);
        if (null != isometricStartTime && null != isometricOneHundredTime) {
            BigDecimal hour = BigDecimal.valueOf(hourBetween(isometricStartTime, isometricOneHundredTime)).setScale(1, BigDecimal.ROUND_HALF_UP);
            if (!(hour.compareTo(BigDecimal.ZERO) == 0)) {
                successCrystalBase.setIsometricOneHundredSpeed(new BigDecimal(100).divide(hour, 2, BigDecimal.ROUND_HALF_UP));
            }
        }
        //等径500mm时间
        Date isometricFiveHundredTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "等径500mm时间"));
        successCrystalBase.setIsometricFiveHundredTime(isometricFiveHundredTime);
        if (null != isometricStartTime && null != isometricFiveHundredTime) {
            BigDecimal hour = BigDecimal.valueOf(hourBetween(isometricStartTime, isometricFiveHundredTime)).setScale(1, BigDecimal.ROUND_HALF_UP);
            if (!(hour.compareTo(BigDecimal.ZERO) == 0)) {
                successCrystalBase.setIsometricFiveHundredSpeed(new BigDecimal(500).divide(hour, 2, BigDecimal.ROUND_HALF_UP));
            }
        }

        //等径长度
        BigDecimal isometricLength = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "1274Max", 1));
        successCrystalBase.setIsometricLength(isometricLength);
        //等径长度小于50mm扩断
        if (null != isometricLength && shoulderingLength != null) {
            if ((isometricLength.compareTo(new BigDecimal(50)) == -1) && (shoulderingLength.compareTo(new BigDecimal(10)) != -1)) {
                successCrystalBase.setShoulderingWithBroken(1);
            } else {
                successCrystalBase.setShoulderingWithBroken(0);
            }
        }

        Integer isometricFiveHundredWithBroken = null;
        BigDecimal isometricWithOnce = new BigDecimal(500);
        //按照等径长度判断
        if (null != isometricLength) {
            isometricFiveHundredWithBroken = ((isometricLength.compareTo(new BigDecimal(50)) == 1) && (isometricLength.compareTo(isometricWithOnce) == -1)) ? 1 : 0;
        }
        successCrystalBase.setIsometricFiveHundredWithBroken(isometricFiveHundredWithBroken);

        //若当前炉台当前复投次数  拉出的第一根单晶  且长度大于500mm为一次成晶
        //获取字典信息（一次成晶）
        List<DictionaryItem> dictionaryItemList = dictionaryItemService.findByThemeValueAndItemName("CrystallineJudge", "一次成晶", true);
        if (0 < dictionaryItemList.size()) {
            isometricWithOnce = new BigDecimal(dictionaryItemList.get(0).getValue());
        }
        List<SuccessCrystalBase> list = successCrystalBaseService.findByDeviceNoAndAgainNum(equipment.getCode(), EAPUtils.getStartCollectionEventValue(dto, "报表复投次数"));
        if (list != null && list.size() <= 0 && null != isometricLength && isometricLength.compareTo(isometricWithOnce) == 1) {
            successCrystalBase.setIsometricWithOnce(1);
        } else {
            successCrystalBase.setIsometricWithOnce(0);
        }

        //获取字典信息（一次整棒）
        BigDecimal fullWithOnce = new BigDecimal(3300);
        List<DictionaryItem> dictionaryItemList1 = dictionaryItemService.findByThemeValueAndItemName("CrystallineJudge", "一次整棒", true);
        if (0 < dictionaryItemList1.size()) {
            fullWithOnce = new BigDecimal(dictionaryItemList1.get(0).getValue());
        }
        if (list != null && list.size() <= 0 && null != isometricLength && isometricLength.compareTo(fullWithOnce) == 1) {
            successCrystalBase.setFullWithOnce(1);
        } else {
            successCrystalBase.setFullWithOnce(0);
        }

        //等径用时
        BigDecimal isometricTime = null;
        //等径结束时间
        Date isometricEndTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "结束等径时间"));
        if (null != isometricEndTime && null != isometricStartTime) {
            isometricTime = BigDecimal.valueOf(hourBetween(isometricStartTime, isometricEndTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
            if (isometricLength != null && isometricTime != null && !(isometricTime.compareTo(BigDecimal.ZERO) == 0)) {
                successCrystalBase.setIsometricAverageSpeed(isometricLength.divide(isometricTime.multiply(new BigDecimal(60)), 2, BigDecimal.ROUND_HALF_UP));
            }
        }

        successCrystalBase.setIsometricWeight(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "等径晶体重量", 1)));
        successCrystalBase.setIsometricEndTime(isometricEndTime);
        successCrystalBase.setIsometricTime(isometricTime);
        successCrystalBase.setSectionResidueWeight(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "取段剩料重量", 1)));
        //进入收尾时间
        Date finishingStartTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入收尾时间"));
        successCrystalBase.setFinishingStartTime(finishingStartTime);
        successCrystalBase.setFinishingLength(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "尾长度", 1)));
        //进入收尾时间
        Date finishingEndTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "结束收尾时间"));
        successCrystalBase.setFinishingEndTime(finishingEndTime);

        //收尾用时
        BigDecimal finishingTime = null;
        if (null != finishingEndTime && null != finishingStartTime) {
            finishingTime = BigDecimal.valueOf(hourBetween(finishingStartTime, finishingEndTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
        }
        successCrystalBase.setFinishingTime(finishingTime);
        successCrystalBase.setFinishingWeight(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "收尾重量", 1)));
        //进入取段稳温时间
        Date sectionStartTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "进入取段稳温时间"));
        successCrystalBase.setSectionStartTime(sectionStartTime);
        //结束取段稳温时间
        Date sectionEndTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "结束取段稳温时间"));
        successCrystalBase.setSectionEndTime(sectionEndTime);
        //收尾用时
        BigDecimal sectionTime = null;
        if (null != sectionStartTime && null != sectionEndTime) {
            sectionTime = BigDecimal.valueOf(hourBetween(sectionStartTime, sectionEndTime)).setScale(2, BigDecimal.ROUND_HALF_UP);
        }
        successCrystalBase.setSectionTime(sectionTime);
        successCrystalBase.setSectionWeight(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "取段稳温晶体重量", 1)));
        successCrystalBase.setCreateTime(new Date());

        successCrystalBaseService.saveOrUpdate(successCrystalBase);
    }

    /**
     * 获取相差小时数
     *
     * @param startDate
     * @param endDate
     * @return
     */
    public static Double hourBetween(Date startDate, Date endDate) {
        Double hour = 0d;
        if (startDate.after(endDate)) {
            return hour;
        }
        long startTime = startDate.getTime();
        long endTime = endDate.getTime();

        hour = ((endTime - startTime) / 1000d) / 60 / 60;
        return hour;
    }

    /**
     * 获取大小角
     * <p>
     * 小角度定义：取肩长 c60mm 时，作出通过顶点的三角，求出三角型 a 顶点的角度，此 a 顶
     * 点的角度定义为小角度。 (公式：小角=(ATAN(直径值/2/晶体长度)/π*180)*2)
     * <p>
     * 大角度定义：取肩长 d60mm 时，以中心线为顶点，取到转肩直径的放肩高度 d120mm 时，
     * 过顶点通过转肩直径 200mm 时作三角形，与顶点形成的角定义为大角度。(公式：大角=(ATAN(直径值/2/(晶体长度-60))/π*180)*2)
     *
     * @param lenth    晶体长度(大角计算:放肩长度 ;小角计算:60mm)
     * @param diameter 直径值(大角计算:放肩最终直径;小角计算:放肩长度60mm对应直径)
     * @param type     1获取小角 2 获取大角
     * @return
     */
    public BigDecimal getBigAngleOrSmallAngle(BigDecimal lenth, BigDecimal diameter, int type) {
        BigDecimal result = null;
        try {
            if (lenth == null || diameter == null || lenth.compareTo(BigDecimal.ZERO) == 0) {
                return result;
            }
            double lenthDouble = lenth.doubleValue();
            double diameterDouble = diameter.doubleValue();
            switch (type) {
                case 1:
                    result = new BigDecimal(Double.toString(Math.atan(diameterDouble / 2 / lenthDouble) / Math.PI * 180));
                    result = result.multiply(new BigDecimal(2)).setScale(2, BigDecimal.ROUND_HALF_UP);
                    break;
                case 2:
                    result = new BigDecimal(Double.toString(Math.atan(diameterDouble / 2 / (lenthDouble - 60)) / Math.PI * 180));
                    result = result.multiply(new BigDecimal(2)).setScale(2, BigDecimal.ROUND_HALF_UP);
                    break;
            }
        } catch (Exception e) {

        }
        return result;
    }

    @Override
    public void crystalBrokenBase(ToMESData dto) {
        Equipment equipment = equipmentService.findByCode(dto.getDeviceCode());
        if (equipment == null) {
            throw new RuntimeException("MES未配置此炉台信息");
        }

        CrystalBrokenBase crystalBrokenBase = new CrystalBrokenBase();
        Date breakTakeTime = DateUtil.toDate(EAPUtils.getStartCollectionEventValue(dto, "引晶断时间"));
        if (breakTakeTime == null) {
            breakTakeTime = new Date();
        }
        crystalBrokenBase.setDateTime(breakTakeTime);
        EquipmentExtendState state = equipmentExtendStateService.getByCode(dto.getDeviceCode());
        if (state != null) {
            crystalBrokenBase.setClassGroup(state.getTeamGroup()); //1.2 班组
        }

        //计算班次
        String classNo = null;
        SimpleDateFormat df = new SimpleDateFormat("HH:mm:ss");
        try {
            if (breakTakeTime != null) {
                Date nowTime = df.parse(df.format(breakTakeTime));
                Date dayTimeStart = df.parse("09:00:00");
                Date dayTimeEnd = df.parse("21:00:00");
                if (timeCalendar(nowTime, dayTimeStart, dayTimeEnd)) {
                    classNo = "白班";
                } else {
                    classNo = "夜班";
                }
            }
        } catch (ParseException e) {
            e.printStackTrace();
        }
        crystalBrokenBase.setClassNo(classNo);// 1.3班次
        crystalBrokenBase.setSeries(equipment.getSeries()); // 1.4系列
        crystalBrokenBase.setDeviceNo(dto.getDeviceCode()); // 1.5 炉台号
        String lotNo = null;
        ProductionSchedule current_productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(dto.getDeviceCode(), Arrays.asList(1, 4, 5));
        if (current_productionSchedule != null) {
            lotNo = current_productionSchedule.getLotNo();
            crystalBrokenBase.setLotNo(lotNo);// 1.6炉次号
        }

        String againNum = "";
        BigDecimal bigDecimalAgainNum = NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "报表复投次数"));
        if (null != bigDecimalAgainNum) {
            againNum = bigDecimalAgainNum.setScale(0, BigDecimal.ROUND_DOWN).toString();
        }
        crystalBrokenBase.setAgainNum(againNum);
        crystalBrokenBase.setCrystalLength(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶长度", 2)));
        crystalBrokenBase.setCrystalResidueWeight(NumberUtil.Object2BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "引晶剩料重量", 2)));
        crystalBrokenBase.setCreateBy("eap");
        crystalBrokenBase.setCreateTime(new Date());

        crystalBrokenBaseService.saveOrUpdate(crystalBrokenBase);
    }


    @Override
    public void materialPrepareSignal(ToMESData dto) {

        Date current = new Date();

        if (dto.getTaskCode().equals("ShutdownFurnace")) {//停炉处理
            DictionaryItem dictionaryItem = dictionaryItemService.findByThemeValueAndNameAndEnable("MMCSPrepare", "chargeDelayed", true);//拆清装料延时时间(h)

//        	ProductionSchedule productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(dto.getDeviceCode(), EnumValuesServer.ProductionScheduleStatus.未开始.getKey());
//        	ProductModel productMode = productionSchedule.getProductModel();

            if (dictionaryItem == null)
                return;


            int stepMinute = (int) (Double.valueOf(dictionaryItem.getValue()) * 60);
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(current);
            calendar.add(Calendar.MINUTE, stepMinute);
            Date estimate = calendar.getTime();


            MmcsDistributionPlan mcs = new MmcsDistributionPlan();
            mcs.setCreateTime(current);
            mcs.setDisconnectOrNot(EAPUtils.getStartCollectionEventValue(dto, "是否断取"));
            mcs.setEquipmentCode(dto.getDeviceCode());
            mcs.setEstimate(estimate);
            mcs.setResidualWeight(EAPUtils.getStartCollectionEventValue(dto, "3286"));
            mcs.setSended(false);
            mcs.setType("0");
            mmcsDistributionPlanService.saveOrUpdate(mcs);

        } else if (dto.getTaskCode().equals("VacuumPumping")) {
            DictionaryItem dictionaryItem = dictionaryItemService.findByThemeValueAndNameAndEnable("MMCSPrepare", "initialDelayed", true);//初始复投延时时间(h)


            if (dictionaryItem == null)
                return;


            int stepMinute = (int) (Double.valueOf(dictionaryItem.getValue()) * 60);
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(current);
            calendar.add(Calendar.MINUTE, stepMinute);
            Date estimate = calendar.getTime();


            MmcsDistributionPlan mcs = new MmcsDistributionPlan();
            mcs.setCreateTime(current);
            mcs.setDisconnectOrNot(EAPUtils.getStartCollectionEventValue(dto, "是否断取"));
            mcs.setEquipmentCode(dto.getDeviceCode());
            mcs.setEstimate(estimate);
            mcs.setResidualWeight(EAPUtils.getStartCollectionEventValue(dto, "3286"));
            mcs.setSended(false);
            mcs.setType("1");
            mmcsDistributionPlanService.saveOrUpdate(mcs);


        } else if (dto.getTaskCode().equals("取段投料发送")) {
            DictionaryItem dictionaryItem = dictionaryItemService.findByThemeValueAndNameAndEnable("MMCSPrepare", "takeSectionDelayed", true);//取段复投延时时间(h)


            if (dictionaryItem == null)
                return;


            int stepMinute = (int) (Double.valueOf(dictionaryItem.getValue()) * 60);
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(current);
            calendar.add(Calendar.MINUTE, stepMinute);
            Date estimate = calendar.getTime();


            MmcsDistributionPlan mcs = new MmcsDistributionPlan();
            mcs.setCreateTime(current);
            mcs.setDisconnectOrNot(EAPUtils.getStartCollectionEventValue(dto, "是否断取"));
            mcs.setEquipmentCode(dto.getDeviceCode());
            mcs.setEstimate(estimate);
            mcs.setResidualWeight(EAPUtils.getStartCollectionEventValue(dto, "3286"));
            mcs.setSended(false);
            mcs.setType("2");
            mmcsDistributionPlanService.saveOrUpdate(mcs);
        }
    }

    @Override
    public List<MaterialTaskDto> materialOperationList(MaterialOperationDto dto) {
        List<MaterialTaskDto> taskListDto = new ArrayList<>();
        Integer type = dto.getType();
        String lotNo = dto.getLotNo();
        List<LoadingTask> loadingTasks;
        List<AgainTask> againTasks = new ArrayList<>();
        List<AgainTaskDetail> againTaskDetails;

        //0:取消叫料
        if(type == 0){
            Collection<SearchFilter> searchFilters = new HashSet<>();
            searchFilters.add(new SearchFilter("lotNo", SearchFilter.Operator.EQ,lotNo));
            searchFilters.add(new SearchFilter("rawStatus", SearchFilter.Operator.IN,new String[]{"0"}));
            Specification<LoadingTask> specification = DynamicSpecifications.bySearchFilter(LoadingTask.class, searchFilters);
            loadingTasks = loadingTaskService.findByExampleSort(specification,null);
            Specification<AgainTask> specification1 = DynamicSpecifications.bySearchFilter(AgainTask.class, searchFilters);
            againTasks = againTaskService.findByExampleSort(specification1,null);
            Specification<AgainTaskDetail> specification2 = DynamicSpecifications.bySearchFilter(AgainTaskDetail.class, searchFilters);
            againTaskDetails = againTaskDetailService.findByExampleSort(specification2,null);
            //1:生产退料
        }else if(type == 1){
            Collection<SearchFilter> searchFilters = new HashSet<>();
            searchFilters.add(new SearchFilter("lotNo", SearchFilter.Operator.EQ,lotNo));
            searchFilters.add(new SearchFilter("rawStatus", SearchFilter.Operator.IN,new String[]{"3","4"}));
            Specification<LoadingTask> specification = DynamicSpecifications.bySearchFilter(LoadingTask.class, searchFilters);
            loadingTasks = loadingTaskService.findByExampleSort(specification,null);
            Specification<AgainTaskDetail> specification2 = DynamicSpecifications.bySearchFilter(AgainTaskDetail.class, searchFilters);
            againTaskDetails = againTaskDetailService.findByExampleSort(specification2,null);
            //2重新叫料
        }else{
            Collection<SearchFilter> searchFilters = new HashSet<>();
            searchFilters.add(new SearchFilter("lotNo", SearchFilter.Operator.EQ,lotNo));
            searchFilters.add(new SearchFilter("rawStatus", SearchFilter.Operator.IN,new String[]{"2","5"}));
            Specification<LoadingTask> specification = DynamicSpecifications.bySearchFilter(LoadingTask.class, searchFilters);
            loadingTasks = loadingTaskService.findByExampleSort(specification,null);
            Specification<AgainTask> specification1 = DynamicSpecifications.bySearchFilter(AgainTask.class, searchFilters);
            againTasks = againTaskService.findByExampleSort(specification1,null);
            Specification<AgainTaskDetail> specification2 = DynamicSpecifications.bySearchFilter(AgainTaskDetail.class, searchFilters);
            againTaskDetails = againTaskDetailService.findByExampleSort(specification2,null);
        }
        if(null != loadingTasks && loadingTasks.size() > 0) {
            for (LoadingTask loadingTask : loadingTasks) {
                MaterialTaskDto materialTaskDto = new MaterialTaskDto();
                materialTaskDto.setId(loadingTask.getId());
                materialTaskDto.setType("配料任务");
                materialTaskDto.setWeight(loadingTask.getRealWeight());
                taskListDto.add(materialTaskDto);
            }
        }
        if(null != againTasks && againTasks.size() > 0) {
            for (AgainTask againTask : againTasks) {
                MaterialTaskDto materialTaskDto = new MaterialTaskDto();
                materialTaskDto.setId(againTask.getId());
                materialTaskDto.setType("复投任务");
                Integer againNum = againTask.getAgainNum();
                DictionaryItem item = dictionaryItemService.findByThemeValueAndValueAndEnable("RecipeUsage", againNum.toString(), true);
                materialTaskDto.setAgainNum(item.getName());
                materialTaskDto.setBucketSum(againTask.getAgainPailNum());
                materialTaskDto.setWeight(againTask.getAgainWeigth());
                taskListDto.add(materialTaskDto);
            }
        }
        if(null != againTaskDetails && againTaskDetails.size() > 0) {
            for (AgainTaskDetail againTaskDetail : againTaskDetails) {
                MaterialTaskDto materialTaskDto = new MaterialTaskDto();
                materialTaskDto.setId(againTaskDetail.getId());
                materialTaskDto.setType("灌料任务");
                Integer againNum = againTaskDetail.getAgainNum();
                DictionaryItem item = dictionaryItemService.findByThemeValueAndValueAndEnable("RecipeUsage", againNum.toString(), true);
                materialTaskDto.setAgainNum(item.getName());
                materialTaskDto.setBucketNum(againTaskDetail.getPailNum());
                materialTaskDto.setBucketSum(againTaskDetail.getAgainPailNum());
                materialTaskDto.setWeight(againTaskDetail.getAgainRealWeight());
                taskListDto.add(materialTaskDto);
            }
        }
        return taskListDto;
    }

    @Override
    public void materialOperationAction(MaterialOperationActionDto dto) {
        Integer type = dto.getActionType();
        Long id = dto.getId();
        String cause = dto.getCause();
        //取消叫料
        if(type == 0 || type == 1 || type == 2 || type ==  3|| type == 4){
            if(StringUtils.isBlank(cause)){
                throw new BusinessException("未填写原因！");
            }
        }
        //生产退料
        //操作类型(0:取消叫料配料,1:取消叫料复投,2:取消叫料灌料,3:生产退料配料,4:生产退料灌料,5:重新叫料配料,6:重新叫料复投,7:重新叫料灌料)
        switch (type){
            case 0:
                loadingTaskService.cancelTask(id,cause);
                break;
            case 1:
                againTaskService.cancelTask(id,cause);
                break;
            case 2:
                againTaskDetailService.cancelTask(id,cause);
                break;
            case 3:
                loadingTaskService.backTask(id, cause);
                break;
            case 4:
                againTaskDetailService.backTask(id,cause);
                break;
            case 5:
                loadingTaskService.repeatOpenTask(id);
                break;
            case 6:
                againTaskService.repeatOpenTask(id);
                break;
            case 7:
                againTaskDetailService.repeatOpenTask(id);
                break;
            default:
                break;
        }


    }

    @Override
    public Result updateLastLongCrstalWeight(LongCrystalVO longCrystalVO) {
        return longCrystalService.updateLastLongCrstalWeight(longCrystalVO);
    }

    @Override
    public void surplusReceive(ToMESData dto) {

        //剩余重量
        BigDecimal residualWeight = StringUtils.isBlank(EAPUtils.getStartCollectionEventValue(dto, "3286"))
                ? BigDecimal.ZERO : new BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "3286"));

        //单晶重量
        BigDecimal weight = StringUtils.isBlank(EAPUtils.getStartCollectionEventValue(dto, "3287"))
                ? BigDecimal.ZERO : new BigDecimal(EAPUtils.getStartCollectionEventValue(dto, "3287"));

        String surplusType = dto.getTaskCode();
        String deviceNo = dto.getDeviceCode();
        //1 转换类型
        if (SurplusStepEnum.StepNameEnum.埚底焖炉.getValue().equals(surplusType)) {
            //1.1根据字典配置区分是埚底/焖炉
            DictionaryItem dictionaryItem = dictionaryItemService.findByThemeValueAndNameAndEnable("bottomOrFurnace", "埚底焖炉", true);
            if (null == dictionaryItem || StringUtils.isBlank(dictionaryItem.getValue())) {
                throw new BusinessException("请维护关键字[bottomOrFurnace]字典!");
            }
            if (residualWeight.compareTo(new BigDecimal(dictionaryItem.getValue())) > 0) {
                surplusType = SurplusStepEnum.StepNameEnum.焖炉.getValue();
            } else {
                surplusType = SurplusStepEnum.StepNameEnum.埚底.getValue();
            }
        }
        //2 余料落库
        // 2.1 查询工单号,炉次号,加料次数
        String lotNo = null;
        String workOrderNo = null;
        ProductionSchedule productionSchedule = productionScheduleService.findTopByDeviceNoAndStatusOrderByIdDesc(deviceNo, Arrays.asList(1, 4, 5));
        if (null != productionSchedule) {
            lotNo = productionSchedule.getLotNo();
            if (null != productionSchedule.getProductionOrder()) {
                workOrderNo = productionSchedule.getProductionOrder().getAufnr();
            }
        }
        Integer againNum = null;
        AgainTaskDetail againTaskDetail = againTaskDetailService.findTopByEquipmentCodeOrderByIdDesc(deviceNo);
        if (null != againTaskDetail) {
            AgainTask againTask = againTaskService.get(againTaskDetail.getAgainTaskId());
            if (null != againTask) {
                againNum = againTask.getAgainNum();
            }
        }
        if (StringUtils.isBlank(lotNo) || null == againNum || StringUtils.isBlank(workOrderNo)) {
            throw new BusinessException("设备" + deviceNo + ":炉次" + lotNo + "加料次数" + againNum + "工单" + workOrderNo + "未查询到!");
        }
        String surplusCode = lotNo + againNum + surplusType + workOrderNo;
        SurplusInfo surplusInfo = new SurplusInfo();
        surplusInfo.setDeviceNo(deviceNo)
                .setSurplusCode(surplusCode)
                .setWeight(weight)
                .setSurplusType(surplusType)
                .setLotNo(lotNo)
                .setWorkOrderNo(workOrderNo)
                .setFeedTimes(againNum)
                .setStatus(SurplusInfoStatusEnum.待入库.getKey())
                .setDel(SurplusInfoStatusEnum.未删除.getKey())
                .setDataType(SurplusInfoStatusEnum.EAP自动采集.getKey())
                .setCreateBy(SurplusInfoStatusEnum.EAP自动采集.getValue())
                .setCreateTime(new Date());
        surplusInfoService.saveOrUpdate(surplusInfo);
    }

    @Override
    @Transactional
    public void manualShutdown(String equipmentCode,String abnormalCause) {
        Equipment equipment = equipmentService.findByCode(equipmentCode);
        if (equipment == null) {
            throw new BusinessException(equipmentCode + "设备编号不存在");
        }

        EquipmentDeviceStatus deviceStatus = equipmentDeviceStatusService.findByDeviceNo(equipmentCode);
        if (null != deviceStatus && null != deviceStatus.getStatus() && deviceStatus.getStatus() == 2){
            throw new BusinessException(equipmentCode + ":该炉台已停炉，无需手动操作停炉");
        }
        checkStopStatus(equipmentCode);
        ProductionSchedule productionSchedule = productionScheduleService.findTopByDeviceIdAndStatusOrderByIdDesc(equipment.getId(), EnumValuesServer.ProductionScheduleStatus.进行中.getKey());
        if (productionSchedule == null) {
            throw new BusinessException(equipmentCode + "设备，没有进行中的任务");
        }
        LongCrystal longCrystal = longCrystalService.findTopByLotIdAndCrystalStatus(productionSchedule.getLotId(), EnumValuesFactory.CrystalStatus.待确认.getKey());
        if (longCrystal != null) {
            throw new BusinessException(productionSchedule.getLotNo() + "炉次存在未确认的单晶，无法停炉，请确认单晶后重试");
        }

        //卡控:炉次终止时必须有一根完结尾
        LongCrystal longCrystal1 = longCrystalService.findBLotNoAndClosureIdentification(productionSchedule.getLotNo(), "W");
//        LongCrystal longCrystal1 = longCrystalService.findBLotNoAndClosureIdentification(productionSchedule.getLotNo(), "W");

        if(null == longCrystal1){
            throw new RuntimeException("当前炉次【" + productionSchedule.getLotNo() + "】无完结尾单晶产出，不能点击炉次终止，请联系计划员/MES运维处理!");
        }
        PlanProcessingOrder planProcessingOrder = planProcessingOrderService.get(productionSchedule.getLotId());
        planProcessingOrder.setStatus(EnumValuesFactory.PlanProcessingOrderStatus.加工完成.getKey());
        planProcessingOrderService.saveOrUpdate(planProcessingOrder);

//        equipment.setEnableState(true);
        // 手动停炉也不写设备状态值，与eap发信号保持一致
//        equipment.setStatus(2)
        equipment.setReason("炉次终止");

        //清空设备待机时间信息
        equipment.setStartOrEndWaitTime(null);

        equipmentService.saveOrUpdate(equipment);

        //处理炉次任务，改成完成
        productionSchedule.setStatus(EnumValuesServer.ProductionScheduleStatus.已完成.getKey());
        productionSchedule.setStatusInfo("MES人工手动停炉");
        productionScheduleService.saveOrUpdate(productionSchedule);
        //修改设备加工能力的已开炉次数量
        MachineCapacity machineCapacity = machineCapacityService.findByEquipmentId(planProcessingOrder.getEquipmentId());
//        boolean isCapacityInfoNext = false;
        if (machineCapacity != null) {
            //防止eap错误，关闭自动增长已开炉次
            machineCapacity.setUsedCount((machineCapacity.getUsedCount() == null ? 0 : machineCapacity.getUsedCount()) + 1);
            if (machineCapacity.getCapacityInfoNext() != null) {
                MachineCapacity machineCapacity1 = JSON.parseObject(machineCapacity.getCapacityInfoNext(), MachineCapacity.class);
                machineCapacity.setCapacityInfo(machineCapacity1.getCapacityInfo());
                machineCapacity.setProductType(machineCapacity1.getProductType());
                machineCapacity.setRdlogo(machineCapacity1.getRdlogo());
                machineCapacity.setRdonlylogo(machineCapacity1.getRdonlylogo());
                machineCapacity.setCapacityInfoNext(null);
                machineCapacity.setUpdateTime(new Date());
            }
        }
        machineCapacityService.saveOrUpdate(machineCapacity);

        CrystalPullingInfo info = crystalPullingInfoService.getByDeviceNo(equipment.getCode());
        clearCrystalPullingInfoForManual(info, equipment.getCode(),abnormalCause);
        redisUtils.hmSet("all_device_shutdown_time", equipmentCode, DateUtil.formatDate(new Date(), DateUtil.longFormat));
    }

    /**
     * 检查停炉状态
     *
     * @param equipmentCode 设备编号
     */
    private void checkStopStatus(String equipmentCode) {
        String shutdownTimeStr
                = NumberUtil.object2String(redisUtils.hmGet("all_device_shutdown_time", equipmentCode), null);
        Date shutdownTime = DateUtil.toDateNull(shutdownTimeStr, DateUtil.longFormat);

        double time = 10;
        //查询字典值
        DictionaryItem dictionaryItem = dictionaryItemService.findByThemeValueAndNameAndEnable("shutdownTime", "time", true);
        if (dictionaryItem != null) {
            time = NumberUtil.Object2Double(dictionaryItem.getValue(), 10d);
        }

        if (shutdownTime != null && (System.currentTimeMillis() - shutdownTime.getTime()) < 1000 * 60 * 60 * time) {
            throw new BusinessException("距离上次停炉时间（" + shutdownTimeStr + "），不足" + time + "小时，请不要频繁进行停炉操作");
        }
    }
}

