package com.sw.mes.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "产品方案Dto")
public class FormulaProductSchemeDto {

    private Long id;
    @NotBlank(message = "设备号不能为空")
    @ApiModelProperty(value = "设备号", required = true)
    String equipmentCode;
    @NotBlank(message = "产品料号不能为空")
    @ApiModelProperty(value = "产品料号", required = true)
    String productModeCode;
    @NotBlank(message = "产品名称不能为空")
    @ApiModelProperty(value = "产品名称", required = true)
    String productName;
    @NotNull(message = "拆桶方案id不能为空")
    @ApiModelProperty(value = "拆桶方案id", required = true)
    Long decompositionSchemeId;
    @NotBlank(message = "拆桶方案名称不能为空")
    @ApiModelProperty(value = "拆桶方案名称", required = true)
    String decompositionSchemeName;
    @NotNull(message = "配方id不能为空")
    @ApiModelProperty(value = "初始配方id", required = true)
    Long initialFormulaId;
    @NotBlank(message = "初始配方名称不能为空")
    @ApiModelProperty(value = "初始配方名称", required = true)
    String initialFormulaName;
    @NotNull(message = "配方id不能为空")
    @ApiModelProperty(value = "初始复投方案id", required = true)
    Long initialReinvestmentId;
    @NotBlank(message = "初始复投方案名称不能为空")
    @ApiModelProperty(value = "初始复投方案名称", required = true)
    String initialReinvestmentName;
    @NotNull(message = "取段复投方案id不能为空")
    @ApiModelProperty(value = "取段复投方案id", required = true)
    Long reinvestmentId;
    @NotBlank(message = "取段复投方案名称不能为空")
    @ApiModelProperty(value = "取段复投方案名称", required = true)
    String reinvestmentName;
    @NotNull(message = "状态不能为空")
    @ApiModelProperty(value = "状态(0：生效，1：下炉次生效)", required = true)
    Integer status;
    @ApiModelProperty(value = "下炉次生效信息")
    String nextFurnaceEffective;
    @ApiModelProperty(value = "创建人")
    String userCreate;
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date gmtCreate;
    @ApiModelProperty(value = "修改人")
    String userUpdate;
    @ApiModelProperty(value = "修改时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date gmtUpdate;
}