package com.sw.mes.sap.task;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import cc.cczn.matrix.commons.tasks.queue.TaskProcessor;
import cc.cczn.matrix.commons.tasks.queue.block.LinkedBlockDataQueue;

@Configuration
public class QueueConfig {

    @Autowired
    MaterialDataHandlerTask materialDataHandlerTask;

    @Autowired
    MaterialToStoreHandler materialToStoreHandler;


    @Bean
    public LinkedBlockDataQueue queue() {
        LinkedBlockDataQueue queue = new LinkedBlockDataQueue();
        List<TaskProcessor> taskList = new ArrayList<TaskProcessor>();
        taskList.add(materialDataHandlerTask);
        queue.setTaskProcessors(taskList);
        return queue;
    }

    @Bean
    public LinkedBlockDataQueue storeSyncQueue() {
        LinkedBlockDataQueue queue = new LinkedBlockDataQueue();
        List<TaskProcessor> taskList = new ArrayList<>();
        taskList.add(materialToStoreHandler);
        queue.setTaskProcessors(taskList);
        return queue;
    }

}
