package com.sw.mes.sectionMes.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.sw.mes.core.dto.sectionMes.FbInformationReceptionDto;
import com.sw.mes.sectionMes.dto.FeedBackPassBackDto;
import com.sw.mes.sectionMes.entity.LogSectionMesInteractive;
import com.sw.mes.sectionMes.service.LogSectionMesInteractiveService;
import com.sw.mes.sectionMes.service.MESInputService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.Assert;

import java.util.Date;

/**
 * @author lf
 * @description
 * @date 2024/2/2 9:02
 */
@Service
public class MESInputServiceImpl implements MESInputService {

    @Autowired
    private LogSectionMesInteractiveService logSectionMesInteractiveService;

    @Override
    public FeedBackPassBackDto feedBackPassBack(JSONObject data) {
        Assert.notNull(data, "反馈信息不能为空");
        FeedBackPassBackDto dto = new FeedBackPassBackDto();
        FbInformationReceptionDto fbInformationReceptionDto = JSON.parseObject(String.valueOf(data), FbInformationReceptionDto.class);
        System.out.println(JSON.toJSONString(fbInformationReceptionDto));
//        todo 反馈结果处理
        dto.setState("S");
        //保存交互记录
        saveInteractiveLog("切片MES->拉晶MES", "方棒反馈回传接口", "feedBackPassBack", data, JSON.toJSONString(dto));
        return dto;
    }

    @Override
    public void returnMaterial(JSONObject data) {
        Assert.notNull(data, "退料信息不能为空");
//        todo 退料逻辑
        //保存交互记录
        saveInteractiveLog("切片MES->拉晶MES", "方棒退料", "returnMaterial", data, "退料成功");
    }
    // 保存原始记录到数据表
    @Transactional(propagation = Propagation.REQUIRES_NEW)
    public void saveInteractiveLog(String direction, String controllerName, String oprMethod, Object data, Object result) {
        LogSectionMesInteractive log = new LogSectionMesInteractive();
        log.setDataDirection(direction);
        log.setControllerName(controllerName);
        log.setOprMethod(oprMethod);
        log.setContext(JSONObject.toJSONString(data));
        log.setReturnContext(JSONObject.toJSONString(result));
        log.setCreateTime(new Date());
        logSectionMesInteractiveService.saveOrUpdate(log);
    }
}
