package com.sw.mes.wipstorage.service.impl;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.sw.mes.base.factory.init.entity.CrystalMaterialRelation;
import com.sw.mes.base.factory.init.service.CrystalMaterialRelationService;
import com.sw.mes.core.dto.store.*;
import org.modelmapper.ModelMapper;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.util.CollectionUtils;

import com.sw.mes.base.factory.init.entity.ClassMonitorModelLog;
import com.sw.mes.base.factory.init.entity.Equipment;
import com.sw.mes.base.factory.init.entity.FactoryModel;
import com.sw.mes.base.factory.init.service.ClassMonitorModelLogService;
import com.sw.mes.base.factory.init.service.EquipmentService;
import com.sw.mes.base.factory.inspect.entity.DefaultSample;
import com.sw.mes.base.factory.inspect.service.DefaultSampleService;
import com.sw.mes.base.factory.material.entity.MaterialModel;
import com.sw.mes.base.factory.material.service.MaterialModelService;
import com.sw.mes.base.system.entity.DictionaryItem;
import com.sw.mes.base.system.service.DictionaryItemService;
import com.sw.mes.base.workinprocess.dao.PlanProcessingOrderDao;
import com.sw.mes.base.workinprocess.dao.WipStorageDao;
import com.sw.mes.base.workinprocess.dto.PlanProcessingOrderWipStorageDto;
import com.sw.mes.base.workinprocess.dto.ProcessingOrderNewDto;
import com.sw.mes.base.workinprocess.entity.PlanProcessingOrder;
import com.sw.mes.base.workinprocess.entity.WipStorage;
import com.sw.mes.base.workinprocess.service.PlanProcessingOrderService;
import com.sw.mes.base.workinprocess.service.ProcessLogService;
import com.sw.mes.base.workinprocess.service.WipStorageService;
import com.sw.mes.core.api.system.FbFeignClients;
import com.sw.mes.core.api.system.StoreFeignClients;
import com.sw.mes.core.constant.Constants;
import com.sw.mes.core.context.BaseContextHandler;
import com.sw.mes.core.dto.EapCutCraftDto;
import com.sw.mes.core.dto.FbScheduleDto;
import com.sw.mes.core.dto.WarehouseModelDto;
import com.sw.mes.core.enums.EnumValuesFactory;
import com.sw.mes.core.exception.BusinessException;
import com.sw.mes.core.response.Result;
import com.sw.mes.core.response.ResultCode;
import com.sw.mes.core.response.ResultGenerator;
import com.sw.mes.core.utils.BeanUtil;
import com.sw.mes.core.utils.NumberUtil;
import com.sw.mes.core.utils.ThreadManager;
import com.sw.mes.enumvalue.EnumValuesServer;
import com.sw.mes.inspect.entity.YbInspectData;
import com.sw.mes.inspect.service.YbInspectDataService;
import com.sw.mes.sap.entity.ReportSapGoodsmvt;
import com.sw.mes.sap.entity.ReportSapWorkinghours;
import com.sw.mes.sap.service.ReportSapGoodsmvtService;
import com.sw.mes.sap.service.ReportSapWorkinghoursService;
import com.sw.mes.utils.StringUtils;
import com.sw.mes.wipstorage.service.WipStorageYbService;
import com.sw.mes.yb.mcs.service.PublishRankResultService;
import com.sw.mes.yb.pad.dao.SectionNoDetailDao;
import com.sw.mes.yb.pad.entity.ProductionBackCuttingRecord;
import com.sw.mes.yb.pad.entity.ProductionPaintingLine;
import com.sw.mes.yb.pad.entity.ProductionPaintingLineDetail;
import com.sw.mes.yb.pad.entity.ReCut;
import com.sw.mes.yb.pad.entity.RecutDetail;
import com.sw.mes.yb.pad.entity.SectionNoDetail;
import com.sw.mes.yb.pad.service.FbReCutService;
import com.sw.mes.yb.pad.service.ProductionPaintingLineDetailService;
import com.sw.mes.yb.pad.service.ProductionPaintingLineService;
import com.sw.mes.yb.pad.service.ProductionRecutService;
import com.sw.mes.yb.pad.service.RecutDetailService;
import com.sw.mes.yb.pad.service.SectionNoDetailService;
import com.sw.mes.yb.pc.dao.SectionDAO;
import com.sw.mes.yb.pc.service.SectionService;
import com.sw.mes.yb.pc.service.SpellInfoService;
import com.sw.mes.yb.production.entity.LongCrystal;
import com.sw.mes.yb.production.service.LongCrystalService;
import com.sw.mes.yb.seed.enums.InputBillStatusEnum;
import com.sw.mes.yb.turnstore.service.TurnstoreInItemService;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
@Transactional
public class WipStorageYbServiceImpl implements WipStorageYbService {
    @Autowired
    private DictionaryItemService dictionaryItemService;
    @Autowired
    private SectionNoDetailService sectionNoDetailService;
    @Autowired
    private ProductionPaintingLineService productionPaintingLineService;
    @Autowired
    private FbFeignClients fbFeignClients;
    @Autowired
    private WipStorageService wipStorageService;
    @Autowired
    private ProductionRecutService productionRecutService;
    @Autowired
    private PlanProcessingOrderService planProcessingOrderService;
    @Autowired
    private ProductionPaintingLineDetailService productionPaintingLineDetailService;
    @Autowired
    private SectionNoDetailDao sectionNoDetailDao;
    @Autowired
    private RecutDetailService recutDetailService;
    @Autowired
    private FbReCutService fbReCutService;
    @Autowired
    private WipStorageYbService wipStorageYbService;
    @Autowired
    private YbInspectDataService inspectDataBaseService;
    @Autowired
    private ClassMonitorModelLogService classMonitorModelLogService;

    @Autowired
    private SpellInfoService spellInfoService;

    @Autowired
    private TurnstoreInItemService turnstoreInItemService;

    @Autowired
    private PublishRankResultService publishRankResultService;

    @Autowired
    private SectionDAO sectionDAO;

    @Autowired
    private SectionService sectionService;

    @Autowired
    private FbFeignClients fbFeignService;

    @Autowired
    private ProcessLogService processLogService;

    @Autowired
    private PlanProcessingOrderDao planProcessingOrderDao;

    @Autowired
    private WipStorageDao dao;

    @Autowired
    private ReportSapGoodsmvtService reportSapGoodsmvtService;

    @Autowired
    private LongCrystalService longCrystalService;

    @Autowired
    private YbInspectDataService ybInspectDataService;

    @Autowired
    private StoreFeignClients storeFeignClients;

    @Autowired
    private ModelMapper modelMapper;

    @Autowired
    private MaterialModelService materialModelService;


    @Autowired
    private ReportSapWorkinghoursService reportSapWorkinghoursService;

    @Autowired
    private EquipmentService equipmentService;
    
    @Autowired
    private DefaultSampleService defaultSampleService;

    @Autowired
    private CrystalMaterialRelationService crystalMaterialRelationService;

    /**
     * 截断过站信息处理过站，同时长传截断信息
     *
     * @param planProcessingOrderWipStorageDto
     * @return
     */
    @Override
    public Result execJd(PlanProcessingOrderWipStorageDto planProcessingOrderWipStorageDto, boolean sendEapCutCraft) {
        List<ProcessingOrderNewDto> processingOrderNewDtos = new ArrayList<>();
        PlanProcessingOrder planProcessingOrder = planProcessingOrderWipStorageDto.getPlanProcessingOrder();
        //长棒截断
        if (planProcessingOrder.getOrderType() == EnumValuesFactory.PlanProcessingOrderOrderType.单晶.getKey()) {
            //圆棒画线记录
            ProductionPaintingLine productionPaintingLine = productionPaintingLineService.findByCrystalNo(planProcessingOrderWipStorageDto.getPlanProcessingOrder().getCode());
            if (productionPaintingLine == null) {
                throw new BusinessException("画线信息不能为空，请检查数据");
            }
            List<SectionNoDetail> sectionNoDetails = sectionNoDetailService.findByCrystalIdAndParentId(planProcessingOrderWipStorageDto.getPlanProcessingOrder().getGoodsId(), 0L);
            if (sectionNoDetails.size() == 0) {
                throw new BusinessException("长棒的划线信息不存在，请检查数据");
            }
            setProcessingOrderNewDto(processingOrderNewDtos, sectionNoDetails);
            return getResult(sendEapCutCraft, processingOrderNewDtos, planProcessingOrder,  productionPaintingLine, null, null, null);
        }
        //晶段反切截断
        else if (planProcessingOrder.getOrderType() == EnumValuesFactory.PlanProcessingOrderOrderType.晶段.getKey()) {
            //圆棒反切画线记录
            ProductionBackCuttingRecord productionBackCuttingRecord;
            if (planProcessingOrder.getMaterialType() == EnumValuesFactory.MaterialType.圆棒.getKey()) {
                productionBackCuttingRecord = productionRecutService.findBySegmentNo(planProcessingOrder.getCode());
                if (productionBackCuttingRecord == null) {
                    throw new BusinessException(planProcessingOrder.getCode() + "不存在未切断的反切划线信息，请检查数据");
                }
                if (StringUtils.isNotBlank(productionBackCuttingRecord.getSectionCompose()) && StringUtils.isNotBlank(productionBackCuttingRecord.getUuid())) {
                    // 拼棒过截断站
                    return execYbJdV2(planProcessingOrder, productionBackCuttingRecord, sendEapCutCraft);
                } else {
                    // 非拼棒过截断站
                    execYbJd(planProcessingOrder, productionBackCuttingRecord, sendEapCutCraft);
                    
                    //处理返切不复测业务逻辑
                    if(productionBackCuttingRecord.getCause().contains("返切不复测")){
                    	//根据晶段编号 最后一条记录 查询圆棒检验记录
                    	YbInspectData ybInspectData = ybInspectDataService.findBySectionNo(planProcessingOrder.getCode());
                    	//1.根据原有圆棒检验记录中 掺杂剂，规格 找到对应的默认值  
                    	DefaultSample defaultSample = defaultSampleService.findByDopantLikeAndSpecificationsLikeAndProductTypeLike(ybInspectData.getDopant(), ybInspectData.getProductTypeSecond(),ybInspectData.getProductType());
                    	//根据晶段所在晶棒的编码查询整棒中所有晶段
                    	List<YbInspectData> sectionNos = ybInspectDataService.getInspectDatasByCrystalNo(ybInspectData.getCrystalNo());
                    	//全部赋默认值
                    	for (YbInspectData inspect : sectionNos) {
                    		inspect.setOxygenContentHead(NumberUtil.Object2BigDecimal(defaultSample.getOxygenCenterHead(), null));
                    		inspect.setOxygenContentTail(NumberUtil.Object2BigDecimal(defaultSample.getOxygenCenterTail(), null));
                    		
                    		inspect.setCarbonContentHead(NumberUtil.Object2BigDecimal(defaultSample.getCarbonCenterHead(), null));
                    		inspect.setCarbonContentTail(NumberUtil.Object2BigDecimal(defaultSample.getCarbonCenterTail(), null));
						}
                    	//重新评级 未确认是否重新评级，需求说不需要，开发说需要。未讨论出最终结果
                    	
                    	//过站 - 圆棒检验 进站
                    	wipStorageService.inStation(planProcessingOrder.getCode(), planProcessingOrder.getEquipmentCode(),false);
                    }
                    return ResultGenerator.success();
                }
            } else {
                //方棒反切画线记录
                ReCut reCut = fbReCutService.findBySectionNoAndStatus(planProcessingOrder.getCode(), 0);
                if (reCut == null || reCut.getStatus()) {
                    throw new BusinessException(planProcessingOrder.getCode() + "不存在未切断的反切划线信息，请检查数据");
                }
                List<ProductionPaintingLineDetail> recutDetail = productionPaintingLineDetailService.findByOperateRecutDrawIdFb(reCut.getId());

//                boolean backCutType = reCut.getRecutType() == 2;
//                if (backCutType) {
                    setProcessingOrderNewDtoV2(processingOrderNewDtos, recutDetail);
//                } else {
//                    for (ProductionPaintingLineDetail productionPaintingLineDetail : recutDetail) {
//                        if (productionPaintingLineDetail.getType() == EnumValuesServer.LineType.晶段.getKey()) {
//                            planProcessingOrder.setWeight(productionPaintingLineDetail.getWeight());
//                            planProcessingOrder.setLength(productionPaintingLineDetail.getLength());
//                            break;
//                        }
//                    }
//                }
                reCut.setStatus(true);
                fbReCutService.saveOrUpdate(reCut);
                return getResult(sendEapCutCraft, processingOrderNewDtos, planProcessingOrder, null, null, reCut, null);
            }
        } else {
            throw new BusinessException("该工单不支持过截断站");
        }
    }

    private Result getResult(boolean sendEapCutCraft, List<ProcessingOrderNewDto> processingOrderNewDtos, PlanProcessingOrder planProcessingOrder, ProductionPaintingLine productionPaintingLine, ProductionBackCuttingRecord productionBackCuttingRecord, ReCut reCut, Integer backCutType) {
//        /**
//         * 不需要产生子批
//         */
//        if (backCutType != null && (backCutType == 3 || backCutType == 2)) {
//            planProcessingOrderService.createPlanProcessingOrder(planProcessingOrder, null, null);
//            //2022-09-26 赵文杰： 将过截断站点的，不产生子批的晶段改反切状态改为false.
//            inspectDataBaseService.updateIsCutBack(0, planProcessingOrder.getCode());
//            Result result = wipStorageService.outStation(planProcessingOrder.getCode(), backCutType == 3 ? "-2" : null, null);
//            if (result.getCode() == ResultCode.SUCCESS.getCode()) {
//                if (sendEapCutCraft) {
//                    return sendEapCutCraft(planProcessingOrder, productionPaintingLine, productionBackCuttingRecord, reCut);
//                }
//            } else {
//                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//            }
//            return result;
//        } else {
        if (backCutType != null && backCutType == 3) {
            String processingOrderCode = planProcessingOrder.getCode();
            List<PlanProcessingOrder> planProcessingOrders = planProcessingOrderDao.findByCodeOrderByIdDesc(processingOrderCode);
            if (planProcessingOrders.size() == 0) {
                throw new BusinessException("工单号【" + processingOrderCode + "】不存在");
            }
            WipStorage wipStorage;
            PlanProcessingOrder planProcessingOrder1 = planProcessingOrders.get(0);
            if (true) {
                if (planProcessingOrder1.getStatus() != EnumValuesFactory.PlanProcessingOrderStatus.加工中.getKey()) {
                    if (!true) {
                        throw new BusinessException("【" + processingOrderCode + "】该工单处于" + EnumValuesFactory.PlanProcessingOrderStatus.getText(planProcessingOrder1.getStatus()) + "，无法操作出站");
                    }
                }
                wipStorage = planProcessingOrder1.getWipStorage();
                if (wipStorage == null) {
                    throw new BusinessException("【" + processingOrderCode + "】该工单没有正在加工记录");
                }
                if (wipStorage.getStatus() == EnumValuesFactory.WipStorageStatus.已出站.getKey()) {
                    throw new BusinessException("【" + processingOrderCode + "】该工单的" + wipStorage.getProcessName() + "工序已是出站状态");
                }
                if (wipStorage.getStatus() == EnumValuesFactory.WipStorageStatus.待进站.getKey()) {
                    throw new BusinessException("【" + processingOrderCode + "】该工单的【" + wipStorage.getProcessName() + "工序为待进站状态，无法操作出站");
                }
            } else {
                wipStorage = planProcessingOrder1.getWipStorage();
                if (wipStorage == null) {
                    throw new BusinessException("【" + processingOrderCode + "】该工单没有正在加工记录");
                }
            }

            if (true) { //true当前工单出站，停止当前工单
                WipStorage currentWipStorage = new WipStorage();
                BeanUtils.copyProperties(wipStorage, currentWipStorage);
                currentWipStorage.setEndTime(new Date());
                currentWipStorage.setStatus(EnumValuesFactory.WipStorageStatus.已出站.getKey());
                currentWipStorage.setOutUserName(BaseContextHandler.getUsername());
                currentWipStorage.setOutUserId(BaseContextHandler.getUserID());
                dao.save(currentWipStorage);
                FactoryModel factoryModel = wipStorageService.getFactoryModel(currentWipStorage.getProcessId(), currentWipStorage.getProcessName());
                processLogService.createProcessLog(currentWipStorage.getProcessingOrderId(), currentWipStorage.getProcessingOrderCode(), currentWipStorage.getEquipmentId(), currentWipStorage.getEquipmentCode(), factoryModel.getName(), 0, "【" + factoryModel.getName() + "】工序出站");

                planProcessingOrder1.setStatus(EnumValuesFactory.PlanProcessingOrderStatus.加工完成.getKey());
                planProcessingOrderService.saveOrUpdate(planProcessingOrder1);
                return ResultGenerator.success();
            }
        } else

            /**
             * 产生子批
             */
            if (processingOrderNewDtos.size() == 0) {
                throw new BusinessException("画线信息不能为空，请检查数据");
            }
            Map<String, String> flowLineLables = new HashMap<>();
            processingOrderNewDtos.forEach(processingOrderNewDto -> flowLineLables.put(processingOrderNewDto.getCode(), "A"));
            Result result = wipStorageService.outStation2(planProcessingOrder.getCode(), processingOrderNewDtos, true, flowLineLables);
            if (result.getCode() == ResultCode.SUCCESS.getCode()) {
                if (sendEapCutCraft) {
                    return sendEapCutCraft(planProcessingOrder, productionPaintingLine, productionBackCuttingRecord, reCut);
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            }
            return result;
//        }
    }

    private List<SectionNoDetail> execYbJd(PlanProcessingOrder planProcessingOrder, ProductionBackCuttingRecord productionBackCuttingRecord, boolean sendEapCutCraft) {
        List<ProcessingOrderNewDto> processingOrderNewDtos = new ArrayList<>();
        SectionNoDetail section = sectionNoDetailService.findBySectionNo(planProcessingOrder.getCode());
        // 0：不合格反切，1：分段反切，2：拼棒中，未反切的晶段，直接过站，3：全部为回收料，晶段直接报废
        if (productionBackCuttingRecord.getIsInheritSample() != null) {
            productionRecutService.savePieceAndSectionNoDetail(productionBackCuttingRecord, section);
        }
        // 0：不合格反切，1：分段反切，2：拼棒中，未反切的晶段，直接过站，3：全部为回收料，晶段直接报废
        Integer backCutType = productionBackCuttingRecord.getBackCutType();
        List<SectionNoDetail> sectionNoDetails = new LinkedList<>();
        if (backCutType == 2) {
            SectionNoDetail sectionNoDetail = sectionNoDetailService.get(planProcessingOrder.getGoodsId());
            planProcessingOrder.setWeight(sectionNoDetail.getWeight());
            planProcessingOrder.setLength(sectionNoDetail.getLength());
            sectionNoDetails.add(sectionNoDetail);
        } else if (backCutType != 3) {
            sectionNoDetails = sectionNoDetailService.findByParentId(planProcessingOrder.getGoodsId());
            if (sectionNoDetails.size() == 0) {
                throw new BusinessException("的反切划线信息不存在，请检查数据");
            }
            setProcessingOrderNewDto(processingOrderNewDtos, sectionNoDetails);
        } else if (backCutType == 3) {
            sectionNoDetails = sectionNoDetailService.findByParentId(planProcessingOrder.getGoodsId());
            if (sectionNoDetails.size() == 0) {
                throw new BusinessException("的反切划线信息不存在，请检查数据");
            }
            setProcessingOrderNewDto(processingOrderNewDtos, sectionNoDetails);
        }
        productionBackCuttingRecord.setStatus(true);
        productionRecutService.saveOrUpdate(productionBackCuttingRecord);
        //处理开方退料闭环
        //turnstoreInItemService.updateDealBySectionNoAndWithdrawingType(productionBackCuttingRecord.getSegmentNo(), Arrays.asList("退库反切复检".split(",")));
        Result result = getResult(sendEapCutCraft, processingOrderNewDtos, planProcessingOrder, null, productionBackCuttingRecord, null, backCutType);
        if (result.getCode() != ResultCode.SUCCESS.getCode()) {
            log.error("execYbJd：" + result.getMessage());
        }
        return sectionNoDetails;
    }

    /**
     * 拼棒反切过站
     *
     * @param planProcessingOrder
     * @param productionBackCuttingRecord
     * @param sendEapCutCraft
     */
    private Result execYbJdV2(PlanProcessingOrder planProcessingOrder, ProductionBackCuttingRecord productionBackCuttingRecord, boolean sendEapCutCraft) {
        List<ProductionBackCuttingRecord> productionBackCuttingRecords = productionRecutService.findByUuid(productionBackCuttingRecord.getUuid());
        Map<String, List<SectionNoDetail>> stringListMap = new HashMap<>();
        for (ProductionBackCuttingRecord productionBackCuttingRecord1 : productionBackCuttingRecords) {
            if (planProcessingOrder.getCode().equals(productionBackCuttingRecord1.getSegmentNo())) {
                List<SectionNoDetail> sectionNoDetails = execYbJd(planProcessingOrder, productionBackCuttingRecord1, sendEapCutCraft);
                stringListMap.put(planProcessingOrder.getCode(), sectionNoDetails);
            } else {
                PlanProcessingOrderWipStorageDto result = wipStorageService.selectWipStorage(productionBackCuttingRecord1.getSegmentNo(), EnumValuesFactory.WipStorageCode.圆棒截断.getKey(), true);
                List<SectionNoDetail> sectionNoDetails = execYbJd(result.getPlanProcessingOrder(), productionBackCuttingRecord1, sendEapCutCraft);
                stringListMap.put(result.getPlanProcessingOrder().getCode(), sectionNoDetails);
            }
        }
        List<String> positionsArr = new LinkedList<>();
        if (StringUtils.isNotBlank(productionBackCuttingRecord.getPositions())) {
            positionsArr = Arrays.asList(productionBackCuttingRecord.getPositions().split(","));
        }
        List<String> sectionComposeArr = new LinkedList<>();
        if (StringUtils.isNotBlank(productionBackCuttingRecord.getSectionCompose())) {
            sectionComposeArr = Arrays.asList(productionBackCuttingRecord.getSectionCompose().split(","));
        }
        //旧的拼棒关系进行解绑
        extracted(sectionComposeArr, productionBackCuttingRecord.getSectionCompose());
        LinkedHashSet<String> sectionComposeArrNew = new LinkedHashSet<>();
        for (int index = 1; index < sectionComposeArr.size(); index++) {
            if (!positionsArr.contains(index + "")) {
                //第一颗的最后一颗
                String sectionNoOne = stringListMap.get(sectionComposeArr.get(index - 1)).get(stringListMap.get(sectionComposeArr.get(index - 1)).size() - 1).getSectionNo();
                //第二颗的第一颗
                String sectionNoTwo = stringListMap.get(sectionComposeArr.get(index)).get(0).getSectionNo();
                if (!sectionComposeArr.contains(sectionNoOne)) {
                    throw new BusinessException(sectionNoOne + "没有检验数据，无法自动拼棒");
                }
                sectionComposeArrNew.add(sectionNoOne);
                if (!sectionComposeArr.contains(sectionNoTwo)) {
                    throw new BusinessException(sectionNoTwo + "没有检验数据，无法自动拼棒");
                }
                sectionComposeArrNew.add(sectionNoTwo);
            } else {
                // 提交现有的拼棒反切
                if (sectionComposeArrNew.size() > 1) {
                    sectionService.stickTogetherV2(new LinkedList<>(sectionComposeArrNew), 0);
                }
                sectionComposeArrNew = new LinkedHashSet<>();
            }
        }
        // 提交现有的拼棒反切
        if (sectionComposeArrNew.size() > 1) {
            sectionService.stickTogetherV2(new LinkedList<>(sectionComposeArrNew), 0);
        }
        return ResultGenerator.success();
    }


    private void extracted(List<String> sectionNos, String sectionNoGroup) {
        //删除拼圆棒中间表
        spellInfoService.deleteBySectionNos(sectionNos);
        String sectionType = "非标棒";
        //2022年4月5日10:14:40，修改方棒检验数据库，修复解绑圆棒，方棒反切无法操作，暂时没做工单类型区分，原本功能检验暂时也做更改，因为部分单晶站点过不去，需要重新绑定
        inspectDataBaseService.updateSticksCountFbSectionNoListFromYb(sectionNos, 1, null, sectionType, null);
        //更改圆棒检验拼棒字段，并且重新下发评级
        List<YbInspectData> inspectDataBases = new ArrayList<>();
        for (String sectionNo : sectionNos) {
            YbInspectData inspectDataBase = inspectDataBaseService.findBySectionNo(sectionNo);
            inspectDataBase.setSticksCount(1);
            inspectDataBase.setSpellBarLength(null);
            inspectDataBase.setSectionType(sectionType);
            inspectDataBase.setSectionCompose(null);
            inspectDataBases.add(inspectDataBase);
        }
        //优先保存，确保保存成功，在重新下发评级
        inspectDataBaseService.saveAll(inspectDataBases);
        sectionDAO.updateStateBySectionNoGroup(sectionNoGroup, BaseContextHandler.getUserID(), BaseContextHandler.getUsername(), new Date(), "拼棒反切");
        //重新下发评级，圆棒评级下发
        for (YbInspectData inspectDataBase : inspectDataBases) {
            publishRankResultService.publishRankResult(inspectDataBase, inspectDataBase.getActualWeight(), inspectDataBase.getTheoryWeight());
        }
    }

    private void setProcessingOrderNewDtoV2(List<ProcessingOrderNewDto> processingOrderNewDtos, List<ProductionPaintingLineDetail> productionPaintingLineDetails) {
        for (ProductionPaintingLineDetail sectionNoDetail : productionPaintingLineDetails) {
            if (sectionNoDetail.getType() == EnumValuesServer.LineType.晶段.getKey()) {
                ProcessingOrderNewDto processingOrderNewDto = new ProcessingOrderNewDto();
                processingOrderNewDto.setCode(sectionNoDetail.getNo());
                processingOrderNewDto.setLength(sectionNoDetail.getLength());
                processingOrderNewDto.setWeight(sectionNoDetail.getWeight());
                RecutDetail recutDetail = recutDetailService.findBySectionNoFb(sectionNoDetail.getNo());
                if (recutDetail != null) {
                    processingOrderNewDto.setGoodsId(recutDetail.getId());
                }
                processingOrderNewDto.setOrderType(EnumValuesFactory.PlanProcessingOrderOrderType.晶段.getKey());
                processingOrderNewDtos.add(processingOrderNewDto);
            }
        }
    }


    private void setProcessingOrderNewDtoV3(List<ProcessingOrderNewDto> processingOrderNewDtos, ProductionPaintingLineDetail productionPaintingLineDetail) {
        if (productionPaintingLineDetail.getType() == EnumValuesServer.LineType.晶段.getKey()) {
            ProcessingOrderNewDto processingOrderNewDto = new ProcessingOrderNewDto();
            processingOrderNewDto.setCode(productionPaintingLineDetail.getNo());
            processingOrderNewDto.setLength(productionPaintingLineDetail.getLength());
            processingOrderNewDto.setWeight(productionPaintingLineDetail.getWeight());
            RecutDetail recutDetail = recutDetailService.findBySectionNoFb(productionPaintingLineDetail.getNo());
            if (recutDetail != null) {
                processingOrderNewDto.setGoodsId(recutDetail.getId());
            }
            processingOrderNewDto.setOrderType(EnumValuesFactory.PlanProcessingOrderOrderType.晶段.getKey());
            processingOrderNewDtos.add(processingOrderNewDto);
        }
    }


    @Override
    public void setProcessingOrderNewDto(List<ProcessingOrderNewDto> processingOrderNewDtos, List<SectionNoDetail> sectionNoDetails) {
        for (SectionNoDetail sectionNoDetail : sectionNoDetails) {
            ProcessingOrderNewDto processingOrderNewDto = new ProcessingOrderNewDto();
            processingOrderNewDto.setCode(sectionNoDetail.getSectionNo());
            processingOrderNewDto.setLength(sectionNoDetail.getLength());
            ProductionPaintingLineDetail bySegmentNo = productionPaintingLineDetailService.findBySegmentNo(sectionNoDetail.getSectionNo());
            if (bySegmentNo == null) {
                throw new BusinessException("未查询到画线信息");
            }
            if (sectionNoDetail.getWeight() != null) {
                processingOrderNewDto.setWeight(sectionNoDetail.getWeight());
            } else {
                //重量为空根据系数计算理论重量
                DictionaryItem weightRatio = dictionaryItemService.findByThemeValueAndNameAndEnable("WeightRatio", sectionNoDetail.getSpecs(), true);
                if (weightRatio == null) {
                    throw new BusinessException("【" + sectionNoDetail.getSpecs() + "】规格重量理论系数未配置");
                }
                try {
                    processingOrderNewDto.setWeight(bySegmentNo.getLength().divide(new BigDecimal(weightRatio.getValue()), 2, RoundingMode.HALF_UP));
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new BusinessException("计算理论重量失败：规格为：【" + sectionNoDetail.getSpecs() + "】,系数为：【" + weightRatio.getValue() + "】长度为：【" + bySegmentNo.getLength() + "】");
                }
            }
            processingOrderNewDto.setGoodsId(sectionNoDetail.getId());
            processingOrderNewDto.setOrderType(EnumValuesFactory.PlanProcessingOrderOrderType.晶段.getKey());
            processingOrderNewDto.setIsCut(bySegmentNo.getIsCut());
            if(null != sectionNoDetail.getSectionType() && sectionNoDetail.getSectionType().equals(EnumValuesServer.LineType.回收料.getValue())){
                continue;
            }
            processingOrderNewDtos.add(processingOrderNewDto);
        }
    }

    @Override
    public Result execKfOut(List<String> sectionNoArr, PlanProcessingOrderWipStorageDto result, String flowLineLable, String wipStorageCode) {
        for (String sectionNo : sectionNoArr) {
            if (StringUtils.isNotBlank(sectionNo) && result.getPlanProcessingOrder().getCode().equals(sectionNo)) {
                wipStorageYbService.execKfOut(sectionNo, flowLineLable, result.getPlanProcessingOrder());
            } else {
                PlanProcessingOrderWipStorageDto resultOther = wipStorageService.selectWipStorage(sectionNo, wipStorageCode, true);
                FactoryModel factoryModelOther = wipStorageService.getFactoryModel(resultOther.getWipStorage().getProcessId(), resultOther.getWipStorage().getProcessName());
                if (factoryModelOther != null && factoryModelOther.getCode().equals(EnumValuesFactory.WipStorageCode.开方.getKey())) {
                    wipStorageYbService.execKfOut(sectionNo, flowLineLable, resultOther.getPlanProcessingOrder());
                } else {
                    throw new BusinessException("【" + sectionNo + "】：拼棒中的，这个编号不在开方站点");
                }
            }
        }
        return ResultGenerator.success();
    }

    /**
     * 获取折重系数
     *
     * @param diameter
     * @return
     */
    private BigDecimal getWeightLossCoefficient(String diameter) {
        List<DictionaryItem> dictionaryItems = dictionaryItemService.findByThemeValueAndItemName(Constants.WEIGHT_RATIO, diameter, true);
        if (dictionaryItems.size() == 0) {
            throw new BusinessException("请配置【" + diameter + "】规格的理论重量系数");
        }
        BigDecimal weightLossCoefficient = NumberUtil.Object2BigDecimal(dictionaryItems.get(0).getValue());
        if (weightLossCoefficient == null || weightLossCoefficient.compareTo(new BigDecimal(0)) < 0) {
            throw new BusinessException("【" + dictionaryItems.get(0).getValue() + "】理论重量系数格式不正确，只能为大于0的数字类型");
        }
        return weightLossCoefficient;
    }

    /**
     * 截断出站，上传加工记录
     *
     * @param
     * @return
     */
    private Result sendEapCutCraft(PlanProcessingOrder planProcessingOrder, ProductionPaintingLine productionPaintingLine, ProductionBackCuttingRecord productionBackCuttingRecord, ReCut reCut) {
        EapCutCraftDto eapCutCraftDto = new EapCutCraftDto();
        //设备
        eapCutCraftDto.setEquipNo(planProcessingOrder.getWipStorage().getEquipmentCode());
        //单晶编号
        eapCutCraftDto.setRoundSn(planProcessingOrder.getCode());
        //截断出站时间
        eapCutCraftDto.setEndCut(new Date());
        eapCutCraftDto.setStartCut(new Date());
        //截断出站操作人
        eapCutCraftDto.setCutOperator(BaseContextHandler.getUsername());
        //截断出站操作人班组
        eapCutCraftDto.setShift(BaseContextHandler.getUserTeamGroup());
        //判断单晶来源1:炉次 2:单晶 3: 晶段
        eapCutCraftDto.setType(planProcessingOrder.getOrderType());
        //物料类型 0：圆棒，1：方棒
        eapCutCraftDto.setCrystalType(planProcessingOrder.getMaterialType());
        ClassMonitorModelLog byTeamName = classMonitorModelLogService.findByTeamName(eapCutCraftDto.getShift());
        if (byTeamName != null) {
            eapCutCraftDto.setUserRealName(byTeamName.getUserRealName());
        }
        //查询数据字典长度范围对照表 product_length
        DictionaryItem item = null;
        if (eapCutCraftDto.getRoundSn() != null && eapCutCraftDto.getRoundSn().length() > 7) {
            //获取
            String str = eapCutCraftDto.getRoundSn().substring(5, 8);
            item = dictionaryItemService.findByThemeValueAndNameAndEnable("WeightFractions", str, true);
        }
        //长晶棒过截断
        if (eapCutCraftDto.getType() != null && eapCutCraftDto.getType() == 2) {
            if (productionPaintingLine != null) {
                if (item != null) {
                    BigDecimal lineLength = productionPaintingLine.getValidLength() == null ? BigDecimal.valueOf(0) : productionPaintingLine.getValidLength();
                    BigDecimal xiShu = BigDecimal.valueOf(Double.parseDouble(item.getValue()));
                    eapCutCraftDto.setTheoryWeight(lineLength.divide(xiShu, 2, BigDecimal.ROUND_HALF_UP));
                }
                //晶棒长度
                eapCutCraftDto.setRoundLength(productionPaintingLine.getValidLength());
                int SliceNum = 0;
                List<ProductionPaintingLineDetail> byOperateDrawId = productionPaintingLineDetailService.findByOperateDrawId(productionPaintingLine.getId());
                if (byOperateDrawId != null) {
                    eapCutCraftDto.setNormalNum(byOperateDrawId.size() - 1);
                    for (ProductionPaintingLineDetail productionPaintingLineDetail : byOperateDrawId) {
                        if (productionPaintingLineDetail.getType() != null && productionPaintingLineDetail.getType() == 1) {
                            SliceNum++;
                        }
                    }
                    eapCutCraftDto.setLineNum(byOperateDrawId.size());
                }
                eapCutCraftDto.setKnifeNum(productionPaintingLine.getLineNum());
                eapCutCraftDto.setSliceNum(SliceNum);
                eapCutCraftDto.setIsCut(1);
            }
        }
        // 圆棒晶段反切过截断
        else if (eapCutCraftDto.getType() != null && eapCutCraftDto.getCrystalType() != null && eapCutCraftDto.getType() == 3 && eapCutCraftDto.getCrystalType() == 0) {
            if (productionBackCuttingRecord != null) {
                if (item != null) {
                    BigDecimal lineLength = productionBackCuttingRecord.getBarLength() == null ? BigDecimal.valueOf(0) : productionBackCuttingRecord.getBarLength();
                    BigDecimal xiShu = BigDecimal.valueOf(Double.parseDouble(item.getValue()));
                    eapCutCraftDto.setTheoryWeight(lineLength.divide(xiShu, 2, BigDecimal.ROUND_HALF_UP));
                }
                //晶棒长度
                eapCutCraftDto.setRoundLength(productionBackCuttingRecord.getBarLength());
                eapCutCraftDto.setReverseNum(productionBackCuttingRecord.getKnifeNum());
                int sliceNum = 0;
                int knifeNum = 0;
                List<ProductionPaintingLineDetail> list = productionPaintingLineDetailService.findByOperateReversecutDrawId(productionBackCuttingRecord.getId());
                if (list != null) {
                    eapCutCraftDto.setLineNum(list.size());
                    for (ProductionPaintingLineDetail productionPaintingLineDetail : list) {
                        if (productionPaintingLineDetail.getType() != null && productionPaintingLineDetail.getType() == 1) {
                            sliceNum++;
                        }
                        if (productionPaintingLineDetail.getType() != null && productionPaintingLineDetail.getType() == 0) {
                            knifeNum++;
                        }
                    }
                }
                eapCutCraftDto.setKnifeNum(knifeNum);
                eapCutCraftDto.setSliceNum(sliceNum);
                eapCutCraftDto.setCause(productionBackCuttingRecord.getCause());
                eapCutCraftDto.setIsCut(0);
            }
        }
        // 方棒晶段反切过截断
        else if (eapCutCraftDto.getType() != null && eapCutCraftDto.getCrystalType() != null && eapCutCraftDto.getType() == 3 && eapCutCraftDto.getCrystalType() == 1) {
            if (reCut != null) {
                if (item != null) {
                    BigDecimal lineLength = reCut.getSegmentNoLength() == null ? BigDecimal.valueOf(0) : reCut.getSegmentNoLength();
                    BigDecimal xiShu = BigDecimal.valueOf(Double.parseDouble(item.getValue()));
                    eapCutCraftDto.setTheoryWeight(lineLength.divide(xiShu, 2, BigDecimal.ROUND_HALF_UP));
                }
                //晶棒长度
                eapCutCraftDto.setRoundLength(reCut.getSegmentNoLength());
                eapCutCraftDto.setReverseNum(reCut.getCutNum() != null && isInteger(reCut.getCutNum()) ? Integer.parseInt(reCut.getCutNum()) : 0);
                int sliceNum = 0;
                int knifeNum = 0;
                List<ProductionPaintingLineDetail> list = productionPaintingLineDetailService.findByOperateRecutDrawIdFb(reCut.getId());
                if (list != null) {
                    eapCutCraftDto.setLineNum(list.size());
                    for (ProductionPaintingLineDetail productionPaintingLineDetail : list) {
                        if (productionPaintingLineDetail.getType() != null && productionPaintingLineDetail.getType() == 1) {
                            sliceNum++;
                        }
                        if (productionPaintingLineDetail.getType() != null && productionPaintingLineDetail.getType() == 0) {
                            knifeNum++;
                        }
                    }
                }
                eapCutCraftDto.setKnifeNum(knifeNum);
                eapCutCraftDto.setSliceNum(sliceNum);
                eapCutCraftDto.setCause(reCut.getReason());
                eapCutCraftDto.setIsCut(0);
            }
        }
        //截断信息上传
        Result cutCraftArtificialUpload = fbFeignClients.cutCraftArtificialUpload(eapCutCraftDto);
        //截断信息上传失败，手动回滚过站信息
        if (cutCraftArtificialUpload.getCode() != ResultCode.SUCCESS.getCode()) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return ResultGenerator.fail("截断信息上传失败：" + cutCraftArtificialUpload.getMessage());
        }
        return cutCraftArtificialUpload;
    }

    /**
     * 判断字符串是否是整数
     */
    private boolean isInteger(String value) {
        try {
            Integer.parseInt(value);
            return true;
        } catch (NumberFormatException e) {
            return false;
        }
    }

    /**
     * pad 通用进站
     *
     * @param deviceCode     设备编号
     * @param wipStorageCode 站点代码
     * @return
     */
    @Override
    public Result padInStation(List<String> processingOrderCodes, String deviceCode, String wipStorageCode) {
        Map<String, PlanProcessingOrderWipStorageDto> planProcessingOrderWipStorageDtoMap = new HashMap<>();
        for (String processingOrderCode : processingOrderCodes) {
            PlanProcessingOrderWipStorageDto planProcessingOrderWipStorageDto = wipStorageService.selectWipStorage(processingOrderCode, wipStorageCode, false);
            planProcessingOrderWipStorageDtoMap.put(processingOrderCode, planProcessingOrderWipStorageDto);
        }
        Date date = new Date();
        for (String processingOrderCode : processingOrderCodes) {

            Result<FbScheduleDto> fbScheduleDtoResult = fbFeignClients.findByDeviceNo(deviceCode);
            if (StringUtils.equals(wipStorageCode,EnumValuesFactory.WipStorageCode.毛棒截断.getKey()) || StringUtils.equals(wipStorageCode,EnumValuesFactory.WipStorageCode.开方.getKey()) ){
                if(null != fbScheduleDtoResult && ResultCode.SUCCESS.getCode() == fbScheduleDtoResult.getCode() && null != fbScheduleDtoResult.getData()){
                    FbScheduleDto fbScheduleDtoResultData = fbScheduleDtoResult.getData();
                    CrystalMaterialRelation crystalMaterialRelation = new CrystalMaterialRelation();
                    crystalMaterialRelation.setDeviceNo(deviceCode);
                    crystalMaterialRelation.setSectionNo(processingOrderCode);
                    crystalMaterialRelation.setDeviceType(StringUtils.equals(wipStorageCode,EnumValuesFactory.WipStorageCode.毛棒截断.getKey()) ? EnumValuesFactory.DeviceCategory.截断机.getKey() : EnumValuesFactory.DeviceCategory.开方机.getKey());
                    crystalMaterialRelation.setMaterialCode(fbScheduleDtoResultData.getMatnr());
                    crystalMaterialRelation.setOrderNo(fbScheduleDtoResultData.getOrderNo());
                    crystalMaterialRelation.setGmtCreate(date);
                    if (null != fbScheduleDtoResultData.getMaterialModelId()){
                        crystalMaterialRelation.setMaterialModelId(fbScheduleDtoResultData.getMaterialModelId());
                    }
                    crystalMaterialRelationService.saveOrUpdate(crystalMaterialRelation);
                }else {
                    throw new BusinessException("设备排程未维护，请先维护排程信息。设备编号为：" + deviceCode);
                }
                //先报工
                this.handleReportConsumption(processingOrderCode,wipStorageCode,deviceCode,fbScheduleDtoResult);
            }

            Result result = wipStorageService.inStation(processingOrderCode, deviceCode);
            if (result.getCode() == ResultCode.SUCCESS.getCode()) {
                if (EnumValuesFactory.WipStorageCode.圆棒截断.getKey().equals(wipStorageCode) || StringUtils.equals(wipStorageCode,EnumValuesFactory.WipStorageCode.毛棒截断.getKey())) {
                    //送验车解绑
                    wipStorageService.unbinding(processingOrderCode);

                    /**
                     * 截断进站，发送加工记录
                     */
                    EapCutCraftDto eapCutCraftDto = new EapCutCraftDto();
                    //设备
                    eapCutCraftDto.setEquipNo(deviceCode);
                    //单晶编号
                    eapCutCraftDto.setRoundSn(processingOrderCode);
                    //截断出站时间
                    eapCutCraftDto.setStartCut(new Date());
                    //晶棒长度
                    eapCutCraftDto.setRoundLength(planProcessingOrderWipStorageDtoMap.get(processingOrderCode).getPlanProcessingOrder().getLength());
                    //截断出站操作人
                    eapCutCraftDto.setCutUpOperator(BaseContextHandler.getUsername());
                    //截断出站操作人班组
                    eapCutCraftDto.setShift(BaseContextHandler.getUserTeamGroup());
                    //判断单晶来源
                    eapCutCraftDto.setType(planProcessingOrderWipStorageDtoMap.get(processingOrderCode).getPlanProcessingOrder().getOrderType());
                    //物料类型 0：圆棒，1：方棒
                    eapCutCraftDto.setCrystalType(planProcessingOrderWipStorageDtoMap.get(processingOrderCode).getPlanProcessingOrder().getMaterialType());
                    //截断信息上传
                    Result cutCraftArtificialUpload = fbFeignClients.cutCraftArtificialUpload(eapCutCraftDto);
                    //截断信息上传失败，手动回滚过站信息
                    if (cutCraftArtificialUpload.getCode() != ResultCode.SUCCESS.getCode()) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        return ResultGenerator.fail("截断信息上传失败：" + result.getMessage());
                    }
                } else if(EnumValuesFactory.WipStorageCode.开方.getKey().equals(wipStorageCode)
                        || EnumValuesFactory.WipStorageCode.磨倒.getKey().equals(wipStorageCode)
                ) {
                    EapCutCraftDto eapCutCraftDto = new EapCutCraftDto();
                    //设备
                    eapCutCraftDto.setEquipNo(deviceCode);
                    //单晶编号
                    eapCutCraftDto.setRoundSn(processingOrderCode);
                    eapCutCraftDto.setStartCut(new Date());
                    eapCutCraftDto.setWipStorageCode(wipStorageCode);
                    eapCutCraftDto.setCutUpOperator(BaseContextHandler.getUsername());
                    Result cutCraftArtificialUpload = fbFeignClients.openGrinding(eapCutCraftDto);
                }
            } else {
                throw new BusinessException(result.getMessage());
            }
        }
        return ResultGenerator.success();
    }

    @Override
    public Result execKfOut(String processingOrderCode, String flowLineLable, PlanProcessingOrder planProcessingOrder) {
        Result outResult = wipStorageService.outStation(processingOrderCode, flowLineLable, null);
        if (outResult.getCode() == ResultCode.SUCCESS.getCode()) {
            //开方出站，工单类型变为方棒工单
            planProcessingOrder.setMaterialType(EnumValuesFactory.MaterialType.方棒.getKey());
            planProcessingOrderService.createPlanProcessingOrder(planProcessingOrder, null, null);
            // 找到对应圆棒信息
            List<SectionNoDetail> sectionNoDetails = this.sectionNoDetailDao.findBySectionNo(processingOrderCode);
            if (sectionNoDetails != null && sectionNoDetails.size() > 0) {
                SectionNoDetail sectionNoDetail = sectionNoDetails.get(0);
                RecutDetail recutDetail = recutDetailService.findBySectionNoFb(sectionNoDetail.getSectionNo());
                // 进入开方加工，添加方棒追溯表
                if (recutDetail == null) {
                    recutDetail = new RecutDetail();
                }
                // 圆棒编号
                recutDetail.setSectionNo(processingOrderCode);
                // 方棒编号
                recutDetail.setSectionNoFb(processingOrderCode);
                // 圆棒id
                recutDetail.setYbId(sectionNoDetail.getId());
                // 晶棒id
                recutDetail.setCrystalId(sectionNoDetail.getCrystalId());
                recutDetail.setCreateDate(new Date());
                recutDetail.setCreateUser(BaseContextHandler.getUsername());
                // 保存数据
                recutDetailService.saveOrUpdate(recutDetail);
            }
        }
        return outResult;
    }

    @Override
    public List<String> getSectionNos(Integer materialType, String sectionNo) {
        String sectionCompose;
        List<String> sectionNoArr = new LinkedList<>();
        if (materialType == EnumValuesFactory.MaterialType.圆棒.getKey()) {
            sectionCompose = inspectDataBaseService.getSectionComposeBySectionNo(sectionNo);
        } else {
            Result<String> resultSectionCompose = fbFeignService.getSectionComposeBySectionNo(sectionNo);
            if (resultSectionCompose.getCode() != ResultCode.SUCCESS.getCode()) {
                throw new BusinessException(resultSectionCompose.getMessage());
            }
            sectionCompose = resultSectionCompose.getData();
        }
        if (StringUtils.isNotBlank(sectionCompose)) {
            String[] sectionComposeArr = sectionCompose.split(",");
            sectionNoArr = Arrays.asList(sectionComposeArr);
        } else {
            sectionNoArr.add(sectionNo);
        }
        return sectionNoArr;
    }

    /**
     * 处理截断和开方上报数据
     * @param processingOrderCode
     * @param position
     */
    private void handleReportConsumption(String processingOrderCode,String position,String deviceCode,Result<FbScheduleDto> result){
        if (null == result || null == result.getData()){
            throw new BusinessException("设备排程未维护，请先维护排程信息。设备编号为：" + deviceCode);
        }
        //截断上报
        if (StringUtils.equals(position,EnumValuesFactory.WipStorageCode.毛棒截断.getKey())){
            LongCrystal byCrystalNo = longCrystalService.findByCrystalNo(processingOrderCode);
            if(null == byCrystalNo || null == byCrystalNo.getWeight()){
                throw new BusinessException("该设备不存在长晶记录或长晶重量。设备编号为：" + deviceCode);
            }
            this.handleReportSap(result,"截断成品仓",byCrystalNo,processingOrderCode,deviceCode,byCrystalNo.getWeight(),EnumValuesFactory.WipStorageCode.毛棒截断.getValue());
        }else if (StringUtils.equals(position,EnumValuesFactory.WipStorageCode.开方.getKey())){
            YbInspectData bySectionNo = ybInspectDataService.findBySectionNo(processingOrderCode);
            LongCrystal byCrystalNo = longCrystalService.findByCrystalNo(bySectionNo.getCrystalNo());
            if (null == bySectionNo){
                throw new BusinessException("该设备不存在圆棒检验数据。设备编号为：" + deviceCode);
            }
            if (null == byCrystalNo){
                throw new BusinessException("该设备圆棒检验数据的长晶棒数据不存在。设备编号为：" + deviceCode);
            }
            //下工序材料仓
            String umlgo = null;
            //成品仓
            String warehouseCode ="";
            //材料仓
            String warehouseCodeMaterial = "";
            Equipment byCode = equipmentService.findByCode(deviceCode);
            if (null != byCode){
                DictionaryItem  warehouseLocation = dictionaryItemService.findByThemeValueAndNameAndValueAndEnable("WarehouseLocation",byCode.getArea(),byCode.getSeries(), true);
                if (null != warehouseLocation){
                    warehouseCode = warehouseLocation.getExtendValue1();
                    umlgo = warehouseLocation.getExtendValue2();
                    warehouseCodeMaterial = warehouseLocation.getExtendValue();
                }
            }
            CrystalMaterialRelation crystalMaterialRelation = crystalMaterialRelationService.findBySectionNo(bySectionNo.getCrystalNo());
            if(null == crystalMaterialRelation){
                throw new BusinessException("未经过截断机，排程订单未关联，请核对数据！");
            }
            Result<WarehouseInputReturnDto> warehouseInputReturnDtoResult = this.sendWarehouseInputBillBo(byCrystalNo, null != bySectionNo.getActualWeight() ? bySectionNo.getActualWeight() :  bySectionNo.getTheoryWeight() , InputBillStatusEnum.截断入库.getValue(),umlgo,warehouseCode,crystalMaterialRelation);
            if (null == warehouseInputReturnDtoResult){
                throw new BusinessException("设备入库申请失败，返回为空");
            }
            if (warehouseInputReturnDtoResult.getCode() != ResultCode.SUCCESS.getCode()){
                log.info("线边仓出库失败:{}",warehouseInputReturnDtoResult.getMessage());
                throw new BusinessException("设备入库申请失败，异常信息为：" + warehouseInputReturnDtoResult.getMessage());
            }
            String weigth = (null != bySectionNo.getActualWeight() ? bySectionNo.getActualWeight().toString() :  bySectionNo.getTheoryWeight().toString());
            Date date = new Date();

            this.sendReportSapGoodsmvt("101",byCode.getSeries(),crystalMaterialRelation.getOrderNo(),byCrystalNo.getProductCode(),byCrystalNo.getBatchNo(),weigth,"KG","5041",warehouseCode,processingOrderCode,umlgo,EnumValuesFactory.WipStorageCode.开方.getValue());
            //报工时
            ReportSapGoodsmvt byCrystalNoAndBwart = reportSapGoodsmvtService.findByCrystalNoAndBwart(byCrystalNo.getCrystalNo(), "261");
            if (null != byCrystalNoAndBwart && null != byCrystalNoAndBwart.getBldat()){
                ReportSapWorkinghours reportSapWorkinghours = new ReportSapWorkinghours();
                String cnfTime = new BigDecimal((date.getTime() - byCrystalNoAndBwart.getBldat().getTime()) / 3600000).setScale(2, BigDecimal.ROUND_HALF_UP).toString();
                reportSapWorkinghours.setCnfTimeUom("H");
                reportSapWorkinghours.setCnfTime(cnfTime);
                reportSapWorkinghours.setStatus(false);
                reportSapWorkinghours.setCnfQty1(weigth);
                reportSapWorkinghours.setPlant("5041");
                reportSapWorkinghours.setProductionOrderId(byCrystalNoAndBwart.getAufnr());
                reportSapWorkinghours.setRecordId(byCrystalNoAndBwart.getCharg());
                //reportSapWorkinghours.setPlant(warehouseInputReturnDto.getCustomer());
                reportSapWorkinghoursService.saveOrUpdate(reportSapWorkinghours);
            }

            //SAP 消耗
            this.sendReportSapGoodsmvt("261",byCode.getSeries(),crystalMaterialRelation.getOrderNo(),byCrystalNo.getProductCode(),byCrystalNo.getBatchNo(),weigth,"KG","5041",warehouseCodeMaterial,processingOrderCode,null,EnumValuesFactory.WipStorageCode.开方.getValue());


            //消耗
            //this.handleReportSap(result, "开方材料仓", byCrystalNo, processingOrderCode,deviceCode,null != bySectionNo.getActualWeight() ? bySectionNo.getActualWeight() :  bySectionNo.getTheoryWeight(),EnumValuesFactory.WipStorageCode.开方.getValue());
        }
    }

    private void handleReportSap(Result<FbScheduleDto> result,String type,LongCrystal byCrystalNo,String processingOrderCode,String deviceCode,BigDecimal weigth,String procName){

        FbScheduleDto fbScheduleDto = result.getData();
        WarehouseOutputBillBo outputBillBo = new WarehouseOutputBillBo();
        outputBillBo.setType(type);
        outputBillBo.setAutoAudit(true);
        outputBillBo.setDestination("车间");
        List<WarehouseOutputBillDetailBo> inputBillDetails = new ArrayList<>();
        WarehouseOutputBillDetailBo warehouseOutputBillDetailBo = modelMapper.map(fbScheduleDto,WarehouseOutputBillDetailBo.class);

        warehouseOutputBillDetailBo.setBatchNo(byCrystalNo.getBatchNo());
        warehouseOutputBillDetailBo.setUnitName("KG");
        warehouseOutputBillDetailBo.setRequireCount(weigth);
//            warehouseOutputBillDetailBo.setUniqueCode(processingOrderCode);
        inputBillDetails.add(warehouseOutputBillDetailBo);
        outputBillBo.setOutputBillDetails(inputBillDetails);
        Equipment byCode = equipmentService.findByCode(deviceCode);
        String warehouseCode = "";
        String warehouseName = "";
        if (null != byCode){
            DictionaryItem  warehouseLocation = dictionaryItemService.findByThemeValueAndNameAndValueAndEnable("WarehouseLocation",byCode.getArea(),byCode.getSeries(), true);
            if (null != warehouseLocation){
                warehouseCode = warehouseLocation.getExtendValue();
                warehouseName = warehouseLocation.getExtendValue2();
            }
        }
        warehouseOutputBillDetailBo.setWarehouseName(warehouseName);
        Result<WarehouseInputReturnDto> resultStore = storeFeignClients.outputApplyData(outputBillBo);
        log.info("线边仓出库:{}",JSONObject.toJSONString(outputBillBo));
        if (null == resultStore || resultStore.getCode() != ResultCode.SUCCESS.getCode()){
            log.info("线边仓出库失败:{}",resultStore.getMessage());
            throw new BusinessException("线边仓出库失败，异常信息为：" + resultStore.getMessage());
        }
        //调整为长晶棒料号
        this.sendReportSapGoodsmvt("261",byCode.getSeries(),fbScheduleDto.getOrderNo(),byCrystalNo.getProductCode(),byCrystalNo.getBatchNo(),weigth.toString(),"KG","5041",warehouseCode,processingOrderCode,null,procName);
    }

    /**
     *
     * @param bwart 移动类型
     * @param kostl 成本中心
     * @param aufnr SAP生产订单
     * @param matnr 物料编码
     * @param charg  批次号
     * @param menge  数量
     * @param meins 单位
     */
    public void sendReportSapGoodsmvt(String bwart,String kostl,String aufnr,String matnr,String charg,String menge,String meins,String werks,String lgort,String crystalNo,String umlgo,String procName){
        ReportSapGoodsmvt reportSap = new ReportSapGoodsmvt();
        reportSap.setBwart(bwart);
        //reportSap.setKostl(kostl);
        reportSap.setAufnr(aufnr);
        reportSap.setMatnr(matnr);
        reportSap.setCharg(charg);
        reportSap.setMenge(menge);
        reportSap.setWerks(werks);
        reportSap.setLgort(lgort);
        reportSap.setMeins(meins);
        reportSap.setCrystalNo(crystalNo);
        reportSap.setBldat(new Date());
        reportSap.setProcName(procName);
        if (StringUtils.isNotBlank(umlgo) && StringUtils.equals("101",bwart)){
            ReportSapGoodsmvt reportSapAllocate = new ReportSapGoodsmvt();
            BeanUtil.copyBeanPropWithNullValue(reportSapAllocate, reportSap, "id");
            reportSapAllocate.setUmlgo(umlgo);
            reportSapAllocate.setBwart("Z41");
            reportSapAllocate.setUmwrk("5041");
            reportSapAllocate.setUmcha(charg);
            reportSapGoodsmvtService.saveOrUpdate(reportSapAllocate);
        }
        reportSapGoodsmvtService.saveOrUpdate(reportSap);
    }

    public Result sendWarehouseInputBillBo(LongCrystal longCrystal,BigDecimal weight,String type,String umlgo,String warehouseCode,CrystalMaterialRelation crystalMaterialRelation){
        WarehouseInputBillBo warehouseInputBillBo = new WarehouseInputBillBo();
        warehouseInputBillBo.setCreateUserName(BaseContextHandler.getUsername());
        warehouseInputBillBo.setCreateUserId(BaseContextHandler.getUserID());
        warehouseInputBillBo.setType(type);
        warehouseInputBillBo.setAutomaticOut(true);
        warehouseInputBillBo.setAutoAudit(true);
        if (StringUtils.isBlank(longCrystal.getProductCode())){
            throw new RuntimeException("料号为空！");
        }
        MaterialModel byCode = materialModelService.findByCode(longCrystal.getProductCode());
        if(null == byCode){
            throw new RuntimeException("物料主数据为空！");
        }
        List<WarehouseInputBillDetailBo> inputBillDetails = new ArrayList<>();
        WarehouseInputBillDetailBo warehouseInputBillDetailBo = new WarehouseInputBillDetailBo();
        warehouseInputBillDetailBo.setCount(weight);
        warehouseInputBillDetailBo.setMaterialModelId(Long.valueOf(byCode.getId()));
        warehouseInputBillDetailBo.setMaterialModelCode(byCode.getCode());
        Result<WarehouseModelDto> warehouseCodeResult = storeFeignClients.getCode(warehouseCode);
        if (warehouseCodeResult.getCode() == ResultCode.SUCCESS.getCode()){
            warehouseInputBillDetailBo.setWarehouseId(warehouseCodeResult.getData().getId());
        }
        warehouseInputBillDetailBo.setWarehouseCode(warehouseCode);
        //warehouseInputBillDetailBo.setWarehouseName(warehouseCode);
        Result<WarehouseModelDto> codeResult = storeFeignClients.getCode(warehouseCode);
        if (codeResult.getCode() == ResultCode.SUCCESS.getCode()){
            warehouseInputBillDetailBo.setWarehouseId(codeResult.getData().getWarehouseId());
        }
        warehouseInputBillDetailBo.setMaterialModelName(byCode.getName());
        warehouseInputBillDetailBo.setWeight(weight);
        if (null != byCode.getMaterialType()){
            warehouseInputBillDetailBo.setMaterialTypeName(byCode.getMaterialType().getName());
        }

        warehouseInputBillDetailBo.setBatchNo(longCrystal.getBatchNo());
        if(null != byCode.getUnit()){
            warehouseInputBillDetailBo.setUnitName(byCode.getUnit().getName());
        }
        warehouseInputBillDetailBo.setSupplier(byCode.getSupplier());
        warehouseInputBillDetailBo.setSpecification(byCode.getSpecification());
        warehouseInputBillDetailBo.setMaterialTh(byCode.getNumberOfDrawings());
        inputBillDetails.add(warehouseInputBillDetailBo);
        warehouseInputBillBo.setInputBillDetails(inputBillDetails);
//        Result<WarehouseInputReturnDto> warehouseInputReturnDtoResult = storeFeignClients.inputApplyData(warehouseInputBillBo);
//        if (StringUtils.isNotBlank(umlgo) && null != warehouseInputReturnDtoResult && warehouseInputReturnDtoResult.getCode() == ResultCode.SUCCESS.getCode()){
        WarehouseAllotBillDto warehouseAllotBillDto = new WarehouseAllotBillDto();
        warehouseAllotBillDto.setCreateUserName(BaseContextHandler.getUsername());
        warehouseAllotBillDto.setCreateUserId(BaseContextHandler.getUserID());
        List<WarehouseAllotBillDetailDto> allotBillDetailDtos = new ArrayList<>();
        WarehouseAllotBillDetailDto warehouseAllotBillDetailDto = new WarehouseAllotBillDetailDto();
        BeanUtil.copyBeanPropWithNullValue(warehouseAllotBillDetailDto, warehouseInputBillDetailBo, "id");
        warehouseAllotBillDetailDto.setAllotWarehouseName(umlgo);
        warehouseAllotBillDetailDto.setAllotWarehouseCode(umlgo);
        Result<WarehouseModelDto> umlgoResult = storeFeignClients.getCode(umlgo);
        if (umlgoResult.getCode() == ResultCode.SUCCESS.getCode()){
            warehouseAllotBillDetailDto.setAllotWarehouseId(umlgoResult.getData().getId());
        }
        allotBillDetailDtos.add(warehouseAllotBillDetailDto);
        warehouseAllotBillDto.setAllotBillDetailDtos(allotBillDetailDtos);
        warehouseAllotBillDto.setAutoAudit(true);
//            Result allotBill = storeFeignClients.createAllotBill(warehouseAllotBillDto);
        StoreDto storeDto = new StoreDto();
        storeDto.setWarehouseAllotBillDto(warehouseAllotBillDto);
        storeDto.setInputBillBo(warehouseInputBillBo);
        if (null != crystalMaterialRelation){
            if (null == crystalMaterialRelation.getMaterialModelId()){
                throw new RuntimeException("未找到截断入库关联物料数据为空！");
            }
            MaterialModel materialModel = materialModelService.get(crystalMaterialRelation.getMaterialModelId());
            if (null == materialModel){
                throw new RuntimeException("关联的物料主数据为空！");
            }

            WarehouseOutputBillBo outputBillBo = new WarehouseOutputBillBo();
            outputBillBo.setType(type);
            outputBillBo.setDestination("车间");
            outputBillBo.setAutoAudit(true);
            List<WarehouseOutputBillDetailBo> warehouseOutputBillDetailBos = new ArrayList<>();
            WarehouseOutputBillDetailBo warehouseOutputBillDetailBo = new WarehouseOutputBillDetailBo();
            warehouseOutputBillDetailBo.setMaterialModelCode(materialModel.getCode());
            warehouseOutputBillDetailBo.setMaterialModelId(Long.valueOf(materialModel.getId()));
            warehouseOutputBillDetailBo.setMaterialModelName(materialModel.getName());
            if (null != materialModel.getMaterialType()){
                warehouseOutputBillDetailBo.setMaterialTypeName(materialModel.getMaterialType().getName());
            }
            warehouseOutputBillDetailBo.setSpecification(materialModel.getSpecification());

            if (null != materialModel.getUnit()){
                warehouseOutputBillDetailBo.setUnitName(materialModel.getUnit().getName());
            }
            warehouseOutputBillDetailBo.setMaterialTh(materialModel.getNumberOfDrawings());
            warehouseOutputBillDetailBo.setSupplier(materialModel.getSupplier());
            if (umlgoResult.getCode() == ResultCode.SUCCESS.getCode()){
                warehouseOutputBillDetailBo.setWarehouseId(umlgoResult.getData().getId());
            }
            warehouseOutputBillDetailBo.setBatchNo(longCrystal.getBatchNo());
            warehouseOutputBillDetailBo.setWarehouseName(umlgo);
            warehouseOutputBillDetailBo.setUnitName("KG");
            warehouseOutputBillDetailBo.setRequireCount(weight);
//            warehouseOutputBillDetailBo.setUniqueCode(processingOrderCode);
            warehouseOutputBillDetailBos.add(warehouseOutputBillDetailBo);
            outputBillBo.setOutputBillDetails(warehouseOutputBillDetailBos);
            storeDto.setOutputBillBo(outputBillBo);
        }
        log.info("创建入库单AND调拨单AND出库单接口:{}",JSONObject.toJSONString(storeDto));
        long l = System.currentTimeMillis();
        Result inputAndAllotAndOut = storeFeignClients.createInputAndAllotAndOut(storeDto);
        log.info("接口耗时：{}",System.currentTimeMillis() -l);
       /*     if (null == allotBill || allotBill.getCode() != ResultCode.SUCCESS.getCode()){
                throw new RuntimeException("线边仓调拨失败！返回异常为：" + allotBill.getMessage());
            }
//        }*/
        return inputAndAllotAndOut;
    }
}
