package com.sw.mes.yb.check.service.impl;

import com.sw.mes.base.factory.inspect.service.DefaultSampleService;
import com.sw.mes.base.factory.utils.PageUtils;
import com.sw.mes.base.system.service.DictionaryItemService;
import com.sw.mes.base.system.service.DictionaryThemeService;
import com.sw.mes.config.rabbit.InspectDataBaseChangeAsync;
import com.sw.mes.core.api.system.FbFeignClients;
import com.sw.mes.core.base.BaseServiceImpl;
import com.sw.mes.core.context.BaseContextHandler;
import com.sw.mes.core.entity.SearchFilter;
import com.sw.mes.core.enums.SectionIndexRangeEnum;
import com.sw.mes.core.utils.DateUtil;
import com.sw.mes.core.utils.DynamicSpecifications;
import com.sw.mes.core.utils.RequestPage;
import com.sw.mes.enumvalue.EnumValuesServer;
import com.sw.mes.inspect.dao.YbInspectDataDao;
import com.sw.mes.inspect.entity.YbInspectData;
import com.sw.mes.inspect.service.YbInspectDataService;
import com.sw.mes.utils.ExcelUtil;
import com.sw.mes.yb.check.dao.PieceCheckDAO;
import com.sw.mes.yb.check.entity.PieceCheck;
import com.sw.mes.yb.check.event.ProductOxygenRealErrorEvent;
import com.sw.mes.yb.check.service.PieceCheckService;
import com.sw.mes.yb.check.service.UpdateService;
import com.sw.mes.yb.pad.dao.SectionNoDetailDao;
import com.sw.mes.yb.pad.entity.*;
import com.sw.mes.yb.pad.service.ProductionPaintingLineDetailService;
import com.sw.mes.yb.pad.service.ProductionPaintingLineService;
import com.sw.mes.yb.pad.service.ProductionRecutService;
import com.sw.mes.yb.production.dao.LongCrystalDao;
import com.sw.mes.yb.production.entity.LongCrystal;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import org.springframework.web.multipart.MultipartFile;

import java.math.BigDecimal;
import java.util.*;

@Service
@Transactional
public class PieceCheckServiceImpl extends BaseServiceImpl<PieceCheck> implements PieceCheckService {

    PieceCheckDAO pieceCheckDAO;

    @Autowired
    private ApplicationContext applicationContext;

    @Autowired
    private DictionaryThemeService dictionaryThemeService;


    @Autowired
    private LongCrystalDao longCrystalDao;

    @Autowired
    private SectionNoDetailDao sectionNoDetailDao;


    @Autowired
    private YbInspectDataDao inspectDataBaseDao;

    @Autowired
    private YbInspectDataService inspectDataBaseService;

    @Autowired
    private DefaultSampleService defaultSampleService;

    @Autowired
    private InspectDataBaseChangeAsync inspectDataBaseChangeAsync;

    @Autowired
    private YbInspectDataService ybInspectDataService;

    @Autowired
    FbFeignClients fbFeignClients;

    @Autowired
    private UpdateService updateService;

    @Autowired
    private ProductionRecutService productionRecutService;

    @Autowired
    private ProductionPaintingLineService productionPaintingLineService;

    @Autowired
    private ProductionPaintingLineDetailService productionPaintingLineDetailService;

    @Autowired
    public void setDao(PieceCheckDAO pieceCheckDAO) {
        this.pieceCheckDAO = pieceCheckDAO;
        super.setBaseDao(pieceCheckDAO);
    }

    private Logger logger = LoggerFactory.getLogger(this.getClass());


    @Autowired
    private DictionaryItemService dictionaryItemService;

    @Override
    public List<PieceCheck> findByExample(Specification<PieceCheck> specification, RequestPage page) {
        org.springframework.data.domain.Page<PieceCheck> springDataPage = pieceCheckDAO.findAll(specification, PageUtils.createPageable(page));
        page.setTotal(springDataPage.getTotalElements());
        return springDataPage.getContent();
    }

    @Override
    public PieceCheck getByPieceNo(String pieceNo) {

        List<PieceCheck> pieceChecks = pieceCheckDAO.findByPieceNo(pieceNo);
        if (pieceChecks != null && pieceChecks.size() > 0) {
            return pieceChecks.get(0);
        }
        return null;
    }

    @Override
    public void saveOrUpdateInBatch(List<PieceCheck> pieceChecks, String type) {
        saveAll(pieceChecks);
        String username = BaseContextHandler.getUsername();
        final List<PieceCheck> finalJsonString = pieceChecks;
    }

    @Override
    public List<PieceCheck> findAll(Specification<PieceCheck> specification) {
        return pieceCheckDAO.findAll(specification);
    }

    @Override
    public int findCountByPieceNo(List<String> samples) {
        return pieceCheckDAO.findCountByPieceNo(samples);
    }

    @Override
    public List<PieceCheck> findByMotherCrystalNo(String samples) {
        return pieceCheckDAO.findCountByMotherCrystalNo(samples);
    }

    @Override
    public List<PieceCheck> findPieceNosByPieceNo(List<String> samples) {
        return pieceCheckDAO.findPieceNosByPieceNo(samples);
    }

    /*

     * 评级
     *
     * @param
     */
    // @Override
//    public List<InspectData> grandInspect(List<PieceCheck> pieceChecks) {
//        List<InspectData> list=new ArrayList<>();
//
//        for (PieceCheck pieceCheck : pieceChecks) {
//            if (pieceCheck.getCheckTime1() != null && pieceCheck.getCheckTime2() != null) {
//
////                Map<String, List<String>> sectionNos = sectionDetailService.findSectionNosNew(pieceCheck.getPieceNo());
//                Map<String, List<String>> sectionNos = sectionDetailService.getSectionNosByPieceNo(pieceCheck.getPieceNo());
//                if (sectionNos != null && sectionNos.size() > 0) {
//                    List<InspectData> inspects = new ArrayList<>();
//                    List<String> heads = sectionNos.get("heads");
//                    List<String> tails = sectionNos.get("tails");
//                    List<String> nos = new ArrayList<>();
//                    nos.addAll(heads);
//                    nos.addAll(tails);
//
//                    List<WipState> wipStates = wipStateService.findBySnIn(nos);
//                    Map<String, WipState> map = new HashMap<>();
//                    for (WipState item: wipStates) {
//                        map.put(item.getSn(), item);
//                    }
//
//                    if (heads.size() > 0) {
//                        List<InspectData> headInspects = inspectService.findBySectionNoIn(heads);
//                        if (headInspects != null && headInspects.size() > 0) {
//                            for (InspectData inspect : headInspects) {
//
//                                // 已入库申请，不进行 赋值、评级
//                                if (map.containsKey(inspect.getSectionNo())) {
//                                    WipState wipState = map.get(inspect.getSectionNo());
//                                    if (WipStateEnum.方棒.getKey().equals(wipState.getState())) {
//                                        continue;
//                                    }
//                                }
//
//                                inspect.setPieceNoTail(pieceCheck.getPieceNo());
//                                inspect.setPassivationLifeTail(pieceCheck.getLifeTime());
//                                inspect.setMicrodefectTail(pieceCheck.getMicroDefect());
//                                inspect.setDislocationTail(pieceCheck.getLineDefect());
//                                inspect.setOxygenContentTail(pieceCheck.getoContents());
//                                inspect.setOxygenContentBorderTail(pieceCheck.getoBorderContents());
//                                inspect.setCarbonContentTail(pieceCheck.getcContents());
//                                inspect.setCarbonContentBorderTail(pieceCheck.getcBorderContents());
//                                inspect.setAnnealTailCenter(pieceCheck.getCenterAnneal());
//                                inspect.setAnnealTailBorder(pieceCheck.getBorderAnneal());
////                              inspect.setStickLifeTail(pieceCheck.getLifeTime());
//
//                                try {
//                                    inspectService.judgeExcel(inspect);
//                                } catch (Exception e) {
//                                    logger.error("logger-----样片检验评级异常信息[" + inspect.getSectionNo() + "]:" + e.getMessage());
//                                }
//                                inspects.add(inspect);
//                            }
//
//                        }
//                    }
//
//                    if (tails.size() > 0) {
//                        List<InspectData> tailInspects = inspectService.findBySectionNoIn(tails);
//                        if (tailInspects != null && tailInspects.size() > 0) {
//                            for (InspectData inspect : tailInspects) {
//
//                                // 已入库申请，不进行 赋值、评级
//                                if (map.containsKey(inspect.getSectionNo())) {
//                                    WipState wipState = map.get(inspect.getSectionNo());
//                                    if (WipStateEnum.方棒.getKey().equals(wipState.getState())) {
//                                        continue;
//                                    }
//                                }
//
//                                inspect.setPieceNoHead(pieceCheck.getPieceNo());
//                                inspect.setPassivationLifeHead(pieceCheck.getLifeTime());
//                                inspect.setMicrodefectHead(pieceCheck.getMicroDefect());
//                                inspect.setDislocationHead(pieceCheck.getLineDefect());
//                                inspect.setOxygenContentHead(pieceCheck.getoContents());
//                                inspect.setOxygenContentBorderHead(pieceCheck.getoBorderContents());
//                                inspect.setCarbonContentHead(pieceCheck.getcContents());
//                                inspect.setCarbonContentBorderHead(pieceCheck.getcBorderContents());
//                                inspect.setAnnealHeadCenter(pieceCheck.getCenterAnneal());
//                                inspect.setAnnealHeadBorder(pieceCheck.getBorderAnneal());
////                              inspect.setStickLifeHead(pieceCheck.getLifeTime());
//
//                               try {
//                                    inspectService.judgeExcel(inspect);
//                                } catch (Exception e) {
//                                    logger.error("logger-----样片检验评级异常信息[" + inspect.getSectionNo() + "]:" + e.getMessage());
//                                }
//                                inspects.add(inspect);
//                            }
//
//                        }
//                    }
//
//                    if (inspects.size() > 0) {
//                        inspectService.updateInBatch(inspects);
//                        list.addAll(inspects);
//                    }
//                }
//
//            }
//        }
//        return list;
//    }

    @Override
    public void readExcelFile(MultipartFile file) throws Exception {
        Map<String, List<Map<String, Object>>> excelMap = null;
        List<PieceCheck> pieceChecks = new ArrayList<PieceCheck>();
        Date date = new Date();
        try {
            excelMap = ExcelUtil.getExcelInfo(file);
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception("文件导入异常！" + e.getMessage());
        }
        List<String> pieceNos = new ArrayList<>();
        if (excelMap != null && !excelMap.isEmpty()) {
            Collection<List<Map<String, Object>>> collection = excelMap.values();
            Iterator<List<Map<String, Object>>> iterator = collection.iterator();

            //判断该Excel是否包含相同编号的样片
            Map<String, PieceCheck> pieceCheckMap = new HashMap<>();

            while (iterator.hasNext()) {
                List<Map<String, Object>> list = iterator.next();
                if (list.size() > 10000) {
                    throw new Exception("每批次导入限制[10000]，该批次为：" + list.size());
                }
                for (Map<String, Object> map : list) {
                    PieceCheck pieceCheck = null;
                    String no = String.valueOf(map.get("序号")).trim();
                    String pieceNo = String.valueOf(map.get("样片编号")).trim();
                    LongCrystal byCrystalNo = longCrystalDao.findByCrystalNo(pieceNo);
                    if (null != byCrystalNo) {
                        throw new Exception("【" + pieceNo + "】编号为长晶棒编号，非样片编号");
                    }
                    if ("null".equals(pieceNo) || StringUtils.isBlank(pieceNo)) {
                        continue;
                    }
                    //查看样片检验是否存在该样片检验数据
                    pieceCheck = getByPieceNo(pieceNo);
                    if (pieceCheck == null) {
                        if (pieceCheckMap.containsKey(pieceNo)) {
                            pieceCheck = pieceCheckMap.get(pieceNo);
                        } else {
                            pieceCheck = new PieceCheck();
                            pieceCheck.setPieceNo(pieceNo);
                            pieceCheckMap.put(pieceNo, pieceCheck);
                        }
                    }
                    //载具编号 [新加]
                    String batchNo = String.valueOf(map.get("载具编号")).trim();
                    if (!StringUtils.isBlank(batchNo)) {
                        pieceCheck.setBatchNo(batchNo);
                    }

                    //母单晶编号 [新加]
                    String motherCrystalNo = String.valueOf(map.get("母单晶编号")).trim();
                    if (!StringUtils.isBlank(motherCrystalNo)) {
                        pieceCheck.setMotherCrystalNo(motherCrystalNo);
                    }

                    //炉次号 [新加]
                    String lotNo = String.valueOf(map.get("炉次号")).trim();
                    if (!StringUtils.isBlank(lotNo)) {
                        pieceCheck.setLotNo(lotNo);
                    }

                    //设备编号 [新加]
                    String deviceNo = String.valueOf(map.get("设备编号")).trim();
                    if (!StringUtils.isBlank(deviceNo)) {
                        pieceCheck.setDeviceNo(deviceNo);
                    }


//                    //车间
//                    String workShop = String.valueOf(map.get("车间")).trim();
//                    if (!StringUtils.isBlank(workShop)) {
//                        pieceCheck.setWorkshop(workShop);
//                    }
//                    //微缺陷
//                    String microDefect = String.valueOf(map.get("微缺陷")).trim();
//                    if (StringUtils.isBlank(microDefect)) {
//                        pieceCheck.setMicroDefect("无");
//                    } else {
//                        pieceCheck.setMicroDefect(microDefect);
//                    }
//                    //位错
//                    String lineDefect = String.valueOf(map.get("位错")).trim();
//                    if (StringUtils.isBlank(lineDefect)) {
//                        pieceCheck.setLineDefect("无");
//                    } else {
//                        pieceCheck.setLineDefect(lineDefect);
//                    }

                    //备注1
                    String remark1 = String.valueOf(map.get("备注1")).trim();
                    if (!StringUtils.isBlank(remark1)) {
                        pieceCheck.setRemark1(remark1);
                    }

                    //碳氧含量检验时间【检验时间1】
                    String checkTime1Str = String.valueOf(map.get("检验时间1")).trim();
                    if (!StringUtils.isBlank(checkTime1Str)) {
                        try {
                            Date checkTime1 = DateUtil.toDate(checkTime1Str, "yyyy-MM-dd HH:mm:ss");
                            pieceCheck.setCheckTime1(checkTime1);
                        } catch (Exception e) {
                            throw new Exception("序号：" + no + " 检验时间1格式错误！");
                        }
                    }
//                    else {
//                        pieceCheck.setCheckTime1(date);
//                    }

                    //碳含量中心
                    String cContents = String.valueOf(map.get("碳含量中心")).trim();
                    if (!StringUtils.isBlank(cContents)) {
                        try {
                            BigDecimal decimalC = new BigDecimal(cContents);
                            pieceCheck.setcContents(decimalC);
                        } catch (Exception e) {
                            throw new Exception("序号：" + no + " 碳含量中心格式错误！");
                        }
                    } else {
                        throw new Exception("序号：" + no + "请输入碳含量中心！");
                    }

//                    //缺陷位错备注
//                    String remark1 = String.valueOf(map.get("缺陷位错备注")).trim();
//                    if (!StringUtils.isBlank(lineDefect)) {
//                        pieceCheck.setRemark1(remark1);
//                    }

                    //}

                    //氧含量中心
                    String oContents = String.valueOf(map.get("氧含量中心")).trim();
                    if (!StringUtils.isBlank(oContents)) {
                        try {
                            BigDecimal decimalO = new BigDecimal(oContents);
                            pieceCheck.setoContents(decimalO);
                        } catch (Exception e) {
                            throw new Exception("序号：" + no + " 氧含量中心格式错误！");
                        }
                    } else {
                        throw new Exception("序号：" + no + " 请输入氧含量中心！");

                    }

                    //样片厚度
                    String thickness = String.valueOf(map.get("样片厚度")).trim();
                    if (!StringUtils.isBlank(thickness)) {
                        try {
                            BigDecimal thicknessZ = new BigDecimal(thickness);
                            pieceCheck.setThickness(thicknessZ);
                        } catch (Exception e) {
                            throw new Exception("序号：" + no + " 样片厚度格式错误！");
                        }
                    } else {
                        throw new Exception("序号：" + no + " 请输入样片厚度！");

                    }

                    //碳氧含量备注
                    String remark2 = String.valueOf(map.get("备注2")).trim();
                    if (!StringUtils.isBlank(remark2)) {
                        pieceCheck.setRemark2(remark2);
                    }

                    //缺陷位错检验人【检验人1】
                    String userName1 = String.valueOf(map.get("检验人1")).trim();
                    if (!StringUtils.isBlank(userName1)) {//
                        pieceCheck.setUserName1(userName1);
                    }

                    //碳氧含量检验时间【检验时间2】
                    String checkTime2Str = String.valueOf(map.get("检验时间2")).trim();
                    if (!StringUtils.isBlank(checkTime2Str)) {
                        try {
                            Date checkTime2 = DateUtil.toDate(checkTime2Str, "yyyy-MM-dd HH:mm:ss");
                            pieceCheck.setCheckTime2(checkTime2);
                        } catch (Exception e) {
                            throw new Exception("序号：" + no + " 检验时间2格式错误！");
                        }
                    } else {
                        //pieceCheck.setCheckTime2(date);
                        throw new Exception("序号：" + no + " 请输入检验时间2！");
                    }

                    //寿命
//                    String life = String.valueOf(map.get("寿命")).trim();
//                    if (!StringUtils.isBlank(life)) {
//                        try {
//                            BigDecimal decimalLife = new BigDecimal(life);
//                            pieceCheck.setLifeTime(decimalLife);
//                        } catch (Exception e) {
//                            throw new Exception("序号：" + no + " 寿命格式错误！");
//                        }
//                    }

                    //碳氧含量检验人【检验人2】
                    pieceCheck.setUserName2(BaseContextHandler.getUsername());
//                    String userName2 = String.valueOf(map.get("检验人2")).trim();
//                    if (!StringUtils.isBlank(userName2)) {
//                        pieceCheck.setUserName2(userName2);
//                    }
//                    //碳氧含量检验时间
//                    String checkTime2Str = String.valueOf(map.get("碳氧含量检验时间")).trim();
//                    if (!StringUtils.isBlank(checkTime2Str)) {
//                        try {
//                            Date checkTime2 = DateUtil.toDate(checkTime2Str, "yyyy-MM-dd HH:mm:ss");
//                            pieceCheck.setCheckTime2(checkTime2);
//                        } catch (Exception e) {
//                            throw new Exception("序号：" + no + " 碳氧含量检验时间格式错误！");
//                        }
//                    } else {
//                        pieceCheck.setCheckTime2(date);
//                    }
//                    //辅助测试人员
////                    String receiveUser = String.valueOf(map.get("辅助测试人员")).trim();
////                    if (!StringUtils.isBlank(receiveUser)) {
////                        pieceCheck.setReceiveUser(receiveUser);
////                    }
                    //检验时间1，检验时间2
//                    pieceCheck.setCheckTime1(date);
//                    pieceCheck.setCheckTime2(date);
                    //中心退火电阻率
                    String centerAnneal = String.valueOf(map.get("中心退火电阻率")).trim();
                    if (!StringUtils.isBlank(centerAnneal)) {
                        try {
                            BigDecimal decimalCenterAnneal = new BigDecimal(centerAnneal);
                            pieceCheck.setCenterAnneal(decimalCenterAnneal);
                        } catch (Exception e) {
                            throw new Exception("序号：" + no + " 中心退火电阻率格式错误！");
                        }
                    }
                    //边缘退火电阻率
                    String borderAnneal = String.valueOf(map.get("边缘退火电阻率")).trim();
                    if (!StringUtils.isBlank(borderAnneal)) {
                        try {
                            BigDecimal decimalBorderAnneal = new BigDecimal(borderAnneal);
                            pieceCheck.setBorderAnneal(decimalBorderAnneal);
                        } catch (Exception e) {
                            throw new Exception("序号：" + no + " 边缘退火电阻率格式错误！");
                        }
                    }

                    //Todo 数据字典配置圆棒检验PN规则，后面必填会变的
//                    DictionaryTheme dictionaryTheme = dictionaryThemeService.findByValue("nTypeRules");
//                    if (dictionaryTheme == null) {
//                        throw new Exception("请在数据字典配置圆棒检验PN型判断规则！");
//                    }
//                    String sec3 = pieceNo.substring(2, 3);//样片编号第三位
//                    DictionaryItem dictionaryItem = dictionaryItemService.findByNameAndThemeId(sec3, dictionaryTheme.getId());
//                    if (dictionaryItem == null) {
//                        throw new Exception("序号：" + no + " 没有圆棒检验PN型！");
//                    }


                    //碳含量边缘
                    //String ccs = String.valueOf(map.get("碳含量边缘")).trim();
                    //氧含量边缘
                    //String ocs = String.valueOf(map.get("氧含量边缘")).trim();
                    //Todo 也是后期需要修改
                    //if ("N".equals(dictionaryItem.getValue())) {
//                    if (!StringUtils.isBlank(ccs)) {
//                        try {
//                            BigDecimal cBorderContents = new BigDecimal(ccs);
//                            pieceCheck.setcBorderContents(cBorderContents);
//                        } catch (Exception e) {
//                            throw new Exception("序号：" + no + " 碳含量边缘格式错误！");
//                        }
//                    }
//
//                    if (!StringUtils.isBlank(ocs)) {
//                        try {
//                            BigDecimal oBorderContents = new BigDecimal(ocs);
//                            pieceCheck.setoBorderContents(oBorderContents);
//                        } catch (Exception e) {
//                            throw new Exception("序号：" + no + " 氧含量边缘格式错误！");
//                        }
//                    }
                    //                   }
//                else if ("P".equals(dictionaryItem.getValue())) {
//                        if (!StringUtils.isBlank(ccs)) {
//                            try {
//                                BigDecimal cBorderContents = new BigDecimal(ccs);
//                                pieceCheck.setcBorderContents(cBorderContents);
//                            } catch (Exception e) {
//                                throw new Exception("序号：" + no + " 碳含量边缘格式错误！");
//                            }
//                        }
//
//                        if (!StringUtils.isBlank(ocs)) {
//                            try {
//                                BigDecimal oBorderContents = new BigDecimal(ocs);
//                                pieceCheck.setoBorderContents(oBorderContents);
//                            } catch (Exception e) {
//                                throw new Exception("序号：" + no + " 氧含量边缘格式错误！");
//                            }
//                        }
//
//                    } else {
//                        throw new Exception("序号：" + no + " 不是P/N类型！");
//                    }

                    //退火电阻率检验人[检验人3]
                    String annealUser = String.valueOf(map.get("检验人3")).trim();
                    if (!StringUtils.isBlank(annealUser)) {
                        pieceCheck.setAnnealUser(annealUser);
                    }

                    //退火电阻率检验备注【备注3】
                    String annealRemark = String.valueOf(map.get("备注3")).trim();
                    if (!StringUtils.isBlank(annealRemark)) {
                        pieceCheck.setAnnealRemark(annealRemark);
                    }

                    //退火电阻率检验时间【检验时间3】
                    String checkTime3Str = String.valueOf(map.get("检验时间3")).trim();
                    if (!StringUtils.isBlank(checkTime3Str)) {
                        try {
                            Date checkTime3 = DateUtil.toDate(checkTime3Str, "yyyy-MM-dd HH:mm:ss");
                            pieceCheck.setAnnealTime(checkTime3);
                        } catch (Exception e) {
                            throw new Exception("序号：" + no + " 检验时间3格式错误！");
                        }
                    }
//                    else {
//                        pieceCheck.setAnnealTime(date);
//                    }
                    pieceChecks.add(pieceCheck);
                }
            }
            //对晶棒数据表，和样片检验表数据进行保存以及评级
            if (pieceChecks.size() > 0) {
                saveAll(pieceChecks);

                for (PieceCheck pieceCheck : pieceChecks) {
                    // 同步更新晶段检验样片信息
                    this.saveInspectDataBaseInfo(pieceCheck.getPieceNo());
                    String fromMark = pieceCheck.getPieceNo().substring(SectionIndexRangeEnum.基地追溯产品类型.getBeginIndex(), SectionIndexRangeEnum.基地追溯产品类型.getEndIndex());
                    if (fromMark.matches("[A-Z]+")) {
                        pieceNos.add(pieceCheck.getPieceNo().substring(SectionIndexRangeEnum.毛棒范围.getBeginIndex(),SectionIndexRangeEnum.毛棒范围.getEndIndex()));
                    }else {
                        pieceNos.add(pieceCheck.getPieceNo().substring(0, 12));
                    }
//                    ThreadManager.getThreadPollProxy().execute(() -> {
//                        try {
//                            fbFeignClients.synchronousUpdate(pieceCheck.getPieceNo().substring(0, 11));
//                        } catch (Exception e) {
//                            e.printStackTrace();
//                        }
//                    });
                }
//                final List<PieceCheck> grandInspects = pieceChecks;
//                Thread thread = new Thread(() -> {
//                    //grandInspect(grandInspects);
//                });
//                thread.start();
            }
        }
        updateService.updates(pieceNos);
    }

    @Override
    public Integer countByPieceNo(String pieceNo) {
        return pieceCheckDAO.countByPieceNoLike(pieceNo + "%");
    }

    @Override
    public List<PieceCheck> findByTime(Date beginTime, Date endTime) {
        Specification<PieceCheck> specification = DynamicSpecifications.bySearchFilter(PieceCheck.class,
                new SearchFilter("checkTime1", SearchFilter.Operator.GT, beginTime),
                new SearchFilter("checkTime1", SearchFilter.Operator.LT, endTime));
        List<PieceCheck> pieceCheckList = findByExampleSort(specification, null);
        return pieceCheckList;
    }

    @Override
    public List<String> findPieceCheckLotNoList(Date beginTime, Date endTime) {
        return pieceCheckDAO.findPieceCheckLotNoList(beginTime, endTime);
    }

    @Override
    public List<PieceCheck> findByLotNo(String lotNo) {
        Specification<PieceCheck> specification = DynamicSpecifications.bySearchFilter(PieceCheck.class,
                new SearchFilter("lotNo", SearchFilter.Operator.EQ, lotNo));
        List<PieceCheck> pieceCheckList = findByExampleSort(specification, null);
        return pieceCheckList;
    }

    @Override
    public void saveOrUpdateLineData(List<PieceCheck> pieceChecks) {
        saveAll(pieceChecks);

        final List<PieceCheck> finalJsonString = pieceChecks;

/*
        Thread thread = new Thread(() -> {
            grandInspectNew(finalJsonString);
        });
        thread.start();
*/

    }


    @Override
    public List<PieceCheck> getpieceCheck(String param, String series, String deviceNo, String lotNo, String motherCrystalNo, String startTime, String endTime, Sort sort) {
        Set<SearchFilter> searchSet = new HashSet<>(7);
        if (!StringUtils.isBlank(series)) {
            searchSet.add(new SearchFilter("deviceNo", SearchFilter.Operator.LIKE, series));
        }
        if (!StringUtils.isBlank(deviceNo)) {
            searchSet.add(new SearchFilter("deviceNo", SearchFilter.Operator.EQ, deviceNo));
        }
        if (!StringUtils.isBlank(lotNo)) {
            searchSet.add(new SearchFilter("lotNo", SearchFilter.Operator.EQ, lotNo));
        }
        if (!StringUtils.isBlank(motherCrystalNo)) {
            searchSet.add(new SearchFilter("motherCrystalNo", SearchFilter.Operator.EQ, motherCrystalNo));
        }
        if (!StringUtils.isBlank(startTime)) {
            searchSet.add(new SearchFilter("checkTime1", SearchFilter.Operator.GT, startTime));
        }
        if (!StringUtils.isBlank(endTime)) {
            searchSet.add(new SearchFilter("checkTime1", SearchFilter.Operator.LT, endTime));
        }
        // 氧含量不为空
        searchSet.add(new SearchFilter("oContents", SearchFilter.Operator.ISNOTNULL, ""));
        Specification<PieceCheck> specification = DynamicSpecifications.bySearchFilter(PieceCheck.class, searchSet);
        List<PieceCheck> pieceCheckList = findByExampleSort(specification, sort);
        return pieceCheckList;
    }

    @Override
    public void saveAll(List<PieceCheck> pieceChecks) {
        pieceCheckDAO.saveAll(pieceChecks);
        // spc异步监听
        applicationContext.publishEvent(new ProductOxygenRealErrorEvent(pieceChecks));
        inspectDataBaseChangeAsync.pieceCheckDataBaseChange(pieceChecks);
    }

    @Override
    public void saveOrUpdate(PieceCheck pieceCheck) {
        super.saveOrUpdate(pieceCheck);
        // spc异步监听
        List<PieceCheck> pieceCheckList = new ArrayList<>();
        pieceCheckList.add(pieceCheck);
        applicationContext.publishEvent(new ProductOxygenRealErrorEvent(pieceCheckList));
        inspectDataBaseChangeAsync.pieceCheckDataBaseChange(pieceCheckList);
    }

    @Override
    public void createPieceCheck(List<String> samples, String batchNo, String receiveUser, String workshop) {

        Map<String, SectionDetail> map = new HashMap<>();
        /*List<SectionDetail> details = sectionDetailService.findBySectionNos(samples);
        if (details != null && details.size() > 0) {
            for (SectionDetail detail : details) {
                map.put(detail.getSectionNo(), detail);
            }
        }*/

        List<PieceCheck> pieceChecks = new ArrayList<>();
        SectionDetail sectionDetail;
        for (String sample : samples) {
            PieceCheck pieceCheck = new PieceCheck();
            pieceCheck.setPieceNo(sample);
            pieceCheck.setBatchNo(batchNo);
            pieceCheck.setReceiveUser(receiveUser);
            pieceCheck.setWorkshop(workshop);

            if (map.containsKey(sample)) {
                sectionDetail = map.get(sample);
                if (sectionDetail != null) {
                    pieceCheck.setDeviceNo(sectionDetail.getDeviceNo());
                    pieceCheck.setMotherCrystalNo(sectionDetail.getCrystalNo());
                    pieceCheck.setLotNo(sectionDetail.getLotNo());
                }
            }
            pieceChecks.add(pieceCheck);
        }
        if (pieceChecks.size() > 0) {
            saveAll(pieceChecks);
        }

    }

    @Override
    public void saveInspectDataBaseInfo(String pieceNo) {
        PieceCheck pieceCheck = null;
        // 找到样片检验的数据
        List<PieceCheck> PieceNo = pieceCheckDAO.findByPieceNo(pieceNo);
        if (PieceNo != null && PieceNo.size() > 0) {
            pieceCheck = PieceNo.get(0);
        }

        // 通过样片编号找到晶段信息
        List<SectionNoDetail> sectionNoDetailList = sectionNoDetailDao.findSegmentNoBypieceNo(pieceNo);

        if (!CollectionUtils.isEmpty(sectionNoDetailList)){
            this.handleSectionNoInfo(sectionNoDetailList.get(0),pieceCheck,pieceNo);
        }
       /* SectionNoDetail sectionNoDetail = sectionNoDetailList.get(0);
        LongCrystal byCrystalNo = longCrystalDao.findByCrystalNo(sectionNoDetail.getCrystalNo());
        if (byCrystalNo.getClosureIdentification().equals(EnumValuesServer.FINALIDENTIFICATION)) {
            List<YbInspectData> inspectData1 = new ArrayList<>();
            for (SectionNoDetail noDetail : sectionNoDetailList) {
                inspectData1 = inspectDataBaseDao.findBySectionNo(noDetail.getSectionNo());
            }

            //查询划线记录
//            ProductionPaintingLine byCrystalNo1 = productionPaintingLineService.findByCrystalNo(byCrystalNo.getCrystalNo());
            List<ProductionPaintingLineDetail> byOperateDrawIdAndAndType = productionPaintingLineDetailService.findByOperateDrawIdAndAndType(byCrystalNo.getId(), 0);
            for (ProductionPaintingLineDetail productionPaintingLineDetail : byOperateDrawIdAndAndType) {
                List<YbInspectData> inspectData = inspectDataBaseDao.findBySectionNo(productionPaintingLineDetail.getNo());
                inspectData.addAll(inspectData1);
                if (inspectData.size() > 0) {
//                    YbInspectData inspectDataBase = inspectData.get(0);
                    for (YbInspectData inspectDataBase : inspectData) {
                        if(inspectDataBase.getIsCutBack() != 0){
                            continue;
                        }
                        List<ProductionBackCuttingRecord> allBySegmentNo = productionRecutService.findAllBySegmentNo(inspectDataBase.getSectionNo());
                        if (!CollectionUtils.isEmpty(allBySegmentNo)) {
                            continue;
                        }
                        // 头片
                        if (sectionNoDetail.getPieceNoHead() != null && sectionNoDetail.getPieceNoHead().equals(pieceNo)) {
                            if (pieceCheck != null) {
                                if (pieceCheck.getoContents() != null) {
                                    inspectDataBase.setEndOxygenContentHead(pieceCheck.getoContents());
                                }
                                if (pieceCheck.getcContents() != null) {
                                    inspectDataBase.setEndCarbonContentHead(pieceCheck.getcContents());
                                }
                                // 更新检验数据库头片信息
                                this.inspectDataBaseService.saveDataAndGrade(inspectDataBase);
                                try {
                                    //保存圆棒检验记录表
                                    ybInspectDataService.saveDataInspectLog(inspectDataBase);
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                            }
                            //尾片
                        } else if (sectionNoDetail.getPieceNoEnd() != null && sectionNoDetail.getPieceNoEnd().equals(pieceNo)) {
                            if (pieceCheck != null) {
                                if (pieceCheck.getoContents() != null) {
                                    inspectDataBase.setEndOxygenContentTail(pieceCheck.getoContents());
                                }

                                if (pieceCheck.getcContents() != null) {
                                    inspectDataBase.setEndCarbonContentTail(pieceCheck.getcContents());
                                }

                                // 更新检验数据库尾片信息
                                this.inspectDataBaseService.saveDataAndGrade(inspectDataBase);

                                try {
                                    ybInspectDataService.saveDataInspectLog(inspectDataBase);//保存圆棒检验记录表
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }

                            }
                        }
                    }
                }
            }

        }
        supplementaryData(pieceNo, pieceCheck, sectionNoDetailList);*/
    }

    private void handleSectionNoInfo(SectionNoDetail sectionNoDetail,PieceCheck pieceCheck,String pieceNo){
        if (null == sectionNoDetail || null == pieceCheck || StringUtils.isBlank(pieceNo)){
            return;
        }

        if (StringUtils.equals(pieceNo,sectionNoDetail.getPieceNoHead())){
            if (sectionNoDetail.getSectionPosiotion() == 1){
                List<SectionNoDetail> byCrystalNo = sectionNoDetailDao.findByCrystalNo(sectionNoDetail.getCrystalNo());
                for (SectionNoDetail sectionNoDetail1 : byCrystalNo){
                    this.handleContent(pieceCheck,sectionNoDetail1,true);
                }
            }else {
                this.handleContent(pieceCheck,sectionNoDetail,true);
            }
            return;
        }

        if (StringUtils.equals(pieceNo,sectionNoDetail.getPieceNoEnd())){
            String sampleTail = pieceNo.substring(2, 3);
            if (StringUtils.equals(sampleTail,"T")){
                List<SectionNoDetail> byCrystalNo = sectionNoDetailDao.findByCrystalNo(sectionNoDetail.getCrystalNo());
                for (SectionNoDetail sectionNoDetail2 : byCrystalNo){
                    this.handleContent(pieceCheck,sectionNoDetail2,false);
                }
            }else {
                this.handleContent(pieceCheck,sectionNoDetail,false);
            }
            return;
        }
    }

    private void handleContent(PieceCheck pieceCheck,SectionNoDetail sectionNoDetail,Boolean headFlag){
        if (null == pieceCheck || null == sectionNoDetail){
            return;
        }
        YbInspectData ybInspectData = inspectDataBaseService.findBySectionNo(sectionNoDetail.getSectionNo());
        if (null == ybInspectData){
            return;
        }
        if (headFlag){
            //T氧含量中心
            ybInspectData.setOxygenContentHead(pieceCheck.getoContents());
            //T碳含量中心
            ybInspectData.setCarbonContentHead(pieceCheck.getcContents());
        }else {
            //W氧含量中心
            ybInspectData.setOxygenContentTail(pieceCheck.getoContents());
            //W碳含量中心
            ybInspectData.setCarbonContentTail(pieceCheck.getcContents());
        }
        if (ybInspectData.getSectionNo().endsWith("T") || ybInspectData.getSectionNo().endsWith("A") || (null != sectionNoDetail.getSectionPosiotion() && sectionNoDetail.getSectionPosiotion() == 2)){
            this.inspectDataBaseService.saveDataAndGrade(ybInspectData);
        }else {
            inspectDataBaseService.saveOrUpdate(ybInspectData);
        }
    }

    private void supplementaryData(String pieceNo, PieceCheck pieceCheck, List<SectionNoDetail> sectionNoDetailList) {
        for (SectionNoDetail sectionNoDetail : sectionNoDetailList) {
            // 查询该晶段是否已经有检验数据
            List<YbInspectData> inspectData = inspectDataBaseDao.findBySectionNo(sectionNoDetail.getSectionNo());
            if (inspectData.size() > 0) {
                YbInspectData inspectDataBase = inspectData.get(0);
                List<ProductionBackCuttingRecord> allBySegmentNo = productionRecutService.findAllBySegmentNo(inspectDataBase.getSectionNo());
                if (!CollectionUtils.isEmpty(allBySegmentNo)) {
                    continue;
                }
                // 如果是头片
                if (sectionNoDetail.getPieceNoHead() != null && sectionNoDetail.getPieceNoHead().equals(pieceNo)) {
                    if (pieceCheck != null) {
                        if (pieceCheck.getoContents() != null) {
                            inspectDataBase.setOxygenContentHead(pieceCheck.getoContents());
                        }
//                        if (pieceCheck.getoBorderContents() != null) {//氧含量 边缘
//                            inspectDataBase.setOxygenContentBorder(pieceCheck.getoBorderContents());
//                        }
//                        else {
//                            // 改为空则引用默认值
//                            DefaultSample sample = this.defaultSampleService.findByDopantLikeAndSpecificationsLike(inspectDataBase.getDopant(), byCrystalNo.getSpecs());
//                            if (sample != null) {
//                                if (sample.getOxygenEdge().equals("/")) {
//                                    inspectDataBase.setOxygenContentBorder(null);
//                                } else {
//                                    inspectDataBase.setOxygenContentBorder(new BigDecimal(sample.getOxygenEdge()));
//                                }
//                            }
//                        }
                        if (pieceCheck.getcContents() != null) {
                            inspectDataBase.setCarbonContentHead(pieceCheck.getcContents());
                        }
//                        if (pieceCheck.getcBorderContents() != null) {// 边缘碳含量
//                            inspectDataBase.setCarbonContentBorder(pieceCheck.getcBorderContents());
//                        }
//                        else {
//                            // 改为空则引用默认值
//                            DefaultSample sample = this.defaultSampleService.findByDopantLikeAndSpecificationsLike(inspectDataBase.getDopant(), byCrystalNo.getSpecs());
//                            if (sample != null) {
//                                if (sample.getCarbonEdge().equals("/")) {
//                                    inspectDataBase.setCarbonContentBorder(null);
//                                } else {
//                                    inspectDataBase.setCarbonContentBorder(new BigDecimal(sample.getCarbonEdge()));
//                                }
//                            }
//                        }
                        if (pieceCheck.getCenterAnneal() != null) {
//                            inspectDataBase.setTCenterAnneal(pieceCheck.getCenterAnneal());
                        }
                        if (pieceCheck.getBorderAnneal() != null) {
//                            inspectDataBase.setTBorderAnneal(pieceCheck.getBorderAnneal());
                        }


                        // inspectDataBase.setHeadDefectGrade(pieceCheck.getMicroDefect());// 微缺陷一直用默认值
//                            if (com.sw.mes.common.utils.StringUtils.isNotBlank(pieceCheck.getLineDefect()) && pieceCheck.getLineDefect().contains("有")) {
//                                inspectDataBase.setIsMalposition(1);// 位错一直用默认值
//                            } else {
//                                inspectDataBase.setIsMalposition(0);
//                            }
                        // 导电型号是N才赋值
                        if (inspectDataBase.getConductiveType() != null && inspectDataBase.getConductiveType().equals("N") && pieceCheck.getCenterAnneal() != null) {
//                            // 中心退火电阻率
//                            inspectDataBase.setTCenterAnneal(pieceCheck.getCenterAnneal());
//                            // 边缘退火电阻率
//                            inspectDataBase.setTBorderAnneal(pieceCheck.getBorderAnneal());
                        }
                        // 更新检验数据库头片信息
                        this.inspectDataBaseService.saveDataAndGrade(inspectDataBase);


                        try {
                            ybInspectDataService.saveDataInspectLog(inspectDataBase);//保存圆棒检验记录表
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }

                    //尾片
                } else if (sectionNoDetail.getPieceNoEnd() != null && sectionNoDetail.getPieceNoEnd().equals(pieceNo)) {
                    if (pieceCheck != null) {
                        if (pieceCheck.getoContents() != null) {
                            inspectDataBase.setOxygenContentTail(pieceCheck.getoContents());
                        }
//                        if (pieceCheck.getoBorderContents() != null) {//氧含量 边缘
//                            inspectDataBase.setOxygenContentBorderTail(pieceCheck.getoBorderContents());
//                        }
//                            else {
//                            // 改为空则引用默认值
//                            DefaultSample sample = this.defaultSampleService.findByDopantLikeAndSpecificationsLike(inspectDataBase.getDopant(), byCrystalNo.getSpecs());
//                            // 氧含量边缘
//                            if (sample != null) {
//                                if (sample.getOxygenEdge().equals("/")) {
//                                    inspectDataBase.setOxygenContentBorderTail(null);
//                                } else {
//                                    inspectDataBase.setOxygenContentBorderTail(new BigDecimal(sample.getOxygenEdge()));
//                                }
//                            }
//                       }
                        if (pieceCheck.getcContents() != null) {
                            inspectDataBase.setCarbonContentTail(pieceCheck.getcContents());
                        }
//                        if (pieceCheck.getcBorderContents() != null) {// 边缘碳含量
//                            inspectDataBase.setCarbonContentBorderTail(pieceCheck.getcBorderContents());
//                        }
//                        else {
//                            // 改为空则引用默认值
//                            DefaultSample sample = this.defaultSampleService.findByDopantLikeAndSpecificationsLike(inspectDataBase.getDopant(), byCrystalNo.getSpecs());
//                            if (sample != null) {
//                                if (sample.getCarbonEdge().equals("/")) {
//                                    inspectDataBase.setCarbonContentBorderTail(null);
//                                } else {
//                                    inspectDataBase.setCarbonContentBorderTail(new BigDecimal(sample.getCarbonEdge()));
//                                }
//                            }
//                        }
//                        if (pieceCheck.getCenterAnneal() != null) {
//                            inspectDataBase.setWcenterAnneal(pieceCheck.getCenterAnneal());
//                        }
//                        if (pieceCheck.getBorderAnneal() != null) {
//                            inspectDataBase.setWBorderAnneal(pieceCheck.getBorderAnneal());
//                        }


                        // inspectDataBase.setTailDefect(pieceCheck.getMicroDefect());// 微缺陷一直用默认值


//                            if (com.sw.mes.common.utils.StringUtils.isNotBlank(pieceCheck.getLineDefect()) && pieceCheck.getLineDefect().contains("有")) {
//                                inspectDataBase.setIsMalposition(1);// 位错一直用默认值
//                            } else {
//                                inspectDataBase.setIsMalposition(0);
//                            }
                        // 导电型号是N才赋值
                        if (inspectDataBase.getConductiveType() != null && inspectDataBase.getConductiveType().equals("N") && pieceCheck.getCenterAnneal() != null) {
//                            // 中心退火电阻率
//                            inspectDataBase.setWcenterAnneal(pieceCheck.getCenterAnneal());
//                            // 边缘退火电阻率
//                            inspectDataBase.setWBorderAnneal(pieceCheck.getBorderAnneal());
                        }
                        // 更新检验数据库尾片信息
                        this.inspectDataBaseService.saveDataAndGrade(inspectDataBase);

                        try {
                            ybInspectDataService.saveDataInspectLog(inspectDataBase);//保存圆棒检验记录表
                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                    }
                }
            }
        }
    }

    @Override
//    @Transactional(rollbackFor = Throwable.class)
    public void savePieceCheck(List<PieceCheck> pieceChecks) {
        if (pieceChecks.size() > 0) {
            saveOrUpdateInBatch(pieceChecks, "样片检验-新增");

            for (PieceCheck pieceCheck : pieceChecks) {
                // 同步更新晶段检验样片信息
                saveInspectDataBaseInfo(pieceCheck.getPieceNo());
            }
        }
    }

}
