package com.sw.mes.yb.ipc.service.impl;

import java.util.Date;

import com.sw.mes.core.utils.BeanUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;


import com.sw.mes.base.factory.init.service.EquipmentService;
import com.sw.mes.yb.ipc.dto.ButtonClickDto;
import com.sw.mes.yb.ipc.mapping.ButtonType;
import com.sw.mes.yb.ipc.service.IBaseButtonHandler;
import com.sw.mes.yb.production.entity.EquipmentWorkHoursLog;
import com.sw.mes.yb.production.service.EquipmentExtendStateService;
import com.sw.mes.yb.production.service.EquipmentWorkHoursLogService;

/**
 * 工时操作 点击处理
 *
 * @author 李儒
 *
 */
@Service
@Transactional
public class WorkHoursClickServiceImpl implements IBaseButtonHandler {

	@Autowired
	private EquipmentService equipmentService;
	@Autowired
	private EquipmentExtendStateService equipmentExtendStateService;
	@Autowired
	private EquipmentWorkHoursLogService equipmentWorkHoursLogService;

	@Override
	public Object execute(ButtonClickDto dto) throws Exception {

		if (dto.getButtonName().equals("拆清开始")) {
			return "操作:拆清开始";
		} else if (dto.getButtonName().equals("吊料合炉盖开始")) {
			return "操作:吊料合炉盖开始";
		}

		return "未知操作:"+dto.getButtonName();
	}

	@Override
	public void writeWorkHours(ButtonClickDto dto) {
		if(ButtonType.isCalculationWorkHours(dto.getButtonName())) {
			EquipmentWorkHoursLog log = new EquipmentWorkHoursLog();
			BeanUtil.copyProperties(dto, log);


			String changePath = "";

			//获取上次操作
			EquipmentWorkHoursLog preLog = equipmentWorkHoursLogService.getByEquipmentCodeLastOperation(dto.getEquipmentCode());
			if(preLog!=null) {
				changePath = preLog.getButtonName();
				log.setStartTime(preLog.getEndTime());
				log.setWorkStep(ButtonType.getType(preLog.getButtonName()));
			}

			changePath = changePath + "->" + dto.getButtonName();

			log.setChangePath(changePath);
			log.setEndTime(new Date());

			if(log.getStartTime()!=null && log.getEndTime()!=null) {
				log.setTimeLong(log.getEndTime().getTime() - log.getStartTime().getTime());
			}else {
				log.setTimeLong(0L);
			}

			equipmentWorkHoursLogService.saveOrUpdate(log);
		}
	}

}
