package com.sw.mes.yb.pad.service.impl;


import com.sw.mes.core.base.BaseServiceImpl;
import com.sw.mes.yb.pad.dao.SectionNoDetailDao;
import com.sw.mes.yb.pad.entity.SectionNoDetail;
import com.sw.mes.yb.pad.service.SectionNoDetailService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Service
@Transactional
public class SectionNoDetailServiceImpl extends BaseServiceImpl<SectionNoDetail> implements SectionNoDetailService {
    SectionNoDetailDao dao;

    @Autowired
    public void setDao(SectionNoDetailDao dao) {
        super.setBaseDao(dao);
        this.dao = dao;
    }

    @Override
    public SectionNoDetail findBySectionNo(String sectionNo) {
        List<SectionNoDetail> sectionNoDetailList = dao.findBySectionNo(sectionNo);
        if (sectionNoDetailList.size() <= 0) {
            return null;
        }
        return sectionNoDetailList.get(0);
    }

    @Override
    public Boolean sectionNoDetailIsExist(String sectionNo) {
        List<SectionNoDetail> sectionNoDetailList = dao.findBySectionNo(sectionNo);
        return sectionNoDetailList.size() > 0 ? true : false;
    }

    @Override
    public List<SectionNoDetail> findByCrystalIdAndParentId(Long goodsId, Long parentId) {
        return dao.findByCrystalIdAndParentIdOrderById(goodsId, parentId);
    }

    @Override
    public List<SectionNoDetail> findByParentId(Long goodsId) {
        return dao.findByParentId(goodsId);
    }

    @Override
    public Integer findSegmentNumByNo(String crystalNo) {
        return dao.findSegmentNumByNo(crystalNo);
    }
}
