package com.sw.mes.yb.pc.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
@ApiModel(value = "通过方棒编号找到圆棒信息dto")
public class GetFbInfoDto {

    @ApiModelProperty(value = "导电型号")
    String conductionType;
    /**
     * 字段删除
     */
//    @ApiModelProperty(value = "圆棒入库长度(mm)" )
//    BigDecimal instoreLengthYb;
    @ApiModelProperty(value = "方棒长度")
    BigDecimal length;
    @ApiModelProperty(value = "产品实验等级名称")
    String ybExperiLevel;
    @ApiModelProperty(value = "产品等级")
    String productLevel;
    @ApiModelProperty(value = "编号(圆棒)")
    String ybSectionNo;
    @ApiModelProperty(value = "掺杂剂")
    String dopant;
    @ApiModelProperty(value = "拼棒总长(mm)")
    BigDecimal spellBarLength;
    @ApiModelProperty(value = "拼数")
    Integer sticksCount;
    /**
     * 字段删除
     */
//    @ApiModelProperty(value = "直径判定")
//    String diamDecide;
//
//    @ApiModelProperty(value = "细")
//    BigDecimal fineDiameter;
//
//
//    @ApiModelProperty(value = "细减长")
//    BigDecimal fineCutLength;
    @ApiModelProperty(value = "订单号")
    String orderNo;
    @ApiModelProperty(value = "订单类型")
    String orderType;
    @ApiModelProperty(value = "圆棒规格")
    String productTypeSecond;
    @ApiModelProperty(value = "单晶组合")
    private String sectionCompose;
    @ApiModelProperty(value = "实验等级")
    String productLevelExperiment;
    @ApiModelProperty(value = "长棒编号")
    private String crystalNo;
    @ApiModelProperty(value = "计划订单类型")
    private String planOrderType;
    @ApiModelProperty(value = "计划订单号")
    private String planOrderNo;
    @ApiModelProperty(value = "计划产品等级")
    private String planGrade;
    @ApiModelProperty(value = "拼数")
    private Integer stickCount;

    @ApiModelProperty(value = "头尾识别")
    String headTailRecognition;

    @ApiModelProperty(value = "段号")
    Integer piecewiseNum;

    /**
     * 方棒边长
     */
    @ApiModelProperty(value = "方棒边长")
    private String sideLengthRange;

    @ApiModelProperty(value = "产品类型")
    String productType;


    @ApiModelProperty(value = "批次号")
    private String batchNo;

    @ApiModelProperty(value = "物料编码")
    private String materialCode;

    @ApiModelProperty(value = "头碳含量中心值")
    BigDecimal carbonContentHead;
    @ApiModelProperty(value = "尾碳含量中心值")
    BigDecimal carbonContentTail;
    @ApiModelProperty(value = "A电阻率均值")
    private BigDecimal meanResistivityA;
    @ApiModelProperty(value = "A电阻率1")
    private BigDecimal resistivityAOne;
    @ApiModelProperty(value = "A电阻率2")
    private BigDecimal resistivityATwo;
    @ApiModelProperty(value = "A电阻率3")
    private BigDecimal resistivityAThree;
    @ApiModelProperty(value = "B电阻率均值")
    private BigDecimal meanResistivityB;
    @ApiModelProperty(value = "B电阻率1")
    private BigDecimal resistivityBOne;
    @ApiModelProperty(value = "B电阻率2")
    private BigDecimal resistivityBTwo;
    @ApiModelProperty(value = "B电阻率3")
    private BigDecimal resistivityBThree;
    @ApiModelProperty(value = "A少子寿命均值")
    private BigDecimal meanCarrierLifetimeA;
    @ApiModelProperty(value = "A少子寿命1")
    private BigDecimal carrierLifetimeAOne;
    @ApiModelProperty(value = "A少子寿命2")
    private BigDecimal carrierLifetimeATwo;
    @ApiModelProperty(value = "A少子寿命3")
    private BigDecimal carrierLifetimeAThree;
    @ApiModelProperty(value = "B少子寿命均值")
    private BigDecimal meanCarrierLifetimeB;
    @ApiModelProperty(value = "B少子寿命1")
    private BigDecimal carrierLifetimeBOne;
    @ApiModelProperty(value = "B少子寿命2")
    private BigDecimal carrierLifetimeBTwo;
    @ApiModelProperty(value = "B少子寿命3")
    private BigDecimal carrierLifetimeBThree;
    @ApiModelProperty(value = "T段电阻率")
    @JsonProperty("tResistivity")
    private BigDecimal tResistivity;
    @ApiModelProperty(value = "w段电阻率")
    @JsonProperty("wResistivity")
    private BigDecimal wResistivity;

    @ApiModelProperty("头段A少子寿命均值")
    @JsonProperty("tCarrierLifetime")
    private BigDecimal tCarrierLifetime;

    @ApiModelProperty("头段B少子寿命均值")
    @JsonProperty("tLifeEdge1")
    private BigDecimal tLifeEdge1;

    @ApiModelProperty("尾段A少子寿命均值")
    @JsonProperty("wCentreLife")
    private BigDecimal wCentreLife;

    @ApiModelProperty("尾段B少子寿命均值")
    @JsonProperty("wCarrierLifetime")
    private BigDecimal wCarrierLifetime;

    public GetFbInfoDto() {
    }
}

