package com.sw.mes.yb.production.dao;

import java.math.BigDecimal;
import java.util.List;

import com.sw.mes.yb.production.entity.InputFurnaceDetail;
import org.springframework.data.jpa.repository.Query;

import com.sw.mes.core.base.BaseDao;
import com.sw.mes.yb.production.entity.AgainTask;

/**
 * @Author
 * @Description：
 * @Date:
 * @Modified By:
 */
public interface AgainTaskDao extends BaseDao<AgainTask, Long> {

	@Query(value = "select * from production_again_task where equipment_code = ?1 and lot_no=?2 and (raw_status=0 or raw_status=1 or raw_status=3 or raw_status=4) ORDER BY id desc limit 1", nativeQuery = true)
	AgainTask getByEquipmentLastTask(String equimentCode, String lotNo);

	@Query(value = "select * from production_again_task where lot_no=?2 and again_num < ?1 and raw_status = 4 ORDER BY again_num desc limit 1", nativeQuery = true)
	AgainTask getByLotNoAndAgainNum(Integer againNum, String lotNo);

	List<AgainTask> findByLotNo(String lotNo);

	List<AgainTask> findByLotNoAndAgainNum(String lotNo, Integer againNum);

	@Query(value = "select * from production_again_task where equipment_code = ?1 and lot_no=?2 and raw_type=?3 ORDER BY id desc limit 1", nativeQuery = true)
	AgainTask getByEquipmentAndStateLastTask(String equimentCode, String lotNo, Integer rawStatus);

	@Query(value = "select * from production_again_task where equipment_code = ?1 and lot_no=?2 and (raw_type=2 or raw_type=5) ORDER BY id desc limit 1", nativeQuery = true)
	AgainTask getByRepeatOpenTask(String equipmentCode, String lotNo);

	@Query(value = "select * from production_again_task where lot_no = ?1 and again_num = ?2 and (raw_status=3 or raw_status=4) ",nativeQuery = true)
	List<AgainTask> findSuccessByLotNoAndAgainNum(String lotNo, Integer againNum);

	@Query(value = "select * from production_again_task where lot_no in ?1",nativeQuery = true)
	List<AgainTask> findByLotNoList(List<String> lotNo);

	@Query(value = "select * from production_again_task where equipment_code = ?1 and again_num = ?2 and (raw_status=3 or raw_status=4) ",nativeQuery = true)
	List<AgainTask> findSuccessByEquipmentCodeAndAgainNum(String equipmentCode, Integer againNum);

	AgainTask findByEquipmentCode(String code);

    @Query(value = "select * from production_again_task where lot_no = ?1 and (raw_status=3 or raw_status=4)",nativeQuery = true)
	List<AgainTask> findSuccessByLotNo(String lotNo);

	@Query(value = "SELECT pifd.weight ,pifd.product_code from production_input_furnace_detail pifd  where pifd.again_task_detail_id = (SELECT patd.id FROM production_again_task pak\n" +
			"\tLEFT JOIN production_again_task_detail patd ON pak.id = patd.again_task_id " +
			"WHERE ( pak.raw_status = 3 OR pak.raw_status = 4 ) \n" +
			"\tAND pak.lot_no = ?1 \n" +
			"\tAND pak.product_code = ?2 ORDER BY patd.id desc limit 1)",nativeQuery = true)
	List<InputFurnaceDetail> findByLotNoAndProductCode(String lotNo, String code);
}
