package com.sw.mes.yb.production.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author lf
 * @description
 * @date 2024/1/22 17:18
 */
@Data
@ApiModel(value = "DocketMasterAlloyPrintDto对象", description = "母合金信息")
public class DocketMasterAlloyPrintDto implements Serializable {
    @ApiModelProperty(value = "打印模板对应打印模板的documentMould")
    String printModel;
    @ApiModelProperty(value = "打印类型:对应打印模板的documentName")
    String printType;
    @ApiModelProperty(value = "打印份数")
    Integer printNum;
    @ApiModelProperty(value = "是否预览")
    Boolean isPreview;
    @ApiModelProperty(value = "工单号")
    String workOrderNumber;
    @ApiModelProperty(value = "炉台号")
    String furnaceCode;
    @ApiModelProperty(value = "加次")
    String addTime;
    @ApiModelProperty("配方方案名称")
    private String recipeName;
    @ApiModelProperty("创建人")
    private String createUser;
    @ApiModelProperty(value = "母合金档位")
    BigDecimal motherAlloyGear;
    @ApiModelProperty(value = "母合金重量")
    BigDecimal motherAlloyWeight;
    @ApiModelProperty("创建时间")
    private Date createDate;
    @ApiModelProperty(value = "编码（如：单晶编码、晶段编码）")
    @NotBlank(message = "编码，不能为空")
    String code;

}
