package com.sw.mes.yb.production.dto;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.sw.mes.core.annotation.Jinko;
import io.swagger.annotations.ApiModel;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Jinko(value = "灌料部分退料", author = "wxl")
@Data
@ApiModel(value = "退料记录Dto")
public class ProductionMaterialReturnRecordDto {


    @ExcelIgnore
    private Long id;

    /**
     * 配料灌料任务ID
     */
    @ExcelIgnore
    private Long taskId;

    /**
     * 配料灌料记录ID
     */
    @ExcelIgnore
    private Long taskRecordId;

    /**
     * 设备号
     */
    @ExcelProperty(value = "设备号")
    private String equipmentNo;

    /**
     * 炉次号
     */
    @ExcelProperty(value = "炉次号")
    private String lotNo;

    /**
     * 复投次数
     */
    @ExcelProperty(value = "复投次数")
    private Integer againNum;

    /**
     * 料号
     */
    @ExcelProperty(value = "料号")
    private String productCode;

    /**
     * 物料条码
     */
    @ExcelProperty(value = "物料条码")
    private String materialCode;

    /**
     * 物料名称
     */
    @ExcelProperty(value = "物料名称")
    private String materialName;

    /**
     * 批次号
     */
    @ExcelProperty(value = "批次号")
    private String batchNo;

    /**
     * 退料重量
     */
    @ExcelProperty(value = "退料重量")
    private BigDecimal weight;

    /**
     * 物料类型名称
     */
    @ExcelProperty(value = "物料类型名称")
    private String materialTypeName;

    /**
     * 供应商
     */
    @ExcelProperty(value = "供应商")
    private String supplierName;

    /**
     * 原因
     */
    @ExcelProperty(value = "原因")
    private String reason;

    /**
     * 退料时间
     */
    @ExcelProperty(value = "退料时间")
    private Date createTime;

    /**
     * 灌料时间
     */
    @ExcelProperty(value = "灌料时间")
    private Date installTime;

    /**
     * 退料人
     */
    @ExcelProperty(value = "退料人")
    private String createUser;

    /**
     * 灌料人
     */
    @ExcelProperty(value = "灌料人")
    private String installUser;

    /**
     * sap订单单号
     */
    @ExcelProperty(value = "sap订单单号")
    private String sapOrderNo;

    /**
     * sap料号
     */
    @ExcelProperty(value = "sap料号")
    private String sapProductCode;

    /**
     * 灌料桶数
     */
    @ExcelProperty(value = "灌料桶数")
    private String pailNum;

    /**
     * 载具号
     */
    @ExcelProperty(value = "载具号")
    private String carrierNo;


    /**
     * 班次
     */
    @ExcelIgnore
    private String classNo;


    /**
     * 班组
     */
    @ExcelIgnore
    private String teamGroup;

}
