package com.sw.mes.yb.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Column;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Author: xushu
 * @Date: 2022/08/17/16:20
 * @Description:
 */
@Data
@ApiModel(value = "回收料管理信息Dto")
public class RecycledMaterialManageDto {

    private Long id;
    @ApiModelProperty(value = "托号")
    String trayNo;

    //回收料管理模块新增生产批次号
    @ApiModelProperty(value = "生产批次号")
    String produceBatchNo;

    @ApiModelProperty(value = "炉次号")
    String lotNo;
    @ApiModelProperty(value = "回收料类型", required = true )
    String recycledMaterialType;
    @ApiModelProperty(value = "来源", required = true )
    String source;
    @ApiModelProperty(value = "产品类别", required = true)
    String productionCategory;
    @ApiModelProperty(value = "等级", required = true)
    String grade;
    @ApiModelProperty(value = "物料编号", required = true)
    String materialCode;
    @ApiModelProperty(value = "物料名称", required = true)
    String materialName;
    @ApiModelProperty(value = "厂区", required = true)
    String factory;
    @ApiModelProperty(value = "片料")
    String sheetStock;
    @ApiModelProperty(value = "挡位")
    String gear;
    @ApiModelProperty(value = "个数")
    Integer num;
    @ApiModelProperty(value = "单位名称")
    String unitName;
    @ApiModelProperty(value = "重量")
    BigDecimal weight;
    @ApiModelProperty(value = "规格")
    String specification;
    @ApiModelProperty(value = "状态(1待入库，2取消，3待确定，4已接收，5拒收)" )
    Integer status;
    @ApiModelProperty(value = "创建人(组托人)" )
    String createBy;
    @ApiModelProperty(value = "创建时间(组托时间)" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date createTime;
    @ApiModelProperty(value = "更新人" )
    String updateBy;
    @ApiModelProperty(value = "更新时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date updateTime;
    @ApiModelProperty(value = "接收人" )
    String receiver;
    @ApiModelProperty(value = "接收时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date receiveTime;
    @ApiModelProperty(value = "ERP工单" )
    private String erpOrder;
    @ApiModelProperty(value = "详情" )
    List<RecycledMaterialManageDetailDto> recycledMaterialMangeDetailDtos;

    @ApiModelProperty(value = "卡板箱号")
    private String boxNo;

    @ApiModelProperty("追溯标识")
    private String fromMark;

    /**
     * ERP上报状态，0 未上报，1 已上报
     */
    @Column(length=3)
    @ApiModelProperty("ERP上报状态，0 未上报，1 已上报")
    private Integer reportedState;

    /**
     * erp库位
     */
    @ApiModelProperty("erp库位")
    private String erpWarehouseCode;

    @ApiModelProperty("erp上报时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date erpTime;

    @ApiModelProperty(value = "载具箱重量")
    BigDecimal boxWeight;

    @ApiModelProperty(value = "成本中心")
    private String kostl;

    @ApiModelProperty(value = "工单号")
    private String workOrderNo;

    @ApiModelProperty(value = "车间")
    String workShop;

    @ApiModelProperty(value = "掺杂剂")
    String dopant;

    @ApiModelProperty(value = "定向标识")
    String directionalSign;

    @ApiModelProperty(value = "导电型号")
    String conductionType;

    @ApiModelProperty(value = "清洗返工批次")
    String reworkProduceBatchNo;

    @ApiModelProperty(value = "物料类别(1 余料(默认) 2 废料)")
    private Integer materialCategory;
}
