package com.sw.mes.yb.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "余料采集关联Dto")
public class SurplusInfoDto {

    private Long id;
    @ApiModelProperty(value = "余料编码")
    String surplusCode;
    @ApiModelProperty(value = "工单号")
    String workOrderNo;
    @ApiModelProperty(value = "炉号")
    String deviceNo;
    @ApiModelProperty(value = "炉次号")
    String lotNo;
    @ApiModelProperty(value = "投料次数")
    Integer feedTimes;
    @ApiModelProperty(value = "余料类型")
    String surplusType;
    @ApiModelProperty(value = "重量")
    BigDecimal weight;
    @ApiModelProperty(value = "长度")
    BigDecimal length;
    @ApiModelProperty(value = "状态(1待入库，2取消，3待确定，4已接收，5拒收)")
    Integer status;
    @ApiModelProperty(value = "数据采集类型(1 EAP自动采集，2 人工采集)")
    Integer dataType;
    @ApiModelProperty(value = "区域")
    String area;
    @ApiModelProperty(value = "删除状态(1：删除，0未删除 默认)")
    Integer del;
    @ApiModelProperty(value = "创建人")
    String createBy;
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date createTime;
    @ApiModelProperty(value = "更新人")
    String updateBy;
    @ApiModelProperty(value = "更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date updateTime;
    @ApiModelProperty(value = "第一备用字段")
    String filedFirst;
    @ApiModelProperty(value = "第二备用字段")
    String filedSecond;
}