package com.sw.mes.yb.production.service;

import com.sw.mes.core.base.BaseService;
import com.sw.mes.core.response.Result;
import com.sw.mes.yb.production.dto.LongCrystalDto;
import com.sw.mes.yb.production.dto.LongCrystalExcelDto;
import com.sw.mes.yb.production.dto.LongCrystalInfoDto;
import com.sw.mes.yb.production.dto.LongCrystalVO;
import com.sw.mes.yb.production.entity.LongCrystal;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Author
 * @Description：
 * @Date:
 * @Modified By:
 */
public interface LongCrystalService extends BaseService<LongCrystal> {

    LongCrystal getLastCrystalNo(String equipmentCode);

    List<LongCrystalExcelDto> giveSomeValues(List<LongCrystalDto> longCrystalDto);

    List<LongCrystal> findByLotNo(String lotNo);

    List<LongCrystal> findByEquipmentCode(String equipmentCode);

    List<String> findByLotNoAndClosureIdentification(List<String> lotNoList, String closureIdentification);

    LongCrystal findByCrystalNo(String toString);

    List<LongCrystal> findAllByCrystalNo(List<String> toString);

    LongCrystal findByCrystalNo2(String toString);

    List<LongCrystal> findByAgvTaskCode(String taskCode);

    List<LongCrystal> findByConfirmCrystals(String equipmentCode);

    LongCrystal findTopByLotId(Long id);

    List<LongCrystal> findByIds(List<Integer> ids);

    List<String> findTop3LotNo( );

    List<String> findTop3LotNoByEquipmentCode(String equipmentCode);

    LongCrystal findByLotIdAndAgainNumAndCrystalNumAndCrystalStatusNotAndIdNot(Long lotId, Integer againNum, Integer crystalNum, int crystalStatus,Long id);

    Result updateCrystalNo(LongCrystalInfoDto dto);

    //更新单晶状态
    Result updateCrystalStatus(LongCrystalDto dto);

    List<LongCrystal> findByLotIdAndCrystalStatusNot(Long lotId, Integer crystalStatus);

    Result<Integer> updateYbWorkOrder(String crystalNo, String ybWorkOrder);

    void completionLongCrystalOrder(String lotNo, String crystalNo, Date startTime, BigDecimal maxDiam, BigDecimal minDiam, Boolean flag);


    LongCrystal findBLotNoAndClosureIdentification(String crystalNo, String closureIdentification);

    LongCrystal findTopByLotIdAndCrystalStatus(Long lotId, Integer crystalStatus);

    Result updateLastLongCrstalWeight(LongCrystalVO longCrystalVO);

    Result updateWeightAndHeight(LongCrystalInfoDto dto);

    List<LongCrystal> findByGmtCreate(String startTime, String endTime);

    List<String> findByGmtCreate1(String startTime, String endTime, String area, String s);

    List<LongCrystal> findByGmtCreate2(List<String> lotNoList, String area, String s);

    BigDecimal findByGmtCreateAndAreaAndarea(String startTime, String endTime, String area);

    BigDecimal findByGmtCreateAndAreaAndarea1(String startTime, String endTime, String area);

    List<Map<String, Object>> pullOutPutData();

    List<Map<String, Object>> pullOutPutDataCut();

    void updatePulledState(List<Long> idList2);

    void updateSquarePulledState(List<Long> idList2);

    /**
     * 获取当前炉台，当前长晶棒上一根棒子
     * @param equipmentCode
     * @param id
     * @return
     */
    LongCrystal getLastId(String equipmentCode, Long id);

}
