/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.report.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="rpt_broken_bract_base")
@DynamicUpdate
@DynamicInsert
public class BrokenBractBase{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 日期(格式yyyy-MM-dd hh:mm:ss)
	 */
    @Column(length=50)
    private String dateTime;
    
	/**
	 * 班组
	 */
    @Column(length=40)
    private String classGroup;
    
	/**
	 * 班次
	 */
    @Column(length=10)
    private String classNo;
    
	/**
	 * 系列
	 */
    @Column(length=50)
    private String series;
    
	/**
	 * 炉台号
	 */
    @Column(length=50)
    private String deviceNo;
    
	/**
	 * 炉次号
	 */
    @Column(length=80)
    private String lotNo;
    
	/**
	 * 规格
	 */
    @Column(length=50)
    private String specs;
    
	/**
	 * 运行时长
	 */
    @Column(length=19)
    private BigDecimal runTime;
    
	/**
	 * 断苞类别
	 */
    @Column(length=20)
    private String brokenBractType;
    
	/**
	 * 断苞工序
	 */
    @Column(length=40)
    private String brokenBractProcesses;
    
	/**
	 * 晶体长度
	 */
    @Column(length=19)
    private BigDecimal crystalLength;
    
	/**
	 * 复投情况
	 */
    @Column(length=40)
    private String repeatedInfo;
    
	/**
	 * 引晶功率
	 */
    @Column(length=19)
    private BigDecimal crystalPower;
    
	/**
	 * 引晶时长(h)
	 */
    @Column(length=19)
    private BigDecimal crystalTime;
    
	/**
	 * 投料量
	 */
    @Column(length=19)
    private BigDecimal feedingQuantity;

	/**
	 * 等径1000mm液面像素值（等径1000mm液面像素值）
	 */
	@Column(length=19)
	private BigDecimal liquidLevelPixel;

	/**
	 * 液位光标（8032）
	 */
	@Column(length=19)
	private BigDecimal liquidCursor;

	/**
	 * 干锅类型（1196）
	 */
	@Column(length=40)
	private String dryPotType;

	/**
	 * 长度区间
	 */
    @Column(length=40)
    private String crystalLengthArea;
    
	/**
	 * uap发送给mes报文内容
	 */
    @Column(length=2147483647)
    private String toMesDataBody;


	public BrokenBractBase() {
	}

	public BrokenBractBase(Long id) {
		this.id = id;
	}
}
