package com.sw.mes.store.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author wupeng
 * @Description 出库单明细
 * @Date 18:47 2023/7/31
 * @Param
 * @return
 **/
@Data
@ApiModel(value = "出库单明细Dto")
public class WarehouseOutputBillDetailDto {

    private Long id;
    @ApiModelProperty(value = "出库单ID")
    private Long outputBillId;
    @ApiModelProperty(value = "出库单号")
    private String outputBillNo;
    @ApiModelProperty(value = "物料主数据ID", required = true)
    private Long materialModelId;
    @ApiModelProperty(value = "物料主数据料号")
    private String materialModelCode;
    @ApiModelProperty(value = "物料主数据名称")
    private String materialModelName;
    @ApiModelProperty(value = "物料主数据类型")
    private String materialTypeName;
    @ApiModelProperty(value = "物料主数据类别")
    private String materialCategoryName;
    @ApiModelProperty(value = "唯一码")
    private String uniqueCode;
    @ApiModelProperty(value = "批次号")
    private String batchNo;
    @ApiModelProperty(value = "物料主数据供应商")
    private String supplier;
    @ApiModelProperty(value = "物料主数据规格")
    private String specification;
    @ApiModelProperty(value = "物料主数据图号")
    private String materialTh;
    @ApiModelProperty(value = "物料等级")
    private String materialLevel;
    @ApiModelProperty(value = "物料粒径")
    private String suppliesGrain;
    @ApiModelProperty("物料档位")
    private String materialGear;
    @ApiModelProperty(value = "出库数量")
    private BigDecimal outputCount;
    @ApiModelProperty(value = "需求数量")
    private BigDecimal requireCount;
    @ApiModelProperty(value = "库存数量")
    private BigDecimal quantity;
    @ApiModelProperty(value = "物料单位")
    private String unitName;
    @ApiModelProperty(value = "库位ID")
    private Long warehouseId;
    @ApiModelProperty(value = "库位名称")
    private String warehouseName;
    @ApiModelProperty(value = "库位编码")
    private String warehouseCode;
    @ApiModelProperty(value = "创建人ID")
    private Integer createUserId;
    @ApiModelProperty(value = "创建人名称")
    private String createUserName;
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
    @ApiModelProperty(value = "操作人ID")
    private Integer updateUserId;
    @ApiModelProperty(value = "操作人名称")
    private String updateUserName;
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;
    @ApiModelProperty(value = "出库类型")
    private String type;
    @ApiModelProperty(value = "去向")
    private String destination;
    @ApiModelProperty(value = "单据状态。待出库、已出库、锁定、取消")
    private String status;
    @ApiModelProperty("载具编号")
    private String traceid;
    @ApiModelProperty("SAP工厂")
    private String customer;
}