package com.sw.mes.store.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.sw.mes.store.entity.WarehouseInputBillDetail;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * @Author wupeng
 * @Description 入库单详情
 * @Date 18:58 2023/7/27
 * @Param
 * @return
 **/
@Mapper
public interface WarehouseInputBillDetailMapper extends BaseMapper<WarehouseInputBillDetail> {

    @Select("select * from warehouse_input_bill_detail where input_bill_no = #{billNo}")
    List<WarehouseInputBillDetail> getByBillNo(@Param("billNo") String billNo);

    @Select("select * from warehouse_input_bill_detail where unique_code = #{uniqueCode}")
    WarehouseInputBillDetail getByUniqueCode(@Param("uniqueCode") String uniqueCode);

    @Select("select * from warehouse_input_bill_detail where batch_no = #{batchNo}")
    List<WarehouseInputBillDetail> getByBatchNo(@Param("batchNo") String batchNo);

    @Select("select * from warehouse_input_bill_detail where input_bill_id = #{billId}")
    List<WarehouseInputBillDetail> getByBillId(@Param("billId") Long billId);
}