package com.sw.mes.store.service;


import com.baomidou.mybatisplus.extension.service.IService;
import com.sw.mes.core.response.Result;
import com.sw.mes.store.dto.WarehouseInputBillDto;
import com.sw.mes.store.entity.WarehouseInputBill;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

/**
 * @Author wupeng
 * @Description 针对表【warehouse_input_bill】的数据库操作Service
 * @Date 11:13 2023/7/24
 * @Param
 * @return
 **/
public interface WarehouseInputBillService extends IService<WarehouseInputBill> {

    void saveInputBill(WarehouseInputBillDto bill);
    String saveInputBills(WarehouseInputBillDto bill);

    WarehouseInputBill getByBillNo(String billNo);

    void auditReceiveAtomic(WarehouseInputBill inputBill);

    void auditReceive(WarehouseInputBill inputBill);

    void autoReceiveAtomic(WarehouseInputBill inputBill);

    void autoReceive(WarehouseInputBill inputBill);

    Result rejectApply(WarehouseInputBill inputBill);

    void cancelApply(String billNo);

    void importInputBill(MultipartFile file) throws IOException;
}
