package com.sw.mes.store.service.impl;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sw.mes.store.entity.WarehouseInputBillDetail;
import com.sw.mes.store.mapper.WarehouseInputBillDetailMapper;
import com.sw.mes.store.service.WarehouseInputBillDetailService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


/**
 * @Author wupeng
 * @Description 入库单详情
 * @Date 18:58 2023/7/27
 * @Param
 * @return
 **/
@Service
@Transactional
public class WarehouseInputBillDetailServiceImpl extends ServiceImpl<WarehouseInputBillDetailMapper, WarehouseInputBillDetail> implements WarehouseInputBillDetailService {

    @Autowired
    private WarehouseInputBillDetailMapper inputBillDetailMapper;
    /**
     * 根据入库单号查询入库明细
     **/
    @Override
    public List<WarehouseInputBillDetail> getByBillNo(String billNo) {
        return inputBillDetailMapper.getByBillNo(billNo);
    }

    @Override
    public List<WarehouseInputBillDetail> getByBillId(Long billId) {
        return inputBillDetailMapper.getByBillId(billId);
    }

    @Override
    public WarehouseInputBillDetail getByUniqueCode(String uniqueCode) {
        return inputBillDetailMapper.getByUniqueCode(uniqueCode);
    }

    @Override
    public List<WarehouseInputBillDetail> getByBatchNo(String batchNo) {
        return inputBillDetailMapper.getByBatchNo(batchNo);
    }
}